.*
:set symbol="cat" value="Application Frameworks"

.chap Application Frameworks
.*
.np
The following section contains listings for application frameworks supporting
Watcom C or C++.
.*

.section Dynace OO Extension to C (&cat)
.*
.np
.illust begin
Algorithms Corporation
3020 Liberty Hills Drive
Franklin, TN  37064


Tel:  (615) 791-1636
FAX:  (615) 791-7736
.illust end
.*
.np
.*
.ix 'Dynace OO Extension to C (&cat)'

.ix 'Algorithms Corporation'

.ix '&cat'
.*
.illust begin
Dynace Object Oriented Extension To C (Dynace)
------------------------------------------------------------------------------
.illust end
.np
Dynace is a preprocessor, include files and a library which extends the C
language with advanced object oriented capabilities, automatic garbage
collection and multiple threads.  Dynace is designed to solve many of the
problems associated with C++ while being easier to learn
and containing more flexable object oriented facilities.  Dynace is able to add
facilities previously only available in languages such as Smalltalk and CLOS
without all the overhead normally associated with those environments.
.*
.figure *depth='2.75' *scale= *file='algologo'
.*

.*

.section Dynace Windows Development System (&cat)
.*
.np
.illust begin
Algorithms Corporation
3020 Liberty Hills Drive
Franklin, TN  37064


Tel:  (615) 791-1636
FAX:  (615) 791-7736
.illust end
.*
.np
.*
.ix 'Dynace Windows Development System (&cat)'

.ix 'Algorithms Corporation'

.ix '&cat'
.*
Dynace Windows Development System (WDS)
-------------------------------------------------------------------------
The Dynace Windows Development System (WDS) is a Dynace class library which
enables a C programmer with no knowledge of C++, Dynace, the Windows API or
message-driven architecture to write real Windows applications with an absolute
minimum learning curve and number of lines of code.  In fact, it is possible to
become familiar enough with windows, menus, dialogs and controls using WDS to
write a Windows application after just one day!  A 'Hello World' program takes
only four lines of code!
.*
.figure *depth='2.75' *scale= *file='algologo'
.*

.*

.section LANSA (&cat)
.*
.np
.illust begin
Aspect Computing
187 Albert Street
Waterloo, ON  N2L 3T4


Tel:  (519) 886-1688
FAX:  (519) 886-7407
.illust end
.*
.np
.*
.ix 'LANSA (&cat)'

.ix 'Aspect Computing'

.ix '&cat'
.*
LANSA is an integrated family of highly productive software design, development
and maintenance products for both host and client/server applications. LANSA's
structured high level language greatly improves productivity and facilitates
the production of platform independent
client/server solutions. With LANSA, commercial grade software can be developed
quickly with a minimum skill set.  It can also be maintained simply and safely.
.illust begin
Features
*      Active Repository
*      Referential Integrity
*      Validations - declarative and programmable
*      Extended DB2/400 Event Triggers
*      PC DB Event Triggers
*      Security - field and file
*      Multilingual, DBCS and RLTB support
*      Structured high level language (RDML)
*      Full RDML prompting syntax experts
*      Programmable RDML templates
*      Action diagram editor
*      Free form editor
*      Object Oriented modelling and prototyping
*      Automatic screen/window generation
*      Screen/Window painter
*      Report painter
*      Compile
*      Online RDML debugging
*      Stand-alone PC development
*      LAN team development
*      Test across multiple platforms
.illust end
.illust begin
Source Code Independence
*      Operating System
*      Database
*      User Interface
*      Communications protocols
*      Distributed Function Partitioning
*      Distributed Data Partitioning
*      Independent of client/server model
.illust end
.illust begin
PC Application Integration
*      Copy and paste clipboard
*      DB to ASCII file import/export
.illust end
.illust begin
Client/Server Models
*      AS/400 standalone
*      Distributed logic
*      Mobile PC standalone
*      Distributed data
*      Remote data
.illust end
.illust begin
Development Platform
*      OS/400
*      OS/2
*      Windows 95
*      Windows NT
.illust end
.illust begin
Execution Environments - Server
*      OS/400 DDS, DB2/400, RPG
*      OS/2 PM, DB2/2, C
*      AIX Motif, DB2/6000, C
*      Windows NT, SQL Server, C
.illust end
.illust begin
Execution Environments - Client
*      Windows 3.1, ODBC, C
*      OS/2 PM, DB2/2, C
*      Windows NT, SQL Server, C
.illust end
.illust begin
Communication Protocols
*      APPC, TCP/IP
*      SNA Server
.illust end
.illust begin
Note: Server combinations may also be used in 3 tier Server / Agent / Client
topology.
.illust end
.*

.*

.*

.section Menuet/CPP (&cat)
.*
.np
.illust begin
Autumn Hill Software
1145 Ithaca Drive
Boulder, Colorado 80303


Tel:  (303) 494-8865
FAX:  (303) 494-7802
.illust end
.*
.np
.*
.ix 'Menuet/CPP (&cat)'

.ix 'Autumn Hill Software'

.ix '&cat'
.*
If you're looking for a sophisticated versatile, powerful, easy to use, and
good looking development framework for DOS, then look no further.  Menuet/CPP
has proven to be this and more in a wide range of developer settings, from one-
man shops to Fortune 500 I.S. departments.  We support all major DOS compilers
as well as low-level graphics packages from MetaGraphics and Flash-Tek and
extenders from Flash Tek, Phar Lap, and Tenberry Systems. Menuet provides all
of the important components needed to get an application up and running.
There's a wide range of general purpose classes and a dilaogs library
containing many pre-built dialogs.  We-ve also included a large collection of
icons and fonts and the best icon and font editors you'll find anywhere.
.*

.*

.*

.section Menuet/CX (&cat)
.*
.np
.illust begin
Autumn Hill Software
1145 Ithaca Drive
Boulder, Colorado 80303


Tel:  (303) 494-8865
FAX:  (303) 494-7802
.illust end
.*
.np
.*
.ix 'Menuet/CX (&cat)'

.ix 'Autumn Hill Software'

.ix '&cat'
.*
 Menuet/CX is the fourth generation of the Menuet family of GUI Application
Frameworks.  Menuet/CX delivers a new level of excellence in cross-platform GUI
application frameworks for the professional developer who is concerned about
aesthetics as well as efficiency.  Menuet/CX provides a high quality visual
presentation for you application while taking minimal resources. With its
visual design editors, you get to produce functional and  artistic results
fast.  Menuet/CX supports OS/2 2.x and Warp, MS-Windows 3.x, MS-Windows 95, and
Windows NT along with all
major compilers on these platforms.
.*

.*

.*

.section C/C++ Data Object Library (&cat)
.*
.np
.illust begin
Code Farms Inc.
7214 Jock Trail
Richmond, Ont.  K0A 2Z0
Canada

Tel:  (613) 838-4829
FAX:  (613) 838-3316
.illust end
.*
.np
.*
.ix 'C/C++ Data Object Library (&cat)'

.ix 'Code Farms Inc.'

.ix '&cat'
.*
 New concept of C++ class library with all data structures and container
classes, from lists, hash tables, ER models to run-time extensible objects, and
virtual disk access. Extremely fast and efficient, useful especially for large
projects - see the book 'Taming C++' by J.Soukup.
.np
Treats data structures as design patterns. Represents relations as objects, and
improves maintenance by removing cyclic dependency among classes.
Automatically persistent data do not require user-coded I/O functions for every
new class. Generates fast frameworks and OO databases.  Prevents dangling
pointers, includes memory management and automatic paging to disk. Portable
data and programs. Complete source, no royalties.
.np
Price: US299 one user DOS/WINDOWS/MAC US599 one UNIX workstation
.*

.*

.*

.section Yacc++ and the Language Objects Library (&cat)
.*
.np
.illust begin
Compiler Resources
85 Main Street, Suite 310
Hopkinton, MA  01748


Tel:  (508) 435-5016  x.2
FAX:  (508) 435-4847
.illust end
.*
.np
.*
.ix 'Yacc++ and the Language Objects Library (&cat)'

.ix 'Compiler Resources'

.ix '&cat'
.*
.illust begin
Product Name:  Yacc++ and the Language Objects Library
Product Category:  LEX and YACC Utilities
This product supports:  Watcom C/C++ 10.5 (any 32 bit target)
.illust end
.np
Yacc++ is Object-Oriented Successor to Lex and YaccYacc++ and the Language
Objects Library from Compiler Resources, Inc. is an object-oriented rewrite of
lex and yacc which creates C++ classes from grammars.
.np
.illust begin
* Yacc++ directly translates regular expressions without introducing artificial
productions and produces minimal state LR(1) lexers and parsers.
* Multiple lexer and parser objects can be active concurrently and are fully
reentrant.
* Automatic class generation for ASTs (abstract syntax trees) per token, parser
non-terminal, or alternative.
* Multiple inheritance features for modularizing and reusing grammars.
* Grammar classes can be dynamically bound to lexer and parser objects.
* Multiple entry point grammars allow the matching of partial parse trees.
* Lexer and parser objects act as call-back coroutines within Windows, Motif,
and other event driven applications.
* Yacc++ comes with the Language Objects Library, a C++ class library with
syntactic and semantic support for building applications.  The library provides
base classes which define lexer, parser, input, AST, symbol table, and error
objects.
* Includes three ready to run example applications, a complete reference
manual, a comprehensive tutorial guide, sources to the class library, and a set
of tutorials with one hundred sample grammars.
.illust end
.np
.illust begin
ISV Contact Person:  Barbara ZinoSales
Information (for publication):
.illust end
.np
.illust begin
Compiler Resources, Inc.
Main Street, Suite 310
Hopkinton, MA  01748
Phone: (508) 435-501685
Fax: (508) 435-4847
E-mail: compres@world.std.com
.illust end
.*

.*

.*

.section MEWEL (&cat)
.*
.np
.illust begin
MAGMA Software Systems
15 Bodwell Terrace
Millburn, New Jersey 07041


Tel:  (201) 912-0192
FAX:  (201) 912-0103
.illust end
.*
.np
.*
.ix 'MEWEL (&cat)'

.ix 'MAGMA Software Systems'

.ix '&cat'
.*
MEWEL 4.1 is a cross-platform user interface tookit which gives your
application complete portability between Microsoft Windows, DOS text, DOS
graphics, OS/2 text, UNIX text, and OSF Motif. Since MEWEL's API is compatible
with the standard Microsoft Windows API, you can easily port programs between
Windows and any of the environments which MEWEL supports,
even if you already have existing Windows programs.
.np
Programmers can develop new stand-alone applications using MEWEL, or can port
their existing Windows applications to any of the platforms which MEWEL
supports. MEWEL supports Windows 3.x features such as Control windows (listbox,
combo, radio, checkbox, pushbutton, scrollbars, single & multi-line edit,
static) Multiple Document Interface (MDI) Dialog Boxes Overlapping Windows with
moving and resizing Multi-level Menus Mouse Windows BMP files (blitting,
stretching, compressing) PCX files Icons (character and graphical) Multiple
proportional fonts MEWEL supports the Watcom 10.5 32-bit compiler, and the DOS
4G/W and Pharlap TNT DOS extenders. The DOS Graphics version supports the
MetaWindows 386 and Watcom graphics libraries.
.*
.figure *depth='2.75' *scale= *file='wmewlgui'
.*

.*

.section MethodMaker (&cat)
.*
.np
.illust begin
Mark V Systems Ltd.
16400 Ventura Blvd., Suite 303
Encino, CA 91436


Sales:  (800) 995-7671
Tel:  (818) 995-7671
FAX:  (818) 995-4267
.illust end
.*
.np
.*
.ix 'MethodMaker (&cat)'

.ix 'Mark V Systems Ltd.'

.ix '&cat'
.*
MethodMaker (R) by Mark V Systems:  MethodMaker is an exciting  new extension
to the ObjectMaker family which allows rapid development of new method
notations.  MethodMaker also allows the user to modify and extend existing
ObjectMaker and ProcessMaker method support to meet project and organization
requirements. The user can easily build or modify the
tool support for a method by editing a diagram set. The new, or further
prototyped method is self
documented by the defining diagram set, and can be regenerated at any time to
take advantage of new ObjectMaker features and capabilities.  MethodMaker, with
simple diagrams and fill in forms allows you to specify and modify the tool
support for menus, notations, syntax checking, semantics specification and
repository capture of semantics and other information and relationships.  All
ObjectMaker CASE  Tool functionality is inherited.
.np
Contact MethodMaker marketing at 818 995 7671, fax 818 995 4267 or
methodmaker@markv.com.
.*

.*

.*

.section Object Maker (&cat)
.*
.np
.illust begin
Mark V Systems Ltd.
16400 Ventura Blvd., Suite 303
Encino, CA 91436


Sales:  (800) 995-7671
Tel:  (818) 995-7671
FAX:  (818) 995-4267
.illust end
.*
.np
.*
.ix 'Object Maker (&cat)'

.ix 'Mark V Systems Ltd.'

.ix '&cat'
.*
ObjectMaker by Mark V Systems:  With the ObjectMaker CASE Tool you can model
your application requirements and design in one or more of the most popular
notations.  ObjectMaker supports more than 30 of the most popular analysis and
design notations for software engineering and allows you to mix and match
notations to build a single model of your software application.  You can choose
the notations and the depth of detail your application requires.  ObjectMaker
also offers support for detailed design, code generation and document
generation for construction, delivery and maintenance phases.  Reverse
Engineering tools offer you the opportunity to re-engineer applications, reuse
legacy code and incorporate commercially available components into your model
for design, construction and maintenance.
.np
Contact ObjectMaker marketing at 818 995 7671, fax 818 995 4267, or
objectmaker@markv.com.
.*

.*

.*

.section ObjectMaker TDK (&cat)
.*
.np
.illust begin
Mark V Systems Ltd.
16400 Ventura Blvd., Suite 303
Encino, CA 91436


Sales:  (800) 995-7671
Tel:  (818) 995-7671
FAX:  (818) 995-4267
.illust end
.*
.np
.*
.ix 'ObjectMaker TDK (&cat)'

.ix 'Mark V Systems Ltd.'

.ix '&cat'
.*
ObjectMaker TDK by Mark V Systems: The ObjectMaker Tool Development Kit (TDK)
offers developers, integrators, OEMs, consultants, and methodologists the
opportunity to customize methods, notations, syntax rules, syntax checking,
semantic specification and repository capture of all semantics, and other
information and relationships important to your process and problem space.  The
TDK provides direct access to the rules (predicate logic) that create, control,
and pre- and post-condition all tool behavior, and manage all repository
navigation and iteration.  The TDK offers you the possibility of growing your
tool and method support as your organization and process grows and matures.
This is more than just being able to use the next method that
comes along, more than mixing and matching notations to create the multiple
views necessary for today's problems.  It means you can add to the notation you
select, add to the semantics, add to the checking,  add to the code generation,
and more as you gain experience and understand that what you need is beyond
what the published methods offer.  Published methods,
especially the object oriented methods, are good starting points.  Your process
will mature past the published methods. You will need to recognize and capture
the information and relationships important for your problem space.  The
ObjectMaker TDK provides tailorable support which enables you to develop and
extend your own methods.  The TDK gives you the opportunity to use and reuse
your repository contents, your application models, your component libraries by
giving you the facilities for data and control integration with other life
cycle tools.
.np
Contact ObjectMaker marketing at 818 995 7671, fax 818 995 4267, or
objectmaker@markv.com.
.*

.*

.*

.section ProcessMaker (&cat)
.*
.np
.illust begin
Mark V Systems Ltd.
16400 Ventura Blvd., Suite 303
Encino, CA 91436


Sales:  (800) 995-7671
Tel:  (818) 995-7671
FAX:  (818) 995-4267
.illust end
.*
.np
.*
.ix 'ProcessMaker (&cat)'

.ix 'Mark V Systems Ltd.'

.ix '&cat'
.*
ProcessMaker (R) by Mark V Systems:  ProcessMaker is a specialized modeling
tool which is coupled to an underlying semantics repository and code/text
generator.  ProcessMaker supports many popular process diagram notations and
provides the user the capability to easily develop a graphic representation of
a process. Users needing to capture process models, work flow models or
enterprise models for process improvement, analysis, measurement, reuse, re-
engineering or enactment have the choice of using multiple notations to create
the views necessary for
these tasks. ProcessMaker will generate output to a variety of process
enactment products.  Additional process modeling notations, and other
techniques can be added to ProcessMaker using MethodMaker and ObjectMaker TDK
tools described above.  More than 15 notations are supported at this time
including the popular IDEF/IDEF1x, ProNet, Process Decision Program
Charts, Process Breakdown Structure Charts, YPL and Petri Nets.
.np
Contact ProcessMaker marketing at 818 995 7671, fax 818 995 4267 or
processmaker@markv.com.
.*

.*

.*

.section Graph Layout Toolkit (&cat)
.*
.np
.illust begin
Tom Sawyer Software
1828 Fourth Street
Berkeley, CA  94710


Sales:  800-929-TOMS
Tel:  (510) 848-0853
FAX:  (510) 848-0854
.illust end
.*
.np
.*
.ix 'Graph Layout Toolkit (&cat)'

.ix 'Tom Sawyer Software'

.ix '&cat'
.*
.illust begin
Tom Sawyer's Graph Layout Toolkit is a family of portable libraries that
deliver an immediate face-lift to graphics applications with their
sophisticated layout algorithms. The Graph Layout Toolkit libraries' logical
representation of objects and connections allow end users to more easily see
underlying relationships within complicated data. The libraries also work in
real time, rarely requiring more than a few seconds to produce quality output
even for large graphs with several hundred nodes.

Four extensible C++ class libraries that include ANSI C APIs make up the Graph
Layout Toolkit family: the Circular, Hierarchical, Orthogonal*, and Symmetric
Layout Libraries. All libraries share a common foundation.

* Orthogonal layout will be generally available with release 2.2 of the Graph
Layout Toolkit in the first quarter of 1996, but can be made available in pre-
release form for select customers.

The Hierarchical library is ideal for the layout of directed graphs.  For
example, it is excellent for drawing complicated function call graphs and for
layout of nested outline PERT charts used in project management applications.

The Circular library is ideal for layout of complicated ring and star
topologies. For example, it may be used to layout complicated IP networks where
devices on the same Class A, Class B or Class C network
or devices on the same subnet are placed around the same circle. It is also
excellent at relating geographic site based information within the framework of
a logical layout product. It functions by partitioning
nodes into logical groups based on a number of flexible node grouping models.
Each group of nodes is placed on radiating circles based on the interconnection
of these groups.

The Symmetric library exposes the natural symmetry inherent in many graph
structures. For instance, this library is superb at rendering arbitrary
enterprise-wide computer networks or mesh networks.

Navigation Features
-------------------------
Graphs help you to manage information, but one graph is often not sufficient.
We provide easy to use, yet powerful tools to help you to manage information
that often spans many graphs.

The Graph Layout Toolkit helps you write powerful graph editing applications
with intelligent window management. Set up hypertext like associations from
nodes and edges in a graph to other graphs whether they are displayed in the
same window or different windows.

Supported Environments
-------------------------
The Graph Layout Toolkit libraries operate with most major operating systems,
compilers and GUI Toolkits. Support is also provided for the ANSI C compiler
designed to work with these C++ compilers listed below.

Sun SPARCstation:
    SunOS 4.1.x: Sun C++, GNU C++, MetaWare C++ and CenterLine C++
    Solaris 2.x: Sun C++, GNU C++, MetaWare C++ and CenterLine C++
HP 9000: HP C++, GNU C++
SGI Iris: SGI C++
IBM RS/6000: IBM C++
NeXT: NeXT C++
DEC OSF/1: DEC C++

Tom Sawyer Software is one of seven software companies nationwide to win the
U.S. Department of Commerce, National Institute of Standards and Technology's
Advanced Technology Program (ATP) award grant (95-09) for Component Based
Software Technology Development in 1995.
.illust end
.*

.*

.*

.section Zinc Application Framework (&cat)
.*
.np
.illust begin
Zinc Software Inc.
405 South 100 East  2nd Floor
Pleasant Grove, Utah  84062


Sales:  (800) 638-8665
Tel:  (801) 785-8900
FAX:  (801) 785-8996
.illust end
.*
.np
.*
.ix 'Zinc Application Framework (&cat)'

.ix 'Zinc Software Inc.'

.ix '&cat'
.*
Zinc Application Framework 4.1 is an object-oriented, cross-platform,
internationalized, class library and visual development tool.  Zinc supports
Symantec C++ 7.0 for DOS (both Text Mode and Graphics Mode), Microsoft Windows,
Win32 and Apple Macintosh (required Symantec C++
7.0 for Macintosh).  Zinc 4.0 also supports Windows NT, IBM OS/2, OSF/Motif,
Curses, NEXTSTEP and DESQview/X.  All platforms are supported with one set of
source code.
.np
Zinc 4.1 offers a comprehensive feature set including the following objects:
drag and drop, geometry management, scrolling windows, event mapping, palette
mapping, table, printer, notebook, status bar, tool bar, formatted string,
date, time, number (with currency), bitmap buttons, lists, combo box and many
more.
.np
Zinc Designer is the only visual development tool that creates and stores
platform-independent, user-interface objects.  Developers can interactively
drag and drop interface objects to develop application screens on any platform
that Zinc supports.  Twenty two full featured object editors give direct access
to all library-level features for each object.  Zinc Designer also features an
image editor for bitmaps and icons, a message editor and a defaults editor for
Help and System
information.  Zinc POST (Persistent Object Storage Technology) provides robust
platform-independent resources.  These binary files can be moved transparently
across platforms and are easily internationalized.
.np
Zinc 4.1 supports 13 languages and 19 country locales.  Developers can use a
single set of source code to support single-byte (ISO) languages such as
English, French and German as well as double-byte (Unicode) languages such as
Japanese, Korean and Chinese.
.np
The product includes the library, Zinc Designer and full source code.
.*
.figure *depth='2.75' *scale= *file='zinc'
.*

.*
:set symbol="cat" value="CAD/CAM Libraries"

.chap CAD/CAM Libraries
.*
.np
The following section contains listings for CAD/CAM libraries
supporting Watcom C or C++.
.*

.section CAD/CAM Developer's Kit (&cat)
.*
.np
.illust begin
Building Block Software
77 Pearson Road
Somerville, MA  02144


Tel:  (617) 628-5217
FAX:  (617) 628-6333
.illust end
.*
.np
.*
.ix 'CAD/CAM Developer's Kit (&cat)'

.ix 'Building Block Software'

.ix '&cat'
.*
The 'CAD/CAM Developer's Kit' libraries provide ANSI C functions which support
core CAD/CAM features for custom applications including: area booleans,
boundary offsets, mill/turn toolpaths; reading & writing all DXF entitities R10-
12 ; 2D/3D wireframe display; 2D & 3D lines, arcs, circles, ellipses, NURB
splines; transforms; intersect/trim/fillet; can be used for
DOS/Windows/ADS/UNIX applications.
.*

.*

.*

.section TG-CAD 2D (&cat)
.*
.np
.illust begin
Disk Software Inc.
109 S. Murphy Road
Plano, Texas  75094


Sales:  (800) 635-7760
Tel:  (214) 423-7288
FAX:  (214) 423-7288
.illust end
.*
.np
.*
.ix 'TG-CAD 2D (&cat)'

.ix 'Disk Software Inc.'

.ix '&cat'
.*
This is a collection of over 400 2D device independent geometric routines.  The
library includes routines that create parametric lines, compute tangents and
normals, generate arcs, ellipses, circles, and 2D curves such as NURBS, Bezier,
B-Spline, Catmull-Rom, quadratic, and conics.  You can create a NURB curve that
interpolates through the control points.  You can compute a circle or arc that
is tangent to two or three circles, lines, and points.  This library contains a
rich assortment of intersection routines that compute the intersections of
lines, arcs, circles, curves and combinations thereof.  You can compute a
piecewise Bezier curve that will pass through a set of digitized points (great
for reproducing text and symbols).  You can determine the intersections,
unions, differences, of convex and concave polygons.  You can compute the
distance between points, lines, arcs and combinations thereof.  This product
gives you the ability to determine if points are outside, inside, or on the
edge of a polygon.  Also, there are 2D composite transformations such as scale,
rotate, shear, translate, reflect, and their respective inverse.  Included with
the library are routines that compute the surface area of 2D geometric shapes.
A wide range of vector computations are included.  You can decompose a concave
polygon into a series of convex polygons.  You can compute the offset of a
polyline made up of line segments and arcs.  A complete entity library is
included that gives you the ability to maintain data that describes a geometric
entity.  This information includes athe geometric data that describes the
entity plus color, line style, entity coordinate system, layer, and more.  Two
dimensional entities include Point, Line, Polyline, Text, Fill, Dimension,
Circle, Arc, Shape, Insert, Viewport, and more.  Manual & example programs
included.  Source Code Available, 30 day limited guarantee.
.*

.*

.*

.section TG-CAD 3D (&cat)
.*
.np
.illust begin
Disk Software Inc.
109 S. Murphy Road
Plano, Texas  75094


Sales:  (800) 635-7760
Tel:  (214) 423-7288
FAX:  (214) 423-7288
.illust end
.*
.np
.*
.ix 'TG-CAD 3D (&cat)'

.ix 'Disk Software Inc.'

.ix '&cat'
.*
This is a collection of over 400 3D geometric routines.  The library includes a
wide range of routines that generate B-Spline, Catmull-Rom, Bezier, quadratic
and NURBS surfaces and curves.  The library makes it easy to compute normals
and tangents to curves and surfaces.  You can perform 3D polygon planar
clipping and view clipping.  View clipping allows you to clip a scene to a
specific view volume.  You can create wire frames of solids such as spheres,
paraboloids, hyperboloids, ellipsoids, regular polyhedrons, cones, cylinders,
pyramids, prisms and more.  You can create complete or partial surfaces of
revolution.  You can extrude solids based on a 2D shape.  There are hidden line
routines that can create scenes with all hidden lines removed.  You can specify
the color of the objects in the hidden transformations such as rotation, scale,
translate mirror and perspective and their respective inverses.  You can
compute the intersection of lines, planes, and curves.  You can create
perspective views of 3D objects or scenes.  Manual & example programs included.
Source code available.  30 day limited guarantee.
.*

.*

.*

.section TG-CAD Draw (&cat)
.*
.np
.illust begin
Disk Software Inc.
109 S. Murphy Road
Plano, Texas  75094


Sales:  (800) 635-7760
Tel:  (214) 423-7288
FAX:  (214) 423-7288
.illust end
.*
.np
.*
.ix 'TG-CAD Draw (&cat)'

.ix 'Disk Software Inc.'

.ix '&cat'
.*
A complete Drawing Library for Windows and DOS.  A complete set of 2D and 3D
(floating point) drawing routines for DOS and Windows.  The command set is the
same for Windows and DOS.  The drawing entities include:  Line, Arc, Circle,
Ellipse, Polyline, Curve, Surface, Solid, Text, Dimensions, Shapes, Insertions,
Blocks and more. Each of the entities can be drawn in 2D or 3D.  You can define
multiple viewports within a window.  Each viewport can have a different view of
an object or group of objects.  This allows you to combine 2D and 3D drawings
within the same window.  You can layer your drawings.  The library comes with
16 vector line styles or you can create your own.  Line styles can be scaled,
they are not pixel based.  Each entity can be drawn in its own coordinate
system.  This give you the ability to import symbols and blocks of data and
draw them at a specific location.  You can dimension your drawings.  All text
is vector based and can be drawn at any angle, size or direction.  You can
create your own text styles or use the ones provided with the library.  A
complete ray tracer and shading program is included with the library.  You can
specify multiple light sources using user defined surface properties such as
ambient lighting, diffuse lighting, and Phong highlights.  The shading program
creates spectacular images.  The images created can be output as GIP or PCX
files.  The library comes with a PCX/GIF viewer and a set of routines that will
read, write PCX or GIF file formats.  DXF files read by TG-CAD DXF Translator
can be drawn using the routines in this library.  In fact, the library comes
with a DXF Viewer coompiled and ready to use.  Manual & example programs
included.  Source code available.  30 day limited guarantee.
.*

.*

.*

.section TG-CAD Professional (&cat)
.*
.np
.illust begin
Disk Software Inc.
109 S. Murphy Road
Plano, Texas  75094


Sales:  (800) 635-7760
Tel:  (214) 423-7288
FAX:  (214) 423-7288
.illust end
.*
.np
.*
.ix 'TG-CAD Professional (&cat)'

.ix 'Disk Software Inc.'

.ix '&cat'
.*
A Complete CAD/CAM/CAE Graphics Developers Kit.  The professional version is a
combination of TG-CAD 2D v5.0, TG-CAD 3D v5.0, TG-CAD DXF Translator v2.0 and
TG-CAD Draw v2.0.
.*

.*

.*

.section TG-DXF Translator (&cat)
.*
.np
.illust begin
Disk Software Inc.
109 S. Murphy Road
Plano, Texas  75094


Sales:  (800) 635-7760
Tel:  (214) 423-7288
FAX:  (214) 423-7288
.illust end
.*
.np
.*
.ix 'TG-DXF Translator (&cat)'

.ix 'Disk Software Inc.'

.ix '&cat'
.*
A complete DXF Library for Windows and DOS.  This library gives you the ability
to read and write AutoCAD DXF files through release 12.  You can read AutoCAD
symbol/font files.  You read and write all DXF data structures.  Once you read
them into our data structures, you can use the DXF entities with the geometric
routines in TG-CAD 2D and 3D.  You can draw DXF files using TG-CAD Draw.  You
can read a single layer or all of the layers in a DXF file.  You can explode
AutoCAD DXF block entities into a series of entities.  Included with the
library is a program that will read a DXF file, expolode the blocks and write a
new file with the exploded blocks.  Manual & example programs included.  Source
code available.  30 day limited guarantee.
.*

.*

.*

.section AUTODIRECT (&cat)
.*
.np
.illust begin
Marcomp
13 Lauriann #100
Parkton, Maryland  21120


Tel:  (410) 343-2743
FAX:  (410) 357-8662
.illust end
.*
.np
.*
.ix 'AUTODIRECT (&cat)'

.ix 'Marcomp'

.ix '&cat'
.*
AUTODIRECT is a family of C programming libraries for direct access to DWG, DXF
and binary DXF files from AutoCAD versions 2.5 and up.  AUTODIRECT 2 libraries
provide the C programmer with a comprehensive set of functions to read and
write AutoCAD files, supporting all drawing entities, as well as block
definitions, header values, extended entity data, layer, linetype,
block, style, view, UCS and viewport lists.  AUTODIRECT 3 adds the ability to
vectorize AutoCAD files for display, and supports paperspace, external
references, and AutoCAD fonts (including bigfonts).  All AUTODIRECT versions
are able to open multiple files simultaneously.
.*

.*

.*

.section FontBUILDER (&cat)
.*
.np
.illust begin
Metagraphics Software Corporation
200 Clock Tower Place, Suite 201E

Carmel, CA  93922

Sales:  (800) 332-1550
Tel:  (408) 622-8950
FAX:  (408) 622-8955
.illust end
.*
.np
.*
.ix 'FontBUILDER (&cat)'

.ix 'Metagraphics Software Corporation'

.ix '&cat'
.*
Metagraphics FontBUILDER works with scaleable outline fonts to create high-
quality MetaWINDOW bitmap fonts at any size or resolution you specify.
FontBUILDER includes over 20 outline typefaces in four font families (Times,
Helvetica, Courier and Script), plus can import both
PostScript and TrueType fonts for conversion to bitmap fonts for use with
MetaWINDOW graphic toolkits.  Style facings include normal, bold, italic, thin,
condensed, wide, expanded, hollow - and
combinations thereof.  Virtually no limitiation on font point sizes.  Virtually
unlimited font rasterization resolutions.
.np
FontBUILDER works with MetaWINDOW for DOS, -286 or -386 protected mode.  All
fonts provided may be distributed Royalty Free.  Full 30-day product guarantee.
.*
.figure *depth='2.75' *scale= *file='metapowr'
.*

.*

.section FontWINDOW (&cat)
.*
.np
.illust begin
Metagraphics Software Corporation
200 Clock Tower Place, Suite 201E

Carmel, CA  93922

Sales:  (800) 332-1550
Tel:  (408) 622-8950
FAX:  (408) 622-8955
.illust end
.*
.np
.*
.ix 'FontWINDOW (&cat)'

.ix 'Metagraphics Software Corporation'

.ix '&cat'
.*
Metagraphics FontWINDOW provides an extended set of bitmap fonts, font tools
and font documentation for use with Metagraphics MetaWINDOW. Over 200
additional English and international font styles are provided.  The graphical
bitmap font editor allows you to create
custom fonts or foreign language character sets; merge characters from
different fonts to create a new font; create icons and animation fonts; or
create new bold-faced, italicized or rotated font sets.
.np
FontWINDOW works with MetaWINDOW-DOS, -286 or -386.  All fonts provided are
Royalty Free.  Full 30-day product guarantee.
.np
For additional information:
.np
CompuServe:        GO METAGR, LIB 12, download FWDEMO.ZIP
.br
Internet ftp:      ftp.metagraphics.com, download FWDEMO.ZIP
.br
Metagraphics BBS:  408-622-8945, download DEMO\\FWDEMO.ZIP
.*
.figure *depth='2.75' *scale= *file='metapowr'
.*

.*

.section MetAccel (&cat)
.*
.np
.illust begin
Metagraphics Software Corporation
200 Clock Tower Place, Suite 201E

Carmel, CA  93922

Sales:  (800) 332-1550
Tel:  (408) 622-8950
FAX:  (408) 622-8955
.illust end
.*
.np
.*
.ix 'MetAccel (&cat)'

.ix 'Metagraphics Software Corporation'

.ix '&cat'
.*
Metagraphics MetACCEL provides an enhanced set of MetaWINDOW graphic display
drivers for use with hardware-accelerated SuperVGA's such the ATI Graphics
Ultra, Diamond Stealth, Orchid Fahrenheit-1280, Actrix Graphics Engine, IBM
8514A, and many others.  MetACCEL with a
hardware accelerated graphics card can boost display performance more than 5 to
15 times over the speed of standard software-only SuperVGA's.  MetACCEL
supports popular hardware accelerated cards up to 1280x1024 256-color.
Optimized entirely in assembly language for
tight, fast code, MetACCEL provides unsurpassed graphics performance.  MetACCEL
includes a full set of MetaWINDOW display drivers for DOS, plus both 16-bit and
32-bit protected-mode.
Full 30-day product guarantee.
.*
.figure *depth='2.75' *scale= *file='metapowr'
.*

.*

.section MetaWINDOW (&cat)
.*
.np
.illust begin
Metagraphics Software Corporation
200 Clock Tower Place, Suite 201E

Carmel, CA  93922

Sales:  (800) 332-1550
Tel:  (408) 622-8950
FAX:  (408) 622-8955
.illust end
.*
.np
.*
.ix 'MetaWINDOW (&cat)'

.ix 'Metagraphics Software Corporation'

.ix '&cat'
.*
Metagraphics MetaWINDOW is a fast, comprehensive graphics toolkit that expands
the capabilties of your Watcom compiler library.  Optimized entirely in tight
assembly language code, MetaWINDOW provides a full set of graphic functions
for: points, lines, squares, rectangles, circles, ovals, arcs, polygons, bitmap
text, plus seed and boundary fills.  Enhanced features include: rounded-corner
rectangles, object hit detection, scaleable text, font facing, image
scaling, fill rules, dash styles, line cap styles, extended rasterOps, multi-
colored patterns and more.  MetaWINDOW also supports drawing to offscreen
bitmaps located in conventional, EMS, XMS or virtual disk memory.  Using
MetaWINDOW you can create multi-windowed applications, process
mouse/keyboard/timer events, and print graphics to popular laser and dot-matrix
printers.  MetaWINDOW additionally includes advanced features for: irregular-
area region clipping, Bezier curves and fills, PostScript style pens and lines,
colored cursors, hi-res cursors and patterns, and more.  MetaWINDOW supports
over 80 graphic display modes from Hercules to SuperVGA and VESA, up to
1280x1024 resolution.  Add expanded support for hardware
accelerated and hi-color SuperVGA's with optional MetACCEL and MetHICOLOR add-
on products.  MetaWINDOW-386 includes DOS real-mode, 286 protected-mode and 386
protected-mode libraries.  Top-rated performance and in a comprehensive
graphics toolkit has made
MetaWINDOW the professional choice for leading applications from Autodesk,
Borland International, Cadam/Altium, Hewlett-Packard, IBM, Maxis, SCO,
Symantec/Peter Norton, ...plus over a thousand others.
.np
Full source code is available, plus all products are Royalty-Free. Full 30-day
product guarantee.
.np
For additional information:
.np
CompuServe:        GO METAGR, LIB 12, download MWINFO.ZIP, MWDEMO.ZIP
.br
Internet ftp:      ftp.metagraphics.com, download MWINFO.ZIP, MWDEMO.ZIP
.br
Metagraphics BBS:  408-622-8945, download DEMO\\MWINFO.ZIP, MWDEMO.ZIP
.*
.figure *depth='2.75' *scale= *file='metapowr'
.*

.*

.section MetHICOLOR (&cat)
.*
.np
.illust begin
Ted Gruber Software
PO Box 13408
Las Vegas, NV  89112


Tel:  (702) 735-1980
FAX:  (702) 735-4603
.illust end
.*
.np
.*
.ix 'MetHICOLOR (&cat)'

.ix 'Ted Gruber Software'

.ix '&cat'
.*
Metagraphics MetHICOLOR provides an advanced set of MetaWINDOW graphic display
drivers for use with new high-color SuperVGA's such as the ATI VGA Wonder,
Diamond Stealth, Orchid ProDesigner, and many others.
.np
MetHICOLOR allows you to create 16 bit-per-pixel graphics applications with
near photorealistic images up to 1280x1024 resolution with up to 65,536
displayable colors.  Optimized entirely
in assembly language for tight, fast code, MetHICOLOR provides unsurpassed
graphics performance.  MetACCEL includes a full set of MetaWINDOW display
drivers for DOS, plus both 16-bit and 32-bit protected-mode.  Applications
distributed using MetHICOLOR are
Royalty-Free.
.*
.figure *depth='2.75' *scale= *file='metapowr'
.*

.*

.section PCX-Lab (&cat)
.*
.np
.illust begin
Ted Gruber Software
PO Box 13408
Las Vegas, NV  89112


Tel:  (702) 735-1980
FAX:  (702) 735-4603
.illust end
.*
.np
.*
.ix 'PCX-Lab (&cat)'

.ix 'Ted Gruber Software'

.ix '&cat'
.*
Metagraphics PCX-Lab provides an expanded set of MetaWINDOW routines for
working with PCX image files and DCX image file libraries. PCX-Lab supports
popular monochrome, 16-color, 256-color and 16-bit/pixel high-color PCX image
file formats.  PCX-Lab lets you read PCX/DCX image files to the screen or to
off-screen bitmaps located in conventional, EMS, XMS or disk-cached virutal
memory.  PCX image files can be written from either on-screen or off-screen
bitmaps buffers.  PCX-Lab functions allow you to: read and write PCX images
from files or memory buffers; get, set and update palette settings; scroll,
scale, rotate and clip PCX images to the screen or off-screen bitmaps; access
PCX header file information; plus output PCX images to popular laser and dot-
matrix printers.  PCX-LAB includes a full set of MetaWINDOW compatible
libraries for DOS, plus both 16-bit and 32-bit protected-mode.  Applications
distributed
using PCX-Lab are Royalty-Free.
.*
.figure *depth='2.75' *scale= *file='metapowr'
.*

.*
:set symbol="cat" value="Class Libraries"

.chap Class Libraries
.*
.np
The following section contains listings for class libraries supporting
Watcom C or C++.
.*

.section Math++ (&cat)
.*
.np
.illust begin
Advanced Computing Labs
P.O. Box 1547
West Chester, Ohio  45071


Sales:  (800) 430-5227
Tel:  (513) 779-2716
FAX:  (513) 779-4010
.illust end
.*
.np
.*
.ix 'Math++ (&cat)'

.ix 'Advanced Computing Labs'

.ix '&cat'
.*
Todays advanced technologies require complex solutions: Math++ takes away some
of the complexity so that you can focus on the application.
.np
Every matrix class can be initialized with random numbers based on uniform,
Bernoulli, binomial, custom (derived directly from data), exponential, gamma,
normal, and Poisson distributions.
Numerous intelligent operators perform matrix arithmetic easily and
efficiently.
.np
Copy and paste data among different matrices. Overloaded iostream operators
provide unlimited flexibility in implementing object persistence. Other member
functions include inverse, resize, mean, trace, transpose, variance ...  Global
(friend) functions extend the usability of matrices and vectors with functions
like: abs, acos, asin, atan, betaDist, .... sort, sqrt, sum, tan, tanh.
Complex numbers, matrices, and vectors are fully supported.
.np
Math++ vector classes behave like the mathematical constructs that you're
already familiar with. Given a column vector of length n multiply it by a row
vector of length m and you get a matrix of
size nxm - try doing that with other math libraries...
.np
Solutions to real and complex linear equations of the form AX = B, where B is
the constants vector, A is the coefficient matrix, and X is the vector of
unknowns, are easily obtained by creating an LU decomposition server object.
.np
Math++ offers two random number generation algorithms: select between the
highly efficient minimal standard algorithm with period 2^31, or the perfect
pseudo-random number generator with
period 261.  Generate random deviates from uniform, Bernoulli, binomial, custom
(derived directly from data), exponential, gamma, normal, and Poisson
distributions. Create an arbitrary number of
completely independent random deviate generators simultaneously!
.np
The precisely documented FFT server does forward and inverse transforms,
convolution, and correlation of arbitrary length 2^n real and complex vectors.
Approximate data with linear or
non-linear functions, including polynomial, logarithmic, exponential, and power
functions.
.np

To order call: 1-800-430-LABS, FAX 1-513-779-2716
.*
.figure *depth='2.75' *scale= *file='math'
.*

.*

.section Neural L++ (&cat)
.*
.np
.illust begin
Advanced Computing Labs
P.O. Box 1547
West Chester, Ohio  45071


Sales:  (800) 430-5227
Tel:  (513) 779-2716
FAX:  (513) 779-4010
.illust end
.*
.np
.*
.ix 'Neural L++ (&cat)'

.ix 'Advanced Computing Labs'

.ix '&cat'
.*
The Neural++ library features a fully object oriented design, utilizing
features like class inheritance, virtual functions, and object persistence. The
object granularity extends to the
level of layers, collections of fully interconnected neurons. Weight (or
connection) matrices are implemented as objects of class DMatrix, a full-
featured general purpose matrix class (Math++).
.np
Neural++ was developed using Math++, a general purpose C++ mathematics library
from Advanced Computing Labs. The Neural++ package includes the Math++ library.
.np
Imagine having the full functionality of a mathematics library at your
disposal, ready to be applied to your data, to sets of neurons, to weight
matrices, to experimental neural networks, to anything you can imagine, to
anything you dare imagine...
.np
Imagine the power of an object oriented mathematical development library
designed with the needs of your neural network in mind! Or, stop imagining and
get your hands on Neural++ today!
.np
.illust begin
For example, this is the code needed to create and train a 2 layer BP
(backpropagation) neural network:

BP bpnet( 5, 10, 1 );
    /* BP object: 5 input nodes, 10 hidden, 1 output neuron */
NNData Data;
    /* uninitialized Data object
*/
Data.useDataFile('parity.dat');
    /* initial with raw data from file parity.dat                         */
double error;
while ((error = bpnet.train( &Data, bp_epoch)) > 0.05)
  cout << 'Error ' << error << endl;
.illust end
.np
Math++ library functions can be used to great advantage. For example, to
compute the variance of all data samples corresponding to input node 1,
Neural++ and Math++ functions can be combined:   double variance =
(Data.getData( 1 )).variance(); What could possibly be easier than that!
.np
Neural++ includes Neural++ Tools, a collection of prompt-driven command line
utilities that provide easy access to complex neural objects. Neural++ comes
with close to 600 pages of text
including numerous examples, hints, and complete class by class reference
sections. Neural++ Tools features step-by-step tutorials, walking you through
the tasks of setting up a neural network
project, pre-processing training and validation data, and training a neural
network.
.np
Neural++ object library available for DOS and NT based compilers. Neural++
source code sold separately, requires non-disclosure. Math++ object library
included, source sold separately. No royalties.
.np

To order call: 1-800-430-LABS, FAX 1-513-779-2716
.*
.figure *depth='2.75' *scale= *file='neural'
.*

.*

.section Dynace OO Extension to C (&cat)
.*
.np
.illust begin
Algorithms Corporation
3020 Liberty Hills Drive
Franklin, TN  37064


Tel:  (615) 791-1636
FAX:  (615) 791-7736
.illust end
.*
.np
.*
.ix 'Dynace OO Extension to C (&cat)'

.ix 'Algorithms Corporation'

.ix '&cat'
.*
.illust begin
Dynace Object Oriented Extension To C (Dynace)
------------------------------------------------------------------------------
.illust end
.np
Dynace is a preprocessor, include files and a library which extends the C
language with advanced object oriented capabilities, automatic garbage
collection and multiple threads.  Dynace is designed to solve many of the
problems associated with C++ while being easier to learn
and containing more flexable object oriented facilities.  Dynace is able to add
facilities previously only available in languages such as Smalltalk and CLOS
without all the overhead normally associated with those environments.
.*
.figure *depth='2.75' *scale= *file='algologo'
.*

.*

.section Dynace Windows Development System (&cat)
.*
.np
.illust begin
Algorithms Corporation
3020 Liberty Hills Drive
Franklin, TN  37064


Tel:  (615) 791-1636
FAX:  (615) 791-7736
.illust end
.*
.np
.*
.ix 'Dynace Windows Development System (&cat)'

.ix 'Algorithms Corporation'

.ix '&cat'
.*
Dynace Windows Development System (WDS)
-------------------------------------------------------------------------
The Dynace Windows Development System (WDS) is a Dynace class library which
enables a C programmer with no knowledge of C++, Dynace, the Windows API or
message-driven architecture to write real Windows applications with an absolute
minimum learning curve and number of lines of code.  In fact, it is possible to
become familiar enough with windows, menus, dialogs and controls using WDS to
write a Windows application after just one day!  A 'Hello World' program takes
only four lines of code!
.*
.figure *depth='2.75' *scale= *file='algologo'
.*

.*

.section Menuet/CPP (&cat)
.*
.np
.illust begin
Autumn Hill Software
1145 Ithaca Drive
Boulder, Colorado 80303


Tel:  (303) 494-8865
FAX:  (303) 494-7802
.illust end
.*
.np
.*
.ix 'Menuet/CPP (&cat)'

.ix 'Autumn Hill Software'

.ix '&cat'
.*
If you're looking for a sophisticated versatile, powerful, easy to use, and
good looking development framework for DOS, then look no further.  Menuet/CPP
has proven to be this and more in a wide range of developer settings, from one-
man shops to Fortune 500 I.S. departments.  We support all major DOS compilers
as well as low-level graphics packages from MetaGraphics and Flash-Tek and
extenders from Flash Tek, Phar Lap, and Tenberry Systems. Menuet provides all
of the important components needed to get an application up and running.
There's a wide range of general purpose classes and a dilaogs library
containing many pre-built dialogs.  We-ve also included a large collection of
icons and fonts and the best icon and font editors you'll find anywhere.
.*

.*

.*

.section Menuet/CX (&cat)
.*
.np
.illust begin
Autumn Hill Software
1145 Ithaca Drive
Boulder, Colorado 80303


Tel:  (303) 494-8865
FAX:  (303) 494-7802
.illust end
.*
.np
.*
.ix 'Menuet/CX (&cat)'

.ix 'Autumn Hill Software'

.ix '&cat'
.*
 Menuet/CX is the fourth generation of the Menuet family of GUI Application
Frameworks.  Menuet/CX delivers a new level of excellence in cross-platform GUI
application frameworks for the professional developer who is concerned about
aesthetics as well as efficiency.  Menuet/CX provides a high quality visual
presentation for you application while taking minimal resources. With its
visual design editors, you get to produce functional and  artistic results
fast.  Menuet/CX supports OS/2 2.x and Warp, MS-Windows 3.x, MS-Windows 95, and
Windows NT along with all
major compilers on these platforms.
.*

.*

.*

.section C/C++ Data Object Library (&cat)
.*
.np
.illust begin
Code Farms Inc.
7214 Jock Trail
Richmond, Ont.  K0A 2Z0
Canada

Tel:  (613) 838-4829
FAX:  (613) 838-3316
.illust end
.*
.np
.*
.ix 'C/C++ Data Object Library (&cat)'

.ix 'Code Farms Inc.'

.ix '&cat'
.*
 New concept of C++ class library with all data structures and container
classes, from lists, hash tables, ER models to run-time extensible objects, and
virtual disk access. Extremely fast and efficient, useful especially for large
projects - see the book 'Taming C++' by J.Soukup.
.np
Treats data structures as design patterns. Represents relations as objects, and
improves maintenance by removing cyclic dependency among classes.
Automatically persistent data do not require user-coded I/O functions for every
new class. Generates fast frameworks and OO databases.  Prevents dangling
pointers, includes memory management and automatic paging to disk. Portable
data and programs. Complete source, no royalties.
.np
Price: US299 one user DOS/WINDOWS/MAC US599 one UNIX workstation
.*

.*

.*

.section Yacc++ and the Language Objects Library (&cat)
.*
.np
.illust begin
Compiler Resources
85 Main Street, Suite 310
Hopkinton, MA  01748


Tel:  (508) 435-5016  x.2
FAX:  (508) 435-4847
.illust end
.*
.np
.*
.ix 'Yacc++ and the Language Objects Library (&cat)'

.ix 'Compiler Resources'

.ix '&cat'
.*
.illust begin
Product Name:  Yacc++ and the Language Objects Library
Product Category:  LEX and YACC Utilities
This product supports:  Watcom C/C++ 10.5 (any 32 bit target)
.illust end
.np
Yacc++ is Object-Oriented Successor to Lex and YaccYacc++ and the Language
Objects Library from Compiler Resources, Inc. is an object-oriented rewrite of
lex and yacc which creates C++ classes from grammars.
.np
.illust begin
* Yacc++ directly translates regular expressions without introducing artificial
productions and produces minimal state LR(1) lexers and parsers.
* Multiple lexer and parser objects can be active concurrently and are fully
reentrant.
* Automatic class generation for ASTs (abstract syntax trees) per token, parser
non-terminal, or alternative.
* Multiple inheritance features for modularizing and reusing grammars.
* Grammar classes can be dynamically bound to lexer and parser objects.
* Multiple entry point grammars allow the matching of partial parse trees.
* Lexer and parser objects act as call-back coroutines within Windows, Motif,
and other event driven applications.
* Yacc++ comes with the Language Objects Library, a C++ class library with
syntactic and semantic support for building applications.  The library provides
base classes which define lexer, parser, input, AST, symbol table, and error
objects.
* Includes three ready to run example applications, a complete reference
manual, a comprehensive tutorial guide, sources to the class library, and a set
of tutorials with one hundred sample grammars.
.illust end
.np
.illust begin
ISV Contact Person:  Barbara ZinoSales
Information (for publication):
.illust end
.np
.illust begin
Compiler Resources, Inc.
Main Street, Suite 310
Hopkinton, MA  01748
Phone: (508) 435-501685
Fax: (508) 435-4847
E-mail: compres@world.std.com
.illust end
.*

.*

.*

.section Greenleaf ArchiveLib (&cat)
.*
.np
.illust begin
Greenleaf Software, Inc.
16479 Dallas Parkway, Suite 570
Dallas, Texas 75248


Sales:  (800) 523-9830
Tel:  (214) 248-2561
FAX:  (214) 248-7830
.illust end
.*
.np
.*
.ix 'Greenleaf ArchiveLib (&cat)'

.ix 'Greenleaf Software, Inc.'

.ix '&cat'
.*
Greenleaf ArchiveLib provides the developer with a set of classes and functions
to compress and store ASCII and binary data into an archive for storage, as
well as to retrieve and expand the stored data from the archive.  Data is
compressed and expanded using a proprietary algorithm.  Uncompressed data can
be situated in a file or a memory buffer.  ArchiveLib has been designed to be
flexible for handling any type of data that developers require.  The series of
classes and functions in ArchiveLib is geared to the C++ or C programmer, but
maintains language independence.  It contains a variety of functions to add,
replace, delete, update and retrieve objects of compressed data within the
archive.  ArchiveLib is available as a DLL for access by Windows 3.1 and
Windows NT developers.  Includes complete, fully commented, ANSI C compliant
source code and is royalty free.  Supports most popular C/C++ compilers.
.*
.figure *depth='2.75' *scale= *file='green1'
.*

.*

.section Greenleaf Comm++ (&cat)
.*
.np
.illust begin
Greenleaf Software, Inc.
16479 Dallas Parkway, Suite 570
Dallas, Texas 75248


Sales:  (800) 523-9830
Tel:  (214) 248-2561
FAX:  (214) 248-7830
.illust end
.*
.np
.*
.ix 'Greenleaf Comm++ (&cat)'

.ix 'Greenleaf Software, Inc.'

.ix '&cat'
.*
Comm++ will accommodate interrupt-driven, circular buffered service for 35
ports at baud rates to 115, 200 baud.  As a C++ communication library, it
provides a hierarchy of classes which give the programmer simple access and
control of serial communications.  Classes are provided for: serial port
controls, modem controls including NASI support for modems on NOVELL networks,
file transfer protocols and calculation of check values.  In addition to this,
there are classes that support hardware dependent features.  These classes are
derived from an abstract base class.  Features include support for Hayes
Smartmodems(tm), XMODEM, YMODEM, ZMODEM, Kermit and CompuServe B+ transfer
protocols, XON/XOFF, RTS/CTS flow control, and VT52, VT100 (subset) ANSI,
terminal emulation.  Support is included for MSDOS, 32 bit MSDOS protected
mode, Microsoft Windows 3.1, Windows NT (DLL's and WIN32s thunking layer
included for Windows 3.1 and NT)along with OS/2.  An automated installation
procedure and examples are included.  The programmer receives access to the
technical BBS, free technical support, source code and a quarterly product
newsletter.  No royalties.
.*
.figure *depth='2.75' *scale= *file='green3'
.*

.*

.section MEWEL (&cat)
.*
.np
.illust begin
MAGMA Software Systems
15 Bodwell Terrace
Millburn, New Jersey 07041


Tel:  (201) 912-0192
FAX:  (201) 912-0103
.illust end
.*
.np
.*
.ix 'MEWEL (&cat)'

.ix 'MAGMA Software Systems'

.ix '&cat'
.*
MEWEL 4.1 is a cross-platform user interface tookit which gives your
application complete portability between Microsoft Windows, DOS text, DOS
graphics, OS/2 text, UNIX text, and OSF Motif. Since MEWEL's API is compatible
with the standard Microsoft Windows API, you can easily port programs between
Windows and any of the environments which MEWEL supports,
even if you already have existing Windows programs.
.np
Programmers can develop new stand-alone applications using MEWEL, or can port
their existing Windows applications to any of the platforms which MEWEL
supports. MEWEL supports Windows 3.x features such as Control windows (listbox,
combo, radio, checkbox, pushbutton, scrollbars, single & multi-line edit,
static) Multiple Document Interface (MDI) Dialog Boxes Overlapping Windows with
moving and resizing Multi-level Menus Mouse Windows BMP files (blitting,
stretching, compressing) PCX files Icons (character and graphical) Multiple
proportional fonts MEWEL supports the Watcom 10.5 32-bit compiler, and the DOS
4G/W and Pharlap TNT DOS extenders. The DOS Graphics version supports the
MetaWindows 386 and Watcom graphics libraries.
.*
.figure *depth='2.75' *scale= *file='wmewlgui'
.*

.*

.section Media!Lab (&cat)
.*
.np
.illust begin
Metagraphics Software Corporation
200 Clock Tower Place, Suite 201E

Carmel, CA  93922

Sales:  (800) 332-1550
Tel:  (408) 622-8950
FAX:  (408) 622-8955
.illust end
.*
.np
.*
.ix 'Media!Lab (&cat)'

.ix 'Metagraphics Software Corporation'

.ix '&cat'
.*
MEDIA!LAB(tm) is a powerful multimedia programming toolkit that lets you create
stunning interactive graphic programs, animated titles and games better and
faster than ever before.  MEDIA!LAB combines imaging, animation, video,
sprites, special effects and sound in a
streamlined C/C++ programming toolkit.  Optimized in assembly language for
quick tight code, MEDIA!LAB pushes the limits for fast Windows performance.
.np
MEDIA!LAB provides a powerful suite of fast interactive graphic capabilities
supporting BMP/PCX/DCX image files, AVI/FLC/FLI video, sprite animation,
transparent 'blue screen' cinematic animation, sound, timer controls, fade and
wipe effects, color-palette animation, object hit and collision detection,
bitmap tiling, and more.  MEDIA!LAB can be used by itself, or in combination
with other C++ class libraries such as MFC or OWL.
.np
MEDIA!LAB comes with a comprehensive developer's manual, on-line hypertext
help, and is backed by Metagraphics support and a full 30-day guarantee.  Full
source code is available, plus all products are Royalty-Free.
.np
For additional information:
.np
CompuServe: GO METAGR, LIB 12, download MLINFO.ZIP
.br
Internet ftp: ftp.metagraphics.com, download MLINFO.ZIP
.br
Metagraphics BBS: 408-622-8945, download DEMO\\MLINFO.ZIP
.br
.*

.*

.*

.section smx++ (&cat)
.*
.np
.illust begin
Micro Digital, Inc.
12842 Valley View Street
Garden Grove, CA 92649


Sales:  (800) 366-2491
Tel:  (714) 373-6862
FAX:  (714) 891-2363
.illust end
.*
.np
.*
.ix 'smx++ (&cat)'

.ix 'Micro Digital, Inc.'

.ix '&cat'
.*
smx++ is a C++ class library which rests on top of smx.  The smx++ Application
Program Interface (API) is designed to mirror smx yet be simpler and easier to
use.  In most cases, smx++ methods call their smx counterparts for system
services.
.np
A chief advantage of smx++ is that it provides a simpler API which meets most
user requirements.  With this in mind, several seldom-used smx features and
functions have been omitted.  Yet,
since smx underlies smx++, direct smx calls are still possible.  This feature
eases the transition from C to C++ by permitting a mix of C and C++ application
modules.
.np
smx++  supports Borland C++ and Microsoft C++.  From the C++ developer's
perspective, the enticing aspect of smx++ is that it allows him to create his
own objects, by inheritance, from smx++ classes.  For example, device drivers
can be derived from the Bucket and Pipe classes  (which, in turn, have been
derived from the Software I/O bus (SIObus) class.)  Process classes can be
derived from a mixture of  smx++ objects to perform  specific work functions.
Actual processes (objects) can be  conveniently created when needed and deleted
when  not
needed.
.np
smx++ consists of 9 base  classes and 7 derived classes.  The class hierarchy
is deliberately shallow in order to achieve the speed necessary for real time
systems.
.*

.*

.*

.section STL <Toolkit> (&cat)
.*
.np
.illust begin
ObjectSpace, Inc.
14881 Quorum Drive
Suite 400
Dallas, TX  75240

Tel:  (214) 934-2496
FAX:  (214) 663-9100
.illust end
.*
.np
.*
.ix 'STL <Toolkit> (&cat)'

.ix 'ObjectSpace, Inc.'

.ix '&cat'
.*
.illust begin
Systems<ToolKit> is a cross-platform, ANSI-compliant C++ library that includes
a comprehensive implementation of the Standard Template Library (STL), the
ANSI/ISO string, time, date, time zone, portable error handling, threads,
synchronization, binary streaming, sockets and other
system programming classes.

The Systems<ToolKit> binary streaming system allows you to stream your own
objects, STL containers, and other vendor's objects into a file or across a
network.  Unlike other vendor's, the streaming system allows you to add
lightweight persistence to your classes without modifying their
inheritance structure.
 ------------------------------------------------------------------------------
----------------------------------
STL<ToolKit>

STL<ToolKit> is a cross-platform, ANSI-compliant C++ library that includes a
comprehensive implementation of the Standard Template Library (STL), the
ANSI/ISO string, 64-bit time and date, time zone, threads and synchronization.
.illust end
.*

.*

.*

.section Systems Toolkit (&cat)
.*
.np
.illust begin
ObjectSpace, Inc.
14881 Quorum Drive
Suite 400
Dallas, TX  75240

Tel:  (214) 934-2496
FAX:  (214) 663-9100
.illust end
.*
.np
.*
.ix 'Systems Toolkit (&cat)'

.ix 'ObjectSpace, Inc.'

.ix '&cat'
.*
Systems<ToolKit> is a cross-platform, ANSI-compliant C++ library that includes
a comprehensive implementation of the Standard Template Library (STL), the
ANSI/ISO string, time, date, time zone, portable error handling, threads,
synchronization, binary streaming, sockets and other
system programming classes.

The Systems<ToolKit> binary streaming system allows you to stream your own
objects, STL containers, and other vendor's objects into a file or across a
network.  Unlike other vendor's, the streaming system allows you to add
lightweight persistence to your classes without modifying their
inheritance structure.
 ------------------------------------------------------------------------------
----------------------------------
STL<ToolKit>

STL<ToolKit> is a cross-platform, ANSI-compliant C++ library that includes a
comprehensive implementation of the Standard Template Library (STL), the
ANSI/ISO string, 64-bit time and date, time zone, threads and synchronization.
.*

.*

.*

.section CodeBase (&cat)
.*
.np
.illust begin
Sequiter Software, Inc.
Suite 209, 9644 - 54 Avenue
Edmonton, Alberta, Canada T6E 5V1


Tel:  (403) 437-2410
FAX:  (403) 436-2999
.illust end
.*
.np
.*
.ix 'CodeBase (&cat)'

.ix 'Sequiter Software, Inc.'

.ix '&cat'
.*
CodeBase 5.1 is a multi-user Xbase compatible C/C++ library for database
management.  With CodeBase, your applications can use any of the five most
popular indexing formats as well as their associated memo files:  FoxPro 2.0
(.CDX, .IDX), dBASE IV (.MDX), dBASE  III
PLUS (.NDX), and Clipper (.NTX).  CodeBase 5.1 also provides record and file
locking that is compatible with the multi-user versions of dBASE IV, FoxPro 2
and Clipper.  Easy to use,... Named like familiar dBase commands, CodeBase 5.1
functions reduce your learning curve by
allowing  you to use your xBase expertise right away.  CodeBase 5.1
applications automatically utilize our new Bit Optimized Query Technology to
return query results on a 500,000 record data file in just one second!
CodeReporter 2.0 and special CodeBase 5.1 reporting functions make designing
and generating reports from your C/C++ applications simple.  CodeBase 5.1,
combined with CodeControls 2.0 our Data Aware custom controls, turn your
favorite compiler into a
visual development environment.  The Standard version of CodeBase 5.1 supports
most compilers under DOS, OS/2 and Windows, and Windows NT.  Upgrade to the
special Multi-Platform version of CodeBase 5.1 to port your application to
UNIX, SUN, AIX and The Macintosh.  (CodeBase 5.1 includes: complete library
Source Code,  CodeReporter 2.0,
CodeControls 2.0 and Royalty Free distribution of your application.)
.*

.*

.*

.section TOUCH-GUI for 32-bit OS/2 (&cat)
.*
.np
.illust begin
SOFTPRO GmbH
Wilhelmstrasse 34
71032 Boeblingen, Germany


Tel:  49 7031 6606-0
FAX:  49 7031 6606-66
.illust end
.*
.np
.*
.ix 'TOUCH-GUI for 32-bit OS/2 (&cat)'

.ix 'SOFTPRO GmbH'

.ix '&cat'
.*
PROFESSIONAL SOFTWARE DEVELOPMENT WITH TOUCH-GUI 2.11 FOR 32BIT OS/2
.np
TOUCH-GUI
.np
is an object-oriented, 32bit C++ class library, which supports mutitasking and
client/server architecture. It includes classes to abstractly handle OS/2 PM
and high-level classes for the applications themselves.
.np
The Product
.np
TOUCH-GUI contains more than 150 C++ classes, which handle the various OS/2 PM
events automatically, but will notify the user of the class, if he so wishes.
These classes support windows, multithreading, menu bars, dialog boxes,
controls (including all OS/2 2.x controls: slider, value set (toolbar),
notebook, container), graphics, printer control, MDI, DDE, Drag and Drop,
loadable resources from DLL's and EXE's, and management of profiles (.INI
files).
.np
Other features include auxiliary classes for comfortable data manipulation and
storage management.
.np
Additionally, TOUCH-GUI contains high-level classes like formatted entry
fields, tables, bitmaps, and NLS (National Language Support).
.np
TOUCH-GUI supplies abstract base classes, which will never have an instance,
but contain the common abilities of various objects. An example is the class
C_WINDOW that defines all common attributes and action schemes for C_VIEW,
C_APPVIEW, and additional PM objects. An
action scheme is a reaction to PM events like resize, move, drag, clip, and
others.
.np
As a special feature, TOUCH-GUI has the ability to find instances of objects
which have been created, but never deleted. This is a very important feature to
improve the quality of an
application program.
.np
All together, these classes build a complete, easy to use class library.
.np
SAA/CUA Standard
.np
TOUCH-GUI fully conforms to the IBM SAA/CUA standard.
.np
System Requirements
.np
- PC with 80386 or higher and 8MB RAM (recommended: 80486 with 16MB RAM for
development)
.br
- OS/2 2.0 or higher (recommended: OS/2 3.0)
.*

.*

.*

.section RC/21 (&cat)
.*
.np
.illust begin
Vermont Database Corporation
400 Upper Hollow Hill Road
Stowe, Vermont  05672


Sales:  (800) 822-4437
Tel:  (802) 253-4437
FAX:  (802) 253-4146
.illust end
.*
.np
.*
.ix 'RC/21 (&cat)'

.ix 'Vermont Database Corporation'

.ix '&cat'
.*
RC/21 is a set of relational database management functions and classes that
perform high-level operations similar to SQL.  RC/21 contains many features not
normally found in a callable database product, including free-text search in
columns, extended BLOB operations with embedded navigation structures and high-
level query language.   ODBC drivers and server configurations are available
for a number of networks and multiprocess operating environments.  Source is
also available.
.*

.*

.*

.section Zinc Application Framework (&cat)
.*
.np
.illust begin
Zinc Software Inc.
405 South 100 East  2nd Floor
Pleasant Grove, Utah  84062


Sales:  (800) 638-8665
Tel:  (801) 785-8900
FAX:  (801) 785-8996
.illust end
.*
.np
.*
.ix 'Zinc Application Framework (&cat)'

.ix 'Zinc Software Inc.'

.ix '&cat'
.*
Zinc Application Framework 4.1 is an object-oriented, cross-platform,
internationalized, class library and visual development tool.  Zinc supports
Symantec C++ 7.0 for DOS (both Text Mode and Graphics Mode), Microsoft Windows,
Win32 and Apple Macintosh (required Symantec C++
7.0 for Macintosh).  Zinc 4.0 also supports Windows NT, IBM OS/2, OSF/Motif,
Curses, NEXTSTEP and DESQview/X.  All platforms are supported with one set of
source code.
.np
Zinc 4.1 offers a comprehensive feature set including the following objects:
drag and drop, geometry management, scrolling windows, event mapping, palette
mapping, table, printer, notebook, status bar, tool bar, formatted string,
date, time, number (with currency), bitmap buttons, lists, combo box and many
more.
.np
Zinc Designer is the only visual development tool that creates and stores
platform-independent, user-interface objects.  Developers can interactively
drag and drop interface objects to develop application screens on any platform
that Zinc supports.  Twenty two full featured object editors give direct access
to all library-level features for each object.  Zinc Designer also features an
image editor for bitmaps and icons, a message editor and a defaults editor for
Help and System
information.  Zinc POST (Persistent Object Storage Technology) provides robust
platform-independent resources.  These binary files can be moved transparently
across platforms and are easily internationalized.
.np
Zinc 4.1 supports 13 languages and 19 country locales.  Developers can use a
single set of source code to support single-byte (ISO) languages such as
English, French and German as well as double-byte (Unicode) languages such as
Japanese, Korean and Chinese.
.np
The product includes the library, Zinc Designer and full source code.
.*
.figure *depth='2.75' *scale= *file='zinc'
.*

.*
:set symbol="cat" value="Code Generation"

.chap Code Generation
.*
.np
The following section contains listings for code generation products
supporting Watcom C or C++.
.*

.section Gpf 2.1 Professional Developers Kit (&cat)
.*
.np
.illust begin
Apical Software Inc.
40 Falls Road
P.O. Box 432
Moodus, Conneticut 06469

Sales:  (800) 831-0017
Tel:  (860) 873-3300
FAX:  (860) 873-3302
.illust end
.*
.np
.*
.ix 'Gpf 2.1 Professional Developers Kit (&cat)'

.ix 'Apical Software Inc.'

.ix '&cat'
.*
Gpf is a Visual application development environment that takes
full advantage of OS/2 2.x to create native Client/Server or
Stand-alone applications for OS/2 PM  or DOS/Windows.  As a 3GL
(C or C++ and optionally PL1) source code generator Gpf offers
all the advantages of hand coding native GUI applications,
combined with the ease of a What You See Is What You Get visual
programming environment.  With Gpf, the designer simply paints
the GUI screens as they ought to appear and Gpf takes care of
the rest.  All interface management and event handling logic is
generated automatically.  Navigation code, custom logic and
context sensitive help are created and linked to objects as they
are designed.  Since these are properly inserted by Gpf, code
integrity during regeneration is assured.

Adding GpfTools provides Reusable objects, Design Browsing, and
Automatic Documentation to create the complete Pro Developers
Toolkit.

Graphical browsing of the design includes a pop up true view of
any window, and automatic documentation. Information may be
output in text or INF (PM viewable) format  In addition,
GpfTools offers a powerful merge facility allowing the developer
to combine designs or  to drag selected objects from the
currently open view and drop them into an accumulate/paste
window.  Copy objects at any level including entire windows,
notebook pages, design objects (presentation objects, user
function objects, user control objects, bitmap/icon/pointer
objects, etc.), even sets of windows with all the associated
objects.
.*

.*

.*

.section FOR_C (&cat)
.*
.np
.illust begin
Cobalt Blue, Inc.
555 Sun Valley Drive
Roswell, GA  30076


Tel:  (770) 518-1116
FAX:  (770) 640-1182
.illust end
.*
.np
.*
.ix 'FOR_C (&cat)'

.ix 'Cobalt Blue, Inc.'

.ix '&cat'
.*
Converts FORTRAN-77 to ANSI C, delivering very readable, maintainable code!  It
supports
many VAX, PRIME and IBM-VS extensions for cost-effective porting of FORTRAN to
other
environments.  FOR_C offers basic static analysis and error checking,
delivering compiler-like
performance even when a FORTRAN compiler is not yet available on your target
platform, e.g.
when using an accelerator board.  The package also includes a C-like
preprocessor for easy
code customization, automatic prototyping, special de-include capabilities and
many formatting
options.  Also compatible with FOR_STRUCT, Cobalt Blue's FORTRAN restructuring
tool.
.*

.*

.*

.section MethodMaker (&cat)
.*
.np
.illust begin
Mark V Systems Ltd.
16400 Ventura Blvd., Suite 303
Encino, CA 91436


Sales:  (800) 995-7671
Tel:  (818) 995-7671
FAX:  (818) 995-4267
.illust end
.*
.np
.*
.ix 'MethodMaker (&cat)'

.ix 'Mark V Systems Ltd.'

.ix '&cat'
.*
MethodMaker (R) by Mark V Systems:  MethodMaker is an exciting  new extension
to the ObjectMaker family which allows rapid development of new method
notations.  MethodMaker also allows the user to modify and extend existing
ObjectMaker and ProcessMaker method support to meet project and organization
requirements. The user can easily build or modify the
tool support for a method by editing a diagram set. The new, or further
prototyped method is self
documented by the defining diagram set, and can be regenerated at any time to
take advantage of new ObjectMaker features and capabilities.  MethodMaker, with
simple diagrams and fill in forms allows you to specify and modify the tool
support for menus, notations, syntax checking, semantics specification and
repository capture of semantics and other information and relationships.  All
ObjectMaker CASE  Tool functionality is inherited.
.np
Contact MethodMaker marketing at 818 995 7671, fax 818 995 4267 or
methodmaker@markv.com.
.*

.*

.*

.section Object Maker (&cat)
.*
.np
.illust begin
Mark V Systems Ltd.
16400 Ventura Blvd., Suite 303
Encino, CA 91436


Sales:  (800) 995-7671
Tel:  (818) 995-7671
FAX:  (818) 995-4267
.illust end
.*
.np
.*
.ix 'Object Maker (&cat)'

.ix 'Mark V Systems Ltd.'

.ix '&cat'
.*
ObjectMaker by Mark V Systems:  With the ObjectMaker CASE Tool you can model
your application requirements and design in one or more of the most popular
notations.  ObjectMaker supports more than 30 of the most popular analysis and
design notations for software engineering and allows you to mix and match
notations to build a single model of your software application.  You can choose
the notations and the depth of detail your application requires.  ObjectMaker
also offers support for detailed design, code generation and document
generation for construction, delivery and maintenance phases.  Reverse
Engineering tools offer you the opportunity to re-engineer applications, reuse
legacy code and incorporate commercially available components into your model
for design, construction and maintenance.
.np
Contact ObjectMaker marketing at 818 995 7671, fax 818 995 4267, or
objectmaker@markv.com.
.*

.*

.*

.section ObjectMaker TDK (&cat)
.*
.np
.illust begin
Mark V Systems Ltd.
16400 Ventura Blvd., Suite 303
Encino, CA 91436


Sales:  (800) 995-7671
Tel:  (818) 995-7671
FAX:  (818) 995-4267
.illust end
.*
.np
.*
.ix 'ObjectMaker TDK (&cat)'

.ix 'Mark V Systems Ltd.'

.ix '&cat'
.*
ObjectMaker TDK by Mark V Systems: The ObjectMaker Tool Development Kit (TDK)
offers developers, integrators, OEMs, consultants, and methodologists the
opportunity to customize methods, notations, syntax rules, syntax checking,
semantic specification and repository capture of all semantics, and other
information and relationships important to your process and problem space.  The
TDK provides direct access to the rules (predicate logic) that create, control,
and pre- and post-condition all tool behavior, and manage all repository
navigation and iteration.  The TDK offers you the possibility of growing your
tool and method support as your organization and process grows and matures.
This is more than just being able to use the next method that
comes along, more than mixing and matching notations to create the multiple
views necessary for today's problems.  It means you can add to the notation you
select, add to the semantics, add to the checking,  add to the code generation,
and more as you gain experience and understand that what you need is beyond
what the published methods offer.  Published methods,
especially the object oriented methods, are good starting points.  Your process
will mature past the published methods. You will need to recognize and capture
the information and relationships important for your problem space.  The
ObjectMaker TDK provides tailorable support which enables you to develop and
extend your own methods.  The TDK gives you the opportunity to use and reuse
your repository contents, your application models, your component libraries by
giving you the facilities for data and control integration with other life
cycle tools.
.np
Contact ObjectMaker marketing at 818 995 7671, fax 818 995 4267, or
objectmaker@markv.com.
.*

.*

.*

.section ProcessMaker (&cat)
.*
.np
.illust begin
Mark V Systems Ltd.
16400 Ventura Blvd., Suite 303
Encino, CA 91436


Sales:  (800) 995-7671
Tel:  (818) 995-7671
FAX:  (818) 995-4267
.illust end
.*
.np
.*
.ix 'ProcessMaker (&cat)'

.ix 'Mark V Systems Ltd.'

.ix '&cat'
.*
ProcessMaker (R) by Mark V Systems:  ProcessMaker is a specialized modeling
tool which is coupled to an underlying semantics repository and code/text
generator.  ProcessMaker supports many popular process diagram notations and
provides the user the capability to easily develop a graphic representation of
a process. Users needing to capture process models, work flow models or
enterprise models for process improvement, analysis, measurement, reuse, re-
engineering or enactment have the choice of using multiple notations to create
the views necessary for
these tasks. ProcessMaker will generate output to a variety of process
enactment products.  Additional process modeling notations, and other
techniques can be added to ProcessMaker using MethodMaker and ObjectMaker TDK
tools described above.  More than 15 notations are supported at this time
including the popular IDEF/IDEF1x, ProNet, Process Decision Program
Charts, Process Breakdown Structure Charts, YPL and Petri Nets.
.np
Contact ProcessMaker marketing at 818 995 7671, fax 818 995 4267 or
processmaker@markv.com.
.*

.*

.*

.section Phase3 (&cat)
.*
.np
.illust begin
Phase3 Software, Inc.
4882 McGrath St
Suite 190
Ventura  CA  93003

Sales:  (800) 851-5650
Tel:  (805) 644-7185
FAX:  (805) 644-4572
.illust end
.*
.np
.*
.ix 'Phase3 (&cat)'

.ix 'Phase3 Software, Inc.'

.ix '&cat'
.*
Phase3 is a Rapid Application Design environment designed to allow developers
to go quickly from prototype to production.  Phase3 generates C/C++ or Pascal
code for a variety of compilers, including the new optimizing Watcom C/C++
10.5.
.np
Phase3 allows high-level development with visual tools to design screens and
user interface elements, reports, and online help.  Also,  the included visual
database tools can be used to design, maintain and query the Phase3 RDBMS
engine.  Developers can experience the benefits of RAD while still being able
to attach native code directly to Windows messages.  Phase3's unique API Wizard
can guide developers in selecting the correct API call to use and then continue
with descriptions of each of the parameters and returns, including the variable
types for each parameter  the API is expecting - no more obscure API reference
books!
.np
Phase3 developers achieve the best of both high and low level design and can
complete projects in record time yet still have the advantages of having
standard, native (C/C++ or Pascal) code generation which results in true .EXEs
which are as fast as they are small.  The included RDBMS engine can read and
write standard xBASE formats including dBASE and Clipper.  Because Phase3 uses
and generates standard source code, developers can interface with
industry-standard 3rd party tools, including VBX- and DLL-based controls.
Traditional language programmers can now develop applications in record time
without learning a proprietary or interpreted language.
.np
Additional information can be obtained by calling Phase3 or on our Internet
site at http://www.pacrain.com/~phase3/phase3.html.
.*

.*

.*

.section Select OMT Professional (&cat)
.*
.np
.illust begin
Select Software Tools Ltd.
Suite #84 Brookhollow Office Park
1526 Brookhollow Drive
Santa Ana, California  92705

Tel:  (714) 957-6633
FAX:  (714) 957-6219
.illust end
.*
.np
.*
.ix 'Select OMT Professional (&cat)'

.ix 'Select Software Tools Ltd.'

.ix '&cat'
.*

.*

.*

.*
:set symbol="cat" value="Communications Libraries"

.chap Communications Libraries
.*
.np
The following section contains listings for communication libraries
supporting Watcom C or C++.
.*

.section Distinct TCP/IP - Software Development Kit (&cat)
.*
.np
.illust begin
Distinct Corporation
12901 Saratoga Ave.
Saratoga, CA  95070


Tel:  (408) 366-8933
FAX:  (408) 366-0153
.illust end
.*
.np
.*
.ix 'Distinct TCP/IP - Software Development Kit (&cat)'

.ix 'Distinct Corporation'

.ix '&cat'
.*
Distinct TCP/IP SDK - Standard and Professional Editions
.np
TCP/IP APIs for Windows Sockets, Berkeley Sockets Kernel, Telnet, FTP,
WinSNMP, NetWin, ONC RPC/XDR, RLIB, SMTP, POP2/POP3, NNTP and VT220. Visual C++
Class Libraries for Windows Sockets, FTP and Telnet.
.np
To Develop Or Not To Develop...   These award winning Software development Kits
offer the most comprehensive set of development tools for client/server
programming in the TCP/IP and RPC network environments. Offering more than
twelve APIs, with support for multiple programming environments, Distinct
TCP/IP outclasses any of its competing products. With these SDKs you are able
to deliver high quality client/server applications, that can run on multivendor
networks, faster than ever before.
.np
But Is It Winsock Compliant?   Yes it is. With the exception of the Berkley
Sockets kernel all of the Distinct libraries interface Windows Sockets. The
Distinct RunTime extensions will run over any Winsock 1.1 compliant TCP/IP. So
you can use Distincts TCP/IP or your existing TCP/IP.
.np
What If I Dont Already Have TCP/IP? Youre in luck! Distinct bundles the
Distinct TCP/IP RunTime stack with each SDK. Distincts RunTime includes the
smallest, fastest, and most robust TCP/IP libraries for Windows. The RunTime
provides you with full TCP/IP services including support for SLIP/PPP, NDIS,
ODI, and Packet drivers for Ethernet and Token Ring. Distinct RunTime even
provides compatibility with Netware and Windows for Workgroups.
.np
Source Code Samples  Over 400KB of source code for complete, tested sample Over
400KB of source code for complete, tested sample programs (Ping, Telnet and
others) in several programming languages are included with both the Standard
and the Professional Edition.
.np
.illust begin
TCP-102 Distinct TCP/IP SDK-Standard Edition:                    $495
TCP-100 Distinct TCP/IP SDK-Professional Edition:                     $695
TCP-102S Distinct TCP/IP SDK-Standard Edition with Subscription       $745
TCP-100S Distinct TCP/IP SDK-Professional Edition with Subscription:  $945
.illust end
.*

.*

.*

.section Greenleaf Comm++ (&cat)
.*
.np
.illust begin
Greenleaf Software, Inc.
16479 Dallas Parkway, Suite 570
Dallas, Texas 75248


Sales:  (800) 523-9830
Tel:  (214) 248-2561
FAX:  (214) 248-7830
.illust end
.*
.np
.*
.ix 'Greenleaf Comm++ (&cat)'

.ix 'Greenleaf Software, Inc.'

.ix '&cat'
.*
Comm++ will accommodate interrupt-driven, circular buffered service for 35
ports at baud rates to 115, 200 baud.  As a C++ communication library, it
provides a hierarchy of classes which give the programmer simple access and
control of serial communications.  Classes are provided for: serial port
controls, modem controls including NASI support for modems on NOVELL networks,
file transfer protocols and calculation of check values.  In addition to this,
there are classes that support hardware dependent features.  These classes are
derived from an abstract base class.  Features include support for Hayes
Smartmodems(tm), XMODEM, YMODEM, ZMODEM, Kermit and CompuServe B+ transfer
protocols, XON/XOFF, RTS/CTS flow control, and VT52, VT100 (subset) ANSI,
terminal emulation.  Support is included for MSDOS, 32 bit MSDOS protected
mode, Microsoft Windows 3.1, Windows NT (DLL's and WIN32s thunking layer
included for Windows 3.1 and NT)along with OS/2.  An automated installation
procedure and examples are included.  The programmer receives access to the
technical BBS, free technical support, source code and a quarterly product
newsletter.  No royalties.
.*
.figure *depth='2.75' *scale= *file='green3'
.*

.*

.section Greenleaf CommLib (&cat)
.*
.np
.illust begin
Greenleaf Software, Inc.
16479 Dallas Parkway, Suite 570
Dallas, Texas 75248


Sales:  (800) 523-9830
Tel:  (214) 248-2561
FAX:  (214) 248-7830
.illust end
.*
.np
.*
.ix 'Greenleaf CommLib (&cat)'

.ix 'Greenleaf Software, Inc.'

.ix '&cat'
.*
The premier communications library for true interrupt driven asynchronous
communications.  Features ANSI terminal emulation, XMODEM, YMODEM, ZMODEM,
KERMIT, and CompuServe B+, transfer protocols, and  XON/XOFF, RTS/CTS flow
control.  Offers support for up to 35 simultaneous serial ports, 115 KBaud,
standard and intelligent multiport board support, modem access across networks
using NASI, Modem Assist Plus, and Sparkle, INT 14 BIOS and EBIOS support.
Device independence is accomplished through a C implementation of virtual
functions.  Applications can run under MSDOS, 16 & 32 bit MSDOS protected mode,
Microsoft Windows 3.1 or Windows NT (DLL's and a WIN32s thunking layer are
included for Windows 3.1 and NT).  On-line help is included along with a
reference guide.  The programmer also receives access to the technical BBS,
free technical support, source code and a quarterly product newsletter.  No
royalties.
.*
.figure *depth='2.75' *scale= *file='green2'
.*

.*

.section Greenleaf PowerComm (&cat)
.*
.np
.illust begin
Greenleaf Software, Inc.
16479 Dallas Parkway, Suite 570
Dallas, Texas 75248


Sales:  (800) 523-9830
Tel:  (214) 248-2561
FAX:  (214) 248-7830
.illust end
.*
.np
.*
.ix 'Greenleaf PowerComm (&cat)'

.ix 'Greenleaf Software, Inc.'

.ix '&cat'
.*
PowerComm Toolkit for Windows is a native Windows 3.1 implementation of
Greenleaf CommLib 5.1.  PowerComm consists of a DLL and a virtual device driver
(VxD).  The DLL contains most of the high level code of CommLib including file
transfer, I/O, status, modem controls and other communications functions.  The
VxD contains the low-level Interrupt Service Routines and other time sensitive
code.  PowerComm implements CommLib's PortOpenGreenleaf(), the most powerful
driver in CommLib, within  Windows.  You can initialize any number of ports
using one or more types of non-intelligent multiport boards in the same PC.
Another unique feature of PowerComm is that it does not 'step on' the Windows
COMM.DRV communications driver.  Requires CommLib 5.1 or 5.2.
.*
.figure *depth='2.75' *scale= *file='green5'
.*

.*

.section smxNet (&cat)
.*
.np
.illust begin
Micro Digital, Inc.
12842 Valley View Street
Garden Grove, CA 92649


Sales:  (800) 366-2491
Tel:  (714) 373-6862
FAX:  (714) 891-2363
.illust end
.*
.np
.*
.ix 'smxNet (&cat)'

.ix 'Micro Digital, Inc.'

.ix '&cat'
.*
smxNet is a TCP/IP network stack for the smx real-time, multitasking kernel.
It supports both the TCP and UDP protocols through a Berkeley sockets API.
smxNet uses smx primitives to manage data flow, thereby minimizing code and
data space.  Data space requirements are tunable depending upon application
speed vs. space requirements.  Code space requirements are: 32 KB for UDP/IP,
44 KB including TCP, and 70 KB for all protocols plus the Server Package.
.np
.illust begin
Features
             -  RFC-compliant TCP support
             -  Standard BSD sockets interface
             -  Supports UDP, TCP, ARP, and ICMP (ping)
             -  Integrated with smx
             -  Fast unbuffered mode (no copy) for UDP packets
             -  ROM'able
             -  Includes BOOTP and RARP for ROM'ed systems
             -  Supports simultaneous communications over multiple interfaces
             -  Designed for reliable operation in embedded systems
             -  Extensive error checking
             -  FTP, TFTP, and TELNET are available in separate Server Package
             -  Driver Support (included)
                -   Ethernet driver for NE1000, NE2000, 3Com 3C503, plus SMC &
WD boards
                -   SLIP
                -   FTP packet driver interface.  (Supports over 50 freeware
drivers developed at
                    universities.)
             -  PPP (separate package)
.illust end
.np
The smxNet development kit includes source code, a comprehensive demo program,
support for either Microsoft Visual C++ or Borland C++, and 6 months of  free
support and updates.  In addition to the drivers provided and the FTP packet
driver interface, smxNet includes
a simple device driver interface for custom drivers.
.*

.*

.*

.section SciComm (&cat)
.*
.np
.illust begin
MicroGlyph Systems
P.O. Box 474
Lexington, MA  02173


Tel:  (617) 861-0426
FAX:  (617) 674-1179
.illust end
.*
.np
.*
.ix 'SciComm (&cat)'

.ix 'MicroGlyph Systems'

.ix '&cat'
.*
The SciComm product provides a driver for four serial ports and a FORTRAN or C
communications library. The library routines provide interrupt driven two way
communication over standard RS-232C ports. The SciComm driver contains circular
input and output buffers, allowing parallel two way communications with
complete data integrity for user applications. A variety of baud rates are
provided from 300 to 56,000. Flow control is provided by XON/XOFF.
SciComm was designed for an IBM PC, XT, AT, PS/2, or (8088/80286/80386)
compatibles with 640Kb of conventional memory and up to 4 Gb of extended memory
under the DOS operating system (3.0 or later), and an IBM Parallel/Serial
Adapter or IBM Asynchronous Communications Adapter.  A complete user manual is
included.
.*

.*

.*

.section Systems Toolkit (&cat)
.*
.np
.illust begin
ObjectSpace, Inc.
14881 Quorum Drive
Suite 400
Dallas, TX  75240

Tel:  (214) 934-2496
FAX:  (214) 663-9100
.illust end
.*
.np
.*
.ix 'Systems Toolkit (&cat)'

.ix 'ObjectSpace, Inc.'

.ix '&cat'
.*
Systems<ToolKit> is a cross-platform, ANSI-compliant C++ library that includes
a comprehensive implementation of the Standard Template Library (STL), the
ANSI/ISO string, time, date, time zone, portable error handling, threads,
synchronization, binary streaming, sockets and other
system programming classes.

The Systems<ToolKit> binary streaming system allows you to stream your own
objects, STL containers, and other vendor's objects into a file or across a
network.  Unlike other vendor's, the streaming system allows you to add
lightweight persistence to your classes without modifying their
inheritance structure.
 ------------------------------------------------------------------------------
----------------------------------
STL<ToolKit>

STL<ToolKit> is a cross-platform, ANSI-compliant C++ library that includes a
comprehensive implementation of the Standard Template Library (STL), the
ANSI/ISO string, 64-bit time and date, time zone, threads and synchronization.
.*

.*

.*

.section COMM-DRV/Lib (&cat)
.*
.np
.illust begin
Willies Computer Software Co.
2470 S. Dairy Ashford
Suite 188
Houston, TX  77077

Sales:  (800) 966-4832
Tel:  (713) 498-4832
FAX:  (713) 568-3334
.illust end
.*
.np
.*
.ix 'COMM-DRV/Lib (&cat)'

.ix 'Willies Computer Software Co.'

.ix '&cat'
.*
COMM-DRV/LIB is a professional serial communication  library for  MS-DOS,
Windows 3.x, Windows 95, and Windows  NT.  The serial communication API is
identical under all of the above
mentioned operating systems.
.np
COMM-DRV/LIB provides true interrupt driven communication on any number of
ports concurrently. It provides for baud rates in excess of 115,200 baud.
Xmodem, Zmodem, Ymodem, and other protocols are provided. Hayes compatible
modem functions are provided.  An extensive API is provided for string
scanning, buffer manipulation and much more. COMM-DRV/LIB supports all
languages that can make calls to the Windows API or can link
with Microsoft compatible object code.
.np
COMM-DRV/LIB  supports both intelligent and  non-intelligent multiport serial
communication cards as well as the standard COM1-COM4, on the PC. Applications
may use serial cards from
different vendors concurrently.
.np
COMM-DRV/LIB  supports virtually any number of ports  active concurrently. File
transfers may occur on all  opened  ports concurrently.
.*

.*

.*

.section COMM-DRV/VxD (&cat)
.*
.np
.illust begin
Willies Computer Software Co.
2470 S. Dairy Ashford
Suite 188
Houston, TX  77077

Sales:  (800) 966-4832
Tel:  (713) 498-4832
FAX:  (713) 568-3334
.illust end
.*
.np
.*
.ix 'COMM-DRV/VxD (&cat)'

.ix 'Willies Computer Software Co.'

.ix '&cat'
.*
COMM-DRV/VxD  is  a ultra high speed VxD  for  Windows  that
allows  the  standard 8250/16450/16550 UARTs to  operate  at
baud  rates  in excess of 115,200 baud. Windows applications
as  well  as  MS-DOS  applications in a  DOS  box  can  take
advantage  of  this DLL to provide high speed  and  reliable
communications in the Windows environment. COMM-DRV/VxD  may
be integrated seamlessly with COMM-DRV/Lib.

COMM-DRV/VxD ships with an extensive API that may be  called
from C, Visual Basic, or any language that can make calls to
the  Windows API or any application that can link  Microsoft
compatible object files.
.*

.*

.*
:set symbol="cat" value="Data Management"

.chap Data Management
.*
.np
The following section contains listings for data management products
supporting Watcom C or C++.
.*

.section C/C++ Data Object Library (&cat)
.*
.np
.illust begin
Code Farms Inc.
7214 Jock Trail
Richmond, Ont.  K0A 2Z0
Canada

Tel:  (613) 838-4829
FAX:  (613) 838-3316
.illust end
.*
.np
.*
.ix 'C/C++ Data Object Library (&cat)'

.ix 'Code Farms Inc.'

.ix '&cat'
.*
 New concept of C++ class library with all data structures and container
classes, from lists, hash tables, ER models to run-time extensible objects, and
virtual disk access. Extremely fast and efficient, useful especially for large
projects - see the book 'Taming C++' by J.Soukup.
.np
Treats data structures as design patterns. Represents relations as objects, and
improves maintenance by removing cyclic dependency among classes.
Automatically persistent data do not require user-coded I/O functions for every
new class. Generates fast frameworks and OO databases.  Prevents dangling
pointers, includes memory management and automatic paging to disk. Portable
data and programs. Complete source, no royalties.
.np
Price: US299 one user DOS/WINDOWS/MAC US599 one UNIX workstation
.*

.*

.*

.section Crusher! Data Compression Toolkit (&cat)
.*
.np
.illust begin
DC Micro Development
P.O. Box 54588
Lexington, KY
40555

Sales:  1-800-775-1073
Tel:  (606) 268-1559
FAX:  (606) 266-0726
.illust end
.*
.np
.*
.ix 'Crusher! Data Compression Toolkit (&cat)'

.ix 'DC Micro Development'

.ix '&cat'
.*
Crusher is a high-performance, portable data compression library for DOS,
Windows, OS/2, Unix, and Macintosh developers. The comprehensive API of 45+
functions, identical for all platforms, provides buffer compression, file
compression, archiving, subdirectory support, wildcards, disk spanning,
encryption, self-extracting EXE's and more. Compresses data to 20-50% of
original size or less. As little as 15K overhead. Implement full archiving in
just four function calls. Crusher archives are portable across all supported
platforms, including DOS, Windows (16-bit and 32-bit), Macintosh, OS/2, Unix,
HP-9000, RS/6000, AS/400 and other O/S's. Special support for embedded
systems.
.np
Includes FULL SOURCE CODE as well as numerous sample applications including
ARQ, convenient command-line utility for managing Crusher archives, and SETUP,
a
Windows installation/setup program. Supports all C/C++ memory models and
Visual Basic. Windows version includes VBX custom control and full on-line
documentation. Limited 30-day warranty. A free demo is available for
downloading from our bbs.
.np
.illust begin
Retail Pricing
Platform        w/o source code w/source code
DOS             $199                    $249
Win16           $239                    $299
Win32           n/a                     $299
Macintosh       n/a                     $299
OS/2            n/a                     $349
Unix            n/a                     $349
.illust end
.*

.*

.*

.section dbfLIB (&cat)
.*
.np
.illust begin
dSoft Development
4710 Innsbruk Drive
Houston, TX  77066


Tel:  (713) 537-0318
FAX:  (713) 537-0318
.illust end
.*
.np
.*
.ix 'dbfLIB (&cat)'

.ix 'dSoft Development'

.ix '&cat'
.*
dbfLIB is a C/C++ programming library for accessing dBASE files. Whether you
are a dBASE programmer who is moving forward with C/C++ programming in the
Windows and OS/2 environments, or a seasoned GUI developer looking for database
management routines, you will find that programming in C/C++ with dbfLIB will
make your job easier.  Included are royalty free DLLs for Windows 3.x, OS/2
1.x, OS/2 2.x, OS/2 Warp, Windows NT and Windows 95.
In addition, static libraries for DOS and OS/2 are also included.  Supports
indexing, memo fields, record locking.  Calls are multithread safe.  Compilers
supported are Microsoft, Borland, IBM, and Watcom.
.np
If you have any questions you can call me @ 713-514-5736 or you can send me
email at 70562,1044@compuserve.com.
.*

.*

.*

.section c-tree Plus File Handler (&cat)
.*
.np
.illust begin
FairCom Corporation
4006 West Broadway
Columbia, Missouri  65203-0100


Sales:  (800) 234-8180
Tel:  (314) 445-6833
FAX:  (314) 445-9698
.illust end
.*
.np
.*
.ix 'c-tree Plus File Handler (&cat)'

.ix 'FairCom Corporation'

.ix '&cat'
.*
c-tree Plus File Handler
.np
Based on the most advanced B+tree routines available today, c-tree Plus gives
you unprecedented control over your file management needs. With unparalleled
sophistication, c-tree Plus has established itself as the premier choice for
commercial development. Use the low-level routines or take advantage of the
high-level ISAM routines for high speed random or sequential access. c-tree
Plus is distributed in complete C source code and has been ported to over 100
environments. It is royalty-free. Designed for single-user, multi-user or
client-side application development. Transaction processing is included in c-
tree Plus as well as features like: file mirroring, fixed/variable length
records and keys; file level alternate collating sequence; duplicate keys
and/or automatic sequence numbers; native operating system I/O utilization for
maximum portability; dynamic space reclamation; high speed hashed data and
index caching, multiple simultaneous sets/batches, resource records superfiles,
much more. Full ISAM functionality. All functions are fully ANSI prototyped.
Call for a complete list of features.
.np
Supported Environments:  DOS, Windows, NT, OS/2, Unix, QNX 4.X, Coherent,
Xenix, RISC platforms and MAC.  Supports most commercial grade C compilers.
.np
Version 6.4 release B.  Limited 30 day guarantee.  4.0 lbs
.*
.figure *depth='2.75' *scale= *file='faircom'
.*

.*

.section d-tree Development Tool (&cat)
.*
.np
.illust begin
FairCom Corporation
4006 West Broadway
Columbia, Missouri  65203-0100


Sales:  (800) 234-8180
Tel:  (314) 445-6833
FAX:  (314) 445-9698
.illust end
.*
.np
.*
.ix 'd-tree Development Tool (&cat)'

.ix 'FairCom Corporation'

.ix '&cat'
.*
Increase application development productivity without relinquishing control by
utilizing the convenience of a 4GL product at the C development level. d-tree
offers applications developers a bridge to the control, flexibility, and
portability obtained only at the C development level.
.np
Features include: a complete portable screen handler; data dictionary; resource
generation; instant file maintenance; easy-to-use database validation; flexible
data windows; field
masks; user defined/field level edits; and data file reformatting. d-tree's
dynamics allow runtime control of program resources (screens, files, edits,
etc.) not found in other package.
Resources can be changed in memory, and/or swapped on/off disk at runtime.
Additionally,
d-tree applications can be run in three different modes: interpreted; compiled;
or dynamic. If you develop applications on multiple platforms, or you're
debating 4GL versus C development, d-tree is designed for you.
.*
.figure *depth='2.75' *scale= *file='faircom'
.*

.*

.section FairCom Server (&cat)
.*
.np
.illust begin
FairCom Corporation
4006 West Broadway
Columbia, Missouri  65203-0100


Sales:  (800) 234-8180
Tel:  (314) 445-6833
FAX:  (314) 445-9698
.illust end
.*
.np
.*
.ix 'FairCom Server (&cat)'

.ix 'FairCom Corporation'

.ix '&cat'
.*
FairCom Server
.np
Originally introduced in 1988, the FairCom server is based on the client/server
model. This allows data to be more available while insuring that a system can
evolve as needs change. Client/server systems are open and modular, therefore
systems can be tailored to particular application requirements, leaving the
choice for cost-effective hardware options open. Coupled with c-tree Plus'
unparalleled portability and proven performance,  FairCom Servers meet even the
most demanding application requirements. FairCom Servers are multi-threaded by
design, allowing previously unused time spent waiting for locks and I/O
operations to be used processing requests from other users. Additionally, these
servers incorporate new indexing technology which allows a very high level of
concurrency among clients without jeopardizing data integrity. Page locks are
not performed; read locks are not required; extensive'anti-deadlock'
detection/resolution is built-in; sophisticated hashed caching reduces I/O
time; transaction processing on three levels; extensive data
availability/security; client-side source.  Also available in SQL
configuration. OEM/full server source available.
.np
Version 6.04.20. Supported environments: DOS Extended/Windows Hosted, Apple
System 7, Apple A/UX, OS/2 2.X, AT&T Unix System V,  SCO Unix, Interactive Unix
,QNX 4.X, Banyan VINES, Data General Avion, SUN SPARC,SUN Solaris, DEC Alpha,
HP 9000, RS/6000, 88OPEN.  3.5' diskettes.    3.5 lbs.
.*
.figure *depth='2.75' *scale= *file='faircom'
.*

.*

.section FairCom SQL Server (&cat)
.*
.np
.illust begin
FairCom Corporation
4006 West Broadway
Columbia, Missouri  65203-0100


Sales:  (800) 234-8180
Tel:  (314) 445-6833
FAX:  (314) 445-9698
.illust end
.*
.np
.*
.ix 'FairCom SQL Server (&cat)'

.ix 'FairCom Corporation'

.ix '&cat'
.*
FairCom provides configurations for both SQL and non-SQL applications (see
separate description.) Both servers are ultra-high performance servers, which
utilize the widely accepted c-tree Plus Application Programmers Interface. The
FairCom SQL server offers all the features and API of the non-SQL server, plus
a complete ANSI 1986 level 2 SQL engine. Since both configurations are built
using c-tree Plus, applications easily migrate between  three operating modes:
single-user; multi-user non-server; client/server. Change between these modes
by simply recompiling. FairCom's unique implementation of SQL allows the same
executable to access FairCom files using the c-tree Plus low level API, ISAM
level API or SQL API simultaneously. Other
features include: complete client-side source code; native file system
utilization (increases performance); requires less than 1 MB to run; complete
transaction logging and intermediate save/restore points; full commit and
rollback; automatic restart and disaster recovery; full user/file security; on-
line administration utilities and data backup, SQL pre-processor and
interpreter. Available in 5; 12; unlimited user versions. OEM/full server
source available.
.*
.figure *depth='2.75' *scale= *file='faircom'
.*

.*

.section r-tree Report Generator (&cat)
.*
.np
.illust begin
FairCom Corporation
4006 West Broadway
Columbia, Missouri  65203-0100


Sales:  (800) 234-8180
Tel:  (314) 445-6833
FAX:  (314) 445-9698
.illust end
.*
.np
.*
.ix 'r-tree Report Generator (&cat)'

.ix 'FairCom Corporation'

.ix '&cat'
.*
Produces complex, multi-line reports from multiple c-tree Plus data files, both
fixed and variable length. r-tree handles virtually every aspect of report
generation. Your only programming requirement is to call the r-tree report
function which reads c-tree Plus data files; performs necessary calculations;
monitors control breaks and accumulators; and produces a formatted report.
Because of its unique design, r-tree allows you to distribute report scripts in
either
their original form, or in a special compiled from. Report scripts in text form
can be modified by your customers. Report scripts in compiled form cannot be
modified by customers. Other
features: define any number of virtual fields; sort by any number of criteria;
any number of nested control breaks; accumulators automatically track each
control break level; complete layout control with conditional page breaks, page
headers/footers, report headers/footers, and control headers/footers.
.*
.figure *depth='2.75' *scale= *file='faircom'
.*

.*

.section STL <Toolkit> (&cat)
.*
.np
.illust begin
ObjectSpace, Inc.
14881 Quorum Drive
Suite 400
Dallas, TX  75240

Tel:  (214) 934-2496
FAX:  (214) 663-9100
.illust end
.*
.np
.*
.ix 'STL <Toolkit> (&cat)'

.ix 'ObjectSpace, Inc.'

.ix '&cat'
.*
.illust begin
Systems<ToolKit> is a cross-platform, ANSI-compliant C++ library that includes
a comprehensive implementation of the Standard Template Library (STL), the
ANSI/ISO string, time, date, time zone, portable error handling, threads,
synchronization, binary streaming, sockets and other
system programming classes.

The Systems<ToolKit> binary streaming system allows you to stream your own
objects, STL containers, and other vendor's objects into a file or across a
network.  Unlike other vendor's, the streaming system allows you to add
lightweight persistence to your classes without modifying their
inheritance structure.
 ------------------------------------------------------------------------------
----------------------------------
STL<ToolKit>

STL<ToolKit> is a cross-platform, ANSI-compliant C++ library that includes a
comprehensive implementation of the Standard Template Library (STL), the
ANSI/ISO string, 64-bit time and date, time zone, threads and synchronization.
.illust end
.*

.*

.*

.section Systems Toolkit (&cat)
.*
.np
.illust begin
ObjectSpace, Inc.
14881 Quorum Drive
Suite 400
Dallas, TX  75240

Tel:  (214) 934-2496
FAX:  (214) 663-9100
.illust end
.*
.np
.*
.ix 'Systems Toolkit (&cat)'

.ix 'ObjectSpace, Inc.'

.ix '&cat'
.*
Systems<ToolKit> is a cross-platform, ANSI-compliant C++ library that includes
a comprehensive implementation of the Standard Template Library (STL), the
ANSI/ISO string, time, date, time zone, portable error handling, threads,
synchronization, binary streaming, sockets and other
system programming classes.

The Systems<ToolKit> binary streaming system allows you to stream your own
objects, STL containers, and other vendor's objects into a file or across a
network.  Unlike other vendor's, the streaming system allows you to add
lightweight persistence to your classes without modifying their
inheritance structure.
 ------------------------------------------------------------------------------
----------------------------------
STL<ToolKit>

STL<ToolKit> is a cross-platform, ANSI-compliant C++ library that includes a
comprehensive implementation of the Standard Template Library (STL), the
ANSI/ISO string, 64-bit time and date, time zone, threads and synchronization.
.*

.*

.*

.section CodeBase (&cat)
.*
.np
.illust begin
Sequiter Software, Inc.
Suite 209, 9644 - 54 Avenue
Edmonton, Alberta, Canada T6E 5V1


Tel:  (403) 437-2410
FAX:  (403) 436-2999
.illust end
.*
.np
.*
.ix 'CodeBase (&cat)'

.ix 'Sequiter Software, Inc.'

.ix '&cat'
.*
CodeBase 5.1 is a multi-user Xbase compatible C/C++ library for database
management.  With CodeBase, your applications can use any of the five most
popular indexing formats as well as their associated memo files:  FoxPro 2.0
(.CDX, .IDX), dBASE IV (.MDX), dBASE  III
PLUS (.NDX), and Clipper (.NTX).  CodeBase 5.1 also provides record and file
locking that is compatible with the multi-user versions of dBASE IV, FoxPro 2
and Clipper.  Easy to use,... Named like familiar dBase commands, CodeBase 5.1
functions reduce your learning curve by
allowing  you to use your xBase expertise right away.  CodeBase 5.1
applications automatically utilize our new Bit Optimized Query Technology to
return query results on a 500,000 record data file in just one second!
CodeReporter 2.0 and special CodeBase 5.1 reporting functions make designing
and generating reports from your C/C++ applications simple.  CodeBase 5.1,
combined with CodeControls 2.0 our Data Aware custom controls, turn your
favorite compiler into a
visual development environment.  The Standard version of CodeBase 5.1 supports
most compilers under DOS, OS/2 and Windows, and Windows NT.  Upgrade to the
special Multi-Platform version of CodeBase 5.1 to port your application to
UNIX, SUN, AIX and The Macintosh.  (CodeBase 5.1 includes: complete library
Source Code,  CodeReporter 2.0,
CodeControls 2.0 and Royalty Free distribution of your application.)
.*

.*

.*

.section DataVision (&cat)
.*
.np
.illust begin
VisionSoft Corporation
PruneYard Tower 1, 1901 S. Bascom Ave., Suite 1060
Campbell, CA  95008


Sales:  (800) 695-6382
Tel:  (408) 879-2672
FAX:  (408) 879-2307
.illust end
.*
.np
.*
.ix 'DataVision (&cat)'

.ix 'VisionSoft Corporation'

.ix '&cat'
.*
DataVision is an embedded database system for client/server, distributed and
embedded applications.  It combines the benefits of an embedded database
(extremely fast response times, efficient memory utilization, flexible schemas,
low-level access) with the requirements for client/server applications (modular
design and scalability).  DataVision fully supports features found in industry
databases plus (variable length records, quick key index search,
ascending/descending reads).
.np
.illust begin
DataVision provides the ability to:
* read/write data for heterogeneous platforms independent of the Processor
Architecture, Compiler and Operating System; and therefore,
* developers who utilize this DataVision database API will not need to worry
about what platform the database resides on because the database can be easily
transferred to new platform environments with no programming changes or
database reformatting.
* now, write interactive applications that utilize fully relational queries,
fast response times and transparent data movement simply and easily.
.illust end
.illust begin
Key Benefits
* Ensures minimal size, native performance and portability on all platforms
* Significantly reduces design, development and test cycles
* Shortens time-to-market
* Flexible, customizable, and extensible
* Speeds the creation of database related application resources
* Eliminates the need to re-code your application for a new platform
* Delivers your products to marketplace with a single source code version
* Source Code provided
.illust end
.illust begin
Example Database Library Functions
DVgetinfo - returns key header information such as version and key names etc
DVdefkey - defines a key
DVdelkey - deletes a key
DVopen - opens and creates a database
DVscratch - removes a file from the system
DVclose - closes a file
DVcopy - copies the database
DVrebuild - rebuilds and compresses the database
DVdelete - provides for deleting a record
DVundo - reverses a record delete operation for the key specified
DVpos - approximate, generic and exact positioning to records supported for 1-
10 key fields
DVread - ascending or descending key record reading
DVwrite - writes new key and data records into the database
DVupdate - replace an existing record or write a new record
DVtread - text read for a file opened in text mode
DVtwrite - text write for a file opened in text mode
.illust end
.illust begin
Platforms Supported:
Windows 3.1, Windows '95, Windows/NT, Macintosh, OS/2
.illust end
.illust begin
Target Execution Platforms Supported:
All Host Platforms Listed Above, TANDEM Guardian, SunOS, Solaris, HP/UX, AIX,
Embedded Systems
.illust end
.*

.*

.*
:set symbol="cat" value="Database Development Tools"

.chap Database Development Tools
.*
.np
The following section contains listings for database development tools
supporting Watcom C or C++.
.*

.section Gpf 2.1 Professional Developers Kit (&cat)
.*
.np
.illust begin
Apical Software Inc.
40 Falls Road
P.O. Box 432
Moodus, Conneticut 06469

Sales:  (800) 831-0017
Tel:  (860) 873-3300
FAX:  (860) 873-3302
.illust end
.*
.np
.*
.ix 'Gpf 2.1 Professional Developers Kit (&cat)'

.ix 'Apical Software Inc.'

.ix '&cat'
.*
Gpf is a Visual application development environment that takes
full advantage of OS/2 2.x to create native Client/Server or
Stand-alone applications for OS/2 PM  or DOS/Windows.  As a 3GL
(C or C++ and optionally PL1) source code generator Gpf offers
all the advantages of hand coding native GUI applications,
combined with the ease of a What You See Is What You Get visual
programming environment.  With Gpf, the designer simply paints
the GUI screens as they ought to appear and Gpf takes care of
the rest.  All interface management and event handling logic is
generated automatically.  Navigation code, custom logic and
context sensitive help are created and linked to objects as they
are designed.  Since these are properly inserted by Gpf, code
integrity during regeneration is assured.

Adding GpfTools provides Reusable objects, Design Browsing, and
Automatic Documentation to create the complete Pro Developers
Toolkit.

Graphical browsing of the design includes a pop up true view of
any window, and automatic documentation. Information may be
output in text or INF (PM viewable) format  In addition,
GpfTools offers a powerful merge facility allowing the developer
to combine designs or  to drag selected objects from the
currently open view and drop them into an accumulate/paste
window.  Copy objects at any level including entire windows,
notebook pages, design objects (presentation objects, user
function objects, user control objects, bitmap/icon/pointer
objects, etc.), even sets of windows with all the associated
objects.
.*

.*

.*

.section AccSys for Paradox (&cat)
.*
.np
.illust begin
Copia International, Ltd.
1342 Avalon Court
Wheaton, IL  60187


Sales:  (800) 689-8898
Tel:  (708) 682-8898
FAX:  (708) 665-9841
.illust end
.*
.np
.*
.ix 'AccSys for Paradox (&cat)'

.ix 'Copia International, Ltd.'

.ix '&cat'
.*
AccSys for Paradox provides C, Visual Basic for DOS and/or Visual Basic for
Windows programmers with fast, easy access to the database routines found in
Paradox (including 5.0). AccSys gives the programmer the ability to create,
read, write, modify and update Paradox files without having to learn the
internal file formats. Read/write public and private BLOBs with AccSys.
Paradox's interface provides users with tools for total control over Paradox
primary and secondary index files as well as tables. Applications using Windows
(DLL), OS/2 and DOS Extenders may be developed. Supports Watcom C/C++, Borland
C, C++, Microsoft C, and Symantec.  AccSys allows for standalone program
construction and is 100% network compatible. No runtime royalties.
.*

.*

.*

.section dbfLIB (&cat)
.*
.np
.illust begin
dSoft Development
4710 Innsbruk Drive
Houston, TX  77066


Tel:  (713) 537-0318
FAX:  (713) 537-0318
.illust end
.*
.np
.*
.ix 'dbfLIB (&cat)'

.ix 'dSoft Development'

.ix '&cat'
.*
dbfLIB is a C/C++ programming library for accessing dBASE files. Whether you
are a dBASE programmer who is moving forward with C/C++ programming in the
Windows and OS/2 environments, or a seasoned GUI developer looking for database
management routines, you will find that programming in C/C++ with dbfLIB will
make your job easier.  Included are royalty free DLLs for Windows 3.x, OS/2
1.x, OS/2 2.x, OS/2 Warp, Windows NT and Windows 95.
In addition, static libraries for DOS and OS/2 are also included.  Supports
indexing, memo fields, record locking.  Calls are multithread safe.  Compilers
supported are Microsoft, Borland, IBM, and Watcom.
.np
If you have any questions you can call me @ 713-514-5736 or you can send me
email at 70562,1044@compuserve.com.
.*

.*

.*

.section c-tree Plus File Handler (&cat)
.*
.np
.illust begin
FairCom Corporation
4006 West Broadway
Columbia, Missouri  65203-0100


Sales:  (800) 234-8180
Tel:  (314) 445-6833
FAX:  (314) 445-9698
.illust end
.*
.np
.*
.ix 'c-tree Plus File Handler (&cat)'

.ix 'FairCom Corporation'

.ix '&cat'
.*
c-tree Plus File Handler
.np
Based on the most advanced B+tree routines available today, c-tree Plus gives
you unprecedented control over your file management needs. With unparalleled
sophistication, c-tree Plus has established itself as the premier choice for
commercial development. Use the low-level routines or take advantage of the
high-level ISAM routines for high speed random or sequential access. c-tree
Plus is distributed in complete C source code and has been ported to over 100
environments. It is royalty-free. Designed for single-user, multi-user or
client-side application development. Transaction processing is included in c-
tree Plus as well as features like: file mirroring, fixed/variable length
records and keys; file level alternate collating sequence; duplicate keys
and/or automatic sequence numbers; native operating system I/O utilization for
maximum portability; dynamic space reclamation; high speed hashed data and
index caching, multiple simultaneous sets/batches, resource records superfiles,
much more. Full ISAM functionality. All functions are fully ANSI prototyped.
Call for a complete list of features.
.np
Supported Environments:  DOS, Windows, NT, OS/2, Unix, QNX 4.X, Coherent,
Xenix, RISC platforms and MAC.  Supports most commercial grade C compilers.
.np
Version 6.4 release B.  Limited 30 day guarantee.  4.0 lbs
.*
.figure *depth='2.75' *scale= *file='faircom'
.*

.*

.section d-tree Development Tool (&cat)
.*
.np
.illust begin
FairCom Corporation
4006 West Broadway
Columbia, Missouri  65203-0100


Sales:  (800) 234-8180
Tel:  (314) 445-6833
FAX:  (314) 445-9698
.illust end
.*
.np
.*
.ix 'd-tree Development Tool (&cat)'

.ix 'FairCom Corporation'

.ix '&cat'
.*
Increase application development productivity without relinquishing control by
utilizing the convenience of a 4GL product at the C development level. d-tree
offers applications developers a bridge to the control, flexibility, and
portability obtained only at the C development level.
.np
Features include: a complete portable screen handler; data dictionary; resource
generation; instant file maintenance; easy-to-use database validation; flexible
data windows; field
masks; user defined/field level edits; and data file reformatting. d-tree's
dynamics allow runtime control of program resources (screens, files, edits,
etc.) not found in other package.
Resources can be changed in memory, and/or swapped on/off disk at runtime.
Additionally,
d-tree applications can be run in three different modes: interpreted; compiled;
or dynamic. If you develop applications on multiple platforms, or you're
debating 4GL versus C development, d-tree is designed for you.
.*
.figure *depth='2.75' *scale= *file='faircom'
.*

.*

.section FairCom Server (&cat)
.*
.np
.illust begin
FairCom Corporation
4006 West Broadway
Columbia, Missouri  65203-0100


Sales:  (800) 234-8180
Tel:  (314) 445-6833
FAX:  (314) 445-9698
.illust end
.*
.np
.*
.ix 'FairCom Server (&cat)'

.ix 'FairCom Corporation'

.ix '&cat'
.*
FairCom Server
.np
Originally introduced in 1988, the FairCom server is based on the client/server
model. This allows data to be more available while insuring that a system can
evolve as needs change. Client/server systems are open and modular, therefore
systems can be tailored to particular application requirements, leaving the
choice for cost-effective hardware options open. Coupled with c-tree Plus'
unparalleled portability and proven performance,  FairCom Servers meet even the
most demanding application requirements. FairCom Servers are multi-threaded by
design, allowing previously unused time spent waiting for locks and I/O
operations to be used processing requests from other users. Additionally, these
servers incorporate new indexing technology which allows a very high level of
concurrency among clients without jeopardizing data integrity. Page locks are
not performed; read locks are not required; extensive'anti-deadlock'
detection/resolution is built-in; sophisticated hashed caching reduces I/O
time; transaction processing on three levels; extensive data
availability/security; client-side source.  Also available in SQL
configuration. OEM/full server source available.
.np
Version 6.04.20. Supported environments: DOS Extended/Windows Hosted, Apple
System 7, Apple A/UX, OS/2 2.X, AT&T Unix System V,  SCO Unix, Interactive Unix
,QNX 4.X, Banyan VINES, Data General Avion, SUN SPARC,SUN Solaris, DEC Alpha,
HP 9000, RS/6000, 88OPEN.  3.5' diskettes.    3.5 lbs.
.*
.figure *depth='2.75' *scale= *file='faircom'
.*

.*

.section FairCom SQL Server (&cat)
.*
.np
.illust begin
FairCom Corporation
4006 West Broadway
Columbia, Missouri  65203-0100


Sales:  (800) 234-8180
Tel:  (314) 445-6833
FAX:  (314) 445-9698
.illust end
.*
.np
.*
.ix 'FairCom SQL Server (&cat)'

.ix 'FairCom Corporation'

.ix '&cat'
.*
FairCom provides configurations for both SQL and non-SQL applications (see
separate description.) Both servers are ultra-high performance servers, which
utilize the widely accepted c-tree Plus Application Programmers Interface. The
FairCom SQL server offers all the features and API of the non-SQL server, plus
a complete ANSI 1986 level 2 SQL engine. Since both configurations are built
using c-tree Plus, applications easily migrate between  three operating modes:
single-user; multi-user non-server; client/server. Change between these modes
by simply recompiling. FairCom's unique implementation of SQL allows the same
executable to access FairCom files using the c-tree Plus low level API, ISAM
level API or SQL API simultaneously. Other
features include: complete client-side source code; native file system
utilization (increases performance); requires less than 1 MB to run; complete
transaction logging and intermediate save/restore points; full commit and
rollback; automatic restart and disaster recovery; full user/file security; on-
line administration utilities and data backup, SQL pre-processor and
interpreter. Available in 5; 12; unlimited user versions. OEM/full server
source available.
.*
.figure *depth='2.75' *scale= *file='faircom'
.*

.*

.section r-tree Report Generator (&cat)
.*
.np
.illust begin
FairCom Corporation
4006 West Broadway
Columbia, Missouri  65203-0100


Sales:  (800) 234-8180
Tel:  (314) 445-6833
FAX:  (314) 445-9698
.illust end
.*
.np
.*
.ix 'r-tree Report Generator (&cat)'

.ix 'FairCom Corporation'

.ix '&cat'
.*
Produces complex, multi-line reports from multiple c-tree Plus data files, both
fixed and variable length. r-tree handles virtually every aspect of report
generation. Your only programming requirement is to call the r-tree report
function which reads c-tree Plus data files; performs necessary calculations;
monitors control breaks and accumulators; and produces a formatted report.
Because of its unique design, r-tree allows you to distribute report scripts in
either
their original form, or in a special compiled from. Report scripts in text form
can be modified by your customers. Report scripts in compiled form cannot be
modified by customers. Other
features: define any number of virtual fields; sort by any number of criteria;
any number of nested control breaks; accumulators automatically track each
control break level; complete layout control with conditional page breaks, page
headers/footers, report headers/footers, and control headers/footers.
.*
.figure *depth='2.75' *scale= *file='faircom'
.*

.*

.section DataLIB (&cat)
.*
.np
.illust begin
Franklin Computing Group
3624 Market Street
3rd Floor
Philadelphia, PA
19104
Tel:  (215) 243-2250
FAX:  (215) 243-2253
.illust end
.*
.np
.*
.ix 'DataLIB (&cat)'

.ix 'Franklin Computing Group'

.ix '&cat'
.*
DataLIB allows software developers to read, write and convert most popular
spreadsheet, database and ASCII file formats including Excel 5.0, Excel 4.X,
Excel 3.X, Excel 2.X, Lotus 123 1.X, Lotus 123 2.X, Lotus 123 3.X, Lotus 123
4.X, Lotus 123 5.X, Symphony, Quattro, dBase II, dBase III, dBase III+, dBase
IV, FoxPro, SYLK, CSV, TAB, TXT and ASCII. Used by hundreds of
commercial software developers  worldwide.
.np
.illust begin
Pricing :
        Developer Kit   (16-bit)        :       $395.00
        Royalty Free License (16-bit)   :       $995.00
.illust end
.*

.*

.*

.section Map SDK (&cat)
.*
.np
.illust begin
Franklin Computing Group
3624 Market Street
3rd Floor
Philadelphia, PA
19104
Tel:  (215) 243-2250
FAX:  (215) 243-2253
.illust end
.*
.np
.*
.ix 'Map SDK (&cat)'

.ix 'Franklin Computing Group'

.ix '&cat'
.*
MapSDK will allow you to incorporate spectacular mapping functionality directly
within your applications. You have full control over the display, content and
user interaction associated with the map. MapSDK allows you to link up any of
your databases to a map. A complete set of high quality world/national vector
maps and demographic databases are also available. MapSDK can additionally
import and export MapInfo files.
.np
.illust begin
Pricing :
        Developer Kit                   :       $495.00
        World & National MapPack        :       $295.00
        National StreetPack (CD)        :       $995.00
.illust end
.*

.*

.*

.section Greenleaf Database Library (&cat)
.*
.np
.illust begin
Greenleaf Software, Inc.
16479 Dallas Parkway, Suite 570
Dallas, Texas 75248


Sales:  (800) 523-9830
Tel:  (214) 248-2561
FAX:  (214) 248-7830
.illust end
.*
.np
.*
.ix 'Greenleaf Database Library (&cat)'

.ix 'Greenleaf Software, Inc.'

.ix '&cat'
.*
This library has over 240 functions to create or provide fast access to xBASE
files such as dBASE III & IV, Clipper, FoxPro, FoxBASE+, Alpha IV, and
compatible database products.  Library features include:  standalone, multi-
user and network access, automatic record and file locking, built-in disk
caching, index expression evaluation, and searches using full or partial keys.
Routines are supplied to access the following file types: fixed length records
(DBF), variable length memo records (DBT and FBT), and indices (CDX, IDX, MDX,
NDX and NTX).  Now includes high level functions which allow you greater
flexibility; i.e., when you open a database file, it also opens index and memo
files.  New version also includes a C++ layer, relational capabilities, a
Windows Help file, and new Windows demos.  Includes complete, fully commented,
ANSI C compliant source code and Microsoft Windows 3.1 and NT DLL's.
.*
.figure *depth='2.75' *scale= *file='green4'
.*

.*

.section MethodMaker (&cat)
.*
.np
.illust begin
Mark V Systems Ltd.
16400 Ventura Blvd., Suite 303
Encino, CA 91436


Sales:  (800) 995-7671
Tel:  (818) 995-7671
FAX:  (818) 995-4267
.illust end
.*
.np
.*
.ix 'MethodMaker (&cat)'

.ix 'Mark V Systems Ltd.'

.ix '&cat'
.*
MethodMaker (R) by Mark V Systems:  MethodMaker is an exciting  new extension
to the ObjectMaker family which allows rapid development of new method
notations.  MethodMaker also allows the user to modify and extend existing
ObjectMaker and ProcessMaker method support to meet project and organization
requirements. The user can easily build or modify the
tool support for a method by editing a diagram set. The new, or further
prototyped method is self
documented by the defining diagram set, and can be regenerated at any time to
take advantage of new ObjectMaker features and capabilities.  MethodMaker, with
simple diagrams and fill in forms allows you to specify and modify the tool
support for menus, notations, syntax checking, semantics specification and
repository capture of semantics and other information and relationships.  All
ObjectMaker CASE  Tool functionality is inherited.
.np
Contact MethodMaker marketing at 818 995 7671, fax 818 995 4267 or
methodmaker@markv.com.
.*

.*

.*

.section Object Maker (&cat)
.*
.np
.illust begin
Mark V Systems Ltd.
16400 Ventura Blvd., Suite 303
Encino, CA 91436


Sales:  (800) 995-7671
Tel:  (818) 995-7671
FAX:  (818) 995-4267
.illust end
.*
.np
.*
.ix 'Object Maker (&cat)'

.ix 'Mark V Systems Ltd.'

.ix '&cat'
.*
ObjectMaker by Mark V Systems:  With the ObjectMaker CASE Tool you can model
your application requirements and design in one or more of the most popular
notations.  ObjectMaker supports more than 30 of the most popular analysis and
design notations for software engineering and allows you to mix and match
notations to build a single model of your software application.  You can choose
the notations and the depth of detail your application requires.  ObjectMaker
also offers support for detailed design, code generation and document
generation for construction, delivery and maintenance phases.  Reverse
Engineering tools offer you the opportunity to re-engineer applications, reuse
legacy code and incorporate commercially available components into your model
for design, construction and maintenance.
.np
Contact ObjectMaker marketing at 818 995 7671, fax 818 995 4267, or
objectmaker@markv.com.
.*

.*

.*

.section ObjectMaker TDK (&cat)
.*
.np
.illust begin
Mark V Systems Ltd.
16400 Ventura Blvd., Suite 303
Encino, CA 91436


Sales:  (800) 995-7671
Tel:  (818) 995-7671
FAX:  (818) 995-4267
.illust end
.*
.np
.*
.ix 'ObjectMaker TDK (&cat)'

.ix 'Mark V Systems Ltd.'

.ix '&cat'
.*
ObjectMaker TDK by Mark V Systems: The ObjectMaker Tool Development Kit (TDK)
offers developers, integrators, OEMs, consultants, and methodologists the
opportunity to customize methods, notations, syntax rules, syntax checking,
semantic specification and repository capture of all semantics, and other
information and relationships important to your process and problem space.  The
TDK provides direct access to the rules (predicate logic) that create, control,
and pre- and post-condition all tool behavior, and manage all repository
navigation and iteration.  The TDK offers you the possibility of growing your
tool and method support as your organization and process grows and matures.
This is more than just being able to use the next method that
comes along, more than mixing and matching notations to create the multiple
views necessary for today's problems.  It means you can add to the notation you
select, add to the semantics, add to the checking,  add to the code generation,
and more as you gain experience and understand that what you need is beyond
what the published methods offer.  Published methods,
especially the object oriented methods, are good starting points.  Your process
will mature past the published methods. You will need to recognize and capture
the information and relationships important for your problem space.  The
ObjectMaker TDK provides tailorable support which enables you to develop and
extend your own methods.  The TDK gives you the opportunity to use and reuse
your repository contents, your application models, your component libraries by
giving you the facilities for data and control integration with other life
cycle tools.
.np
Contact ObjectMaker marketing at 818 995 7671, fax 818 995 4267, or
objectmaker@markv.com.
.*

.*

.*

.section ProcessMaker (&cat)
.*
.np
.illust begin
Mark V Systems Ltd.
16400 Ventura Blvd., Suite 303
Encino, CA 91436


Sales:  (800) 995-7671
Tel:  (818) 995-7671
FAX:  (818) 995-4267
.illust end
.*
.np
.*
.ix 'ProcessMaker (&cat)'

.ix 'Mark V Systems Ltd.'

.ix '&cat'
.*
ProcessMaker (R) by Mark V Systems:  ProcessMaker is a specialized modeling
tool which is coupled to an underlying semantics repository and code/text
generator.  ProcessMaker supports many popular process diagram notations and
provides the user the capability to easily develop a graphic representation of
a process. Users needing to capture process models, work flow models or
enterprise models for process improvement, analysis, measurement, reuse, re-
engineering or enactment have the choice of using multiple notations to create
the views necessary for
these tasks. ProcessMaker will generate output to a variety of process
enactment products.  Additional process modeling notations, and other
techniques can be added to ProcessMaker using MethodMaker and ObjectMaker TDK
tools described above.  More than 15 notations are supported at this time
including the popular IDEF/IDEF1x, ProNet, Process Decision Program
Charts, Process Breakdown Structure Charts, YPL and Petri Nets.
.np
Contact ProcessMaker marketing at 818 995 7671, fax 818 995 4267 or
processmaker@markv.com.
.*

.*

.*

.section c/Database Toolchest (&cat)
.*
.np
.illust begin
Mix Software, Inc.
1132 Commerce Drive
Richardson, Texas  75081


Sales:  (800) 333-0330
Tel:  (214) 783-6001
FAX:  (214) 783-1404
.illust end
.*
.np
.*
.ix 'c/Database Toolchest (&cat)'

.ix 'Mix Software, Inc.'

.ix '&cat'
.*
The C/Database Toolchest adds sophisticated file management functions to
your C or C++ compiler.  With the C/Database Toolchest, your data requires
much less disk space than with programs like dBASE, and you can access your
data much faster.  Of course the full power of C provides you with an
unlimited amount of programming flexibility.

The C/Database Toolchest includes three major components:

   1) An advanced B+ tree library gives you instant access to your data.
   2) A high-level ISAM library provides you with an easy-to-use C
      interface, and
   3) A complete database manager (with C source code included) shows
      you how to create impressive applications.

You also receive a comprehensive 350 page manual and a utility for
converting to and from dBASE files.

The C/Database Toolchest supports features that you'd expect to find only
in products costing ten times as much.  Advanced features include variable
length records, variable length keys, multiple keys per index and multiple
indexes stored in a single file.  Your data files can contain an unlimited
number of records, and each record can be as large as 32K bytes in length.

About the only thing that the C/Database Toolchest doesn't do is cost you a
lot of money.  We've kept our price low so you can manage your budget as
easily as your data.

   The C/Database Toolchest, now only $19.95
   Source for the B+ tree and ISAM libraries is $10.00
.*

.*

.*

.section c/Database Toolchest v. 3.0 (&cat)
.*
.np
.illust begin
Mix Software, Inc.
1132 Commerce Drive
Richardson, Texas  75081


Sales:  (800) 333-0330
Tel:  (214) 783-6001
FAX:  (214) 783-1404
.illust end
.*
.np
.*
.ix 'c/Database Toolchest v. 3.0 (&cat)'

.ix 'Mix Software, Inc.'

.ix '&cat'
.*
The C/Database Toolchest adds sophisticated file management functions to
your C or C++ compiler.  With the C/Database Toolchest, your data requires
much less disk space than with programs like dBASE, and you can access your
data much faster.  Of course the full power of C provides you with an
unlimited amount of programming flexibility.

The C/Database Toolchest includes three major components:

   1) An advanced B+ tree library gives you instant access to your data.
   2) A high-level ISAM library provides you with an easy-to-use C
      interface, and
   3) A complete database manager (with C source code included) shows
      you how to create impressive applications.

You also receive a comprehensive 350 page manual and a utility for
converting to and from dBASE files.

The C/Database Toolchest supports features that you'd expect to find only
in products costing ten times as much.  Advanced features include variable
length records, variable length keys, multiple keys per index and multiple
indexes stored in a single file.  Your data files can contain an unlimited
number of records, and each record can be as large as 32K bytes in length.

About the only thing that the C/Database Toolchest doesn't do is cost you a
lot of money.  We've kept our price low so you can manage your budget as
easily as your data.

   The C/Database Toolchest, now only $19.95
   Source for the B+ tree and ISAM libraries is $10.00
.*

.*

.*

.section MKS Source Integrity (&cat)
.*
.np
.illust begin
Mortice Kern Systems, Inc.
185 Columbia Street West
Waterloo, Ontario, Canada  N2L 5Z5


Sales:  (800) 265-2797
Tel:  (519) 884-2251
FAX:  (519) 884-8861
.illust end
.*
.np
.*
.ix 'MKS Source Integrity (&cat)'

.ix 'Mortice Kern Systems, Inc.'

.ix '&cat'
.*
MKS Source Integrity is a complete, project oriented version control and build
system.  With MKS Source Integrity, you can:
.np
.illust begin
     - Track which files are included in each project so important files are
never lost or left behind.

     - Know the current version of each file that is associated with the
project.

     - See at a glance which files are currently locked for editing and who has
locked them.

     - Track dependencies between files and import these dependencies into your
make file.

     - Take snapshots of your project and recreate these snapshots at any point
in the future.
.illust end
.np
MKS Source Integrity offers true team development with sandboxes.  Sandboxes
offer every team member a safe, personalized place to work.  Changes to project
files are automatically communicated to leverage team development.
.np
MKS Source Integrity is designed to make your entire development team more
productive.  You can use our state of the art GUI, or you can access MKS Source
Integrity from the command line.  We even have built in integration into the
WATCOM C/C++ IDE to make MKS Source Integrity the ultimate in ease of use.
.np
Additional features of MKS Source Integrity include:  visual differencing and
visual merging, event triggers, built in reporting facilities, both binary and
text files support, an advanced promotion
model, and more.
.*

.*

.*

.section CodeBase (&cat)
.*
.np
.illust begin
Sequiter Software, Inc.
Suite 209, 9644 - 54 Avenue
Edmonton, Alberta, Canada T6E 5V1


Tel:  (403) 437-2410
FAX:  (403) 436-2999
.illust end
.*
.np
.*
.ix 'CodeBase (&cat)'

.ix 'Sequiter Software, Inc.'

.ix '&cat'
.*
CodeBase 5.1 is a multi-user Xbase compatible C/C++ library for database
management.  With CodeBase, your applications can use any of the five most
popular indexing formats as well as their associated memo files:  FoxPro 2.0
(.CDX, .IDX), dBASE IV (.MDX), dBASE  III
PLUS (.NDX), and Clipper (.NTX).  CodeBase 5.1 also provides record and file
locking that is compatible with the multi-user versions of dBASE IV, FoxPro 2
and Clipper.  Easy to use,... Named like familiar dBase commands, CodeBase 5.1
functions reduce your learning curve by
allowing  you to use your xBase expertise right away.  CodeBase 5.1
applications automatically utilize our new Bit Optimized Query Technology to
return query results on a 500,000 record data file in just one second!
CodeReporter 2.0 and special CodeBase 5.1 reporting functions make designing
and generating reports from your C/C++ applications simple.  CodeBase 5.1,
combined with CodeControls 2.0 our Data Aware custom controls, turn your
favorite compiler into a
visual development environment.  The Standard version of CodeBase 5.1 supports
most compilers under DOS, OS/2 and Windows, and Windows NT.  Upgrade to the
special Multi-Platform version of CodeBase 5.1 to port your application to
UNIX, SUN, AIX and The Macintosh.  (CodeBase 5.1 includes: complete library
Source Code,  CodeReporter 2.0,
CodeControls 2.0 and Royalty Free distribution of your application.)
.*

.*

.*

.section RC/21 (&cat)
.*
.np
.illust begin
Vermont Database Corporation
400 Upper Hollow Hill Road
Stowe, Vermont  05672


Sales:  (800) 822-4437
Tel:  (802) 253-4437
FAX:  (802) 253-4146
.illust end
.*
.np
.*
.ix 'RC/21 (&cat)'

.ix 'Vermont Database Corporation'

.ix '&cat'
.*
RC/21 is a set of relational database management functions and classes that
perform high-level operations similar to SQL.  RC/21 contains many features not
normally found in a callable database product, including free-text search in
columns, extended BLOB operations with embedded navigation structures and high-
level query language.   ODBC drivers and server configurations are available
for a number of networks and multiprocess operating environments.  Source is
also available.
.*

.*

.*

.section Watcom SQL (&cat)
.*
.np
.illust begin
Watcom International Corporation
415 Phillip Street
Waterloo, Ontario, Canada
N2L 3X2

Sales:  (800) 265-4555
Tel:  (519) 886-3700
FAX:  (519) 747-4971
.illust end
.*
.np
.*
.ix 'Watcom SQL (&cat)'

.ix 'Watcom International Corporation'

.ix '&cat'
.*
Watcom SQL 4.0 is a multi-platform standalone database supporting popular
operating environments including Windows, Windows 95, Windows NT, OS/2 and
DOS. Watcom SQL lets you exploit key benefits of true client/server computing
by providing transaction processing and referential integrity to ensure the
consistency of your data. Client/server applications can be designed to run
without change in both the standalone and multi-user environments, to any of
the supported platforms. Highlights include: stored procedures, triggers,
cascading updates and deletes, bi-directional scrollable cursor, row-level
locking, ANSI SQL and IBM SAA standard.
.*

.*

.*
:set symbol="cat" value="Debugging Tools"

.chap Debugging Tools
.*
.np
The following section contains listings for debugging tools supporting
Watcom C or C++.
.*

.section CSI-Locate (&cat)
.*
.np
.illust begin
Concurrent Sciences Inc.
530 South Asbury Street, Suite 4
P.O. Box 9666
Moscow, Idaho 83843

Tel:  (208) 882-0445
FAX:  (208) 882-9774
.illust end
.*
.np
.*
.ix 'CSI-Locate (&cat)'

.ix 'Concurrent Sciences Inc.'

.ix '&cat'
.*
CSi-Locate
.np
CSi-Locate is a locator utility that supports off-the-shelf C/C++ compilers
from Microsoft, Borland and Watcom and prepares your DOS and Windows executable
files for debugging with Soft-Scope and burning into EPROM.  The combination of
these compilers with Soft-Scope and CSi-Locate creates a complete tool kit for
embedded 80x86 development.
.*

.*

.*

.section Soft-Scope Remote Target Debugger (&cat)
.*
.np
.illust begin
Concurrent Sciences Inc.
530 South Asbury Street, Suite 4
P.O. Box 9666
Moscow, Idaho 83843

Tel:  (208) 882-0445
FAX:  (208) 882-9774
.illust end
.*
.np
.*
.ix 'Soft-Scope Remote Target Debugger (&cat)'

.ix 'Concurrent Sciences Inc.'

.ix '&cat'
.*
Soft-Scope
.np
Soft-Scope is a source-level, remote-target debugger that supports both real-
and protected-mode applications for the entire Intel 80x86 family, including
the new 32-bit Intel386 EX embedded microprocessor.  Soft-Scope supports C/C++
compilers from Microsoft, Borland, Watcom, MetaWare and Intel and is available
for both Microsoft Windows and DOS.  Several configurations are available
including Soft-Scope/CSi-Mon, Soft-Scope/iRMX, Soft-Scope/iRMX EMB and others.
Soft-Scope also supports the Applied Microsystems CodeTAP and Hitexs TX386
in-circuit emulators, Tektronix logic analyzers, Ampro embedded PC boards and
iRMX, C EXECUTIVE, MTOS, AMX, SMX and ROM-DOS run-time operating system
kernels.
.np
Soft-Scope communicates with our target-resident CSi-Mon monitor via a PC's
serial port.  When used with Grammar Engines PromICE ROM emulator, CSi-Mon can
be accessed via the target boards EPROM socket.  The complete CSi-Mon source
code is included in the package plus a royalty-free license that allows it to
be incorporated into the application, making it easy to create startup code,
install bug fixes and perform on-site testing.
.*
.figure *depth='2.75' *scale= *file='CSI'
.*

.*

.section CauseWay for Watcom C/C++ and Assembly Language (&cat)
.*
.np
.illust begin
Devore Software & Consulting
P.O. Box 4283
Naperville, IL  60567-4283


Tel:  708-717-6389
FAX:  708-717-6373
.illust end
.*
.np
.*
.ix 'CauseWay for Watcom C/C++ and Assembly Language (&cat)'

.ix 'Devore Software & Consulting'

.ix '&cat'
.*
.illust begin
CauseWay is a plug and play replacement for the Watcom C/C++ bundled version of
DOS/4GW.  Once installed, the developer specifies CauseWay as the target
extender and compiles, links, and debugs as usual.

The CauseWay extender binds to the executable file, adding 45K to the file
size; provides full DPMI .9 function support; offers a virtual address space of
4G, and reflects all hardware interrupts to protected mode when a handler is
installed.  It supports EXE file compression and DOS DLLs.   On application
fault, CauseWay creates an error file with extensive CPU state and memory
resource information.  Desired memory settings can be 'burned' into the
application.

CauseWay has faster file I/O, functions, and virtual memory than the bundled
DOS/4GW extender.  No startup advertising banner is displayed when running
CauseWay-built applications.

CauseWay runs all 386 DOS-extended applications in 150K of free conventional
memory with 350K free extended memory, or in 500K conventional memory with no
free extended memory.  (More memory is recommended for larger programs).
CauseWay allocates memory from DPMI, VCPI, XMS, INT 15h and conventional DOS
memory.  Supported environments are MS-DOS 3.1 or higher, Windows 3.1, Windows
'95, and OS/2.  There are no runtime licensing fees.

CauseWay, priced at $195.00, is available from Devore Software & Consulting.
Technical support via phone, fax, BBS, and e-mail is free for the first year
after purchase, including electronic file updates.  All purchases carry a
liberal no-fault return policy.  CauseWay enjoys active, user-influenced,
development.  Call 1-708-717-6369 or fax 1-708-717-6373 for orders.
.illust end
.*

.*

.*

.section PC-lint for C/C++ (&cat)
.*
.np
.illust begin
Gimpel Software
3207 Hogarth Lane
Collegeville, Pennsylvania 19426


Tel:  (610) 584-4261
FAX:  (610) 584-4266
.illust end
.*
.np
.*
.ix 'PC-lint for C/C++ (&cat)'

.ix 'Gimpel Software'

.ix '&cat'
.*
PC-lint for C/C++ is a source code checker that supports a mixed suite of C and
C++ modules.
It will find bugs, glitches and inconsistencies that a compiler working on one
module at a time will miss.
.np
Are your inherited destructors virtual?  Are your constructor new's matched by
your destructor delete's?  Are names inadvertently hiding other names?  Are C++
modules consistent with C
modules?
.np
PC-lint for C/C++ will find these problems, as well as, missing or redundant
access specifiers, out-of-order constructor initializers, creation of
temporaries, undefined and unreferenced class members, and more.
.np
Full C++ Support:  PC-lint for C/C++ is based on the ARM and is tracking the
latest ANSI/ISO draft including exceptions and templates.
.np
PC-lint for C/C++ also includes our traditional C checking, such as,
inconsistent declarations, argument/parameter mismatches, uninitialized
variables, unaccessed variables, variables assigned but not used, suspicious
macros, indentation irregularities, loss of precision, unusual Booleans,
signed/unsigned mismatches, suspicious expressions, unused macros, printf-scanf
irregularities and more.
.np
PC-lint provides for strong type checking based on typedef and it will flag
variables not initialized based on the flow of control.
.np

It provides a plethora of options for message suppression, message format,
compiler dependencies, etc.  All messages can be individually suppressed or
enabled, both locally and globally. Runs on MS-DOS, Windows NT and OS/2.  The
DOS executable uses a built-in 386 DOS extender to enable it to handle very
large applications.
.*

.*

.*

.section smxProbe (&cat)
.*
.np
.illust begin
Micro Digital, Inc.
12842 Valley View Street
Garden Grove, CA 92649


Sales:  (800) 366-2491
Tel:  (714) 373-6862
FAX:  (714) 891-2363
.illust end
.*
.np
.*
.ix 'smxProbe (&cat)'

.ix 'Micro Digital, Inc.'

.ix '&cat'
.*
smxProbe is a task-level debugger for high-level debugging of systems based
upon smx.  Unlike code debuggers which allow stepping through or breaking upon
instructions and looking at
variables,  smxProbe allows triggering or breaking upon task operations and
looking at control blocks, queues, and trace buffers.  Besides being an
invaluable debugging tool, smxProbe
will show the user the high-level workings of his code and will strengthen his
understanding of multitasking.
.np
We purposely kept smxProbe simple.  Its functionality is limited to only the
most useful debugging commands. This way, the user is freed from having to
learn yet another complicated development
tool!
.np
The primary features of smxProbe are as follows:  smxProbe maintains three
trace buffers:  error buffer, task trace buffer, and smx call trace buffer.
These are allocated from the far heap.  Each may be up to 64K bytes in size.
Trace buffers can be viewed with the showb() command.  In addition, smxProbe
permits examining smx control blocks and queues.  All information is
presented symbolically and is nicely formatted.  smxProbe allows setting
triggerpoints and breakpoints.  It also permits freezing tasks below a
specified level.  In addition to the smxProbe
commands, all smx calls (e.g. start(atask)) may be executed from the smxProbe
command line.  All functions can be performed while the application is running
or stopped.
.np
smxProbe operates standalone or with a code debugger.  It also can be operated
locally or remotely via a serial link.
.*

.*

.*

.section HeapAgent (&cat)
.*
.np
.illust begin
MicroQuill Software Publishing, Inc.
4900 25th Avenue N.E.  Suite 206
Seattle, WA  98105


Sales:  (800) 441-7822
Tel:  (206) 525-8218
FAX:  (206) 525-8309
.illust end
.*
.np
.*
.ix 'HeapAgent (&cat)'

.ix 'MicroQuill Software Publishing, Inc.'

.ix '&cat'
.*
HeapAgent is an interactive memory error debugging tool for programmers.
Unlike tools designed for testing, HeapAgent doesnt stop at detecting memory
errors.  You can also use HeapAgents tools to diagnose the cause of each
error.  And because HeapAgent doesnt require relinking or recompiling, works
with your debuggers normal Run or Step commands, and causes minimal
slowdowns in runtime performance (about 25%), you can use it all the time,
thereby detecting and fixing memory bugs much earlier in the development cycle.
HeapAgent detects a broad range of nasty memory errors, and reports more
information about each error than any other memory debugging tool.  In addition
to file and line, HeapAgent provides a sequentially assigned allocation number,
the contents and address of each allocated object, and, most important, a pass
count.  For source lines that allocate more than one object, the pass count
tells you which pass of the line allocated a given object and thereby ties the
error to a specific data object.
HeapAgent includes a comprehensive memory debugger.  You can set breakpoints on
critical heap events, such as the 32nd call to new from foo line 12, or all
calls to new from main.  You can also browse the live heap at any time for heap-
related information, including allocations, their contents, and the source that
created them.  Moreover, these browsers are linked  you can, for example,
click on a byte of memory in the Dump Browser and immediately display the
source that allocated it or display its declared size.
.*

.*

.*

.section SmartHeap (&cat)
.*
.np
.illust begin
MicroQuill Software Publishing, Inc.
4900 25th Avenue N.E.  Suite 206
Seattle, WA  98105


Sales:  (800) 441-7822
Tel:  (206) 525-8218
FAX:  (206) 525-8309
.illust end
.*
.np
.*
.ix 'SmartHeap (&cat)'

.ix 'MicroQuill Software Publishing, Inc.'

.ix '&cat'
.*
SmartHeap is a professional memory management library and debugging toolkit.
SmartHeap excels in four crucial areas:  speed; error detection; reliability;
and portability.
Speed
In C and C++ applications running on virtual memory systems, malloc and
operator new affect performance more than any other factor.  SmartHeaps
proprietary algorithms deliver unparalleled malloc/new performance, up to 100X
faster.  You can achieve even better results if you use SmartHeaps malloc/new
to automatically route small allocations below a parameterized threshold to an
extremely fast fixed-size allocator, or if you use SmartHeaps multiple memory
pools to improve locality and further eliminate fragmentation.
Error Detection
Because SmartHeap implements and manages the heap, it detects bugs that other
debugging tools miss, thus delivering the most complete heap error detection
available.  In addition, SmartHeap uses its knowledge of the heap to provide
unsurpassed detail about each errors cause.  Bugs detected by SmartHeap
include:  leakage, memory overwrites, double-freeing, wild pointers, invalid
parameters, out of memory, references to previously freed memory, etc.
Portability
SmartHeap ships as binary linkable libraries for DOS, Windows, NT, Mac, OS/2,
UNIX, etc.  Each version provides an identical API, but is specifically
optimized for that particular environment.  Finally, SmartHeaps malloc and new
are strictly ANSI compliant, so you dont have to code to a proprietary API to
realize SmartHeaps benefits.
Reliability
To ensure the ultimate in error-free operation, we built a certification tester
that calls each SmartHeap API hundreds of thousands of times, comprehensively
testing all possible conditions and proving that all the bugs are out.
.*

.*

.*

.section TNT DOS Extender SDK (&cat)
.*
.np
.illust begin
Phar Lap Software
60 Aberdeen Avenue
Cambridge, MA  02138


Tel:  (617) 661-1510
FAX:  (617) 876-2972
.illust end
.*
.np
.*
.ix 'TNT DOS Extender SDK (&cat)'

.ix 'Phar Lap Software'

.ix '&cat'
.*
TNT DOS-Extender SDK Version 8.0
.np
.illust begin
 Write 32-Bit Protected Mode Realtime Programs for MS DOS
 Write Multi Megabyte MS DOS Embedded Applications with 32-Bit Addressing
 Trap Real Mode Interrupts and Pass to Application in Protected Mode
 DosStyle or NtStyle
.illust end
.np
.illust begin
Under NtStyle:
 216 Win32 APIs Supported
 DLLs, Threads, Multitasking, Priority SchedulingAll Four NT Classes
 Semaphores, Mutex, Events
 Adjustable Time SlicesAs Short as 1 Millisecond
 Interrupt Drivers for Printing and Mouse Control
 Disk and Keyboard Drivers Allow Other Threads to Execute During Idle or
Waiting times
 Multiple Extended-DOS Programs Share a Single Copy of the DOS-Extender
.illust end
.np
.illust begin
Under DosStyle:
 Dynamic Link Libraries
 INT 21h Interface
 Uses Less Memory
.illust end
.np
The TNT DOS-Extender SDK is a 32-bit development tool that enables programmers
to build multi-megabyte embedded and realtime applications that take advantage
of powerful Windows NT features. These features include DLLs, threads, priority
scheduling, and multitasking, under MS DOS. The TNT DOS Extender product
includes the WinPipe VXD which enables developers to write a Windows GUI front
end for their 32-bit DOS applications. The TNT DOS-Extender software runs on
any DOS-based 80386 or higher PC and supports a wide range of 32-bit tools.
including C and C++ compilers from Microsoft, Borland, MetaWare, Symantec, and
Watcom. In addition to the TNT DOS-Extender software, the SDK includes a 32-bit
version of the Microsoft CodeView debugger and Phar Laps SRCBug debugger,
386|ASM macro assembler, and 386|LIB librarian.
.*
.figure *depth='2.75' *scale= *file='dos_ext'
.*

.*

.section TNT Embedded ToolSuite SDK (&cat)
.*
.np
.illust begin
Phar Lap Software
60 Aberdeen Avenue
Cambridge, MA  02138


Tel:  (617) 661-1510
FAX:  (617) 876-2972
.illust end
.*
.np
.*
.ix 'TNT Embedded ToolSuite SDK (&cat)'

.ix 'Phar Lap Software'

.ix '&cat'
.*
TNT Embedded ToolSuite version 8.0
.np
The TNT Embedded ToolSuite version 8.0 software set from Phar Lap Software,
Inc. is a suite of development tools delivering a total solution for 32-bit
embedded realtime systems development.
.np
.illust begin
The suite consists of:
 TNT Embedded Realtime Kernel Threads, Priority scheduling, Semaphores, Events,
Pipes, and more
 Visual System Builder
 LinkLoc 32-bit linker/locator
 CVEMB and TDEMB shells for embedded debugging
 Full support for C/C++ run-time libraries
 MS DOS compatible file system
 Floating point emulation library
.illust end
.np
The TNT Embedded ToolSuite system allows a developer to use familiar compilers,
debuggers, and other tools to create a 386/486/Pentium processor based embedded
realtime system. Compilers supported are the C/C++ compilers from Microsoft,
Borland, Watcom, and MetaWare.
The TNT Embedded Kernel is sold with an unlimited run-time licence for use on a
single embedded product.
.np
Requirements for a ROMed embedded kernel are 14K ROM and 13K RAM and a serial
or parallel port. Embedded programs can be loaded from either diskettes or hard
disks. Single board computers such as PC/104 computers make ideal targets.
.np
Minimum host requirements are a MS DOS or Windows compatible system with 4M
memory, C/C++ compiler, and a serial or parallel line for debugging the target.
.*
.figure *depth='2.75' *scale= *file='ets_draw'
.*

.*

.section MemCheck Professional for DOS (&cat)
.*
.np
.illust begin
StratosWare Corporation
1756 Plymouth Road, Suite 1500
Ann Arbor, MI  48105


Sales:  (800) 933-3284
Tel:  (313) 996-2944
FAX:  (313) 996-2955
.illust end
.*
.np
.*
.ix 'MemCheck Professional for DOS (&cat)'

.ix 'StratosWare Corporation'

.ix '&cat'
.*
MemCheck 3.5 Professional for DOS is an automatic runtime debugger for C/C++
applications. MemCheck detects memory overwrites, underwrites, memory leaks,
heap corruption, stack overwrites, out-of-memory conditions, and other memory
errors that cost development projects days and weeks of lost time. MemCheck
detects errors in all parts of the host application, including third-party
vendor libraries.

MemCheck operates completely transparently, allowing simultaneous use of
Watcom's debugger (WD). MemCheck identifies errors by exact file and line
number in the source code. Errors may be directed to the screen, to log files,
or wherever desired. MemCheck provides detailed stack and memory usage
statistics, and stack overflow checking superior to standard compilers. Stack
usage statistics are available at run time, and are reported in a log file.

Installation takes 15 minutes or less, even on large projects (automated by a
configuration utility). No source code changes are required. MemCheck may be
switched on or off at runtime, and overhead on large applications is minimal
(approximately 15K). MemCheck runs 10-300 times faster than similar debuggers,
due to its proprietary storage technology.

You'll find MemCheck invaluable in locating bugs on remote or test machines,
since there's no debug info or external .EXE required. When you're done, simply
link out MemCheck via a 'Production' library, or compile it completely out with
no source code changes.

StratosWare offers an unconditional 60-day money-back guarantee and free
technical support. The price is $139; the upgrade from MemCheck 3.0
Professional for DOS is $49.

***MemCheck 3.5 Professional for Extended DOS***

MemCheck 3.5 Professional for Extended DOS is the only automatic runtime
debugging tool for C/C++ developers supporting both 16- and 32-bit protected
mode under DOS. MemCheck detects memory overwrites, underwrites, memory leaks,
heap corruption, stack overwrites, out-of-memory conditions, and other memory
errors that cost development projects days and weeks of lost time. MemCheck
detects errors in all parts of the host application, including third-party
vendor libraries.

MemCheck operates completely transparently, allowing simultaneous use of
Watcom's debugger (WD). MemCheck identifies errors by exact file and line
number in the source code. Errors may be directed to the screen, to log files,
or wherever desired.

MemCheck aids protected-mode developers by generating a stack trace with symbol
names on GPFs, exceptions, and stack overflow, replacing the default runtime
behaviour of simply printing a register dump and terminating the program.

Automated by a configuration utility, installation takes 15 minutes or less,
and requires no source code changes. MemCheck may be switched on or off at
runtime, and overhead on large applications is minimal (approximately 15K).
MemCheck runs 10-300 times faster than similar debuggers.

You'll find MemCheck invaluable in locating bugs on remote or test machines,
since there's no debug info or external .EXE required. When you're done, simply
link out MemCheck via a 'Production' library, or compile it completely out with
no source code changes.

StratosWare offers an unconditional 60-day money-back guarantee and free
technical support. The price is $139; the upgrade from MemCheck 3.0
Professional for Extended DOS is $49.
.*
.figure *depth='2.75' *scale= *file='mc-demo'
.*

.*

.section MemCheck Professional for Extended DOS (&cat)
.*
.np
.illust begin
StratosWare Corporation
1756 Plymouth Road, Suite 1500
Ann Arbor, MI  48105


Sales:  (800) 933-3284
Tel:  (313) 996-2944
FAX:  (313) 996-2955
.illust end
.*
.np
.*
.ix 'MemCheck Professional for Extended DOS (&cat)'

.ix 'StratosWare Corporation'

.ix '&cat'
.*
MemCheck 3.5 Professional for DOS is an automatic runtime debugger for C/C++
applications. MemCheck detects memory overwrites, underwrites, memory leaks,
heap corruption, stack overwrites, out-of-memory conditions, and other memory
errors that cost development projects days and weeks of lost time. MemCheck
detects errors in all parts of the host application, including third-party
vendor libraries.

MemCheck operates completely transparently, allowing simultaneous use of
Watcom's debugger (WD). MemCheck identifies errors by exact file and line
number in the source code. Errors may be directed to the screen, to log files,
or wherever desired. MemCheck provides detailed stack and memory usage
statistics, and stack overflow checking superior to standard compilers. Stack
usage statistics are available at run time, and are reported in a log file.

Installation takes 15 minutes or less, even on large projects (automated by a
configuration utility). No source code changes are required. MemCheck may be
switched on or off at runtime, and overhead on large applications is minimal
(approximately 15K). MemCheck runs 10-300 times faster than similar debuggers,
due to its proprietary storage technology.

You'll find MemCheck invaluable in locating bugs on remote or test machines,
since there's no debug info or external .EXE required. When you're done, simply
link out MemCheck via a 'Production' library, or compile it completely out with
no source code changes.

StratosWare offers an unconditional 60-day money-back guarantee and free
technical support. The price is $139; the upgrade from MemCheck 3.0
Professional for DOS is $49.

***MemCheck 3.5 Professional for Extended DOS***

MemCheck 3.5 Professional for Extended DOS is the only automatic runtime
debugging tool for C/C++ developers supporting both 16- and 32-bit protected
mode under DOS. MemCheck detects memory overwrites, underwrites, memory leaks,
heap corruption, stack overwrites, out-of-memory conditions, and other memory
errors that cost development projects days and weeks of lost time. MemCheck
detects errors in all parts of the host application, including third-party
vendor libraries.

MemCheck operates completely transparently, allowing simultaneous use of
Watcom's debugger (WD). MemCheck identifies errors by exact file and line
number in the source code. Errors may be directed to the screen, to log files,
or wherever desired.

MemCheck aids protected-mode developers by generating a stack trace with symbol
names on GPFs, exceptions, and stack overflow, replacing the default runtime
behaviour of simply printing a register dump and terminating the program.

Automated by a configuration utility, installation takes 15 minutes or less,
and requires no source code changes. MemCheck may be switched on or off at
runtime, and overhead on large applications is minimal (approximately 15K).
MemCheck runs 10-300 times faster than similar debuggers.

You'll find MemCheck invaluable in locating bugs on remote or test machines,
since there's no debug info or external .EXE required. When you're done, simply
link out MemCheck via a 'Production' library, or compile it completely out with
no source code changes.

StratosWare offers an unconditional 60-day money-back guarantee and free
technical support. The price is $139; the upgrade from MemCheck 3.0
Professional for Extended DOS is $49.
.*

.*

.*

.section Link & Locate 386 (&cat)
.*
.np
.illust begin
Systems & Software, Inc.
18102 Cowan, Suite 100
Irvine, California  92714


Sales:  (800) 788-4386
Tel:  (714) 833-1700
FAX:  (714) 833-1900
.illust end
.*
.np
.*
.ix 'Link & Locate 386 (&cat)'

.ix 'Systems & Software, Inc.'

.ix '&cat'
.*
Link&Locate 386:  An absolute linker and locator for embedded development.
It supports the building of 32-bit protected-mode programs for Intel 386/486
embedded
applications and 32-bit DOS extender application using Watcom C/C++, and/or
WASM.
However, the output absolute object files contain debug information in Intel
OMF-286/386
format which only supports C and assembly source-level debugging.  It includes
start-up code,
C, C++ and floating-point examples, run-time library and floating-point
support.

Link&Locate 386 is provided with executables hosted for both DOS and Microsoft
Windows
NT.  Link&Locate 386 supports the construction of flat or multi-segmented
programs. It has the
flexibility to define and construct segment descriptors, local, global, and
interrupt descriptor
tables, task, interrupt, call, and trap gates, and task state segments.

Third party debugger support includes in-circuit emulators from Microtek
International, Inc. and
Kontron Elektronik GmbH.

Requires 80386 PC or higher, 2 MBytes of memory,  DOS 5.0 or later, and 4
MBytes of hard
disk space.
.*

.*

.*

.section SoftProbe 386/RED (&cat)
.*
.np
.illust begin
Systems & Software, Inc.
18102 Cowan, Suite 100
Irvine, California  92714


Sales:  (800) 788-4386
Tel:  (714) 833-1700
FAX:  (714) 833-1900
.illust end
.*
.np
.*
.ix 'SoftProbe 386/RED (&cat)'

.ix 'Systems & Software, Inc.'

.ix '&cat'
.*
SoftProbe 386/RED:  A DOS-hosted source-level ROM emulator debugger that allows
downloading of a program from the host PC and debugging of the actual 386/486
target system
in real mode and protected mode.  It accepts executable files in Intel OMF-
86/286/386
bootloadable file format.  It also includes a multi-window user interface, a
Target Monitor
program and a Grammar Engine Inc.s PROMICE ROM emulator hardware kit.

SoftProbe 386/RED has a multi-window interface with pull-down menus, mouse
support, online
help, and overlapping and resizable windows.  The multi-window feature enables
you to
concurrently display command dialog and history, source, registers, memory,
program variables,
execution history, and much more.

SoftProbe 386/RED gives you complete access to symbolic names, data types,
functions, source
statements and source modules in both C and assembly.  C-like expression
evaluation can be
used to examine and modify program objects.  An inline assembler allows program
code to be
input in assembly mnemonics.
The Target Monitor controls program execution on the target.  The Target
Monitor
communicates with the host through a ROM-Emulator with a RS-232 serial port and
requires 19
KBytes ROM and 28 KBytes RAM.
The target monitor uses 386 debug registers to facilitate debugging.  It
provides up to 32
breakpoints (program execution breakpoints or data watchpoints).  Program
conditions can
activate breakpoints.

Requires 80386 PC or higher, 2 MBytes of memory,  DOS 5.0 or later, and 3
MBytes of hard
disk space.  A Microsoft-compatible mouse is supported, but not required.
.*

.*

.*

.section SoftProbe 386/SIM (&cat)
.*
.np
.illust begin
Systems & Software, Inc.
18102 Cowan, Suite 100
Irvine, California  92714


Sales:  (800) 788-4386
Tel:  (714) 833-1700
FAX:  (714) 833-1900
.illust end
.*
.np
.*
.ix 'SoftProbe 386/SIM (&cat)'

.ix 'Systems & Software, Inc.'

.ix '&cat'
.*
SoftProbe 386/SIM:  DOS-hosted bus-level simulator and source-level debugger
for debugging
real mode and protected mode 80386 embedded C and assembly applications.  It
accepts
executable files in Intel OMF-86/286/386 bootloadable format.

SoftProbe 386/SIM performs program execution via software simulation.
SoftProbe 386/SIM
provides 80386 CPU (all modes of operation) and 80387 coprocessor simulation at
the bus
level.  The simulation model also supports 4 GBytes memory, direct and memory-
mapped I/O,
master and slave 8259A programmable interrupt controllers, and 8254
programmable interval
timer.

SoftProbe 386/SIM gives you complete access to symbolic names, data types,
functions, source
statements and source modules in both C and assembly.  C-like expression
evaluation can be
used to examine and modify program objects.

SoftProbe 386/SIM provides 32 software breakpoints.  You can define elaborate
and complex
program breakpoints using Boolean expressions of the trigger registers.  You
can control
breakpoints with pass counts and delay counts.

SoftProbe 386/SIM provides path coverage and profiling facilities.  The path
coverage facility
tells you which blocks of program code have been executed.  The profiling
facility provides
execution statistics on a procedure-by-procedure basis.  This helps you to
pinpoint program
bottlenecks.
.*

.*

.*

.section SoftProbe 386/TX (&cat)
.*
.np
.illust begin
Systems & Software, Inc.
18102 Cowan, Suite 100
Irvine, California  92714


Sales:  (800) 788-4386
Tel:  (714) 833-1700
FAX:  (714) 833-1900
.illust end
.*
.np
.*
.ix 'SoftProbe 386/TX (&cat)'

.ix 'Systems & Software, Inc.'

.ix '&cat'
.*
SoftProbe 386/TX:  A DOS-hosted source-level debugger that allows downloading
of a
program from the host PC and debugging on the actual 386/486 target system in
real mode and
protected mode.  It accepts executable files in Intel OMF-86/286/386
bootloadable file format.
It also includes a multi-window user interface and a Target Monitor program.

SoftProbe 386/TX has a multi-window interface with pull-down menus, mouse
support, online
help, and overlapping and resizable windows.  The multi-window feature enables
you to
concurrently display command dialog and history, source, registers, memory,
program variables,
execution history, and much more.

SoftProbe 386/TX gives you complete access to symbolic names, data types,
functions, source
statements and source modules in both C and assembly.  C-like expression
evaluation can be
used to examine and modify program objects.  An inline assembler allows program
code to be
input in assembly mnemonics.
The Target Monitor controls program execution on the target.  The Target
Monitor
communicates with the host through a RS-232 serial port and requires 19 KBytes
ROM and 28
KBytes RAM.
The target monitor uses 386 debug registers to facilitate debugging.  It
provides up to 32
breakpoints (program execution breakpoints or data watchpoints).  Program
conditions can
activate breakpoints.  You can define command sequences that are invoked when a
breakpoint is
encountered.

Requires 80386 PC or higher, 2 MBytes of memory,  DOS 5.0 or later, and 3
MBytes of hard
disk space and a RS-232 serial port.  A Microsoft-compatible mouse is
supported, but not
required.
.*

.*

.*

.section SoftProbe 386EX/SIM (&cat)
.*
.np
.illust begin
Systems & Software, Inc.
18102 Cowan, Suite 100
Irvine, California  92714


Sales:  (800) 788-4386
Tel:  (714) 833-1700
FAX:  (714) 833-1900
.illust end
.*
.np
.*
.ix 'SoftProbe 386EX/SIM (&cat)'

.ix 'Systems & Software, Inc.'

.ix '&cat'
.*
SoftProbe 386EX/SIM:  Developed specifically for Intel and the 80386EX embedded
processor.  It is DOS-hosted bus-level simulator and source-level debugger for
debugging real
mode and protected mode 80386EX embedded C and assembly applications.  It
accepts
executable files in Intel OMF-86/286/386 bootloadable format.

SoftProbe 386EX/SIM performs program execution via software simulation.
SoftProbe
386EX/SIM provides 80386EX CPU (all modes of operation) and 80387 coprocessor
simulation at the bus level.  The simulation model also support 64 MBytes
memory, direct and
memory-mapped I/O, master and slave 8259A programmable interrupt controllers,
and 8254
programmable interval timer.

SoftProbe 386EX/SIM gives you complete access to symbolic names, data types,
functions,
source statements and source modules in both C and assembly.  C-like expression
evaluation can
be used to examine and modify program objects.

SoftProbe 386EX/SIM provides 32 software breakpoints.  You can define elaborate
and
complex program breakpoints using Boolean expressions of the trigger registers.
You can
control breakpoints with pass counts and delay counts.

SoftProbe 386EX/SIM provides path coverage and profiling facilities.  The path
coverage
facility tells you which blocks of program code have been executed.  The
profiling facility
provides execution statistics on a procedure-by-procedure basis.  This helps
you to pinpoint
program bottlenecks.
.*

.*

.*

.section SoftProbe 486/SIM (&cat)
.*
.np
.illust begin
Systems & Software, Inc.
18102 Cowan, Suite 100
Irvine, California  92714


Sales:  (800) 788-4386
Tel:  (714) 833-1700
FAX:  (714) 833-1900
.illust end
.*
.np
.*
.ix 'SoftProbe 486/SIM (&cat)'

.ix 'Systems & Software, Inc.'

.ix '&cat'
.*
SoftProbe 486/SIM:  DOS-hosted bus-level simulator and source-level debugger
for debugging
real mode and protected mode 80486 embedded C and assembly applications.  It
accepts
executable files in Intel OMF-86/286/386 bootloadable format.

SoftProbe 486/SIM performs program execution via software simulation.
SoftProbe 486/SIM
provides 80486 CPU (all modes of operation) and 80387 coprocessor simulation at
the bus
level.  The simulation model also supports 4 GBytes memory, direct and memory-
mapped I/O,
master and slave 8259A programmable interrupt controllers, and 8254
programmable interval
timer.

SoftProbe 486/SIM gives you complete access to symbolic names, data types,
functions, source
statements and source modules in both C and assembly.  C-like expression
evaluation can be
used to examine and modify program objects.

SoftProbe 486/SIM provides 32 software breakpoints.  You can define elaborate
and complex
program breakpoints using Boolean expressions of the trigger registers.  You
can control
breakpoints with pass counts and delay counts.

SoftProbe 486/SIM provides path coverage and profiling facilities.  The path
coverage facility
tells you which blocks of program code have been executed.  The profiling
facility provides
execution statistics on a procedure-by-procedure basis.  This helps you to
pinpoint program
bottlenecks.
.*

.*

.*

.section Periscope Debugger Hardware (&cat)
.*
.np
.illust begin
The Periscope Company, Inc.
1475 Peachtree Street NE
Suite 100
Atlanta, GA  30309

Sales:  800-722-7006
Tel:  (404) 888-5335
FAX:  (404) 888-5520
.illust end
.*
.np
.*
.ix 'Periscope Debugger Hardware (&cat)'

.ix 'The Periscope Company, Inc.'

.ix '&cat'
.*
An 'ICE' for Software Developers
.np
Software-only debuggers provide the routine capabilities you need to debug
typical desktop PC software. They enable you to control the execution of the
program you're debugging, i.e., to step through your program at source level,
to break on specified conditions, and to examine and make changes as needed to
registers, ports, and memory locations.  While software debuggers
are intrusive, when you're debugging an application that runs in a typical
desktop environment, this intrusiveness is usually of little or no consequence.
.np
Conditions are quite different when you're debugging embedded and other types
of software where special challenges dictate the use on non-intrusive debugging
tools.  Hardware-assisted debugging tools, such as in-circuit emulators (ICEs),
offer you the visibility and control you need in such situations by giving you
non-intrusive, real-time debugging capabilities. By far the most valuable of
these capabilities is the real-time trace, which records system activity while
the target system runs at full speed.  By specifying what is to be recorded in
the trace buffer, you can collect the information you need to see what is
causing a particular bug.  And as we all know, once you know the cause of a
bug, it is usually easy to fix it.
.illust begin
If you're bringing up new hardware, you may well need an ICE.  But when you're
developing software for a functioning system, the Periscope hardware gives you
all the real-time ICE capability you need.
.illust end
.illust begin
Whenever:
- you're developing speed-critical, real-time software,
- you need ICE (in-circuit emulator) capabilities, but at an affordable price,
- you have timing-related or intermittent problems to track down,
- your system interacts with the real world in complex ways,
- you can't stop your system with breakpoints,
- you can't go to market with bugs,
- you're holding up the project because your software's late, or
- you need a vacation, or at least a weekend off,
.illust end
Periscope can deliver the debugging power you need at an unbeatable price!
.illust begin
Experts and Users Agree:
'There's absolutely no possible way we could have ever found the bug without
Periscope Model IV!' - Craig Arnush
.illust end
.illust begin
'Periscope does things that few others can match.  If you spend much of your
time on the inside of an operating system looking out, you deserve a Periscope
to improve your view of the world.' - Ben Meyers
.illust end
.illust begin
'Without it [Periscope Model IV], I'd still be working on problems from a year
ago.' - Dennis Williamson
.illust end
.illust begin
'Periscope is well-suited to all sorts of system-level debugging tasks.  For
example, you can trace through DOS or the BIOS and see exactly how they work.
And Periscope makes it easy to debug TSR programs, device drivers, and
interrupt handlers.' - Sal Ricciardi
.illust end
.illust begin
'It's the best I've found...easy to use...and I'm amazed at what I can find!'
- Brad Matthews
.illust end
.illust begin
'If your work involves hardware or problematic software (device drivers, and
interrupt-driven functions like comm ports and networks), Periscope's hardware
assisted debuggers can't be beat.'-Steven Baker
.illust end
.*

.*

.*

.section Periscope/32 (&cat)
.*
.np
.illust begin
The Periscope Company, Inc.
1475 Peachtree Street NE
Suite 100
Atlanta, GA  30309

Sales:  800-722-7006
Tel:  (404) 888-5335
FAX:  (404) 888-5520
.illust end
.*
.np
.*
.ix 'Periscope/32 (&cat)'

.ix 'The Periscope Company, Inc.'

.ix '&cat'
.*
Save time, money, and your sanity... let Periscope help you find even the
toughest bugs.
.np
PERISCOPE SOFTWARE OVERVIEW (revised 7/95)
.np
Periscope Model I user Cas Filar writes, 'I find Periscope a terrific tool...I
certainly can recommend it to anyone who makes a living by writing programs in
C and Assembler. For any serious programmer it must be the debugger of choice.
The support you provide is as good as
the debugger itself-simply great.'
.illust begin
Periscope Debuggers
The core Periscope debuggers product line includes Periscope/EM, Periscope/32,
Periscope Model I, and Periscope Model IV. The Periscope/EM software supports
the Model I and Model IV hardware, and is included in the Model I package.
Periscope/32 is a 32-bit aware
derivative of Periscope/EM. It is included in the Periscope/32 for Windows and
Periscope/32 for OS/2 packages, both of which support the Model IV hardware.
.illust end
.illust begin
Embedded Periscope products include the Model IV hardware plus interface
software for a growing number of embedded debuggers and environments, such as
Phar Lap's TNT Embedded ToolSuite and Concurrent Sciences' Soft-Scope debugger.
.illust end
.illust begin
The following paragraphs describe the capabilities of the Periscope/EM (and
standalone Periscope/32) software. An overview of all Periscope products
follows this description.
.illust end
.illust begin
When the Going Gets Tough Periscope specializes in helping software developers
debug in tough situations. So, in addition to being able to debug applications,
you can debug TSRs, device drivers, and interrupt-service routines. Because
Periscope/EM does not depend on DOS, you can debug software interrupts, non-DOS
programs, pre-DOS programs, even DOS itself.
Periscope/EM also handles exception interrupts. As a bonus, when you're using
the Model I board, you can activate Periscope at ROM-scan time so you can debug
add-in ROM.
.illust end
.illust begin
Trap Uninitialized Pointers and Memory Overwrites Periscope/EM's breakpoints
give you the ability to stop your program's execution whenever it is about to
write into (or read or execute) a range of memory or I/O ports you don't want
it to. When the range is small, you can do this without slowing your program
down by using the debug register breakpoints that Periscope/EM supports. When
the range is larger, you can use software monitor breakpoints. If you need to
run at full speed, you can use Model IV's powerful and sophisticated hardware
breakpoints (requires the Model IV hardware).
.illust end
.illust begin
Easy to Learn and Use Periscope/EM includes optional pull-down menus, automatic
setup,
CodeView and Turbo Debugger function-key emulation, on-screen breakpoint
settings, on-line help, the ability to save and restore debug session
information, and much more, to make it quick and easy to get to Periscope's
considerable capabilities. It also provides symbol and source-
level support for Microsoft, Borland, and other compilers and linkers.
.illust end
.illust begin
Crash Recovery
You get a breakout (NMI) switch with all models of Periscope, so you can break
into the system whenever it crashes, or whenever you want to! The switch is
especially handy when your keyboard's dead and the only alternative is to power
down and back up again.
.illust end
.illust begin
Out of the Way When There's No Room
You can choose whether to load the Periscope/EM software in DOS memory,
extended memory (requires a supporting 386 memory manager), or the Model I
board's memory (requires a Model I board). So when you're debugging software
that needs all or most of the lower 640K, or
that acts differently when you load a debugger in conventional DOS memory,
there are Periscope solutions.
.illust end
.illust begin
AND...The Periscope/EM software takes advantage of the 80386 debug registers to
provide real-time breakpoint capability. It runs on single and dual-monitor
PCs, and can use another PC's video and/or keyboard. It will run with 386
control programs such as 386MAX and QEMM-386
in the system.
.illust end
.illust begin
System Requirements: The Periscope/EM software requires a machine with an 8088
or later CPU; DOS 3.0 or later; one disk drive; and one monitor. To run
Periscope/EM in regular DOS memory, you need an minimum of 75K in the lower
640K. To run Periscope/EM in extended
memory, you need a 386 or later CPU, a supporting 386 memory manager (386MAX,
QEMM, or NETROOM), plus 32K-36K of high DOS memory and 300K of extended memory
(no low DOS memory required). The breakout switch and the Model I board both
require a system with an ISA-compatible bus. Please see the Model IV and
Embedded Periscope literature for the Model IV hardware requirements.
.illust end
.*

.*

.*

.section Periscope/EM (&cat)
.*
.np
.illust begin
The Periscope Company, Inc.
1475 Peachtree Street NE
Suite 100
Atlanta, GA  30309

Sales:  800-722-7006
Tel:  (404) 888-5335
FAX:  (404) 888-5520
.illust end
.*
.np
.*
.ix 'Periscope/EM (&cat)'

.ix 'The Periscope Company, Inc.'

.ix '&cat'
.*
Save time, money, and your sanity... let Periscope help you find even the
toughest bugs.
.np
PERISCOPE SOFTWARE OVERVIEW (revised 7/95)
.np
Periscope Model I user Cas Filar writes, 'I find Periscope a terrific tool...I
certainly can recommend it to anyone who makes a living by writing programs in
C and Assembler. For any serious programmer it must be the debugger of choice.
The support you provide is as good as
the debugger itself-simply great.'
.illust begin
Periscope Debuggers
The core Periscope debuggers product line includes Periscope/EM, Periscope/32,
Periscope Model I, and Periscope Model IV. The Periscope/EM software supports
the Model I and Model IV hardware, and is included in the Model I package.
Periscope/32 is a 32-bit aware
derivative of Periscope/EM. It is included in the Periscope/32 for Windows and
Periscope/32 for OS/2 packages, both of which support the Model IV hardware.
.illust end
.illust begin
Embedded Periscope products include the Model IV hardware plus interface
software for a growing number of embedded debuggers and environments, such as
Phar Lap's TNT Embedded ToolSuite and Concurrent Sciences' Soft-Scope debugger.
.illust end
.illust begin
The following paragraphs describe the capabilities of the Periscope/EM (and
standalone Periscope/32) software. An overview of all Periscope products
follows this description.
.illust end
.illust begin
When the Going Gets Tough Periscope specializes in helping software developers
debug in tough situations. So, in addition to being able to debug applications,
you can debug TSRs, device drivers, and interrupt-service routines. Because
Periscope/EM does not depend on DOS, you can debug software interrupts, non-DOS
programs, pre-DOS programs, even DOS itself.
Periscope/EM also handles exception interrupts. As a bonus, when you're using
the Model I board, you can activate Periscope at ROM-scan time so you can debug
add-in ROM.
.illust end
.illust begin
Trap Uninitialized Pointers and Memory Overwrites Periscope/EM's breakpoints
give you the ability to stop your program's execution whenever it is about to
write into (or read or execute) a range of memory or I/O ports you don't want
it to. When the range is small, you can do this without slowing your program
down by using the debug register breakpoints that Periscope/EM supports. When
the range is larger, you can use software monitor breakpoints. If you need to
run at full speed, you can use Model IV's powerful and sophisticated hardware
breakpoints (requires the Model IV hardware).
.illust end
.illust begin
Easy to Learn and Use Periscope/EM includes optional pull-down menus, automatic
setup,
CodeView and Turbo Debugger function-key emulation, on-screen breakpoint
settings, on-line help, the ability to save and restore debug session
information, and much more, to make it quick and easy to get to Periscope's
considerable capabilities. It also provides symbol and source-
level support for Microsoft, Borland, and other compilers and linkers.
.illust end
.illust begin
Crash Recovery
You get a breakout (NMI) switch with all models of Periscope, so you can break
into the system whenever it crashes, or whenever you want to! The switch is
especially handy when your keyboard's dead and the only alternative is to power
down and back up again.
.illust end
.illust begin
Out of the Way When There's No Room
You can choose whether to load the Periscope/EM software in DOS memory,
extended memory (requires a supporting 386 memory manager), or the Model I
board's memory (requires a Model I board). So when you're debugging software
that needs all or most of the lower 640K, or
that acts differently when you load a debugger in conventional DOS memory,
there are Periscope solutions.
.illust end
.illust begin
AND...The Periscope/EM software takes advantage of the 80386 debug registers to
provide real-time breakpoint capability. It runs on single and dual-monitor
PCs, and can use another PC's video and/or keyboard. It will run with 386
control programs such as 386MAX and QEMM-386
in the system.
.illust end
.illust begin
System Requirements: The Periscope/EM software requires a machine with an 8088
or later CPU; DOS 3.0 or later; one disk drive; and one monitor. To run
Periscope/EM in regular DOS memory, you need an minimum of 75K in the lower
640K. To run Periscope/EM in extended
memory, you need a 386 or later CPU, a supporting 386 memory manager (386MAX,
QEMM, or NETROOM), plus 32K-36K of high DOS memory and 300K of extended memory
(no low DOS memory required). The breakout switch and the Model I board both
require a system with an ISA-compatible bus. Please see the Model IV and
Embedded Periscope literature for the Model IV hardware requirements.
.illust end
.*

.*

.*

.section WinScope (&cat)
.*
.np
.illust begin
The Periscope Company, Inc.
1475 Peachtree Street NE
Suite 100
Atlanta, GA  30309

Sales:  800-722-7006
Tel:  (404) 888-5335
FAX:  (404) 888-5520
.illust end
.*
.np
.*
.ix 'WinScope (&cat)'

.ix 'The Periscope Company, Inc.'

.ix '&cat'
.*

.*

.*

.*
:set symbol="cat" value="DOS Extenders"

.chap DOS Extenders
.*
.np
The following section contains listings for DOS extenders supporting
Watcom C or C++.
.*

.section Blinker (&cat)
.*
.np
.illust begin
Blink, Inc.
8001 W. Broad St.
Richmond, VA  23294


Tel:  (804) 747-6700
FAX:  (804) 747-4200
.illust end
.*
.np
.*
.ix 'Blinker (&cat)'

.ix 'Blink, Inc.'

.ix '&cat'
.*
Blinker 3.2 features a compiler-independent Windows linker, a royalty-free 286
DOS extender, the worlds fastest DOS dynamic overlay linker and an integrated
memory swap function, all in one product forone low price! Compatible with all
the popular C, C++ and FORTRAN compilers, Blinker creates DOS and Windows
programs in seconds, saving hours of valuable programming time.

.np
Why a 286 DOS extender?
The major benefit of a 286 DOS extender is that it will run on any processor
from an 80286 with 1Mb of available memory up to the largest Pentium, whereas a
386 DOS extender requires a minimum of an 80386 processor. The Blinker extender
provides direct access to 16 Mb of
extended memory, runs multi-megabyte programs in protected mode in less than
200 Kb of conventional memory, and solves low memory problems caused by network
shells and other memory hungry TSRs. Fully compatible with DPMI, VCPI and XMS,
so your protected mode programs will run under Windows, DESQview and OS/2 as
well as DOS, it also features a completely transparent virtual memory system to
access up to 64 Mb of virtual memory.

.np
Dual mode - a world first!
Combining a DOS extender with an award-winning linker used by over 50,000
programmers worldwide offers a unique advantage. Blinker 3.0 is the only
product to create dual mode programs, which automatically detect at startup
whether the runtime machine can run in protected mode.  If not, the same
program simply runs in real mode using dynamic overlays, so you can concentrate
on the code instead of worrying about the runtime environment. To create DOS
programs which run within 640 Kb, Blinker calculates the optimum overlay
structure, automatically manages the overlays at runtime and increases
execution speed using an overlay
cache in XMS or EMS. All this is completely invisible to the end user and there
is no size difference between a protected mode program and a dual mode program.
For the first time ever programs will automatically utilize all the available
memory (up to 16 Mb) on every PC, from the
smallest 8086 right up to the Pentium and beyond.
.*
.figure *depth='2.75' *scale= *file='blinker'
.*

.*

.section CauseWay for Watcom C/C++ and Assembly Language (&cat)
.*
.np
.illust begin
Devore Software & Consulting
P.O. Box 4283
Naperville, IL  60567-4283


Tel:  708-717-6389
FAX:  708-717-6373
.illust end
.*
.np
.*
.ix 'CauseWay for Watcom C/C++ and Assembly Language (&cat)'

.ix 'Devore Software & Consulting'

.ix '&cat'
.*
.illust begin
CauseWay is a plug and play replacement for the Watcom C/C++ bundled version of
DOS/4GW.  Once installed, the developer specifies CauseWay as the target
extender and compiles, links, and debugs as usual.

The CauseWay extender binds to the executable file, adding 45K to the file
size; provides full DPMI .9 function support; offers a virtual address space of
4G, and reflects all hardware interrupts to protected mode when a handler is
installed.  It supports EXE file compression and DOS DLLs.   On application
fault, CauseWay creates an error file with extensive CPU state and memory
resource information.  Desired memory settings can be 'burned' into the
application.

CauseWay has faster file I/O, functions, and virtual memory than the bundled
DOS/4GW extender.  No startup advertising banner is displayed when running
CauseWay-built applications.

CauseWay runs all 386 DOS-extended applications in 150K of free conventional
memory with 350K free extended memory, or in 500K conventional memory with no
free extended memory.  (More memory is recommended for larger programs).
CauseWay allocates memory from DPMI, VCPI, XMS, INT 15h and conventional DOS
memory.  Supported environments are MS-DOS 3.1 or higher, Windows 3.1, Windows
'95, and OS/2.  There are no runtime licensing fees.

CauseWay, priced at $195.00, is available from Devore Software & Consulting.
Technical support via phone, fax, BBS, and e-mail is free for the first year
after purchase, including electronic file updates.  All purchases carry a
liberal no-fault return policy.  CauseWay enjoys active, user-influenced,
development.  Call 1-708-717-6369 or fax 1-708-717-6373 for orders.
.illust end
.*

.*

.*

.section TNT DOS Extender SDK (&cat)
.*
.np
.illust begin
Phar Lap Software
60 Aberdeen Avenue
Cambridge, MA  02138


Tel:  (617) 661-1510
FAX:  (617) 876-2972
.illust end
.*
.np
.*
.ix 'TNT DOS Extender SDK (&cat)'

.ix 'Phar Lap Software'

.ix '&cat'
.*
TNT DOS-Extender SDK Version 8.0
.np
.illust begin
 Write 32-Bit Protected Mode Realtime Programs for MS DOS
 Write Multi Megabyte MS DOS Embedded Applications with 32-Bit Addressing
 Trap Real Mode Interrupts and Pass to Application in Protected Mode
 DosStyle or NtStyle
.illust end
.np
.illust begin
Under NtStyle:
 216 Win32 APIs Supported
 DLLs, Threads, Multitasking, Priority SchedulingAll Four NT Classes
 Semaphores, Mutex, Events
 Adjustable Time SlicesAs Short as 1 Millisecond
 Interrupt Drivers for Printing and Mouse Control
 Disk and Keyboard Drivers Allow Other Threads to Execute During Idle or
Waiting times
 Multiple Extended-DOS Programs Share a Single Copy of the DOS-Extender
.illust end
.np
.illust begin
Under DosStyle:
 Dynamic Link Libraries
 INT 21h Interface
 Uses Less Memory
.illust end
.np
The TNT DOS-Extender SDK is a 32-bit development tool that enables programmers
to build multi-megabyte embedded and realtime applications that take advantage
of powerful Windows NT features. These features include DLLs, threads, priority
scheduling, and multitasking, under MS DOS. The TNT DOS Extender product
includes the WinPipe VXD which enables developers to write a Windows GUI front
end for their 32-bit DOS applications. The TNT DOS-Extender software runs on
any DOS-based 80386 or higher PC and supports a wide range of 32-bit tools.
including C and C++ compilers from Microsoft, Borland, MetaWare, Symantec, and
Watcom. In addition to the TNT DOS-Extender software, the SDK includes a 32-bit
version of the Microsoft CodeView debugger and Phar Laps SRCBug debugger,
386|ASM macro assembler, and 386|LIB librarian.
.*
.figure *depth='2.75' *scale= *file='dos_ext'
.*

.*
:set symbol="cat" value="Editing Tools"

.chap Editing Tools
.*
.np
The following section contains listings for editors and editing tools
supporting Watcom C or C++.
.*

.section Object Master for Windows (&cat)
.*
.np
.illust begin
ACI US, Inc.
20883 Stevens Creek Blvd.
Cupertino, CA  95014


Tel:  (408) 252-4444
FAX:  (408) 252-4829
.illust end
.*
.np
.*
.ix 'Object Master for Windows (&cat)'

.ix 'ACI US, Inc.'

.ix '&cat'
.*
Object Master for Windows, winner of InfoWorld's 1994 Landmark Technology
Award, speeds the development of C/C++ programming with innovative tools for
writing, editing and navigating through code.   Object Master parses code,
checks syntax in real-time, and maintains a dynamic data dictionary of project
components. Includes class-tree windows for graphically viewing code and
Smalltalk-like browser windows for quick navigation.
.np
.illust begin
Smart Source Code Editor
Unlike most text or source code editors, Object Master understands code and
takes advantage of the language structure. And it's dynamic. Syntax is checked
when code is added or saved and any changes are automatically updated
throughout the project.  You can immediately see the effects of changes made to
code without having to recompile.
.illust end
.illust begin
Industrial-Strength Browser
Most browsers only let you view individual files. With Object Master, you can
have multiple browser windows open simultaneously, enabling you to work with
several modules or sections of code.  Object Master also provides a high level
of project abstraction, allowing you to visualize the relationship between
various parts of a project.
.illust end
.illust begin
Powerful Navigation
With one mouse click, you can move from a function call directly to its
definition. Object Master's data dictionary instantly locates code and its
components and saves you from searching through the entire project for code.
.illust end
.illust begin
And Much More
'If you ever wished to be able to do something quickly and easily when writing
code, it's probably a feature in Object Master.'  InfoWorld, October 24, 1994.
.illust end
.*

.*

.*

.section Multi-Edit for Windows (&cat)
.*
.np
.illust begin
American Cybernetics
1830 W. University Drive
Suite 112
Tempe, Arizona  85281

Sales:  (800) 899-0100
Tel:  (602) 968-1945
FAX:  (602) 966-1654
.illust end
.*
.np
.*
.ix 'Multi-Edit for Windows (&cat)'

.ix 'American Cybernetics'

.ix '&cat'
.*
Multi-Edit for Windows is a powerful & flexible programmer's text editor
combined with the integration and graphical ease of MS-Windows.
.np
.illust begin
Multi-Edit for Windows offers:

Powerful Extensibility -  Entire Windows apps can be written in the powerful
macro language.  With structures, arrays, DLL import, and a familiar C-like
syntax, you can do almost anything.  Provides a full DLL API - extend Multi-
Edit in your favorite language, or integrate its editing power into your apps.
.illust end
.np
Total integration - Compile, link & make without leaving Multi-Edit. Integrate
into your existing environment through powerful DDE & DLL support.   Link in
your compiler's help files for full
context/language-sensitive help.  Unparalleled integration with most VCS
systems, including PVCS, TLIB, Source Safe & MKS-RCS.
.np
Complete Customizability - Redefine the keyboard, customize menus,
modify/create toolbars, change virtually every setting imaginable without
touching macros or .ini files.
.np
Complete workgroup/network support - Includes file locking, session manager,
multi-user configuration, & MAPI/MS Mail integration.
.np
.illust begin
Also:
Programmer's Calculator, Text Ruler, ASCII/ANSI Chart, Spellchecker, Notebook!
Edit up to 128 DOS, UNIX, or BINARY files of unlimited size! Cross Directory,
Multi-File Search/Replace
Regular Expression Search/Replace Source-Code Locator/Browser Context-Sensitive
Hypertext Help Unlimited UNDO/REDO Unlimited keystroke macros Synchronized File
Compare Hex editing
.illust end
.np
.illust begin
Suggested Retail Price:  $199

For ordering or to receive a free fully-functional demo disk, contact:
American Cybernetics, Inc.
1830 W. University Dr., Suite 112
Tempe, AZ  85281
Tel: (602) 968-1945   Fax: (602) 966-1654
Sales Hotline:  (800) 899-0100
Internet:  sales@amcyber.com
CompuServe:  GO_CYBERNET  (PCVENE, Sec. 11)
.illust end
.*
.figure *depth='2.75' *scale= *file='windune'
.*

.*

.section Multi-Edit Professional (&cat)
.*
.np
.illust begin
American Cybernetics
1830 W. University Drive
Suite 112
Tempe, Arizona  85281

Sales:  (800) 899-0100
Tel:  (602) 968-1945
FAX:  (602) 966-1654
.illust end
.*
.np
.*
.ix 'Multi-Edit Professional (&cat)'

.ix 'American Cybernetics'

.ix '&cat'
.*
In the six years since its introduction,
Multi-Edit has never stagnated.  Instead, it has grown with the times,
evolving into the ultimate developer's environment.  The reason is simple:
YOU!  The Multi-Edit user has always been the driving force behind its
development.  Now, American Cybernetics has once again answered the needs of
the modern programmer.  We listened to your requests and suggestions and
responded with Multi-Edit 7.0.  Just look at some of the features:

MS Windows Clipboard Interface -  Interact with Windows without sacrificing
performance!  Cut and paste directly to and from the Windows clipboard.  Smart
exit-notification eliminates that annoying 'Application still active' message
when quitting windows.

File compare - Sychronized split-screen mode, highlights differences between
two files.  Edit the files without losing sync.  Generate difference reports.

Hex editing - Edit binary or text files in hex mode.

Session Manager - Pop up a list of all your Multi-Edit sessions.  Select one,
and Multi-Edit puts you in the appropriate directory and restores the session
just like you left it.

Multi-Tags - Our source-code browser package has been updated and integrated
into Multi-Edit Professional.  Scans your source code and builds databases of
functions, structures and objects (language dependent).  Instantly locate and
browse any supported tag.

Edit up to 128 DOS, UNIX or BINARY FILES of unlimited size!
Hex Editing!
EMS/XMS Support!  Swaps to just 3k
Multi-File Search/Replace/Regular expressions
Synchronized File Compare!
MS Windows Clipboard Interface!
Unlimited UNDO and REDO
Real-Time DOS output window
30/33/43/50 line display and  Ultravision support
Alternate BRIEF or WordStar keymaps
Line, Stream and Column blocks
Programmer's Calculator, text ruler, ASCII chart and notebook
Session Manager!
Auto-save and auto-backup
Powerful C-like macro language
Supports more than 60 different compilers
Unlimited keystroke macros
Condensed display mode
Context-sensitive Hypertext help
386 optimized!
Document formatter
Spellchecker
Macro debugger
Communications
System macro source
VCS support
Multi-Tags source code browser
Much more!

Photo Caption:
'Multi-Edit will convert programmers - Editing tools and easy configuration
will surpass user expectations,'
Nicholas Petreley, Info World
.*
.figure *depth='2.75' *scale= *file='amcyber'
.*

.*

.section SlickEdit (&cat)
.*
.np
.illust begin
MicroEdge, Inc.
P.O. Box 18038
Raleigh, NC  27619-8038


Sales:  (800) 934-EDIT
Tel:  (919) 831-0600
FAX:  (919) 831-0101
.illust end
.*
.np
.*
.ix 'SlickEdit (&cat)'

.ix 'MicroEdge, Inc.'

.ix '&cat'
.*
Breeze through your workload with SlickEdit(R). SlickEdit  is the fastest, most
feature rich, and easiest programmer's editor available.  SlickEdit, available
for  DOS and 20 UNIX platforms, makes learning easy with its CUA, Brief, Emacs,
and VI emulations. What's more, it's completely customizable to suit your
individual programming style. SlickEdit takes off with a powerful macro
language and programmable file manager. 30 day money-back guarantee!
.np
.illust begin
Powerful features:
*    Run programs concurrently (except DOS)
*    Line, block, and character selection
*    Word wrap with justification
*    Sort by line or column
*    Interactive file compare
*    Menu and command line driven
*    Argument completion
*    Edit multiple files to 1 Gigabyte
*    Full undo/redo to 32,000 steps- past saves!
*    Fast scrolling on UNIX terminals
*    Run large compilers by swapping to EMS/extended memory or disk (DOS)
*    Line and box drawing
*    Document math
.illust end
.np
.illust begin
Language Support:
*    Syntax expansion and indenting
*    Process compiler error messages
*    Procedure tagging
*    Begin/end structure matching and brace matching
.illust end
.np
.illust begin
Macro Programming:
*    Typeless Rexx-style macro language
*    Automatic tagging of macro procedures
*    Detects uninitialized variables
*    Finds the macro module and line causing a run-time error
*    Over 850 callable functions available from our macro language
*    Macros and macro source are portable across all supported platforms
.illust end
.np
.illust begin
Customizing Features:
*    On-line configuration menu
*    Completely configurable menus
*    Remappable Keyboard
.illust end
.np
.illust begin
Cut your work in half using:
*    Multiple Clipboards
*    Optional CUA markings
*    Edit first/last page without loading the entire file
*    On-line manual with hypertext help
.illust end
.np
.illust begin
Search and Replace:
*    Incremental searching
*    Search and replace across multiple files and directories
*    Regular expression search and replace
*    Use GREP for concurrent searching (except DOS)
.illust end
.*
.figure *depth='2.75' *scale= *file='se1'
.*

.*

.section Visual SlickEdit (&cat)
.*
.np
.illust begin
MicroEdge, Inc.
P.O. Box 18038
Raleigh, NC  27619-8038


Sales:  (800) 934-EDIT
Tel:  (919) 831-0600
FAX:  (919) 831-0101
.illust end
.*
.np
.*
.ix 'Visual SlickEdit (&cat)'

.ix 'MicroEdge, Inc.'

.ix '&cat'
.*
.illust begin
'Visual SlickEdit is an extremely powerful programmers' editor and much more...
Good enough to be used by Microsoft's Windows NT development team and good
enough that I plan to hold on to it...'
WINDOWSTM MAGAZINE APRIL 1994 JOHN D. RULY
.illust end
.np
.illust begin
*30 day risk-free trial!*
.illust end
.np
Visual SlickEdit* The Intelligent programmers' editor. This high powered
programmers' editor has the speed, ease, and features you need to ignite your
productivity.  Visual SlickEdit* is completely customizable to suit your
individual programming style.  Our comprehensive Brief, Emacs, and VI
emulations diminish your learning curve. Take off with our extensive language
support, project management, and NEW SmartPaste*.
.np
.illust begin
Blast through your project with these powerful features:
*Incremental searching
*Search and replace across multiple files and directories
*Line, column, and character selection
*Completely configurable keyboard, menus, and button bar
*Spell check comments and strings in source code
*Specify fonts and screen colors
*Typeless, object oriented, C-Style macro-language
*Built-in dialog editor
*Edit dialog boxes while they are running
*Clipboard Inheritance* (patent pending) Dialog box can be inherited by copying
and pasting from the clipboard.
.illust end
.np
.illust begin
Cut your work in half using:
*    Procedure tagging
*    Syntax color-coding, expansion, and indenting
*    New SmartPaste* automatically re-indents pasted source code according to
nesting level.
*    Process compiler error messages
*    Multiple Clipboards
*    Macro recording
.illust end
.np
.illust begin
Learning is a breeze with:
*    CUA, Brief, Emacs,  and VI emulations
*    Standard MDI interface
*    Best GUI and command line interface
*    Entire Manual on-line
*    Compile/make, check-in/check-out from the button bar
.illust end
.np
.illust begin
Visual SlickEdit* supports C/C++, Pascal, Fortran, Basic, dBASE, Modula-2,
Assembly, COBOL and Ada.
.illust end
.*
.figure *depth='2.75' *scale= *file='visual'
.*

.*

.section Programmer's Editor (&cat)
.*
.np
.illust begin
RimStar Technology Inc.
91 Halls Mill Road
Newfield, NH  03856


Sales:  (800) 746-7007
Tel:  (603) 778-2500
FAX:  (603) 778-2408
.illust end
.*
.np
.*
.ix 'Programmer's Editor (&cat)'

.ix 'RimStar Technology Inc.'

.ix '&cat'
.*
The first editor to provide a graphical user interface for OS/2, Windows and
Windows NT.  Features: 32 bit GUI, Syntax Coloring, ANSI 'C' macro language,
'C' Source Browser, unlimited redo/undo, no limits on number of files, windows,
or line lenght.  Emulates BRIEF plus many other editors.  Hex editing,
compile/jump to error, smart indenting, template editing, customized keyboard,
version control interface and a lot more.
.*
.figure *depth='2.75' *scale= *file='rseos22'
.*

.*
:set symbol="cat" value="Embedded Systems Development"

.chap Embedded Systems Development
.*
.np
The following section contains listings for embedded systems development
products supporting Watcom C or C++.
.*

.section CSI-Locate (&cat)
.*
.np
.illust begin
Concurrent Sciences Inc.
530 South Asbury Street, Suite 4
P.O. Box 9666
Moscow, Idaho 83843

Tel:  (208) 882-0445
FAX:  (208) 882-9774
.illust end
.*
.np
.*
.ix 'CSI-Locate (&cat)'

.ix 'Concurrent Sciences Inc.'

.ix '&cat'
.*
CSi-Locate
.np
CSi-Locate is a locator utility that supports off-the-shelf C/C++ compilers
from Microsoft, Borland and Watcom and prepares your DOS and Windows executable
files for debugging with Soft-Scope and burning into EPROM.  The combination of
these compilers with Soft-Scope and CSi-Locate creates a complete tool kit for
embedded 80x86 development.
.*

.*

.*

.section Soft-Scope Remote Target Debugger (&cat)
.*
.np
.illust begin
Concurrent Sciences Inc.
530 South Asbury Street, Suite 4
P.O. Box 9666
Moscow, Idaho 83843

Tel:  (208) 882-0445
FAX:  (208) 882-9774
.illust end
.*
.np
.*
.ix 'Soft-Scope Remote Target Debugger (&cat)'

.ix 'Concurrent Sciences Inc.'

.ix '&cat'
.*
Soft-Scope
.np
Soft-Scope is a source-level, remote-target debugger that supports both real-
and protected-mode applications for the entire Intel 80x86 family, including
the new 32-bit Intel386 EX embedded microprocessor.  Soft-Scope supports C/C++
compilers from Microsoft, Borland, Watcom, MetaWare and Intel and is available
for both Microsoft Windows and DOS.  Several configurations are available
including Soft-Scope/CSi-Mon, Soft-Scope/iRMX, Soft-Scope/iRMX EMB and others.
Soft-Scope also supports the Applied Microsystems CodeTAP and Hitexs TX386
in-circuit emulators, Tektronix logic analyzers, Ampro embedded PC boards and
iRMX, C EXECUTIVE, MTOS, AMX, SMX and ROM-DOS run-time operating system
kernels.
.np
Soft-Scope communicates with our target-resident CSi-Mon monitor via a PC's
serial port.  When used with Grammar Engines PromICE ROM emulator, CSi-Mon can
be accessed via the target boards EPROM socket.  The complete CSi-Mon source
code is included in the package plus a royalty-free license that allows it to
be incorporated into the application, making it easy to create startup code,
install bug fixes and perform on-site testing.
.*
.figure *depth='2.75' *scale= *file='CSI'
.*

.*

.section RTXC (&cat)
.*
.np
.illust begin
Embedded System Products
10450 Stancliff, Suite 110
Houston, TX 77099-4383


Sales:  (800) 525-4302
Tel:  713-561-9990
FAX:  713-561-9980
.illust end
.*
.np
.*
.ix 'RTXC (&cat)'

.ix 'Embedded System Products'

.ix '&cat'
.*
RTXC - is a flexible, field-proven multitasking real-time kernel for use in a
wide varitey of applications. RTXC manages tasks and time, synchronizes with
events, and permits transferal of data between tasks.  RTXC supports
preemptive, round robin and time-slices task scheduling.
RTXC is ROMable, supplied with source code free of any runtime royalties.  RTXC
can provide support to DOS functions.
.np
RTXC is specifically configured to support Watcom and is integrated with the
Concurrent Sciences and Paradigm debuggers.  Softaid's emulator is kernel aware
with RTXC.
.np
RTXCio - is a device independent input/output subsystem that permits
application tasks to make direct request to any supported device.  Multiple
task may access the same device and a single task may access multiple devices.
RTXCio also supports both synchronous and asynchrous
input/output operations.
.np
DOS File Mangement, Graphics and Networking support are available. RTXC - is a
flexible, field-proven multitasking real-time kernel for use in a wide varitey
of applications. RTXC manages tasks and time, synchronizes with events, and
permits transferal of data between tasks.  RTXC supports preemptive, round
robin and time-slices task scheduling.  RTXC is ROMable, supplied with source
code free of any runtime royalties.  RTXC can provide support to DOS functions.
.np
RTXC is specifically configured to support Watcom and is integrated with the
Concurrent Sciences and Paradigm debuggers.  Softaid's emulator is kernel aware
with RTXC.
.np
RTXCio - is a device independent input/output subsystem that permits
application tasks to make direct request to any supported device.  Multiple
task may access the same device and a single task may access multiple devices.
RTXCio also supports both synchronous and asynchrous
input/output operations.
.np
DOS File Mangement, Graphics and Networking support are available.
.*

.*

.*

.section MethodMaker (&cat)
.*
.np
.illust begin
Mark V Systems Ltd.
16400 Ventura Blvd., Suite 303
Encino, CA 91436


Sales:  (800) 995-7671
Tel:  (818) 995-7671
FAX:  (818) 995-4267
.illust end
.*
.np
.*
.ix 'MethodMaker (&cat)'

.ix 'Mark V Systems Ltd.'

.ix '&cat'
.*
MethodMaker (R) by Mark V Systems:  MethodMaker is an exciting  new extension
to the ObjectMaker family which allows rapid development of new method
notations.  MethodMaker also allows the user to modify and extend existing
ObjectMaker and ProcessMaker method support to meet project and organization
requirements. The user can easily build or modify the
tool support for a method by editing a diagram set. The new, or further
prototyped method is self
documented by the defining diagram set, and can be regenerated at any time to
take advantage of new ObjectMaker features and capabilities.  MethodMaker, with
simple diagrams and fill in forms allows you to specify and modify the tool
support for menus, notations, syntax checking, semantics specification and
repository capture of semantics and other information and relationships.  All
ObjectMaker CASE  Tool functionality is inherited.
.np
Contact MethodMaker marketing at 818 995 7671, fax 818 995 4267 or
methodmaker@markv.com.
.*

.*

.*

.section Object Maker (&cat)
.*
.np
.illust begin
Mark V Systems Ltd.
16400 Ventura Blvd., Suite 303
Encino, CA 91436


Sales:  (800) 995-7671
Tel:  (818) 995-7671
FAX:  (818) 995-4267
.illust end
.*
.np
.*
.ix 'Object Maker (&cat)'

.ix 'Mark V Systems Ltd.'

.ix '&cat'
.*
ObjectMaker by Mark V Systems:  With the ObjectMaker CASE Tool you can model
your application requirements and design in one or more of the most popular
notations.  ObjectMaker supports more than 30 of the most popular analysis and
design notations for software engineering and allows you to mix and match
notations to build a single model of your software application.  You can choose
the notations and the depth of detail your application requires.  ObjectMaker
also offers support for detailed design, code generation and document
generation for construction, delivery and maintenance phases.  Reverse
Engineering tools offer you the opportunity to re-engineer applications, reuse
legacy code and incorporate commercially available components into your model
for design, construction and maintenance.
.np
Contact ObjectMaker marketing at 818 995 7671, fax 818 995 4267, or
objectmaker@markv.com.
.*

.*

.*

.section ObjectMaker TDK (&cat)
.*
.np
.illust begin
Mark V Systems Ltd.
16400 Ventura Blvd., Suite 303
Encino, CA 91436


Sales:  (800) 995-7671
Tel:  (818) 995-7671
FAX:  (818) 995-4267
.illust end
.*
.np
.*
.ix 'ObjectMaker TDK (&cat)'

.ix 'Mark V Systems Ltd.'

.ix '&cat'
.*
ObjectMaker TDK by Mark V Systems: The ObjectMaker Tool Development Kit (TDK)
offers developers, integrators, OEMs, consultants, and methodologists the
opportunity to customize methods, notations, syntax rules, syntax checking,
semantic specification and repository capture of all semantics, and other
information and relationships important to your process and problem space.  The
TDK provides direct access to the rules (predicate logic) that create, control,
and pre- and post-condition all tool behavior, and manage all repository
navigation and iteration.  The TDK offers you the possibility of growing your
tool and method support as your organization and process grows and matures.
This is more than just being able to use the next method that
comes along, more than mixing and matching notations to create the multiple
views necessary for today's problems.  It means you can add to the notation you
select, add to the semantics, add to the checking,  add to the code generation,
and more as you gain experience and understand that what you need is beyond
what the published methods offer.  Published methods,
especially the object oriented methods, are good starting points.  Your process
will mature past the published methods. You will need to recognize and capture
the information and relationships important for your problem space.  The
ObjectMaker TDK provides tailorable support which enables you to develop and
extend your own methods.  The TDK gives you the opportunity to use and reuse
your repository contents, your application models, your component libraries by
giving you the facilities for data and control integration with other life
cycle tools.
.np
Contact ObjectMaker marketing at 818 995 7671, fax 818 995 4267, or
objectmaker@markv.com.
.*

.*

.*

.section ProcessMaker (&cat)
.*
.np
.illust begin
Mark V Systems Ltd.
16400 Ventura Blvd., Suite 303
Encino, CA 91436


Sales:  (800) 995-7671
Tel:  (818) 995-7671
FAX:  (818) 995-4267
.illust end
.*
.np
.*
.ix 'ProcessMaker (&cat)'

.ix 'Mark V Systems Ltd.'

.ix '&cat'
.*
ProcessMaker (R) by Mark V Systems:  ProcessMaker is a specialized modeling
tool which is coupled to an underlying semantics repository and code/text
generator.  ProcessMaker supports many popular process diagram notations and
provides the user the capability to easily develop a graphic representation of
a process. Users needing to capture process models, work flow models or
enterprise models for process improvement, analysis, measurement, reuse, re-
engineering or enactment have the choice of using multiple notations to create
the views necessary for
these tasks. ProcessMaker will generate output to a variety of process
enactment products.  Additional process modeling notations, and other
techniques can be added to ProcessMaker using MethodMaker and ObjectMaker TDK
tools described above.  More than 15 notations are supported at this time
including the popular IDEF/IDEF1x, ProNet, Process Decision Program
Charts, Process Breakdown Structure Charts, YPL and Petri Nets.
.np
Contact ProcessMaker marketing at 818 995 7671, fax 818 995 4267 or
processmaker@markv.com.
.*

.*

.*

.section ACSLrt Realtime (&cat)
.*
.np
.illust begin
MGA Software
200 Baker Avenue
Concord, MA  01742


Tel:  (508) 369-5115
FAX:  (508) 369-0013
.illust end
.*
.np
.*
.ix 'ACSLrt Realtime (&cat)'

.ix 'MGA Software'

.ix '&cat'
.*
ACSLrt is ACSL ( Advanced Continuous Simulation Language) with real time
extensions.  ACSLrt is for real time simulation.  The primary characteristics
of realtime operation are synchronizing model execution with a realtime clock
and communicating simulation data between the computer and the real world
through a realtime I/O board.  ACSLrt is synchronized with a computers real
time clock.  Realtime simulations require precise synchronization between the
model  and the external hardware and Input/Output boards for communication
between the computer and the external hardware.  For the PC computer platform,
ACSLrt includes ACSL with Graphic Modeller for Windows with real time
extensions, Keithley analog and digital Input/Output board, and Watcom FORTRAN
77/32 10.5 compiler.  Major features of ACSLrt are the following: powerful
simulation engine; speed; portability across multiple computer hardware
platforms, including DOS, Windows, and UNIX systems; and an advanced GUI
interface.
.*

.*

.*

.section smxFile (&cat)
.*
.np
.illust begin
Micro Digital, Inc.
12842 Valley View Street
Garden Grove, CA 92649


Sales:  (800) 366-2491
Tel:  (714) 373-6862
FAX:  (714) 891-2363
.illust end
.*
.np
.*
.ix 'smxFile (&cat)'

.ix 'Micro Digital, Inc.'

.ix '&cat'
.*
smxFILE provides embedded systems developers with a DOS-compatible, reentrant
file system.  It features high-performance file i/o and also provides disk
directory management.  smxFILE is
an ANSI C source code library.  The API is similar to POSIX or DOS.  The device
driver interface is similar to UNIX, but simpler.  smxFILE operates in
protected mode as well as in real mode.
.np
The smxFILE package is the latest in a series of DOS file system software
packages that have been marketed since 1987.  It and its predecessors have been
included in many commercial embedded applications.
.np
smxFILE is fully integrated with smx.  An smx call, create_file_mgr(), allows a
task to create its own file managercontrol block (FMCB).  The FMCB is active
whenever the task is active.  As many (or as few) tasks, as desired, may
perform file i/o simultaneously.  Low-level i/o calls to the same disk are
serialized via semaphores (since actual disk operations are inherently non-
reentrant).  A platform, FILEdemo, is provided which illustrates the use of
smxFILE from multiple tasks.
.np
Code for interfacing to standard BIOS disk services and a RAMdisk driver are
included.  Reentrant floppy and IDE drivers are available separately.
.*

.*

.*

.section smxNet (&cat)
.*
.np
.illust begin
Micro Digital, Inc.
12842 Valley View Street
Garden Grove, CA 92649


Sales:  (800) 366-2491
Tel:  (714) 373-6862
FAX:  (714) 891-2363
.illust end
.*
.np
.*
.ix 'smxNet (&cat)'

.ix 'Micro Digital, Inc.'

.ix '&cat'
.*
smxNet is a TCP/IP network stack for the smx real-time, multitasking kernel.
It supports both the TCP and UDP protocols through a Berkeley sockets API.
smxNet uses smx primitives to manage data flow, thereby minimizing code and
data space.  Data space requirements are tunable depending upon application
speed vs. space requirements.  Code space requirements are: 32 KB for UDP/IP,
44 KB including TCP, and 70 KB for all protocols plus the Server Package.
.np
.illust begin
Features
             -  RFC-compliant TCP support
             -  Standard BSD sockets interface
             -  Supports UDP, TCP, ARP, and ICMP (ping)
             -  Integrated with smx
             -  Fast unbuffered mode (no copy) for UDP packets
             -  ROM'able
             -  Includes BOOTP and RARP for ROM'ed systems
             -  Supports simultaneous communications over multiple interfaces
             -  Designed for reliable operation in embedded systems
             -  Extensive error checking
             -  FTP, TFTP, and TELNET are available in separate Server Package
             -  Driver Support (included)
                -   Ethernet driver for NE1000, NE2000, 3Com 3C503, plus SMC &
WD boards
                -   SLIP
                -   FTP packet driver interface.  (Supports over 50 freeware
drivers developed at
                    universities.)
             -  PPP (separate package)
.illust end
.np
The smxNet development kit includes source code, a comprehensive demo program,
support for either Microsoft Visual C++ or Borland C++, and 6 months of  free
support and updates.  In addition to the drivers provided and the FTP packet
driver interface, smxNet includes
a simple device driver interface for custom drivers.
.*

.*

.*

.section TNT DOS Extender SDK (&cat)
.*
.np
.illust begin
Phar Lap Software
60 Aberdeen Avenue
Cambridge, MA  02138


Tel:  (617) 661-1510
FAX:  (617) 876-2972
.illust end
.*
.np
.*
.ix 'TNT DOS Extender SDK (&cat)'

.ix 'Phar Lap Software'

.ix '&cat'
.*
TNT DOS-Extender SDK Version 8.0
.np
.illust begin
 Write 32-Bit Protected Mode Realtime Programs for MS DOS
 Write Multi Megabyte MS DOS Embedded Applications with 32-Bit Addressing
 Trap Real Mode Interrupts and Pass to Application in Protected Mode
 DosStyle or NtStyle
.illust end
.np
.illust begin
Under NtStyle:
 216 Win32 APIs Supported
 DLLs, Threads, Multitasking, Priority SchedulingAll Four NT Classes
 Semaphores, Mutex, Events
 Adjustable Time SlicesAs Short as 1 Millisecond
 Interrupt Drivers for Printing and Mouse Control
 Disk and Keyboard Drivers Allow Other Threads to Execute During Idle or
Waiting times
 Multiple Extended-DOS Programs Share a Single Copy of the DOS-Extender
.illust end
.np
.illust begin
Under DosStyle:
 Dynamic Link Libraries
 INT 21h Interface
 Uses Less Memory
.illust end
.np
The TNT DOS-Extender SDK is a 32-bit development tool that enables programmers
to build multi-megabyte embedded and realtime applications that take advantage
of powerful Windows NT features. These features include DLLs, threads, priority
scheduling, and multitasking, under MS DOS. The TNT DOS Extender product
includes the WinPipe VXD which enables developers to write a Windows GUI front
end for their 32-bit DOS applications. The TNT DOS-Extender software runs on
any DOS-based 80386 or higher PC and supports a wide range of 32-bit tools.
including C and C++ compilers from Microsoft, Borland, MetaWare, Symantec, and
Watcom. In addition to the TNT DOS-Extender software, the SDK includes a 32-bit
version of the Microsoft CodeView debugger and Phar Laps SRCBug debugger,
386|ASM macro assembler, and 386|LIB librarian.
.*
.figure *depth='2.75' *scale= *file='dos_ext'
.*

.*

.section TNT Embedded ToolSuite SDK (&cat)
.*
.np
.illust begin
Phar Lap Software
60 Aberdeen Avenue
Cambridge, MA  02138


Tel:  (617) 661-1510
FAX:  (617) 876-2972
.illust end
.*
.np
.*
.ix 'TNT Embedded ToolSuite SDK (&cat)'

.ix 'Phar Lap Software'

.ix '&cat'
.*
TNT Embedded ToolSuite version 8.0
.np
The TNT Embedded ToolSuite version 8.0 software set from Phar Lap Software,
Inc. is a suite of development tools delivering a total solution for 32-bit
embedded realtime systems development.
.np
.illust begin
The suite consists of:
 TNT Embedded Realtime Kernel Threads, Priority scheduling, Semaphores, Events,
Pipes, and more
 Visual System Builder
 LinkLoc 32-bit linker/locator
 CVEMB and TDEMB shells for embedded debugging
 Full support for C/C++ run-time libraries
 MS DOS compatible file system
 Floating point emulation library
.illust end
.np
The TNT Embedded ToolSuite system allows a developer to use familiar compilers,
debuggers, and other tools to create a 386/486/Pentium processor based embedded
realtime system. Compilers supported are the C/C++ compilers from Microsoft,
Borland, Watcom, and MetaWare.
The TNT Embedded Kernel is sold with an unlimited run-time licence for use on a
single embedded product.
.np
Requirements for a ROMed embedded kernel are 14K ROM and 13K RAM and a serial
or parallel port. Embedded programs can be loaded from either diskettes or hard
disks. Single board computers such as PC/104 computers make ideal targets.
.np
Minimum host requirements are a MS DOS or Windows compatible system with 4M
memory, C/C++ compiler, and a serial or parallel line for debugging the target.
.*
.figure *depth='2.75' *scale= *file='ets_draw'
.*

.*

.section Link & Locate 386 (&cat)
.*
.np
.illust begin
Systems & Software, Inc.
18102 Cowan, Suite 100
Irvine, California  92714


Sales:  (800) 788-4386
Tel:  (714) 833-1700
FAX:  (714) 833-1900
.illust end
.*
.np
.*
.ix 'Link & Locate 386 (&cat)'

.ix 'Systems & Software, Inc.'

.ix '&cat'
.*
Link&Locate 386:  An absolute linker and locator for embedded development.
It supports the building of 32-bit protected-mode programs for Intel 386/486
embedded
applications and 32-bit DOS extender application using Watcom C/C++, and/or
WASM.
However, the output absolute object files contain debug information in Intel
OMF-286/386
format which only supports C and assembly source-level debugging.  It includes
start-up code,
C, C++ and floating-point examples, run-time library and floating-point
support.

Link&Locate 386 is provided with executables hosted for both DOS and Microsoft
Windows
NT.  Link&Locate 386 supports the construction of flat or multi-segmented
programs. It has the
flexibility to define and construct segment descriptors, local, global, and
interrupt descriptor
tables, task, interrupt, call, and trap gates, and task state segments.

Third party debugger support includes in-circuit emulators from Microtek
International, Inc. and
Kontron Elektronik GmbH.

Requires 80386 PC or higher, 2 MBytes of memory,  DOS 5.0 or later, and 4
MBytes of hard
disk space.
.*

.*

.*

.section SoftProbe 386/RED (&cat)
.*
.np
.illust begin
Systems & Software, Inc.
18102 Cowan, Suite 100
Irvine, California  92714


Sales:  (800) 788-4386
Tel:  (714) 833-1700
FAX:  (714) 833-1900
.illust end
.*
.np
.*
.ix 'SoftProbe 386/RED (&cat)'

.ix 'Systems & Software, Inc.'

.ix '&cat'
.*
SoftProbe 386/RED:  A DOS-hosted source-level ROM emulator debugger that allows
downloading of a program from the host PC and debugging of the actual 386/486
target system
in real mode and protected mode.  It accepts executable files in Intel OMF-
86/286/386
bootloadable file format.  It also includes a multi-window user interface, a
Target Monitor
program and a Grammar Engine Inc.s PROMICE ROM emulator hardware kit.

SoftProbe 386/RED has a multi-window interface with pull-down menus, mouse
support, online
help, and overlapping and resizable windows.  The multi-window feature enables
you to
concurrently display command dialog and history, source, registers, memory,
program variables,
execution history, and much more.

SoftProbe 386/RED gives you complete access to symbolic names, data types,
functions, source
statements and source modules in both C and assembly.  C-like expression
evaluation can be
used to examine and modify program objects.  An inline assembler allows program
code to be
input in assembly mnemonics.
The Target Monitor controls program execution on the target.  The Target
Monitor
communicates with the host through a ROM-Emulator with a RS-232 serial port and
requires 19
KBytes ROM and 28 KBytes RAM.
The target monitor uses 386 debug registers to facilitate debugging.  It
provides up to 32
breakpoints (program execution breakpoints or data watchpoints).  Program
conditions can
activate breakpoints.

Requires 80386 PC or higher, 2 MBytes of memory,  DOS 5.0 or later, and 3
MBytes of hard
disk space.  A Microsoft-compatible mouse is supported, but not required.
.*

.*

.*

.section SoftProbe 386/SIM (&cat)
.*
.np
.illust begin
Systems & Software, Inc.
18102 Cowan, Suite 100
Irvine, California  92714


Sales:  (800) 788-4386
Tel:  (714) 833-1700
FAX:  (714) 833-1900
.illust end
.*
.np
.*
.ix 'SoftProbe 386/SIM (&cat)'

.ix 'Systems & Software, Inc.'

.ix '&cat'
.*
SoftProbe 386/SIM:  DOS-hosted bus-level simulator and source-level debugger
for debugging
real mode and protected mode 80386 embedded C and assembly applications.  It
accepts
executable files in Intel OMF-86/286/386 bootloadable format.

SoftProbe 386/SIM performs program execution via software simulation.
SoftProbe 386/SIM
provides 80386 CPU (all modes of operation) and 80387 coprocessor simulation at
the bus
level.  The simulation model also supports 4 GBytes memory, direct and memory-
mapped I/O,
master and slave 8259A programmable interrupt controllers, and 8254
programmable interval
timer.

SoftProbe 386/SIM gives you complete access to symbolic names, data types,
functions, source
statements and source modules in both C and assembly.  C-like expression
evaluation can be
used to examine and modify program objects.

SoftProbe 386/SIM provides 32 software breakpoints.  You can define elaborate
and complex
program breakpoints using Boolean expressions of the trigger registers.  You
can control
breakpoints with pass counts and delay counts.

SoftProbe 386/SIM provides path coverage and profiling facilities.  The path
coverage facility
tells you which blocks of program code have been executed.  The profiling
facility provides
execution statistics on a procedure-by-procedure basis.  This helps you to
pinpoint program
bottlenecks.
.*

.*

.*

.section SoftProbe 386/TX (&cat)
.*
.np
.illust begin
Systems & Software, Inc.
18102 Cowan, Suite 100
Irvine, California  92714


Sales:  (800) 788-4386
Tel:  (714) 833-1700
FAX:  (714) 833-1900
.illust end
.*
.np
.*
.ix 'SoftProbe 386/TX (&cat)'

.ix 'Systems & Software, Inc.'

.ix '&cat'
.*
SoftProbe 386/TX:  A DOS-hosted source-level debugger that allows downloading
of a
program from the host PC and debugging on the actual 386/486 target system in
real mode and
protected mode.  It accepts executable files in Intel OMF-86/286/386
bootloadable file format.
It also includes a multi-window user interface and a Target Monitor program.

SoftProbe 386/TX has a multi-window interface with pull-down menus, mouse
support, online
help, and overlapping and resizable windows.  The multi-window feature enables
you to
concurrently display command dialog and history, source, registers, memory,
program variables,
execution history, and much more.

SoftProbe 386/TX gives you complete access to symbolic names, data types,
functions, source
statements and source modules in both C and assembly.  C-like expression
evaluation can be
used to examine and modify program objects.  An inline assembler allows program
code to be
input in assembly mnemonics.
The Target Monitor controls program execution on the target.  The Target
Monitor
communicates with the host through a RS-232 serial port and requires 19 KBytes
ROM and 28
KBytes RAM.
The target monitor uses 386 debug registers to facilitate debugging.  It
provides up to 32
breakpoints (program execution breakpoints or data watchpoints).  Program
conditions can
activate breakpoints.  You can define command sequences that are invoked when a
breakpoint is
encountered.

Requires 80386 PC or higher, 2 MBytes of memory,  DOS 5.0 or later, and 3
MBytes of hard
disk space and a RS-232 serial port.  A Microsoft-compatible mouse is
supported, but not
required.
.*

.*

.*

.section SoftProbe 386EX/SIM (&cat)
.*
.np
.illust begin
Systems & Software, Inc.
18102 Cowan, Suite 100
Irvine, California  92714


Sales:  (800) 788-4386
Tel:  (714) 833-1700
FAX:  (714) 833-1900
.illust end
.*
.np
.*
.ix 'SoftProbe 386EX/SIM (&cat)'

.ix 'Systems & Software, Inc.'

.ix '&cat'
.*
SoftProbe 386EX/SIM:  Developed specifically for Intel and the 80386EX embedded
processor.  It is DOS-hosted bus-level simulator and source-level debugger for
debugging real
mode and protected mode 80386EX embedded C and assembly applications.  It
accepts
executable files in Intel OMF-86/286/386 bootloadable format.

SoftProbe 386EX/SIM performs program execution via software simulation.
SoftProbe
386EX/SIM provides 80386EX CPU (all modes of operation) and 80387 coprocessor
simulation at the bus level.  The simulation model also support 64 MBytes
memory, direct and
memory-mapped I/O, master and slave 8259A programmable interrupt controllers,
and 8254
programmable interval timer.

SoftProbe 386EX/SIM gives you complete access to symbolic names, data types,
functions,
source statements and source modules in both C and assembly.  C-like expression
evaluation can
be used to examine and modify program objects.

SoftProbe 386EX/SIM provides 32 software breakpoints.  You can define elaborate
and
complex program breakpoints using Boolean expressions of the trigger registers.
You can
control breakpoints with pass counts and delay counts.

SoftProbe 386EX/SIM provides path coverage and profiling facilities.  The path
coverage
facility tells you which blocks of program code have been executed.  The
profiling facility
provides execution statistics on a procedure-by-procedure basis.  This helps
you to pinpoint
program bottlenecks.
.*

.*

.*

.section SoftProbe 486/SIM (&cat)
.*
.np
.illust begin
Systems & Software, Inc.
18102 Cowan, Suite 100
Irvine, California  92714


Sales:  (800) 788-4386
Tel:  (714) 833-1700
FAX:  (714) 833-1900
.illust end
.*
.np
.*
.ix 'SoftProbe 486/SIM (&cat)'

.ix 'Systems & Software, Inc.'

.ix '&cat'
.*
SoftProbe 486/SIM:  DOS-hosted bus-level simulator and source-level debugger
for debugging
real mode and protected mode 80486 embedded C and assembly applications.  It
accepts
executable files in Intel OMF-86/286/386 bootloadable format.

SoftProbe 486/SIM performs program execution via software simulation.
SoftProbe 486/SIM
provides 80486 CPU (all modes of operation) and 80387 coprocessor simulation at
the bus
level.  The simulation model also supports 4 GBytes memory, direct and memory-
mapped I/O,
master and slave 8259A programmable interrupt controllers, and 8254
programmable interval
timer.

SoftProbe 486/SIM gives you complete access to symbolic names, data types,
functions, source
statements and source modules in both C and assembly.  C-like expression
evaluation can be
used to examine and modify program objects.

SoftProbe 486/SIM provides 32 software breakpoints.  You can define elaborate
and complex
program breakpoints using Boolean expressions of the trigger registers.  You
can control
breakpoints with pass counts and delay counts.

SoftProbe 486/SIM provides path coverage and profiling facilities.  The path
coverage facility
tells you which blocks of program code have been executed.  The profiling
facility provides
execution statistics on a procedure-by-procedure basis.  This helps you to
pinpoint program
bottlenecks.
.*

.*

.*

.section SuperTask (&cat)
.*
.np
.illust begin
United States Software Corporation
14215 N.W. Science Park Drive
Portland, Oregon  97229


Sales:  (800) 356-7097
Tel:  (503) 641-8446
FAX:  (503) 644-2413
.illust end
.*
.np
.*
.ix 'SuperTask (&cat)'

.ix 'United States Software Corporation'

.ix '&cat'
.*
SuperTask! 386PM is a suite of development tools and a Real Time Multitasking
OS for use in embedded projects.
.np
The suite includes:
ViewTask! which is a design tool that runs under DOS to specify the project at
the task level, produce skeleton source, and perform a simulation which will
tell you the viability of the
design on the hardware specified, using your task specifications.
.np
ProtoTask! is a debugging versions of the RTOS which allows you to run your
multitasking code in real-mode under DOS.  This allows preliminary testing of
your application in this environment thus saving time downloading to the target
system.
.np
MultiTask! is the 32-bit protected mode RTOS which you include in your
application.  Full source code is provided, and no royalties are charged.
MultiTask! and your application are compiled and linked in 32-bit flat model,
and can then be placed in ROM on the target (386 or higher) processor board.
.np
Applications can also be built to run under DOS with a DOS-extender.
.*

.*

.*

.section USFiles (&cat)
.*
.np
.illust begin
United States Software Corporation
14215 N.W. Science Park Drive
Portland, Oregon  97229


Sales:  (800) 356-7097
Tel:  (503) 641-8446
FAX:  (503) 644-2413
.illust end
.*
.np
.*
.ix 'USFiles (&cat)'

.ix 'United States Software Corporation'

.ix '&cat'
.*
USFiles is a DOS compatible file system for embedded use.  It is supplied in
source code form, and is used to provide DOS compatible file access, in
embedded environments where DOS is not
present.  USFiles can be used with the MultiTask! RTOS, some other RTOS, or
none at all.  Any type of floppy, hard, or ram drive is easily supported by
providing the sector read and sector
write functions necessary to access that device.  The user interface is through
the standard ANSI C stream I/O functions: fopen, fread, fprintf, etc.  No
royalties are charged.
.*

.*

.*

.section USNET (&cat)
.*
.np
.illust begin
United States Software Corporation
14215 N.W. Science Park Drive
Portland, Oregon  97229


Sales:  (800) 356-7097
Tel:  (503) 641-8446
FAX:  (503) 644-2413
.illust end
.*
.np
.*
.ix 'USNET (&cat)'

.ix 'United States Software Corporation'

.ix '&cat'
.*
USNET is a TCP/IP protocol stack designed specifically for embedded use.  It is
compact (about 24K), and fast.  It is compatible with most popular RTOSes
(including MultiTask!).
USNET provides client/server support for FTP, TFTP, TELNET and BOOTP.  Two
API's are supported, either the BSD socket interface, or a dynamic protocol
interface.  USNET supports the following standard Internet suite of protocols,
all of which are compliant with current RFC's:  TCP, UDP, IP, ICMP, ARP, RARP.
Drivers are provided for many popular ethernet interfaces and serial
interfaces.  Full source code is provided, and no royalties are charged.
.*

.*

.*

.section DataVision (&cat)
.*
.np
.illust begin
VisionSoft Corporation
PruneYard Tower 1, 1901 S. Bascom Ave., Suite 1060
Campbell, CA  95008


Sales:  (800) 695-6382
Tel:  (408) 879-2672
FAX:  (408) 879-2307
.illust end
.*
.np
.*
.ix 'DataVision (&cat)'

.ix 'VisionSoft Corporation'

.ix '&cat'
.*
DataVision is an embedded database system for client/server, distributed and
embedded applications.  It combines the benefits of an embedded database
(extremely fast response times, efficient memory utilization, flexible schemas,
low-level access) with the requirements for client/server applications (modular
design and scalability).  DataVision fully supports features found in industry
databases plus (variable length records, quick key index search,
ascending/descending reads).
.np
.illust begin
DataVision provides the ability to:
* read/write data for heterogeneous platforms independent of the Processor
Architecture, Compiler and Operating System; and therefore,
* developers who utilize this DataVision database API will not need to worry
about what platform the database resides on because the database can be easily
transferred to new platform environments with no programming changes or
database reformatting.
* now, write interactive applications that utilize fully relational queries,
fast response times and transparent data movement simply and easily.
.illust end
.illust begin
Key Benefits
* Ensures minimal size, native performance and portability on all platforms
* Significantly reduces design, development and test cycles
* Shortens time-to-market
* Flexible, customizable, and extensible
* Speeds the creation of database related application resources
* Eliminates the need to re-code your application for a new platform
* Delivers your products to marketplace with a single source code version
* Source Code provided
.illust end
.illust begin
Example Database Library Functions
DVgetinfo - returns key header information such as version and key names etc
DVdefkey - defines a key
DVdelkey - deletes a key
DVopen - opens and creates a database
DVscratch - removes a file from the system
DVclose - closes a file
DVcopy - copies the database
DVrebuild - rebuilds and compresses the database
DVdelete - provides for deleting a record
DVundo - reverses a record delete operation for the key specified
DVpos - approximate, generic and exact positioning to records supported for 1-
10 key fields
DVread - ascending or descending key record reading
DVwrite - writes new key and data records into the database
DVupdate - replace an existing record or write a new record
DVtread - text read for a file opened in text mode
DVtwrite - text write for a file opened in text mode
.illust end
.illust begin
Platforms Supported:
Windows 3.1, Windows '95, Windows/NT, Macintosh, OS/2
.illust end
.illust begin
Target Execution Platforms Supported:
All Host Platforms Listed Above, TANDEM Guardian, SunOS, Solaris, HP/UX, AIX,
Embedded Systems
.illust end
.*

.*

.*
:set symbol="cat" value="Graphics Libraries"

.chap Graphics Libraries
.*
.np
The following section contains listings for graphics libraries supporting
Watcom C or C++.
.*

.section AccuSoft Image Format Library (&cat)
.*
.np
.illust begin
AccuSoft Corp.
Two Westborough Business Park
Westborough, MA  01581


Sales:  (800) 525-3577
Tel:  (508) 898-2770
FAX:  (508) 898-9662
.illust end
.*
.np
.*
.ix 'AccuSoft Image Format Library (&cat)'

.ix 'AccuSoft Corp.'

.ix '&cat'
.*
AccuSoft's Image Format Library is a complete high performance imaging toolkit.
Due to the availability of both high level and low level interfaces,
integration into any application can be accomplished in a matter of minutes.
File formats supported include Kodak Photo CD plus ASCII, ATT, BMP, Brooktrout,
CALS, CLP, CUT, DCX, DIB, EPS, GIF, Group 3, Group 4, GX2, ICO, IFF, IMG, IOCA,
JPEG, KoFax, LaserData, MAC, MSP, PCX, PhotoShop, PICT, RLE, SUN, TARGA, TIFF,
WMF, WPG, XBM, XPM, and XWD.  Only raster images are supported in metafile
formats.  Photo CD read only.  Features include automatic aspect ratio
correction, automatic color reduction based on video mode, panning and
scrolling, zoom to any degree, multiple palette image display, color reduction
techniques including a new octree algorithm for reducing to any number of
colors, brightness, contrast, sharpness control, cropping, clipboard support,
matrix convolutions, 10 display effects, flip, invert, rotate, gamma
correction, complete scanning control, compression using any algorithm allowed
by the format, resize with interpolation and sub-sampling, complete printing
control, edge detection, Roberts cross, dilation, fast image display, format
auto-detect, area selection and more.  Special versions for Watcom 32 bit for
both DOS and Windows.  Versions for OS/2, Mac, UNIX, and NT.  All AccuSoft
products are backed by the Image Format Guarantee which states, 'Guaranteed to
read all raster images in existence in the supported formats.  If you can find
a valid image we don't read, send it to us and we will make it work!'
.*
.figure *depth='2.75' *scale= *file='accusoft'
.*

.*

.section Menuet/C (&cat)
.*
.np
.illust begin
Autumn Hill Software
1145 Ithaca Drive
Boulder, Colorado 80303


Tel:  (303) 494-8865
FAX:  (303) 494-7802
.illust end
.*
.np
.*
.ix 'Menuet/C (&cat)'

.ix 'Autumn Hill Software'

.ix '&cat'
.*
Despite the growing importance of the C++ language and graphical operating
systems such as OS/2 and Windows, C is still the most widely used language on
the desktop.  If you are developing applications for DOS using C then you
should know about our Menuet/C GUI toolkit.  Virtually all improtant C
development environments for DOS are supported as well as 16-bit and 32-bit
protected mode environments.  There is EMS memory and virtual memory using
disk.  And, Menuet/C provides the IDT screen designer and icon and font
editors, along with lots of font and icon files.
.np
There's also over 1,000 pages of printed documentation and 35 fully functioning
sample programs.
.*

.*

.*

.section Menuet/CPP (&cat)
.*
.np
.illust begin
Autumn Hill Software
1145 Ithaca Drive
Boulder, Colorado 80303


Tel:  (303) 494-8865
FAX:  (303) 494-7802
.illust end
.*
.np
.*
.ix 'Menuet/CPP (&cat)'

.ix 'Autumn Hill Software'

.ix '&cat'
.*
If you're looking for a sophisticated versatile, powerful, easy to use, and
good looking development framework for DOS, then look no further.  Menuet/CPP
has proven to be this and more in a wide range of developer settings, from one-
man shops to Fortune 500 I.S. departments.  We support all major DOS compilers
as well as low-level graphics packages from MetaGraphics and Flash-Tek and
extenders from Flash Tek, Phar Lap, and Tenberry Systems. Menuet provides all
of the important components needed to get an application up and running.
There's a wide range of general purpose classes and a dilaogs library
containing many pre-built dialogs.  We-ve also included a large collection of
icons and fonts and the best icon and font editors you'll find anywhere.
.*

.*

.*

.section Menuet/CX (&cat)
.*
.np
.illust begin
Autumn Hill Software
1145 Ithaca Drive
Boulder, Colorado 80303


Tel:  (303) 494-8865
FAX:  (303) 494-7802
.illust end
.*
.np
.*
.ix 'Menuet/CX (&cat)'

.ix 'Autumn Hill Software'

.ix '&cat'
.*
 Menuet/CX is the fourth generation of the Menuet family of GUI Application
Frameworks.  Menuet/CX delivers a new level of excellence in cross-platform GUI
application frameworks for the professional developer who is concerned about
aesthetics as well as efficiency.  Menuet/CX provides a high quality visual
presentation for you application while taking minimal resources. With its
visual design editors, you get to produce functional and  artistic results
fast.  Menuet/CX supports OS/2 2.x and Warp, MS-Windows 3.x, MS-Windows 95, and
Windows NT along with all
major compilers on these platforms.
.*

.*

.*

.section CAD/CAM Developer's Kit (&cat)
.*
.np
.illust begin
Building Block Software
77 Pearson Road
Somerville, MA  02144


Tel:  (617) 628-5217
FAX:  (617) 628-6333
.illust end
.*
.np
.*
.ix 'CAD/CAM Developer's Kit (&cat)'

.ix 'Building Block Software'

.ix '&cat'
.*
The 'CAD/CAM Developer's Kit' libraries provide ANSI C functions which support
core CAD/CAM features for custom applications including: area booleans,
boundary offsets, mill/turn toolpaths; reading & writing all DXF entitities R10-
12 ; 2D/3D wireframe display; 2D & 3D lines, arcs, circles, ellipses, NURB
splines; transforms; intersect/trim/fillet; can be used for
DOS/Windows/ADS/UNIX applications.
.*

.*

.*

.section TG-CAD Draw (&cat)
.*
.np
.illust begin
Disk Software Inc.
109 S. Murphy Road
Plano, Texas  75094


Sales:  (800) 635-7760
Tel:  (214) 423-7288
FAX:  (214) 423-7288
.illust end
.*
.np
.*
.ix 'TG-CAD Draw (&cat)'

.ix 'Disk Software Inc.'

.ix '&cat'
.*
A complete Drawing Library for Windows and DOS.  A complete set of 2D and 3D
(floating point) drawing routines for DOS and Windows.  The command set is the
same for Windows and DOS.  The drawing entities include:  Line, Arc, Circle,
Ellipse, Polyline, Curve, Surface, Solid, Text, Dimensions, Shapes, Insertions,
Blocks and more. Each of the entities can be drawn in 2D or 3D.  You can define
multiple viewports within a window.  Each viewport can have a different view of
an object or group of objects.  This allows you to combine 2D and 3D drawings
within the same window.  You can layer your drawings.  The library comes with
16 vector line styles or you can create your own.  Line styles can be scaled,
they are not pixel based.  Each entity can be drawn in its own coordinate
system.  This give you the ability to import symbols and blocks of data and
draw them at a specific location.  You can dimension your drawings.  All text
is vector based and can be drawn at any angle, size or direction.  You can
create your own text styles or use the ones provided with the library.  A
complete ray tracer and shading program is included with the library.  You can
specify multiple light sources using user defined surface properties such as
ambient lighting, diffuse lighting, and Phong highlights.  The shading program
creates spectacular images.  The images created can be output as GIP or PCX
files.  The library comes with a PCX/GIF viewer and a set of routines that will
read, write PCX or GIF file formats.  DXF files read by TG-CAD DXF Translator
can be drawn using the routines in this library.  In fact, the library comes
with a DXF Viewer coompiled and ready to use.  Manual & example programs
included.  Source code available.  30 day limited guarantee.
.*

.*

.*

.section TG-CAD Professional (&cat)
.*
.np
.illust begin
Disk Software Inc.
109 S. Murphy Road
Plano, Texas  75094


Sales:  (800) 635-7760
Tel:  (214) 423-7288
FAX:  (214) 423-7288
.illust end
.*
.np
.*
.ix 'TG-CAD Professional (&cat)'

.ix 'Disk Software Inc.'

.ix '&cat'
.*
A Complete CAD/CAM/CAE Graphics Developers Kit.  The professional version is a
combination of TG-CAD 2D v5.0, TG-CAD 3D v5.0, TG-CAD DXF Translator v2.0 and
TG-CAD Draw v2.0.
.*

.*

.*

.section WordUp Graphics Toolkit (&cat)
.*
.np
.illust begin
Egerter Software
94 Andover Drive
London, ON  N6J 3X2


Tel:  (519) 641-7542
FAX:  (519) 641-7542
.illust end
.*
.np
.*
.ix 'WordUp Graphics Toolkit (&cat)'

.ix 'Egerter Software'

.ix '&cat'
.*
The WordUp Graphics Toolkit is a graphics and game programming library
designed for the professional game developer.  This library was built by
games programmers and has everything you need to quickly develop high
performance PC games under protected mode.  Video modes supported are
320x200x256 and all 256 color SVGA modes.  WGT goes above and beyond
the normal graphics library by providing advanced features such as tiled
parallax scrolling, 3D rendering includes flat, textured, gouraud, flat
textured, gouraud textured, translucent textured, and translucent
gouraud triangles, 3DS file loading, a dirty rectangle sprite engine,
modem/serial routines, mouse, joystick, keyboard, timer, bitmap resizing,
special effects, translucency and other bitmap lighting effects, data
library management, bitmapped fonts, FLI/FLC, drop down menus and much more.
.np
The WGT Sprite Editor is used to edit sprites, fonts, mouse cursors,
pictures, and can store up to 2000 images into a single file.  A single
command in WGT will load all the images at once, and you don't have to
worry about grabbing sprites off a picture at runtime.  It also has image
importing, exporting, resizing, rotation, macros, tile grabbing, and many
other tools.
.np
The WGT Map Editor is used to edit tiled maps.  Using a windowed
graphical interface, you can easily edit your world and place sprites as
well.
.np
WGT also provides 400 pages of printed documentation, and more than 70
detailed examples.  Over 400k of practical example code is available at
your fingertips, making your development time quicker.
.np
For more information: www.kosmic.wit.com
.*
.figure *depth='2.75' *scale= *file='wgtlogo'
.*

.*

.section libhpgl 386/486 C/C++ extended graphics library (&cat)
.*
.np
.illust begin
Gary R. Olhoeft
P.O. Box 10870 Edgemont
Golden, Colorado  80401-0620


Tel:  (303) 273-9202
FAX:  (303) 273-9202
.illust end
.*
.np
.*
.ix 'libhpgl 386/486 C/C++ extended graphics library (&cat)'

.ix 'Gary R. Olhoeft'

.ix '&cat'
.*
libhpgl supports graphics direct to hardware for IBM standard modes EGA, VGA,
MCGA, 8514, VESA/SVGA, TIGA 2.20 devices, Hercules Graphics Station Card, and
WYSIWYG hardcopy to HP-GL and PostScript devices, plot files or arrays. This 32-
bit protected mode library supports mixed vector plotting and raster imaging,
graphics viewports (partial screen windowing), user unit scaling, rotatable and
scalable labels (with 18 fonts including symbols, Greek, and Cyrillic), and
more up to 64k x 64k pixels (4GB max) with 8-, 15- or 24-bit graphics cards
(256-, 32, 768- or 16,777,216-colors).  The library comes with full source code
in C and Phar Lap 386|ASM, extensive example code and manual.  No royalties for
distribution of compiled composite code.
.*

.*

.*

.section Ground Up Graphics (GUG) (&cat)
.*
.np
.illust begin
Ground Up Software
1380 Rio Rancho Blvd.
#314
Rio Rancho, NM  87124

Tel:  505-892-0887

.illust end
.*
.np
.*
.ix 'Ground Up Graphics (GUG) (&cat)'

.ix 'Ground Up Software'

.ix '&cat'
.*
  A Watcom/Pmode mode 13x (320x200x256) color graphics game library. GUG is
easy to use and tool rich. It supports high speed game sprites in both
native and assembled modes. Keyboard (multi-key press detection) and joystick
support is built in. GUG supports both DOS4GW and the CauseWay DOS extenders,
and should work with most others. The basic GUG package is freeware!
Registering GUG gains you full access to the source code! $50 to register.
GUG includes several utilities in the package such as sprite rippers and
editors, color palette converters etc.
   http://www.swcp.com/~nbreeden - look for the GUG link!
.*

.*

.*

.section MEWEL (&cat)
.*
.np
.illust begin
MAGMA Software Systems
15 Bodwell Terrace
Millburn, New Jersey 07041


Tel:  (201) 912-0192
FAX:  (201) 912-0103
.illust end
.*
.np
.*
.ix 'MEWEL (&cat)'

.ix 'MAGMA Software Systems'

.ix '&cat'
.*
MEWEL 4.1 is a cross-platform user interface tookit which gives your
application complete portability between Microsoft Windows, DOS text, DOS
graphics, OS/2 text, UNIX text, and OSF Motif. Since MEWEL's API is compatible
with the standard Microsoft Windows API, you can easily port programs between
Windows and any of the environments which MEWEL supports,
even if you already have existing Windows programs.
.np
Programmers can develop new stand-alone applications using MEWEL, or can port
their existing Windows applications to any of the platforms which MEWEL
supports. MEWEL supports Windows 3.x features such as Control windows (listbox,
combo, radio, checkbox, pushbutton, scrollbars, single & multi-line edit,
static) Multiple Document Interface (MDI) Dialog Boxes Overlapping Windows with
moving and resizing Multi-level Menus Mouse Windows BMP files (blitting,
stretching, compressing) PCX files Icons (character and graphical) Multiple
proportional fonts MEWEL supports the Watcom 10.5 32-bit compiler, and the DOS
4G/W and Pharlap TNT DOS extenders. The DOS Graphics version supports the
MetaWindows 386 and Watcom graphics libraries.
.*
.figure *depth='2.75' *scale= *file='wmewlgui'
.*

.*

.section AUTODIRECT (&cat)
.*
.np
.illust begin
Marcomp
13 Lauriann #100
Parkton, Maryland  21120


Tel:  (410) 343-2743
FAX:  (410) 357-8662
.illust end
.*
.np
.*
.ix 'AUTODIRECT (&cat)'

.ix 'Marcomp'

.ix '&cat'
.*
AUTODIRECT is a family of C programming libraries for direct access to DWG, DXF
and binary DXF files from AutoCAD versions 2.5 and up.  AUTODIRECT 2 libraries
provide the C programmer with a comprehensive set of functions to read and
write AutoCAD files, supporting all drawing entities, as well as block
definitions, header values, extended entity data, layer, linetype,
block, style, view, UCS and viewport lists.  AUTODIRECT 3 adds the ability to
vectorize AutoCAD files for display, and supports paperspace, external
references, and AutoCAD fonts (including bigfonts).  All AUTODIRECT versions
are able to open multiple files simultaneously.
.*

.*

.*

.section FontBUILDER (&cat)
.*
.np
.illust begin
Metagraphics Software Corporation
200 Clock Tower Place, Suite 201E

Carmel, CA  93922

Sales:  (800) 332-1550
Tel:  (408) 622-8950
FAX:  (408) 622-8955
.illust end
.*
.np
.*
.ix 'FontBUILDER (&cat)'

.ix 'Metagraphics Software Corporation'

.ix '&cat'
.*
Metagraphics FontBUILDER works with scaleable outline fonts to create high-
quality MetaWINDOW bitmap fonts at any size or resolution you specify.
FontBUILDER includes over 20 outline typefaces in four font families (Times,
Helvetica, Courier and Script), plus can import both
PostScript and TrueType fonts for conversion to bitmap fonts for use with
MetaWINDOW graphic toolkits.  Style facings include normal, bold, italic, thin,
condensed, wide, expanded, hollow - and
combinations thereof.  Virtually no limitiation on font point sizes.  Virtually
unlimited font rasterization resolutions.
.np
FontBUILDER works with MetaWINDOW for DOS, -286 or -386 protected mode.  All
fonts provided may be distributed Royalty Free.  Full 30-day product guarantee.
.*
.figure *depth='2.75' *scale= *file='metapowr'
.*

.*

.section FontWINDOW (&cat)
.*
.np
.illust begin
Metagraphics Software Corporation
200 Clock Tower Place, Suite 201E

Carmel, CA  93922

Sales:  (800) 332-1550
Tel:  (408) 622-8950
FAX:  (408) 622-8955
.illust end
.*
.np
.*
.ix 'FontWINDOW (&cat)'

.ix 'Metagraphics Software Corporation'

.ix '&cat'
.*
Metagraphics FontWINDOW provides an extended set of bitmap fonts, font tools
and font documentation for use with Metagraphics MetaWINDOW. Over 200
additional English and international font styles are provided.  The graphical
bitmap font editor allows you to create
custom fonts or foreign language character sets; merge characters from
different fonts to create a new font; create icons and animation fonts; or
create new bold-faced, italicized or rotated font sets.
.np
FontWINDOW works with MetaWINDOW-DOS, -286 or -386.  All fonts provided are
Royalty Free.  Full 30-day product guarantee.
.np
For additional information:
.np
CompuServe:        GO METAGR, LIB 12, download FWDEMO.ZIP
.br
Internet ftp:      ftp.metagraphics.com, download FWDEMO.ZIP
.br
Metagraphics BBS:  408-622-8945, download DEMO\\FWDEMO.ZIP
.*
.figure *depth='2.75' *scale= *file='metapowr'
.*

.*

.section Media!Lab (&cat)
.*
.np
.illust begin
Metagraphics Software Corporation
200 Clock Tower Place, Suite 201E

Carmel, CA  93922

Sales:  (800) 332-1550
Tel:  (408) 622-8950
FAX:  (408) 622-8955
.illust end
.*
.np
.*
.ix 'Media!Lab (&cat)'

.ix 'Metagraphics Software Corporation'

.ix '&cat'
.*
MEDIA!LAB(tm) is a powerful multimedia programming toolkit that lets you create
stunning interactive graphic programs, animated titles and games better and
faster than ever before.  MEDIA!LAB combines imaging, animation, video,
sprites, special effects and sound in a
streamlined C/C++ programming toolkit.  Optimized in assembly language for
quick tight code, MEDIA!LAB pushes the limits for fast Windows performance.
.np
MEDIA!LAB provides a powerful suite of fast interactive graphic capabilities
supporting BMP/PCX/DCX image files, AVI/FLC/FLI video, sprite animation,
transparent 'blue screen' cinematic animation, sound, timer controls, fade and
wipe effects, color-palette animation, object hit and collision detection,
bitmap tiling, and more.  MEDIA!LAB can be used by itself, or in combination
with other C++ class libraries such as MFC or OWL.
.np
MEDIA!LAB comes with a comprehensive developer's manual, on-line hypertext
help, and is backed by Metagraphics support and a full 30-day guarantee.  Full
source code is available, plus all products are Royalty-Free.
.np
For additional information:
.np
CompuServe: GO METAGR, LIB 12, download MLINFO.ZIP
.br
Internet ftp: ftp.metagraphics.com, download MLINFO.ZIP
.br
Metagraphics BBS: 408-622-8945, download DEMO\\MLINFO.ZIP
.br
.*

.*

.*

.section MetAccel (&cat)
.*
.np
.illust begin
Metagraphics Software Corporation
200 Clock Tower Place, Suite 201E

Carmel, CA  93922

Sales:  (800) 332-1550
Tel:  (408) 622-8950
FAX:  (408) 622-8955
.illust end
.*
.np
.*
.ix 'MetAccel (&cat)'

.ix 'Metagraphics Software Corporation'

.ix '&cat'
.*
Metagraphics MetACCEL provides an enhanced set of MetaWINDOW graphic display
drivers for use with hardware-accelerated SuperVGA's such the ATI Graphics
Ultra, Diamond Stealth, Orchid Fahrenheit-1280, Actrix Graphics Engine, IBM
8514A, and many others.  MetACCEL with a
hardware accelerated graphics card can boost display performance more than 5 to
15 times over the speed of standard software-only SuperVGA's.  MetACCEL
supports popular hardware accelerated cards up to 1280x1024 256-color.
Optimized entirely in assembly language for
tight, fast code, MetACCEL provides unsurpassed graphics performance.  MetACCEL
includes a full set of MetaWINDOW display drivers for DOS, plus both 16-bit and
32-bit protected-mode.
Full 30-day product guarantee.
.*
.figure *depth='2.75' *scale= *file='metapowr'
.*

.*

.section MetaWINDOW (&cat)
.*
.np
.illust begin
Metagraphics Software Corporation
200 Clock Tower Place, Suite 201E

Carmel, CA  93922

Sales:  (800) 332-1550
Tel:  (408) 622-8950
FAX:  (408) 622-8955
.illust end
.*
.np
.*
.ix 'MetaWINDOW (&cat)'

.ix 'Metagraphics Software Corporation'

.ix '&cat'
.*
Metagraphics MetaWINDOW is a fast, comprehensive graphics toolkit that expands
the capabilties of your Watcom compiler library.  Optimized entirely in tight
assembly language code, MetaWINDOW provides a full set of graphic functions
for: points, lines, squares, rectangles, circles, ovals, arcs, polygons, bitmap
text, plus seed and boundary fills.  Enhanced features include: rounded-corner
rectangles, object hit detection, scaleable text, font facing, image
scaling, fill rules, dash styles, line cap styles, extended rasterOps, multi-
colored patterns and more.  MetaWINDOW also supports drawing to offscreen
bitmaps located in conventional, EMS, XMS or virtual disk memory.  Using
MetaWINDOW you can create multi-windowed applications, process
mouse/keyboard/timer events, and print graphics to popular laser and dot-matrix
printers.  MetaWINDOW additionally includes advanced features for: irregular-
area region clipping, Bezier curves and fills, PostScript style pens and lines,
colored cursors, hi-res cursors and patterns, and more.  MetaWINDOW supports
over 80 graphic display modes from Hercules to SuperVGA and VESA, up to
1280x1024 resolution.  Add expanded support for hardware
accelerated and hi-color SuperVGA's with optional MetACCEL and MetHICOLOR add-
on products.  MetaWINDOW-386 includes DOS real-mode, 286 protected-mode and 386
protected-mode libraries.  Top-rated performance and in a comprehensive
graphics toolkit has made
MetaWINDOW the professional choice for leading applications from Autodesk,
Borland International, Cadam/Altium, Hewlett-Packard, IBM, Maxis, SCO,
Symantec/Peter Norton, ...plus over a thousand others.
.np
Full source code is available, plus all products are Royalty-Free. Full 30-day
product guarantee.
.np
For additional information:
.np
CompuServe:        GO METAGR, LIB 12, download MWINFO.ZIP, MWDEMO.ZIP
.br
Internet ftp:      ftp.metagraphics.com, download MWINFO.ZIP, MWDEMO.ZIP
.br
Metagraphics BBS:  408-622-8945, download DEMO\\MWINFO.ZIP, MWDEMO.ZIP
.*
.figure *depth='2.75' *scale= *file='metapowr'
.*

.*

.section ACSL Model (&cat)
.*
.np
.illust begin
MGA Software
200 Baker Avenue
Concord, MA  01742


Tel:  (508) 369-5115
FAX:  (508) 369-0013
.illust end
.*
.np
.*
.ix 'ACSL Model (&cat)'

.ix 'MGA Software'

.ix '&cat'
.*
ACSL Model  is a complete environment for simulation, modelling, and analyzing
systems described by time-dependent, nonlinear differential equations or
transfer functions.  ACSL Model has powerful instructions,  including a
complete compliment of simulation operators and commands tailored for
continuous simulation and linear analysis.  Included with ACSL Model is the
Graphic Modeller, which is a graphic user interface, block-diagram front end.
.np
The ACSL (Advanced Continuous Simulation Language) consists of two sections:
the model definition and the run time commands.  The model definition involves
establishing mathematical specifications with ACSL statements for the
continuous simulation system being modeled.  The model is then analyzed by
instructions interpreted during the run time command section.  Once a model is
defined, it can be kept on file and analyzed over and over again by the run
time commands since all variables in the model definition can be displayed,
plotted, or printed and any constant or variable changed before a simulation
run.
.np
The Graphic Modeller enables the user to visually create, execute, and analyze
simulation models.  The Graphic Modeller major features include the following:
full compliment of primitives for ACSL instructions, functions, and macros:
user defined blocks: modern drawing package: multiple-view, multiple-editor
environment; and hierarchical modelling, both top down and bottom up.  The
Graphic Modeller helps the user to create a model that is visually meaningful
and easy to understand.
.*

.*

.*

.section ACSLrt Realtime (&cat)
.*
.np
.illust begin
MGA Software
200 Baker Avenue
Concord, MA  01742


Tel:  (508) 369-5115
FAX:  (508) 369-0013
.illust end
.*
.np
.*
.ix 'ACSLrt Realtime (&cat)'

.ix 'MGA Software'

.ix '&cat'
.*
ACSLrt is ACSL ( Advanced Continuous Simulation Language) with real time
extensions.  ACSLrt is for real time simulation.  The primary characteristics
of realtime operation are synchronizing model execution with a realtime clock
and communicating simulation data between the computer and the real world
through a realtime I/O board.  ACSLrt is synchronized with a computers real
time clock.  Realtime simulations require precise synchronization between the
model  and the external hardware and Input/Output boards for communication
between the computer and the external hardware.  For the PC computer platform,
ACSLrt includes ACSL with Graphic Modeller for Windows with real time
extensions, Keithley analog and digital Input/Output board, and Watcom FORTRAN
77/32 10.5 compiler.  Major features of ACSLrt are the following: powerful
simulation engine; speed; portability across multiple computer hardware
platforms, including DOS, Windows, and UNIX systems; and an advanced GUI
interface.
.*

.*

.*

.section GraphiC/(DOS)(WIN)(NT)(286)(OS2) (&cat)
.*
.np
.illust begin
Scientific Endeavors Corp.
508 N. Kentucky Street
Kingston, TN  37753


Sales:  (800) 998-1571
Tel:  (423) 376-4146
FAX:  (423) 376-1571
.illust end
.*
.np
.*
.ix 'GraphiC/(DOS)(WIN)(NT)(286)(OS2) (&cat)'

.ix 'Scientific Endeavors Corp.'

.ix '&cat'
.*
GraphiC is a library of over 240 'C' routines for producing all sorts of
technical plots. With GraphiC it is easy to include publication quality
graphics as part of your application. Most popular printers and file formats
are supported.
.np
Supported plot types include 3-D and contour plots with various shading
options, linear, log-log and semi-log, polar, and more. With the GraphiC
routines you can also invent new plot types to display your data with maximum
impact.
.np
The GraphiC interface has been designed so that platform migration is a snap.
Macros are provided to accomodate differances between DOS and GUI interfaces so
that it is possible to create a Windows or OS/2 application without makeing any
platform specific API calls. For example, a program written for GraphiC for DOS
will work perfectly with GraphiC/OS2 by simply
compiling it for OS/2 and linking with the GraphiC/OS2 library.
.np
GraphiC comes as source code so that complete customization is possible. Make
files are provided to help with the creation and maintainance of the library.
The installation program will compile the library for you if you choose.
.np
GraphiC can be used with PostScript fonts with the PostScript add on
graphiC/PST. GraphiC/PST creates vectors from the PostScript metrics so that
all of the font plotting features of GraphiC can be utilized with the
PostScript fonts installed on your system.
.np
CraphiC uses a high resolution internal grid so that the maximnm resolution of
the output device can be utilizied.
.*
.figure *depth='2.75' *scale= *file='sciend'
.*

.*

.section Ingraf (&cat)
.*
.np
.illust begin
Sutrasoft
10506 Permian Drive
Sugar Land, Texas  77478


Tel:  (713) 491-2088
FAX:  (713) 240-6883
.illust end
.*
.np
.*
.ix 'Ingraf (&cat)'

.ix 'Sutrasoft'

.ix '&cat'
.*
INGRAF contains routines that you can use to create high quality graphics
with your IBM (or compatible) personal computer and any of numerous output
devices. INGRAF is available for C, FORTRAN-77, BASIC, and PASCAL, with most
routines being written in the applicable language.

In addition to general drawing routines such as line, arc, circle, grid, etc.,
that you can use to create log (semi-log and log-log), and polar plots,
INGRAF includes routines for creating bar, pie, scatter, polar and
smith charts , as well as the HIGH-LOW-CLOSE plots.

Some of the features of INGRAF are:

     Draw and scale X and Y axes independently of one another, with
     arbitrary placement.

     Control the placement and direction of text labels, (also the size
     of the text on some devices).

     Determine the size and spacing of tick marks and their placement in
     relation to the axes.

     Choose from several symbols to mark points.

     Select from various line styles and grid styles, depending on your
     choice of graphics device.

     Turn line clipping on or off.

     Generate hatching patterns with six hatch styles.


INGRAF contains over 150 user callable routines. The 350+ page user manual
includes over 50 sample programs and graphs. The same samples also are
included on diskette. INGRAF comes with complete source code and ready
to use libraries. There are NO ROYALTIES or RUN-TIME FEES.
.*

.*

.*

.section Wingraf for Windows (&cat)
.*
.np
.illust begin
Sutrasoft
10506 Permian Drive
Sugar Land, Texas  77478


Tel:  (713) 491-2088
FAX:  (713) 240-6883
.illust end
.*
.np
.*
.ix 'Wingraf for Windows (&cat)'

.ix 'Sutrasoft'

.ix '&cat'
.*
WINGRAF contains routines that you can use to create high quality graphics
with your IBM (or compatible) personal computer and any of numerous output
devices. WINGRAF is available for C, FORTRAN-77, BASIC, and PASCAL, with most
routines being written in the applicable language.

In addition to general drawing routines such as line, arc, circle, grid, etc.,
that you can use to create log (semi-log and log-log), and polar plots,
WINGRAF includes routines for creating bar, pie, scatter, polar and
smith charts , as well as the HIGH-LOW-CLOSE plots.

Some of the features of WINGRAF are:

     Draw and scale X and Y axes independently of one another, with
     arbitrary placement.

     Control the placement and direction of text labels, (also the size
     of the text on some devices).

     Determine the size and spacing of tick marks and their placement in
     relation to the axes.

     Choose from several symbols to mark points.

     Select from various line styles and grid styles, depending on your
     choice of graphics device.

     Turn line clipping on or off.

     Generate hatching patterns with six hatch styles.


WINGRAF contains over 140 API routines. The 350+ page user manual
includes over 50 sample programs and graphs. The same samples also are
included on diskette. WINGRAF comes with complete source code and ready
to use DLL and libraries. There are NO ROYALTIES or RUN-TIME FEES.
.*

.*

.*

.section Fastgrapg for Windows (&cat)
.*
.np
.illust begin
Ted Gruber Software
PO Box 13408
Las Vegas, NV  89112


Tel:  (702) 735-1980
FAX:  (702) 735-4603
.illust end
.*
.np
.*
.ix 'Fastgrapg for Windows (&cat)'

.ix 'Ted Gruber Software'

.ix '&cat'
.*
Fastgraph for Windows allows you to build great graphics applications
for Windows the same way you do for DOS. Powerful, fast low-level
graphics routines interface with your choice of WinG, DirectDraw or
the Windows API and enable you to create fast, smooth animation under
Windows 3.1 and Windows 95. Both 16 and 32-bit libraries support Watcom
C and Watcom C++. Port your Fastgraph DOS code to Windows with just a
few simple modifications. Graphics techniques are extensively documented
in a comprehensive 500+ page manual. Virtual buffers, bitmaps, file
formats, color palette management, graphics primitives, scaling,
blitting, animation, double and triple buffering, and printing are all
supported in a simple, intuitive, well-documented manner. Writing games
for Windows doesn't get much easier than this! Fastgraph for Windows
is only $249, with no royalties.
.*

.*

.*

.section Fastgraph (&cat)
.*
.np
.illust begin
Ted Gruber Software
PO Box 13408
Las Vegas, NV  89112


Tel:  (702) 735-1980
FAX:  (702) 735-4603
.illust end
.*
.np
.*
.ix 'Fastgraph (&cat)'

.ix 'Ted Gruber Software'

.ix '&cat'
.*
Fastgraph is a programmer's graphics library, commonly used by game programmers
but general purpose enough for most applications requiring robust graphics.
Twenty-eight video modes through 1024x768x256 are supported. SVGA support is
accomplished by autodetection with direct chipset support; VESA support is also
available. Graphics primitives, file formats, palette control, video memory
resizing, scrolling, panning, super-fast blits, mouse, joystick, and keyboard
support are included. Bitmapped fonts and a resource file manager are available
as add-ons.
.np
Supports real, 16 and 32-bit protected mode. A shareware version is available -
- call the office and ask for a free demo disk.
.np
Originally a DOS library, Fastgraph for Windows is scheduled for release in the
4th quarter of 1995.
.*
.figure *depth='2.75' *scale= *file='fastgr2'
.*

.*

.section MetHICOLOR (&cat)
.*
.np
.illust begin
Ted Gruber Software
PO Box 13408
Las Vegas, NV  89112


Tel:  (702) 735-1980
FAX:  (702) 735-4603
.illust end
.*
.np
.*
.ix 'MetHICOLOR (&cat)'

.ix 'Ted Gruber Software'

.ix '&cat'
.*
Metagraphics MetHICOLOR provides an advanced set of MetaWINDOW graphic display
drivers for use with new high-color SuperVGA's such as the ATI VGA Wonder,
Diamond Stealth, Orchid ProDesigner, and many others.
.np
MetHICOLOR allows you to create 16 bit-per-pixel graphics applications with
near photorealistic images up to 1280x1024 resolution with up to 65,536
displayable colors.  Optimized entirely
in assembly language for tight, fast code, MetHICOLOR provides unsurpassed
graphics performance.  MetACCEL includes a full set of MetaWINDOW display
drivers for DOS, plus both 16-bit and 32-bit protected-mode.  Applications
distributed using MetHICOLOR are
Royalty-Free.
.*
.figure *depth='2.75' *scale= *file='metapowr'
.*

.*

.section PCX-Lab (&cat)
.*
.np
.illust begin
Ted Gruber Software
PO Box 13408
Las Vegas, NV  89112


Tel:  (702) 735-1980
FAX:  (702) 735-4603
.illust end
.*
.np
.*
.ix 'PCX-Lab (&cat)'

.ix 'Ted Gruber Software'

.ix '&cat'
.*
Metagraphics PCX-Lab provides an expanded set of MetaWINDOW routines for
working with PCX image files and DCX image file libraries. PCX-Lab supports
popular monochrome, 16-color, 256-color and 16-bit/pixel high-color PCX image
file formats.  PCX-Lab lets you read PCX/DCX image files to the screen or to
off-screen bitmaps located in conventional, EMS, XMS or disk-cached virutal
memory.  PCX image files can be written from either on-screen or off-screen
bitmaps buffers.  PCX-Lab functions allow you to: read and write PCX images
from files or memory buffers; get, set and update palette settings; scroll,
scale, rotate and clip PCX images to the screen or off-screen bitmaps; access
PCX header file information; plus output PCX images to popular laser and dot-
matrix printers.  PCX-LAB includes a full set of MetaWINDOW compatible
libraries for DOS, plus both 16-bit and 32-bit protected-mode.  Applications
distributed
using PCX-Lab are Royalty-Free.
.*
.figure *depth='2.75' *scale= *file='metapowr'
.*

.*

.section Graph Layout Toolkit (&cat)
.*
.np
.illust begin
Tom Sawyer Software
1828 Fourth Street
Berkeley, CA  94710


Sales:  800-929-TOMS
Tel:  (510) 848-0853
FAX:  (510) 848-0854
.illust end
.*
.np
.*
.ix 'Graph Layout Toolkit (&cat)'

.ix 'Tom Sawyer Software'

.ix '&cat'
.*
.illust begin
Tom Sawyer's Graph Layout Toolkit is a family of portable libraries that
deliver an immediate face-lift to graphics applications with their
sophisticated layout algorithms. The Graph Layout Toolkit libraries' logical
representation of objects and connections allow end users to more easily see
underlying relationships within complicated data. The libraries also work in
real time, rarely requiring more than a few seconds to produce quality output
even for large graphs with several hundred nodes.

Four extensible C++ class libraries that include ANSI C APIs make up the Graph
Layout Toolkit family: the Circular, Hierarchical, Orthogonal*, and Symmetric
Layout Libraries. All libraries share a common foundation.

* Orthogonal layout will be generally available with release 2.2 of the Graph
Layout Toolkit in the first quarter of 1996, but can be made available in pre-
release form for select customers.

The Hierarchical library is ideal for the layout of directed graphs.  For
example, it is excellent for drawing complicated function call graphs and for
layout of nested outline PERT charts used in project management applications.

The Circular library is ideal for layout of complicated ring and star
topologies. For example, it may be used to layout complicated IP networks where
devices on the same Class A, Class B or Class C network
or devices on the same subnet are placed around the same circle. It is also
excellent at relating geographic site based information within the framework of
a logical layout product. It functions by partitioning
nodes into logical groups based on a number of flexible node grouping models.
Each group of nodes is placed on radiating circles based on the interconnection
of these groups.

The Symmetric library exposes the natural symmetry inherent in many graph
structures. For instance, this library is superb at rendering arbitrary
enterprise-wide computer networks or mesh networks.

Navigation Features
-------------------------
Graphs help you to manage information, but one graph is often not sufficient.
We provide easy to use, yet powerful tools to help you to manage information
that often spans many graphs.

The Graph Layout Toolkit helps you write powerful graph editing applications
with intelligent window management. Set up hypertext like associations from
nodes and edges in a graph to other graphs whether they are displayed in the
same window or different windows.

Supported Environments
-------------------------
The Graph Layout Toolkit libraries operate with most major operating systems,
compilers and GUI Toolkits. Support is also provided for the ANSI C compiler
designed to work with these C++ compilers listed below.

Sun SPARCstation:
    SunOS 4.1.x: Sun C++, GNU C++, MetaWare C++ and CenterLine C++
    Solaris 2.x: Sun C++, GNU C++, MetaWare C++ and CenterLine C++
HP 9000: HP C++, GNU C++
SGI Iris: SGI C++
IBM RS/6000: IBM C++
NeXT: NeXT C++
DEC OSF/1: DEC C++

Tom Sawyer Software is one of seven software companies nationwide to win the
U.S. Department of Commerce, National Institute of Standards and Technology's
Advanced Technology Program (ATP) award grant (95-09) for Component Based
Software Technology Development in 1995.
.illust end
.*

.*

.*
:set symbol="cat" value="LEX & YACC Utilities"

.chap LEX & YACC Utilities
.*
.np
The following section contains listings for Lex and Yacc utilities
supporting Watcom C or C++.

.*

.section CodeCheck (&cat)
.*
.np
.illust begin
Abraxas Software, Inc.
5530 SW Kelly Avenue
Portland, Oregon  97201


Sales:  (800) 347-5214
Tel:  (503) 244-5253
FAX:  (503) 244-8375
.illust end
.*
.np
.*
.ix 'CodeCheck (&cat)'

.ix 'Abraxas Software, Inc.'

.ix '&cat'
.*
CodeCheck 5.0 is a programmable tool for managing all C and C++ source code on
a file or project basis.  CodeCheck is input compatible with all variants of
K&R, ANSI C and C++.  CodeCheck is designed to solve all of your Portability,
Maintainability, Complexity, Reusability, Quality Assurance, Style Analysis,
Library/Class Management, Code Review, Software Metric, Standards Adherence,
and Corporate Compliance Problems.
.illust begin
*  Compliance- CODECHECK allows your corporate coding and project specification
standards to be completely automated for compliance validation
*  Complexity-Measures program size(Halstead) and program complexity(McCabe).
*  Portability-CODECHECK identifies code that will not port between DOS, OS/S,
Unix, VMS, and the Macintosh, and check for compatibility with ANSI, POSIX, and
other standards.
.illust end
.illust begin
Prices are: DOS,MAC $495.00
*    OS/2,NT $995.00
*    UNIX,   $1995.00
.illust end
.illust begin
ABRAXAS SOFTWARE, INC  5530 SW KELLY, PORTLAND OREGON 97201
TEL (503) 244-5253  FAX (503) 244-8375 E-mail: abraxas @ ortel.org
.illust end
.*

.*

.*

.section PCYACC (&cat)
.*
.np
.illust begin
Abraxas Software, Inc.
5530 SW Kelly Avenue
Portland, Oregon  97201


Sales:  (800) 347-5214
Tel:  (503) 244-5253
FAX:  (503) 244-8375
.illust end
.*
.np
.*
.ix 'PCYACC (&cat)'

.ix 'Abraxas Software, Inc.'

.ix '&cat'
.*
PCYACC 5.0 is a complete language development environment that generates ANSI C
& C++ source code from input Language Description Grammars for building
Assemblers, Compilers, Interpreters, Browsers, Page Description Languages,
Language Translators, Syntax Directed Editors, Language Validators, Natural
Language Processors, Expert System Shells, and Query Languages.
.illust begin
*  New! Generates C & YACC classes for Windows 3.0 and OS/2 2.0 Presentation
Manager
*  New! Build Professional systems with full ERROR HANDLING, RECOVERY &
REPORTING.
*  Lexical analyzer generator ABRAXAS PCLEX is included.
.illust end
.illust begin
Prices are: DOS,MAC  $495.00
*    OS/2, NT $995.00
*    UNIX     $1995.99
.illust end
.np
ABRAXAS SOFTWARE, INC. 5530 SW KELLY, PORTLAND OREGON 97201
TEL (503) 244-5253  FAX (503) 244-8375 E-mail: abraxas @ ortel.org
.*

.*

.*

.section Yacc++ and the Language Objects Library (&cat)
.*
.np
.illust begin
Compiler Resources
85 Main Street, Suite 310
Hopkinton, MA  01748


Tel:  (508) 435-5016  x.2
FAX:  (508) 435-4847
.illust end
.*
.np
.*
.ix 'Yacc++ and the Language Objects Library (&cat)'

.ix 'Compiler Resources'

.ix '&cat'
.*
.illust begin
Product Name:  Yacc++ and the Language Objects Library
Product Category:  LEX and YACC Utilities
This product supports:  Watcom C/C++ 10.5 (any 32 bit target)
.illust end
.np
Yacc++ is Object-Oriented Successor to Lex and YaccYacc++ and the Language
Objects Library from Compiler Resources, Inc. is an object-oriented rewrite of
lex and yacc which creates C++ classes from grammars.
.np
.illust begin
* Yacc++ directly translates regular expressions without introducing artificial
productions and produces minimal state LR(1) lexers and parsers.
* Multiple lexer and parser objects can be active concurrently and are fully
reentrant.
* Automatic class generation for ASTs (abstract syntax trees) per token, parser
non-terminal, or alternative.
* Multiple inheritance features for modularizing and reusing grammars.
* Grammar classes can be dynamically bound to lexer and parser objects.
* Multiple entry point grammars allow the matching of partial parse trees.
* Lexer and parser objects act as call-back coroutines within Windows, Motif,
and other event driven applications.
* Yacc++ comes with the Language Objects Library, a C++ class library with
syntactic and semantic support for building applications.  The library provides
base classes which define lexer, parser, input, AST, symbol table, and error
objects.
* Includes three ready to run example applications, a complete reference
manual, a comprehensive tutorial guide, sources to the class library, and a set
of tutorials with one hundred sample grammars.
.illust end
.np
.illust begin
ISV Contact Person:  Barbara ZinoSales
Information (for publication):
.illust end
.np
.illust begin
Compiler Resources, Inc.
Main Street, Suite 310
Hopkinton, MA  01748
Phone: (508) 435-501685
Fax: (508) 435-4847
E-mail: compres@world.std.com
.illust end
.*

.*

.*
:set symbol="cat" value="Linkers & Libraries"

.chap Linkers & Libraries
.*
.np
The following section contains listings for linkers and libraries
supporting Watcom C or C++.

.*

.section Blinker (&cat)
.*
.np
.illust begin
Blink, Inc.
8001 W. Broad St.
Richmond, VA  23294


Tel:  (804) 747-6700
FAX:  (804) 747-4200
.illust end
.*
.np
.*
.ix 'Blinker (&cat)'

.ix 'Blink, Inc.'

.ix '&cat'
.*
Blinker 3.2 features a compiler-independent Windows linker, a royalty-free 286
DOS extender, the worlds fastest DOS dynamic overlay linker and an integrated
memory swap function, all in one product forone low price! Compatible with all
the popular C, C++ and FORTRAN compilers, Blinker creates DOS and Windows
programs in seconds, saving hours of valuable programming time.

.np
Why a 286 DOS extender?
The major benefit of a 286 DOS extender is that it will run on any processor
from an 80286 with 1Mb of available memory up to the largest Pentium, whereas a
386 DOS extender requires a minimum of an 80386 processor. The Blinker extender
provides direct access to 16 Mb of
extended memory, runs multi-megabyte programs in protected mode in less than
200 Kb of conventional memory, and solves low memory problems caused by network
shells and other memory hungry TSRs. Fully compatible with DPMI, VCPI and XMS,
so your protected mode programs will run under Windows, DESQview and OS/2 as
well as DOS, it also features a completely transparent virtual memory system to
access up to 64 Mb of virtual memory.

.np
Dual mode - a world first!
Combining a DOS extender with an award-winning linker used by over 50,000
programmers worldwide offers a unique advantage. Blinker 3.0 is the only
product to create dual mode programs, which automatically detect at startup
whether the runtime machine can run in protected mode.  If not, the same
program simply runs in real mode using dynamic overlays, so you can concentrate
on the code instead of worrying about the runtime environment. To create DOS
programs which run within 640 Kb, Blinker calculates the optimum overlay
structure, automatically manages the overlays at runtime and increases
execution speed using an overlay
cache in XMS or EMS. All this is completely invisible to the end user and there
is no size difference between a protected mode program and a dual mode program.
For the first time ever programs will automatically utilize all the available
memory (up to 16 Mb) on every PC, from the
smallest 8086 right up to the Pentium and beyond.
.*
.figure *depth='2.75' *scale= *file='blinker'
.*

.*

.section CSI-Locate (&cat)
.*
.np
.illust begin
Concurrent Sciences Inc.
530 South Asbury Street, Suite 4
P.O. Box 9666
Moscow, Idaho 83843

Tel:  (208) 882-0445
FAX:  (208) 882-9774
.illust end
.*
.np
.*
.ix 'CSI-Locate (&cat)'

.ix 'Concurrent Sciences Inc.'

.ix '&cat'
.*
CSi-Locate
.np
CSi-Locate is a locator utility that supports off-the-shelf C/C++ compilers
from Microsoft, Borland and Watcom and prepares your DOS and Windows executable
files for debugging with Soft-Scope and burning into EPROM.  The combination of
these compilers with Soft-Scope and CSi-Locate creates a complete tool kit for
embedded 80x86 development.
.*

.*

.*

.section CauseWay for Watcom C/C++ and Assembly Language (&cat)
.*
.np
.illust begin
Devore Software & Consulting
P.O. Box 4283
Naperville, IL  60567-4283


Tel:  708-717-6389
FAX:  708-717-6373
.illust end
.*
.np
.*
.ix 'CauseWay for Watcom C/C++ and Assembly Language (&cat)'

.ix 'Devore Software & Consulting'

.ix '&cat'
.*
.illust begin
CauseWay is a plug and play replacement for the Watcom C/C++ bundled version of
DOS/4GW.  Once installed, the developer specifies CauseWay as the target
extender and compiles, links, and debugs as usual.

The CauseWay extender binds to the executable file, adding 45K to the file
size; provides full DPMI .9 function support; offers a virtual address space of
4G, and reflects all hardware interrupts to protected mode when a handler is
installed.  It supports EXE file compression and DOS DLLs.   On application
fault, CauseWay creates an error file with extensive CPU state and memory
resource information.  Desired memory settings can be 'burned' into the
application.

CauseWay has faster file I/O, functions, and virtual memory than the bundled
DOS/4GW extender.  No startup advertising banner is displayed when running
CauseWay-built applications.

CauseWay runs all 386 DOS-extended applications in 150K of free conventional
memory with 350K free extended memory, or in 500K conventional memory with no
free extended memory.  (More memory is recommended for larger programs).
CauseWay allocates memory from DPMI, VCPI, XMS, INT 15h and conventional DOS
memory.  Supported environments are MS-DOS 3.1 or higher, Windows 3.1, Windows
'95, and OS/2.  There are no runtime licensing fees.

CauseWay, priced at $195.00, is available from Devore Software & Consulting.
Technical support via phone, fax, BBS, and e-mail is free for the first year
after purchase, including electronic file updates.  All purchases carry a
liberal no-fault return policy.  CauseWay enjoys active, user-influenced,
development.  Call 1-708-717-6369 or fax 1-708-717-6373 for orders.
.illust end
.*

.*

.*

.section TNT DOS Extender SDK (&cat)
.*
.np
.illust begin
Phar Lap Software
60 Aberdeen Avenue
Cambridge, MA  02138


Tel:  (617) 661-1510
FAX:  (617) 876-2972
.illust end
.*
.np
.*
.ix 'TNT DOS Extender SDK (&cat)'

.ix 'Phar Lap Software'

.ix '&cat'
.*
TNT DOS-Extender SDK Version 8.0
.np
.illust begin
 Write 32-Bit Protected Mode Realtime Programs for MS DOS
 Write Multi Megabyte MS DOS Embedded Applications with 32-Bit Addressing
 Trap Real Mode Interrupts and Pass to Application in Protected Mode
 DosStyle or NtStyle
.illust end
.np
.illust begin
Under NtStyle:
 216 Win32 APIs Supported
 DLLs, Threads, Multitasking, Priority SchedulingAll Four NT Classes
 Semaphores, Mutex, Events
 Adjustable Time SlicesAs Short as 1 Millisecond
 Interrupt Drivers for Printing and Mouse Control
 Disk and Keyboard Drivers Allow Other Threads to Execute During Idle or
Waiting times
 Multiple Extended-DOS Programs Share a Single Copy of the DOS-Extender
.illust end
.np
.illust begin
Under DosStyle:
 Dynamic Link Libraries
 INT 21h Interface
 Uses Less Memory
.illust end
.np
The TNT DOS-Extender SDK is a 32-bit development tool that enables programmers
to build multi-megabyte embedded and realtime applications that take advantage
of powerful Windows NT features. These features include DLLs, threads, priority
scheduling, and multitasking, under MS DOS. The TNT DOS Extender product
includes the WinPipe VXD which enables developers to write a Windows GUI front
end for their 32-bit DOS applications. The TNT DOS-Extender software runs on
any DOS-based 80386 or higher PC and supports a wide range of 32-bit tools.
including C and C++ compilers from Microsoft, Borland, MetaWare, Symantec, and
Watcom. In addition to the TNT DOS-Extender software, the SDK includes a 32-bit
version of the Microsoft CodeView debugger and Phar Laps SRCBug debugger,
386|ASM macro assembler, and 386|LIB librarian.
.*
.figure *depth='2.75' *scale= *file='dos_ext'
.*

.*

.section Link & Locate 386 (&cat)
.*
.np
.illust begin
Systems & Software, Inc.
18102 Cowan, Suite 100
Irvine, California  92714


Sales:  (800) 788-4386
Tel:  (714) 833-1700
FAX:  (714) 833-1900
.illust end
.*
.np
.*
.ix 'Link & Locate 386 (&cat)'

.ix 'Systems & Software, Inc.'

.ix '&cat'
.*
Link&Locate 386:  An absolute linker and locator for embedded development.
It supports the building of 32-bit protected-mode programs for Intel 386/486
embedded
applications and 32-bit DOS extender application using Watcom C/C++, and/or
WASM.
However, the output absolute object files contain debug information in Intel
OMF-286/386
format which only supports C and assembly source-level debugging.  It includes
start-up code,
C, C++ and floating-point examples, run-time library and floating-point
support.

Link&Locate 386 is provided with executables hosted for both DOS and Microsoft
Windows
NT.  Link&Locate 386 supports the construction of flat or multi-segmented
programs. It has the
flexibility to define and construct segment descriptors, local, global, and
interrupt descriptor
tables, task, interrupt, call, and trap gates, and task state segments.

Third party debugger support includes in-circuit emulators from Microtek
International, Inc. and
Kontron Elektronik GmbH.

Requires 80386 PC or higher, 2 MBytes of memory,  DOS 5.0 or later, and 4
MBytes of hard
disk space.
.*

.*

.*
:set symbol="cat" value="Math Libraries"

.chap Math Libraries
.*
.np
The following section contains listings for math libraries supporting
Watcom C or C++.
.*

.section Math++ (&cat)
.*
.np
.illust begin
Advanced Computing Labs
P.O. Box 1547
West Chester, Ohio  45071


Sales:  (800) 430-5227
Tel:  (513) 779-2716
FAX:  (513) 779-4010
.illust end
.*
.np
.*
.ix 'Math++ (&cat)'

.ix 'Advanced Computing Labs'

.ix '&cat'
.*
Todays advanced technologies require complex solutions: Math++ takes away some
of the complexity so that you can focus on the application.
.np
Every matrix class can be initialized with random numbers based on uniform,
Bernoulli, binomial, custom (derived directly from data), exponential, gamma,
normal, and Poisson distributions.
Numerous intelligent operators perform matrix arithmetic easily and
efficiently.
.np
Copy and paste data among different matrices. Overloaded iostream operators
provide unlimited flexibility in implementing object persistence. Other member
functions include inverse, resize, mean, trace, transpose, variance ...  Global
(friend) functions extend the usability of matrices and vectors with functions
like: abs, acos, asin, atan, betaDist, .... sort, sqrt, sum, tan, tanh.
Complex numbers, matrices, and vectors are fully supported.
.np
Math++ vector classes behave like the mathematical constructs that you're
already familiar with. Given a column vector of length n multiply it by a row
vector of length m and you get a matrix of
size nxm - try doing that with other math libraries...
.np
Solutions to real and complex linear equations of the form AX = B, where B is
the constants vector, A is the coefficient matrix, and X is the vector of
unknowns, are easily obtained by creating an LU decomposition server object.
.np
Math++ offers two random number generation algorithms: select between the
highly efficient minimal standard algorithm with period 2^31, or the perfect
pseudo-random number generator with
period 261.  Generate random deviates from uniform, Bernoulli, binomial, custom
(derived directly from data), exponential, gamma, normal, and Poisson
distributions. Create an arbitrary number of
completely independent random deviate generators simultaneously!
.np
The precisely documented FFT server does forward and inverse transforms,
convolution, and correlation of arbitrary length 2^n real and complex vectors.
Approximate data with linear or
non-linear functions, including polynomial, logarithmic, exponential, and power
functions.
.np

To order call: 1-800-430-LABS, FAX 1-513-779-2716
.*
.figure *depth='2.75' *scale= *file='math'
.*

.*

.section SciMath C/C++ (&cat)
.*
.np
.illust begin
Advanced Scientific Applications
215 E. Orangethorpe Ave. Suite 333
Fullerton, CA 92632


Tel:  (714) 680-6600
FAX:  (714) 680-4241
.illust end
.*
.np
.*
.ix 'SciMath C/C++ (&cat)'

.ix 'Advanced Scientific Applications'

.ix '&cat'
.*
SciMath   C/C++

Advanced Scientific Math Library.  Now SciMath Version 7.00 provides a complete
C/C++ scientific numerical math library on a royalty free basis.   SciMath.lib
provides hundreds of advanced mathematical functions in the areas of:
Optimization   Interpolation    Approximation    Complex FFTAEs   Complex
Bessel  Functions       Integration Differentiation   Roots   Statistics
Differential Equations Linear/Nonlinear Systems Eigensystems Transforms
Special Functions    Matrix/Vector Operations  Random Numbers Sparse Systems
and many more. Just link SciMath.lib to your application and start using
hundreds of advanced mathematical functions.

Available  for most 16 and 32 bit compilers and platforms including  Borland
C/C++, Watcom C/C++, Microsoft  C/C++, Intel  Codebuilder,  Zortech  C++,  and
more.  Operating Systems:  DOS  16/32  (Extended and real  mode),  Windows
16/32/NT/95,  OS/2,  UNIX...etc.    Original  list  price starting at: $600.00.
.*

.*

.*

.section CAD/CAM Developer's Kit (&cat)
.*
.np
.illust begin
Building Block Software
77 Pearson Road
Somerville, MA  02144


Tel:  (617) 628-5217
FAX:  (617) 628-6333
.illust end
.*
.np
.*
.ix 'CAD/CAM Developer's Kit (&cat)'

.ix 'Building Block Software'

.ix '&cat'
.*
The 'CAD/CAM Developer's Kit' libraries provide ANSI C functions which support
core CAD/CAM features for custom applications including: area booleans,
boundary offsets, mill/turn toolpaths; reading & writing all DXF entitities R10-
12 ; 2D/3D wireframe display; 2D & 3D lines, arcs, circles, ellipses, NURB
splines; transforms; intersect/trim/fillet; can be used for
DOS/Windows/ADS/UNIX applications.
.*

.*

.*

.section CPLEX Callable Library (&cat)
.*
.np
.illust begin
CPLEX Optimization, Inc.
930 Tahoe Blvd, Building 802
Suite 279
Incline Village, Nevada  89451

Tel:  (702) 831-7744
FAX:  (702) 831-7755
.illust end
.*
.np
.*
.ix 'CPLEX Callable Library (&cat)'

.ix 'CPLEX Optimization, Inc.'

.ix '&cat'
.*
The CPLEX Callable Library provides high-performance, robust routines for
solving linear and mixed integer programming problems.  CPLEX is the leading
supplier of state-of-the art linear programming algorithms which reliably solve
even extremely large (millions of variables) or difficult problems.  The
Callable Library format enables users to embed powerful CPLEX optimization
algorithms within user-written applications or custom interfaces.  Used by
operations research and math programming professionals throughout the world to
create resource allocation applications used by commercial airlines,
manufacturers, financial institutions, and many others.
.np
A wide range of algorithms and algorithmic options is provided, including
primal and dual simplex, mixed integer, network, and barrier solvers.
.np
CPLEX's library routines can be seamlessly integrated into programs developed
in C, FORTRAN, or other languages.  Written in C, using a calling format
familiar to C programmers.  Extremely flexible, yet easy to use.  Many examples
are provided; many users find that their applications can be created with only
minor modifications to these example programs.
.np
Libraries available for personal computers include extended-DOS, Windows 3.1,
Windows NT, and OS/2.
.np
The CPLEX Callable Library includes routines for defining problems, solving
problems, modifying problems, reading/writing files, changing algorithmic
parameters, and querying problem or solution information, as well as utility
routines for controlling output and user interrupts.
.np
CPLEX also provides for distribution of applications created using the CPLEX
Callable Library.  So developers can profitably use the powerful CPLEX routines
to create resource optimization applications for use within a company or for
resale to third parties.
.*
.figure *depth='2.75' *scale= *file='cplexlog'
.*

.*

.section TG-CAD 2D (&cat)
.*
.np
.illust begin
Disk Software Inc.
109 S. Murphy Road
Plano, Texas  75094


Sales:  (800) 635-7760
Tel:  (214) 423-7288
FAX:  (214) 423-7288
.illust end
.*
.np
.*
.ix 'TG-CAD 2D (&cat)'

.ix 'Disk Software Inc.'

.ix '&cat'
.*
This is a collection of over 400 2D device independent geometric routines.  The
library includes routines that create parametric lines, compute tangents and
normals, generate arcs, ellipses, circles, and 2D curves such as NURBS, Bezier,
B-Spline, Catmull-Rom, quadratic, and conics.  You can create a NURB curve that
interpolates through the control points.  You can compute a circle or arc that
is tangent to two or three circles, lines, and points.  This library contains a
rich assortment of intersection routines that compute the intersections of
lines, arcs, circles, curves and combinations thereof.  You can compute a
piecewise Bezier curve that will pass through a set of digitized points (great
for reproducing text and symbols).  You can determine the intersections,
unions, differences, of convex and concave polygons.  You can compute the
distance between points, lines, arcs and combinations thereof.  This product
gives you the ability to determine if points are outside, inside, or on the
edge of a polygon.  Also, there are 2D composite transformations such as scale,
rotate, shear, translate, reflect, and their respective inverse.  Included with
the library are routines that compute the surface area of 2D geometric shapes.
A wide range of vector computations are included.  You can decompose a concave
polygon into a series of convex polygons.  You can compute the offset of a
polyline made up of line segments and arcs.  A complete entity library is
included that gives you the ability to maintain data that describes a geometric
entity.  This information includes athe geometric data that describes the
entity plus color, line style, entity coordinate system, layer, and more.  Two
dimensional entities include Point, Line, Polyline, Text, Fill, Dimension,
Circle, Arc, Shape, Insert, Viewport, and more.  Manual & example programs
included.  Source Code Available, 30 day limited guarantee.
.*

.*

.*

.section TG-CAD 3D (&cat)
.*
.np
.illust begin
Disk Software Inc.
109 S. Murphy Road
Plano, Texas  75094


Sales:  (800) 635-7760
Tel:  (214) 423-7288
FAX:  (214) 423-7288
.illust end
.*
.np
.*
.ix 'TG-CAD 3D (&cat)'

.ix 'Disk Software Inc.'

.ix '&cat'
.*
This is a collection of over 400 3D geometric routines.  The library includes a
wide range of routines that generate B-Spline, Catmull-Rom, Bezier, quadratic
and NURBS surfaces and curves.  The library makes it easy to compute normals
and tangents to curves and surfaces.  You can perform 3D polygon planar
clipping and view clipping.  View clipping allows you to clip a scene to a
specific view volume.  You can create wire frames of solids such as spheres,
paraboloids, hyperboloids, ellipsoids, regular polyhedrons, cones, cylinders,
pyramids, prisms and more.  You can create complete or partial surfaces of
revolution.  You can extrude solids based on a 2D shape.  There are hidden line
routines that can create scenes with all hidden lines removed.  You can specify
the color of the objects in the hidden transformations such as rotation, scale,
translate mirror and perspective and their respective inverses.  You can
compute the intersection of lines, planes, and curves.  You can create
perspective views of 3D objects or scenes.  Manual & example programs included.
Source code available.  30 day limited guarantee.
.*

.*

.*

.section TG-CAD Professional (&cat)
.*
.np
.illust begin
Disk Software Inc.
109 S. Murphy Road
Plano, Texas  75094


Sales:  (800) 635-7760
Tel:  (214) 423-7288
FAX:  (214) 423-7288
.illust end
.*
.np
.*
.ix 'TG-CAD Professional (&cat)'

.ix 'Disk Software Inc.'

.ix '&cat'
.*
A Complete CAD/CAM/CAE Graphics Developers Kit.  The professional version is a
combination of TG-CAD 2D v5.0, TG-CAD 3D v5.0, TG-CAD DXF Translator v2.0 and
TG-CAD Draw v2.0.
.*

.*

.*

.section TG-DXF Translator (&cat)
.*
.np
.illust begin
Disk Software Inc.
109 S. Murphy Road
Plano, Texas  75094


Sales:  (800) 635-7760
Tel:  (214) 423-7288
FAX:  (214) 423-7288
.illust end
.*
.np
.*
.ix 'TG-DXF Translator (&cat)'

.ix 'Disk Software Inc.'

.ix '&cat'
.*
A complete DXF Library for Windows and DOS.  This library gives you the ability
to read and write AutoCAD DXF files through release 12.  You can read AutoCAD
symbol/font files.  You read and write all DXF data structures.  Once you read
them into our data structures, you can use the DXF entities with the geometric
routines in TG-CAD 2D and 3D.  You can draw DXF files using TG-CAD Draw.  You
can read a single layer or all of the layers in a DXF file.  You can explode
AutoCAD DXF block entities into a series of entities.  Included with the
library is a program that will read a DXF file, expolode the blocks and write a
new file with the exploded blocks.  Manual & example programs included.  Source
code available.  30 day limited guarantee.
.*

.*

.*

.section Math Advantage (&cat)
.*
.np
.illust begin
Dynamic Communications, Inc.
8625 SW Cascade Blvd.
Suite 603
Beaverton, OR
97008
Tel:  (503) 646-5300
FAX:  (503) 641-6012
.illust end
.*
.np
.*
.ix 'Math Advantage (&cat)'

.ix 'Dynamic Communications, Inc.'

.ix '&cat'
.*
QTC MATH ADVANTAGE* scientific subroutine library version 5.0 for Watcom C/C++
and FORTRAN (both single precision and double precision).
.np
Originally developed for supercomputers and array processors, this powerful
application development tool is available on over 40 systems, from PC to
supercomputers. The subroutines, available in a choice of C or FORTRAN, are 314
frequently used algorithms for scientific and
engineering computing. They free you from coding thousands of lines of source
code in signal/image/seismic processing, simulation, and scientific
applications. Many are core algorithms -- such as vector operations; full
matrix operations; sparse matrix operations;
eigensystems; one- and two-dimensional FFTs; convolution; regressions;
BLAS(Basic Linear Algebra Subprograms) 1, 2 and 3; and more.
.np
Source code is also available for porting or modifying if necessary to meet
requirements. A comprehensive and concise user's manual includes installation
instructions, calling conventions, literature references, and command summary
card and full technique supports are provided with
purchase agreement.
.np
Founded in 1981, QTC (Quantitative Technology, Corp) is the leader in
scientific library standard. The other more specific libraries, such as STAT
ADVANTAGE* for statistical analysis and DSP ADVANTAGE* for digital signal
processing are also available. For more information about the products, please
feel free to call our sales manager, Tim Kuehn at (503)-626-3081 or fax to
(503)-641-6012.
.*

.*

.*

.section CSL - Scientific Programming Library (&cat)
.*
.np
.illust begin
Eigenware Technologies
1959 White Feather Lane
Nokomis, Florida  34275


Tel:  (813) 488-0118
FAX:  (813) 488-0118
.illust end
.*
.np
.*
.ix 'CSL - Scientific Programming Library (&cat)'

.ix 'Eigenware Technologies'

.ix '&cat'
.*
CSL is a collection of Eigenware's most frequently requested numerical
solutions, covering a wide range of problems, including linear algebra,
eigensystems, matrix computations, time series, smoothing and filtering,
statistics, regression, linear and integer programming, nonlinear systems,
optimization, differential equations, curve fitting, graphics, test functions
and much, much more.
.np
CSL is mature and reliable, derived from credible algorithms, and maintained
over a large user base. Used by industry, universities, consultants, financial,
government, and research institutions.  When your program calls on CSL, it is
calling on proven reliability, demonstrated by
extensive use in a variety of applications around the world. Over 800
exhaustively tested and proven functions give you greater accuracy,
reliability, and efficiency.  CSL example programs are supplied on computer
readable media.  Application notes illustrate the utility of CSL. Distributed
as source code with Makefiles for the WATCOM compiler.
.*

.*

.*

.section ACSL Model (&cat)
.*
.np
.illust begin
MGA Software
200 Baker Avenue
Concord, MA  01742


Tel:  (508) 369-5115
FAX:  (508) 369-0013
.illust end
.*
.np
.*
.ix 'ACSL Model (&cat)'

.ix 'MGA Software'

.ix '&cat'
.*
ACSL Model  is a complete environment for simulation, modelling, and analyzing
systems described by time-dependent, nonlinear differential equations or
transfer functions.  ACSL Model has powerful instructions,  including a
complete compliment of simulation operators and commands tailored for
continuous simulation and linear analysis.  Included with ACSL Model is the
Graphic Modeller, which is a graphic user interface, block-diagram front end.
.np
The ACSL (Advanced Continuous Simulation Language) consists of two sections:
the model definition and the run time commands.  The model definition involves
establishing mathematical specifications with ACSL statements for the
continuous simulation system being modeled.  The model is then analyzed by
instructions interpreted during the run time command section.  Once a model is
defined, it can be kept on file and analyzed over and over again by the run
time commands since all variables in the model definition can be displayed,
plotted, or printed and any constant or variable changed before a simulation
run.
.np
The Graphic Modeller enables the user to visually create, execute, and analyze
simulation models.  The Graphic Modeller major features include the following:
full compliment of primitives for ACSL instructions, functions, and macros:
user defined blocks: modern drawing package: multiple-view, multiple-editor
environment; and hierarchical modelling, both top down and bottom up.  The
Graphic Modeller helps the user to create a model that is visually meaningful
and easy to understand.
.*

.*

.*

.section ACSLrt Realtime (&cat)
.*
.np
.illust begin
MGA Software
200 Baker Avenue
Concord, MA  01742


Tel:  (508) 369-5115
FAX:  (508) 369-0013
.illust end
.*
.np
.*
.ix 'ACSLrt Realtime (&cat)'

.ix 'MGA Software'

.ix '&cat'
.*
ACSLrt is ACSL ( Advanced Continuous Simulation Language) with real time
extensions.  ACSLrt is for real time simulation.  The primary characteristics
of realtime operation are synchronizing model execution with a realtime clock
and communicating simulation data between the computer and the real world
through a realtime I/O board.  ACSLrt is synchronized with a computers real
time clock.  Realtime simulations require precise synchronization between the
model  and the external hardware and Input/Output boards for communication
between the computer and the external hardware.  For the PC computer platform,
ACSLrt includes ACSL with Graphic Modeller for Windows with real time
extensions, Keithley analog and digital Input/Output board, and Watcom FORTRAN
77/32 10.5 compiler.  Major features of ACSLrt are the following: powerful
simulation engine; speed; portability across multiple computer hardware
platforms, including DOS, Windows, and UNIX systems; and an advanced GUI
interface.
.*

.*

.*
:set symbol="cat" value="Memory Management"

.chap Memory Management
.*
.np
The following section contains listings for memory management products
supporting Watcom C or C++.
.*

.section Blinker (&cat)
.*
.np
.illust begin
Blink, Inc.
8001 W. Broad St.
Richmond, VA  23294


Tel:  (804) 747-6700
FAX:  (804) 747-4200
.illust end
.*
.np
.*
.ix 'Blinker (&cat)'

.ix 'Blink, Inc.'

.ix '&cat'
.*
Blinker 3.2 features a compiler-independent Windows linker, a royalty-free 286
DOS extender, the worlds fastest DOS dynamic overlay linker and an integrated
memory swap function, all in one product forone low price! Compatible with all
the popular C, C++ and FORTRAN compilers, Blinker creates DOS and Windows
programs in seconds, saving hours of valuable programming time.

.np
Why a 286 DOS extender?
The major benefit of a 286 DOS extender is that it will run on any processor
from an 80286 with 1Mb of available memory up to the largest Pentium, whereas a
386 DOS extender requires a minimum of an 80386 processor. The Blinker extender
provides direct access to 16 Mb of
extended memory, runs multi-megabyte programs in protected mode in less than
200 Kb of conventional memory, and solves low memory problems caused by network
shells and other memory hungry TSRs. Fully compatible with DPMI, VCPI and XMS,
so your protected mode programs will run under Windows, DESQview and OS/2 as
well as DOS, it also features a completely transparent virtual memory system to
access up to 64 Mb of virtual memory.

.np
Dual mode - a world first!
Combining a DOS extender with an award-winning linker used by over 50,000
programmers worldwide offers a unique advantage. Blinker 3.0 is the only
product to create dual mode programs, which automatically detect at startup
whether the runtime machine can run in protected mode.  If not, the same
program simply runs in real mode using dynamic overlays, so you can concentrate
on the code instead of worrying about the runtime environment. To create DOS
programs which run within 640 Kb, Blinker calculates the optimum overlay
structure, automatically manages the overlays at runtime and increases
execution speed using an overlay
cache in XMS or EMS. All this is completely invisible to the end user and there
is no size difference between a protected mode program and a dual mode program.
For the first time ever programs will automatically utilize all the available
memory (up to 16 Mb) on every PC, from the
smallest 8086 right up to the Pentium and beyond.
.*
.figure *depth='2.75' *scale= *file='blinker'
.*

.*

.section C/C++ Data Object Library (&cat)
.*
.np
.illust begin
Code Farms Inc.
7214 Jock Trail
Richmond, Ont.  K0A 2Z0
Canada

Tel:  (613) 838-4829
FAX:  (613) 838-3316
.illust end
.*
.np
.*
.ix 'C/C++ Data Object Library (&cat)'

.ix 'Code Farms Inc.'

.ix '&cat'
.*
 New concept of C++ class library with all data structures and container
classes, from lists, hash tables, ER models to run-time extensible objects, and
virtual disk access. Extremely fast and efficient, useful especially for large
projects - see the book 'Taming C++' by J.Soukup.
.np
Treats data structures as design patterns. Represents relations as objects, and
improves maintenance by removing cyclic dependency among classes.
Automatically persistent data do not require user-coded I/O functions for every
new class. Generates fast frameworks and OO databases.  Prevents dangling
pointers, includes memory management and automatic paging to disk. Portable
data and programs. Complete source, no royalties.
.np
Price: US299 one user DOS/WINDOWS/MAC US599 one UNIX workstation
.*

.*

.*

.section CauseWay for Watcom C/C++ and Assembly Language (&cat)
.*
.np
.illust begin
Devore Software & Consulting
P.O. Box 4283
Naperville, IL  60567-4283


Tel:  708-717-6389
FAX:  708-717-6373
.illust end
.*
.np
.*
.ix 'CauseWay for Watcom C/C++ and Assembly Language (&cat)'

.ix 'Devore Software & Consulting'

.ix '&cat'
.*
.illust begin
CauseWay is a plug and play replacement for the Watcom C/C++ bundled version of
DOS/4GW.  Once installed, the developer specifies CauseWay as the target
extender and compiles, links, and debugs as usual.

The CauseWay extender binds to the executable file, adding 45K to the file
size; provides full DPMI .9 function support; offers a virtual address space of
4G, and reflects all hardware interrupts to protected mode when a handler is
installed.  It supports EXE file compression and DOS DLLs.   On application
fault, CauseWay creates an error file with extensive CPU state and memory
resource information.  Desired memory settings can be 'burned' into the
application.

CauseWay has faster file I/O, functions, and virtual memory than the bundled
DOS/4GW extender.  No startup advertising banner is displayed when running
CauseWay-built applications.

CauseWay runs all 386 DOS-extended applications in 150K of free conventional
memory with 350K free extended memory, or in 500K conventional memory with no
free extended memory.  (More memory is recommended for larger programs).
CauseWay allocates memory from DPMI, VCPI, XMS, INT 15h and conventional DOS
memory.  Supported environments are MS-DOS 3.1 or higher, Windows 3.1, Windows
'95, and OS/2.  There are no runtime licensing fees.

CauseWay, priced at $195.00, is available from Devore Software & Consulting.
Technical support via phone, fax, BBS, and e-mail is free for the first year
after purchase, including electronic file updates.  All purchases carry a
liberal no-fault return policy.  CauseWay enjoys active, user-influenced,
development.  Call 1-708-717-6369 or fax 1-708-717-6373 for orders.
.illust end
.*

.*

.*

.section SmartHeap (&cat)
.*
.np
.illust begin
MicroQuill Software Publishing, Inc.
4900 25th Avenue N.E.  Suite 206
Seattle, WA  98105


Sales:  (800) 441-7822
Tel:  (206) 525-8218
FAX:  (206) 525-8309
.illust end
.*
.np
.*
.ix 'SmartHeap (&cat)'

.ix 'MicroQuill Software Publishing, Inc.'

.ix '&cat'
.*
SmartHeap is a professional memory management library and debugging toolkit.
SmartHeap excels in four crucial areas:  speed; error detection; reliability;
and portability.
Speed
In C and C++ applications running on virtual memory systems, malloc and
operator new affect performance more than any other factor.  SmartHeaps
proprietary algorithms deliver unparalleled malloc/new performance, up to 100X
faster.  You can achieve even better results if you use SmartHeaps malloc/new
to automatically route small allocations below a parameterized threshold to an
extremely fast fixed-size allocator, or if you use SmartHeaps multiple memory
pools to improve locality and further eliminate fragmentation.
Error Detection
Because SmartHeap implements and manages the heap, it detects bugs that other
debugging tools miss, thus delivering the most complete heap error detection
available.  In addition, SmartHeap uses its knowledge of the heap to provide
unsurpassed detail about each errors cause.  Bugs detected by SmartHeap
include:  leakage, memory overwrites, double-freeing, wild pointers, invalid
parameters, out of memory, references to previously freed memory, etc.
Portability
SmartHeap ships as binary linkable libraries for DOS, Windows, NT, Mac, OS/2,
UNIX, etc.  Each version provides an identical API, but is specifically
optimized for that particular environment.  Finally, SmartHeaps malloc and new
are strictly ANSI compliant, so you dont have to code to a proprietary API to
realize SmartHeaps benefits.
Reliability
To ensure the ultimate in error-free operation, we built a certification tester
that calls each SmartHeap API hundreds of thousands of times, comprehensively
testing all possible conditions and proving that all the bugs are out.
.*

.*

.*

.section STL <Toolkit> (&cat)
.*
.np
.illust begin
ObjectSpace, Inc.
14881 Quorum Drive
Suite 400
Dallas, TX  75240

Tel:  (214) 934-2496
FAX:  (214) 663-9100
.illust end
.*
.np
.*
.ix 'STL <Toolkit> (&cat)'

.ix 'ObjectSpace, Inc.'

.ix '&cat'
.*
.illust begin
Systems<ToolKit> is a cross-platform, ANSI-compliant C++ library that includes
a comprehensive implementation of the Standard Template Library (STL), the
ANSI/ISO string, time, date, time zone, portable error handling, threads,
synchronization, binary streaming, sockets and other
system programming classes.

The Systems<ToolKit> binary streaming system allows you to stream your own
objects, STL containers, and other vendor's objects into a file or across a
network.  Unlike other vendor's, the streaming system allows you to add
lightweight persistence to your classes without modifying their
inheritance structure.
 ------------------------------------------------------------------------------
----------------------------------
STL<ToolKit>

STL<ToolKit> is a cross-platform, ANSI-compliant C++ library that includes a
comprehensive implementation of the Standard Template Library (STL), the
ANSI/ISO string, 64-bit time and date, time zone, threads and synchronization.
.illust end
.*

.*

.*

.section Systems Toolkit (&cat)
.*
.np
.illust begin
ObjectSpace, Inc.
14881 Quorum Drive
Suite 400
Dallas, TX  75240

Tel:  (214) 934-2496
FAX:  (214) 663-9100
.illust end
.*
.np
.*
.ix 'Systems Toolkit (&cat)'

.ix 'ObjectSpace, Inc.'

.ix '&cat'
.*
Systems<ToolKit> is a cross-platform, ANSI-compliant C++ library that includes
a comprehensive implementation of the Standard Template Library (STL), the
ANSI/ISO string, time, date, time zone, portable error handling, threads,
synchronization, binary streaming, sockets and other
system programming classes.

The Systems<ToolKit> binary streaming system allows you to stream your own
objects, STL containers, and other vendor's objects into a file or across a
network.  Unlike other vendor's, the streaming system allows you to add
lightweight persistence to your classes without modifying their
inheritance structure.
 ------------------------------------------------------------------------------
----------------------------------
STL<ToolKit>

STL<ToolKit> is a cross-platform, ANSI-compliant C++ library that includes a
comprehensive implementation of the Standard Template Library (STL), the
ANSI/ISO string, 64-bit time and date, time zone, threads and synchronization.
.*

.*

.*

.section MemCheck Professional for DOS (&cat)
.*
.np
.illust begin
StratosWare Corporation
1756 Plymouth Road, Suite 1500
Ann Arbor, MI  48105


Sales:  (800) 933-3284
Tel:  (313) 996-2944
FAX:  (313) 996-2955
.illust end
.*
.np
.*
.ix 'MemCheck Professional for DOS (&cat)'

.ix 'StratosWare Corporation'

.ix '&cat'
.*
MemCheck 3.5 Professional for DOS is an automatic runtime debugger for C/C++
applications. MemCheck detects memory overwrites, underwrites, memory leaks,
heap corruption, stack overwrites, out-of-memory conditions, and other memory
errors that cost development projects days and weeks of lost time. MemCheck
detects errors in all parts of the host application, including third-party
vendor libraries.

MemCheck operates completely transparently, allowing simultaneous use of
Watcom's debugger (WD). MemCheck identifies errors by exact file and line
number in the source code. Errors may be directed to the screen, to log files,
or wherever desired. MemCheck provides detailed stack and memory usage
statistics, and stack overflow checking superior to standard compilers. Stack
usage statistics are available at run time, and are reported in a log file.

Installation takes 15 minutes or less, even on large projects (automated by a
configuration utility). No source code changes are required. MemCheck may be
switched on or off at runtime, and overhead on large applications is minimal
(approximately 15K). MemCheck runs 10-300 times faster than similar debuggers,
due to its proprietary storage technology.

You'll find MemCheck invaluable in locating bugs on remote or test machines,
since there's no debug info or external .EXE required. When you're done, simply
link out MemCheck via a 'Production' library, or compile it completely out with
no source code changes.

StratosWare offers an unconditional 60-day money-back guarantee and free
technical support. The price is $139; the upgrade from MemCheck 3.0
Professional for DOS is $49.

***MemCheck 3.5 Professional for Extended DOS***

MemCheck 3.5 Professional for Extended DOS is the only automatic runtime
debugging tool for C/C++ developers supporting both 16- and 32-bit protected
mode under DOS. MemCheck detects memory overwrites, underwrites, memory leaks,
heap corruption, stack overwrites, out-of-memory conditions, and other memory
errors that cost development projects days and weeks of lost time. MemCheck
detects errors in all parts of the host application, including third-party
vendor libraries.

MemCheck operates completely transparently, allowing simultaneous use of
Watcom's debugger (WD). MemCheck identifies errors by exact file and line
number in the source code. Errors may be directed to the screen, to log files,
or wherever desired.

MemCheck aids protected-mode developers by generating a stack trace with symbol
names on GPFs, exceptions, and stack overflow, replacing the default runtime
behaviour of simply printing a register dump and terminating the program.

Automated by a configuration utility, installation takes 15 minutes or less,
and requires no source code changes. MemCheck may be switched on or off at
runtime, and overhead on large applications is minimal (approximately 15K).
MemCheck runs 10-300 times faster than similar debuggers.

You'll find MemCheck invaluable in locating bugs on remote or test machines,
since there's no debug info or external .EXE required. When you're done, simply
link out MemCheck via a 'Production' library, or compile it completely out with
no source code changes.

StratosWare offers an unconditional 60-day money-back guarantee and free
technical support. The price is $139; the upgrade from MemCheck 3.0
Professional for Extended DOS is $49.
.*
.figure *depth='2.75' *scale= *file='mc-demo'
.*

.*
:set symbol="cat" value="Multi-Platform Tools"

.chap Multi-Platform Tools
.*
.np
The following section contains listings for products supporting GUI multi-
platform development with Watcom C or C++.
.*

.section AccuSoft Image Format Library (&cat)
.*
.np
.illust begin
AccuSoft Corp.
Two Westborough Business Park
Westborough, MA  01581


Sales:  (800) 525-3577
Tel:  (508) 898-2770
FAX:  (508) 898-9662
.illust end
.*
.np
.*
.ix 'AccuSoft Image Format Library (&cat)'

.ix 'AccuSoft Corp.'

.ix '&cat'
.*
AccuSoft's Image Format Library is a complete high performance imaging toolkit.
Due to the availability of both high level and low level interfaces,
integration into any application can be accomplished in a matter of minutes.
File formats supported include Kodak Photo CD plus ASCII, ATT, BMP, Brooktrout,
CALS, CLP, CUT, DCX, DIB, EPS, GIF, Group 3, Group 4, GX2, ICO, IFF, IMG, IOCA,
JPEG, KoFax, LaserData, MAC, MSP, PCX, PhotoShop, PICT, RLE, SUN, TARGA, TIFF,
WMF, WPG, XBM, XPM, and XWD.  Only raster images are supported in metafile
formats.  Photo CD read only.  Features include automatic aspect ratio
correction, automatic color reduction based on video mode, panning and
scrolling, zoom to any degree, multiple palette image display, color reduction
techniques including a new octree algorithm for reducing to any number of
colors, brightness, contrast, sharpness control, cropping, clipboard support,
matrix convolutions, 10 display effects, flip, invert, rotate, gamma
correction, complete scanning control, compression using any algorithm allowed
by the format, resize with interpolation and sub-sampling, complete printing
control, edge detection, Roberts cross, dilation, fast image display, format
auto-detect, area selection and more.  Special versions for Watcom 32 bit for
both DOS and Windows.  Versions for OS/2, Mac, UNIX, and NT.  All AccuSoft
products are backed by the Image Format Guarantee which states, 'Guaranteed to
read all raster images in existence in the supported formats.  If you can find
a valid image we don't read, send it to us and we will make it work!'
.*
.figure *depth='2.75' *scale= *file='accusoft'
.*

.*

.section HASP -- The Professional Software Protection Solution (&cat)
.*
.np
.illust begin
Aladdin Software Security Inc.
The Empire State Building
350 Fifth Ave., Suite 6614
New York, NY  10118

Tel:  (972) 3-5375795
FAX:  (972) 3-5375796
.illust end
.*
.np
.*
.ix 'HASP -- The Professional Software Protection Solution (&cat)'

.ix 'Aladdin Software Security Inc.'

.ix '&cat'
.*
Unauthorized use of software costs software developers over $15 billion each
year.
.np
Aladdin Knowledge Systems is a world leading developer of software security
systems. Aladdin's HASP product line is an advanced software protection system
that enables software developers to increase their revenues by protecting their
software from unauthorized use and distribution.
.np
Since 1984, over one million HASP hardware keys have enabled more than 8,000
software developers in over 60 countries to protect their software. Our clients
include industry leaders such as CA, IBM, Lotus, Quark, Toshiba, Samsung and
AT&T. In fact, reviews in the international computer press consistently rate
HASP as the best protection solution available.
.np
Based on advanced ASIC technology and sophisticated anti-debugging and
protection algorithms, HASP is regarded as the most secure software protection
system available. Multiple protection features further enhance security.
.np
State-of-the-art technology makes HASP the most secure, reliable, and cost-
effective protection system on the market. With unsurpassed ease-of-use, HASP
offers the developer rapid implementation, using high-level programming
procedures. And, full transparency and
compatibility guarantee end-user satisfaction.
.np
HASP is available in memory, non-memory, time-based, and network versions, with
cross-platform support for different operating environments and hardware
platforms, and hundreds of supported
compilers and languages. Utilities and software upgrades are provided free of
change.
.np
The HASP product line offers the widest range of PC-based protection solutions
available, with support for Watcom C/C++ compilers under DOS, Windows 3.x,
Windows NT, Windows95, Win32s, OS/2, Japanese NEC and Fujitsu, and LANs. HASP
also offers Macintosh, Power Mac, Amiga, and Open Systems solutions.
.np
For more information, visit Aladdin's World Wide Web Home Page -
http://www.hasp.com/.
.*

.*

.*

.section MemoHASP (&cat)
.*
.np
.illust begin
Aladdin Software Security Inc.
The Empire State Building
350 Fifth Ave., Suite 6614
New York, NY  10118

Tel:  (972) 3-5375795
FAX:  (972) 3-5375796
.illust end
.*
.np
.*
.ix 'MemoHASP (&cat)'

.ix 'Aladdin Software Security Inc.'

.ix '&cat'
.*
Unauthorized use of software costs software developers over $15 billion each
year.
.np
MemoHASP is an advanced software protection key that enables software
developers to increase their revenues by protecting their software from
unauthorized use and distribution.
.np
With up to 496 bytes of internal read/write memory, MemoHASP gives the
developer virtually unlimited flexibility.
.np
.illust begin
MemoHASP lets you:

Control access to different software modules.
Rent or lease software.
Distribute demo versions that can be activated only a limited number of times.
Implement correct version control of your software.
Save passwords and other sensitive data.
Assign a unique code to each of your clients.
And more.
.illust end
.np
The HASP Remote Update System enables remote updating (via phone, fax, e-mail
or modem) of MemoHASP's memory to allow additional users to access the
application, and open new software modules.
.np
Based on advanced ASIC technology and sophisticated anti-debugging and
protection algorithms, MemoHASP is regarded as the most secure software
protection system available. Multiple protection features further enhance
security.
.np
State-of-the-art technology makes MemoHASP the most secure, reliable, and cost-
effective protection system on the market. With unsurpassed ease-of-use,
MemoHASP offers the developer rapid implementation, using high-level
programming procedures. And, full
transparency and compatibility guarantee end-user satisfaction.
.np
MemoHASP offers support for Watcom C/C++ compilers under DOS, Windows 3.x,
Windows NT, Windows95, Win32s, OS/2, Japanese NEC and Fujitsu, and LANs.
Utilities and software upgrades are provided free of change.
.np
HASP-3 is a low-cost/high-security non-memory version of MemoHASP, and
MemoHASP36 is a version for Japanese NEC and Fujitsu PCs.
.np
For more information, visit Aladdin's World Wide Web Home Page -
http://www.hasp.com/.
.*

.*

.*

.section NetHASP (&cat)
.*
.np
.illust begin
Aladdin Software Security Inc.
The Empire State Building
350 Fifth Ave., Suite 6614
New York, NY  10118

Tel:  (972) 3-5375795
FAX:  (972) 3-5375796
.illust end
.*
.np
.*
.ix 'NetHASP (&cat)'

.ix 'Aladdin Software Security Inc.'

.ix '&cat'
.*
Unauthorized use of software costs software developers over $15 billion each
year.
.np
NetHASP is an advanced software protection key for LAN and WAN network
environments that enables software developers to increase their revenues by
protecting their software from unauthorized use and distribution.
.np
A single NetHASP protection key, connected to any of the computers in the
network, provides flexible 3-way software protection: protect your software
against illegal use, limit the number of users who can access the application
concurrently, and control access for up to 112 different applications or
modules! The HASP Remote Update System enables remote updating (via phone, fax,
e-mail or modem) of NetHASP's memory to allow additional workstations to access
the
protected software, enable additional runtimes, and more.
.np
Based on advanced ASIC technology, and sophisticated anti-debugging and
protection algorithms, NetHASP is regarded as the most secure software
protection system available. Multiple protection features further enhance
security.
.np
State-of-the-art technology makes NetHASP the most secure, reliable, and cost-
effective protection system on the market. With unsurpassed ease-of-use,
NetHASP offers the developer rapid implementation, using high-level programming
procedures. And, full transparency and
compatibility guarantee end-user satisfaction.
.np
NetHASP offers support for IPX, NetBIOS, and TCP/IP LANs and WANs, with
solutions for Watcom C/C++ compilers under DOS, Windows 3.x, Windows NT,
Windows95, OS/2, Japanese NEC and Fujitsu. Utilities and software upgrades are
provided free of change.
.np
NetHASP36 is a version for Japanese NEC PCs.
.np
For more information, visit Aladdin's World Wide Web Home Page -
http://www.hasp.com/.
.*

.*

.*

.section TimeHASP (&cat)
.*
.np
.illust begin
Aladdin Software Security Inc.
The Empire State Building
350 Fifth Ave., Suite 6614
New York, NY  10118

Tel:  (972) 3-5375795
FAX:  (972) 3-5375796
.illust end
.*
.np
.*
.ix 'TimeHASP (&cat)'

.ix 'Aladdin Software Security Inc.'

.ix '&cat'
.*
Unauthorized use of software costs software developers over $15 billion each
year.
.np
TimeHASP is an advanced software protection key with an internal real-time
clock that enables software developers to increase their revenues by protecting
their software from unauthorized use and distribution.
.np
With an internal clock and up to 496 bytes of internal read/write memory,
TimeHASP lets you rent or lease software, and charge clients periodically for
software use and maintenance. The HASP Remote Update System enables remote
updating (via phone, fax, e-mail or modem) of TimeHASP's memory to renew an
expired demo or lease period.
.np
Based on advanced ASIC technology and sophisticated anti-debugging and
protection algorithms, TimeHASP is regarded as the most secure software
protection system available. Multiple protection features further enhance
security.
.np
State-of-the-art technology makes TimeHASP the most secure, reliable, and cost-
effective protection system on the market. With unsurpassed ease-of-use,
TimeHASP offers the developer rapid implementation, using high-level
programming procedures. And, full transparency and compatibility guarantee end-
user satisfaction.
.np
TimeHASP offers support for Watcom C/C++ compilers under DOS, Windows 3.x,
Windows NT, Windows95, OS/2, Japanese NEC and Fujitsu, and LANs. Utilities and
software upgrades are provided free of change.
.np
For more information, visit Aladdin's World Wide Web Home Page -
http://www.hasp.com/.
.*

.*

.*

.section Dynace OO Extension to C (&cat)
.*
.np
.illust begin
Algorithms Corporation
3020 Liberty Hills Drive
Franklin, TN  37064


Tel:  (615) 791-1636
FAX:  (615) 791-7736
.illust end
.*
.np
.*
.ix 'Dynace OO Extension to C (&cat)'

.ix 'Algorithms Corporation'

.ix '&cat'
.*
.illust begin
Dynace Object Oriented Extension To C (Dynace)
------------------------------------------------------------------------------
.illust end
.np
Dynace is a preprocessor, include files and a library which extends the C
language with advanced object oriented capabilities, automatic garbage
collection and multiple threads.  Dynace is designed to solve many of the
problems associated with C++ while being easier to learn
and containing more flexable object oriented facilities.  Dynace is able to add
facilities previously only available in languages such as Smalltalk and CLOS
without all the overhead normally associated with those environments.
.*
.figure *depth='2.75' *scale= *file='algologo'
.*

.*

.section Dynace Windows Development System (&cat)
.*
.np
.illust begin
Algorithms Corporation
3020 Liberty Hills Drive
Franklin, TN  37064


Tel:  (615) 791-1636
FAX:  (615) 791-7736
.illust end
.*
.np
.*
.ix 'Dynace Windows Development System (&cat)'

.ix 'Algorithms Corporation'

.ix '&cat'
.*
Dynace Windows Development System (WDS)
-------------------------------------------------------------------------
The Dynace Windows Development System (WDS) is a Dynace class library which
enables a C programmer with no knowledge of C++, Dynace, the Windows API or
message-driven architecture to write real Windows applications with an absolute
minimum learning curve and number of lines of code.  In fact, it is possible to
become familiar enough with windows, menus, dialogs and controls using WDS to
write a Windows application after just one day!  A 'Hello World' program takes
only four lines of code!
.*
.figure *depth='2.75' *scale= *file='algologo'
.*

.*

.section Gpf 2.1 Professional Developers Kit (&cat)
.*
.np
.illust begin
Apical Software Inc.
40 Falls Road
P.O. Box 432
Moodus, Conneticut 06469

Sales:  (800) 831-0017
Tel:  (860) 873-3300
FAX:  (860) 873-3302
.illust end
.*
.np
.*
.ix 'Gpf 2.1 Professional Developers Kit (&cat)'

.ix 'Apical Software Inc.'

.ix '&cat'
.*
Gpf is a Visual application development environment that takes
full advantage of OS/2 2.x to create native Client/Server or
Stand-alone applications for OS/2 PM  or DOS/Windows.  As a 3GL
(C or C++ and optionally PL1) source code generator Gpf offers
all the advantages of hand coding native GUI applications,
combined with the ease of a What You See Is What You Get visual
programming environment.  With Gpf, the designer simply paints
the GUI screens as they ought to appear and Gpf takes care of
the rest.  All interface management and event handling logic is
generated automatically.  Navigation code, custom logic and
context sensitive help are created and linked to objects as they
are designed.  Since these are properly inserted by Gpf, code
integrity during regeneration is assured.

Adding GpfTools provides Reusable objects, Design Browsing, and
Automatic Documentation to create the complete Pro Developers
Toolkit.

Graphical browsing of the design includes a pop up true view of
any window, and automatic documentation. Information may be
output in text or INF (PM viewable) format  In addition,
GpfTools offers a powerful merge facility allowing the developer
to combine designs or  to drag selected objects from the
currently open view and drop them into an accumulate/paste
window.  Copy objects at any level including entire windows,
notebook pages, design objects (presentation objects, user
function objects, user control objects, bitmap/icon/pointer
objects, etc.), even sets of windows with all the associated
objects.
.*

.*

.*

.section LANSA (&cat)
.*
.np
.illust begin
Aspect Computing
187 Albert Street
Waterloo, ON  N2L 3T4


Tel:  (519) 886-1688
FAX:  (519) 886-7407
.illust end
.*
.np
.*
.ix 'LANSA (&cat)'

.ix 'Aspect Computing'

.ix '&cat'
.*
LANSA is an integrated family of highly productive software design, development
and maintenance products for both host and client/server applications. LANSA's
structured high level language greatly improves productivity and facilitates
the production of platform independent
client/server solutions. With LANSA, commercial grade software can be developed
quickly with a minimum skill set.  It can also be maintained simply and safely.
.illust begin
Features
*      Active Repository
*      Referential Integrity
*      Validations - declarative and programmable
*      Extended DB2/400 Event Triggers
*      PC DB Event Triggers
*      Security - field and file
*      Multilingual, DBCS and RLTB support
*      Structured high level language (RDML)
*      Full RDML prompting syntax experts
*      Programmable RDML templates
*      Action diagram editor
*      Free form editor
*      Object Oriented modelling and prototyping
*      Automatic screen/window generation
*      Screen/Window painter
*      Report painter
*      Compile
*      Online RDML debugging
*      Stand-alone PC development
*      LAN team development
*      Test across multiple platforms
.illust end
.illust begin
Source Code Independence
*      Operating System
*      Database
*      User Interface
*      Communications protocols
*      Distributed Function Partitioning
*      Distributed Data Partitioning
*      Independent of client/server model
.illust end
.illust begin
PC Application Integration
*      Copy and paste clipboard
*      DB to ASCII file import/export
.illust end
.illust begin
Client/Server Models
*      AS/400 standalone
*      Distributed logic
*      Mobile PC standalone
*      Distributed data
*      Remote data
.illust end
.illust begin
Development Platform
*      OS/400
*      OS/2
*      Windows 95
*      Windows NT
.illust end
.illust begin
Execution Environments - Server
*      OS/400 DDS, DB2/400, RPG
*      OS/2 PM, DB2/2, C
*      AIX Motif, DB2/6000, C
*      Windows NT, SQL Server, C
.illust end
.illust begin
Execution Environments - Client
*      Windows 3.1, ODBC, C
*      OS/2 PM, DB2/2, C
*      Windows NT, SQL Server, C
.illust end
.illust begin
Communication Protocols
*      APPC, TCP/IP
*      SNA Server
.illust end
.illust begin
Note: Server combinations may also be used in 3 tier Server / Agent / Client
topology.
.illust end
.*

.*

.*

.section Crusher! Data Compression Toolkit (&cat)
.*
.np
.illust begin
DC Micro Development
P.O. Box 54588
Lexington, KY
40555

Sales:  1-800-775-1073
Tel:  (606) 268-1559
FAX:  (606) 266-0726
.illust end
.*
.np
.*
.ix 'Crusher! Data Compression Toolkit (&cat)'

.ix 'DC Micro Development'

.ix '&cat'
.*
Crusher is a high-performance, portable data compression library for DOS,
Windows, OS/2, Unix, and Macintosh developers. The comprehensive API of 45+
functions, identical for all platforms, provides buffer compression, file
compression, archiving, subdirectory support, wildcards, disk spanning,
encryption, self-extracting EXE's and more. Compresses data to 20-50% of
original size or less. As little as 15K overhead. Implement full archiving in
just four function calls. Crusher archives are portable across all supported
platforms, including DOS, Windows (16-bit and 32-bit), Macintosh, OS/2, Unix,
HP-9000, RS/6000, AS/400 and other O/S's. Special support for embedded
systems.
.np
Includes FULL SOURCE CODE as well as numerous sample applications including
ARQ, convenient command-line utility for managing Crusher archives, and SETUP,
a
Windows installation/setup program. Supports all C/C++ memory models and
Visual Basic. Windows version includes VBX custom control and full on-line
documentation. Limited 30-day warranty. A free demo is available for
downloading from our bbs.
.np
.illust begin
Retail Pricing
Platform        w/o source code w/source code
DOS             $199                    $249
Win16           $239                    $299
Win32           n/a                     $299
Macintosh       n/a                     $299
OS/2            n/a                     $349
Unix            n/a                     $349
.illust end
.*

.*

.*

.section MTOS-UX/386/486 (&cat)
.*
.np
.illust begin
Industrial Programming Inc.
100 Jericho Quadrangle
Suite 215
Jericho, NY  11753

Tel:  (516) 938-6600
FAX:  (516) 938-6609
.illust end
.*
.np
.*
.ix 'MTOS-UX/386/486 (&cat)'

.ix 'Industrial Programming Inc.'

.ix '&cat'
.*
MTOS-UX/386/486 is a real-time multi-tasking executive for the 386, 486 and
Pentium.  It is a member of the MTOS-UX family of real-time operating systems,
available for a PC and for stand-alone platforms.   All versions of MTOS-UX
have the same programmer interface.  Application software, when written in C,
is portable from platform to platform.
.np
MTOS-UX is specifically designed for high speed, compactness, portability and
generality.  It is widely used in communications, process control, medical
instrumentation, factory automation and a variety of other embedded systems.
All objects in this fully dynamic system may be created and deleted.
Scheduling is based on priority, with round-robin for tasks of equal priority.
MTOS-UX features include an extensive set of coordination and synchronization
facilities, such as message exchanges, event flags, memory pools, deferred
coordination, semaphores, signals, and controlled
shared variables.
.np
Additional available features include: (1) a DOS-compatible file system, (2)
MTOS-UX windowing system, (3) an interface to US Software UseNet(tm) and
Epilogue(tm) communication software, and (4) an interface to the metaWINDOW(tm)
graphics system, plus a full set of drivers for the screen/keyboard, diskette,
hard disk,line printer, serial I/O, RAMdisk, etc.
.np
When debugging with MTOS-UX, a third party debugger can be used, as well as the
MTOS-UX dynamic debugger, which includes a basic debugger and status reporter.
This debugger/status reporter is included with every MTOS-UX development kit to
facilitate development and testing of application code.
.*

.*

.*

.section MEWEL (&cat)
.*
.np
.illust begin
MAGMA Software Systems
15 Bodwell Terrace
Millburn, New Jersey 07041


Tel:  (201) 912-0192
FAX:  (201) 912-0103
.illust end
.*
.np
.*
.ix 'MEWEL (&cat)'

.ix 'MAGMA Software Systems'

.ix '&cat'
.*
MEWEL 4.1 is a cross-platform user interface tookit which gives your
application complete portability between Microsoft Windows, DOS text, DOS
graphics, OS/2 text, UNIX text, and OSF Motif. Since MEWEL's API is compatible
with the standard Microsoft Windows API, you can easily port programs between
Windows and any of the environments which MEWEL supports,
even if you already have existing Windows programs.
.np
Programmers can develop new stand-alone applications using MEWEL, or can port
their existing Windows applications to any of the platforms which MEWEL
supports. MEWEL supports Windows 3.x features such as Control windows (listbox,
combo, radio, checkbox, pushbutton, scrollbars, single & multi-line edit,
static) Multiple Document Interface (MDI) Dialog Boxes Overlapping Windows with
moving and resizing Multi-level Menus Mouse Windows BMP files (blitting,
stretching, compressing) PCX files Icons (character and graphical) Multiple
proportional fonts MEWEL supports the Watcom 10.5 32-bit compiler, and the DOS
4G/W and Pharlap TNT DOS extenders. The DOS Graphics version supports the
MetaWindows 386 and Watcom graphics libraries.
.*
.figure *depth='2.75' *scale= *file='wmewlgui'
.*

.*

.section Media!Lab (&cat)
.*
.np
.illust begin
Metagraphics Software Corporation
200 Clock Tower Place, Suite 201E

Carmel, CA  93922

Sales:  (800) 332-1550
Tel:  (408) 622-8950
FAX:  (408) 622-8955
.illust end
.*
.np
.*
.ix 'Media!Lab (&cat)'

.ix 'Metagraphics Software Corporation'

.ix '&cat'
.*
MEDIA!LAB(tm) is a powerful multimedia programming toolkit that lets you create
stunning interactive graphic programs, animated titles and games better and
faster than ever before.  MEDIA!LAB combines imaging, animation, video,
sprites, special effects and sound in a
streamlined C/C++ programming toolkit.  Optimized in assembly language for
quick tight code, MEDIA!LAB pushes the limits for fast Windows performance.
.np
MEDIA!LAB provides a powerful suite of fast interactive graphic capabilities
supporting BMP/PCX/DCX image files, AVI/FLC/FLI video, sprite animation,
transparent 'blue screen' cinematic animation, sound, timer controls, fade and
wipe effects, color-palette animation, object hit and collision detection,
bitmap tiling, and more.  MEDIA!LAB can be used by itself, or in combination
with other C++ class libraries such as MFC or OWL.
.np
MEDIA!LAB comes with a comprehensive developer's manual, on-line hypertext
help, and is backed by Metagraphics support and a full 30-day guarantee.  Full
source code is available, plus all products are Royalty-Free.
.np
For additional information:
.np
CompuServe: GO METAGR, LIB 12, download MLINFO.ZIP
.br
Internet ftp: ftp.metagraphics.com, download MLINFO.ZIP
.br
Metagraphics BBS: 408-622-8945, download DEMO\\MLINFO.ZIP
.br
.*

.*

.*

.section MKS Source Integrity (&cat)
.*
.np
.illust begin
Mortice Kern Systems, Inc.
185 Columbia Street West
Waterloo, Ontario, Canada  N2L 5Z5


Sales:  (800) 265-2797
Tel:  (519) 884-2251
FAX:  (519) 884-8861
.illust end
.*
.np
.*
.ix 'MKS Source Integrity (&cat)'

.ix 'Mortice Kern Systems, Inc.'

.ix '&cat'
.*
MKS Source Integrity is a complete, project oriented version control and build
system.  With MKS Source Integrity, you can:
.np
.illust begin
     - Track which files are included in each project so important files are
never lost or left behind.

     - Know the current version of each file that is associated with the
project.

     - See at a glance which files are currently locked for editing and who has
locked them.

     - Track dependencies between files and import these dependencies into your
make file.

     - Take snapshots of your project and recreate these snapshots at any point
in the future.
.illust end
.np
MKS Source Integrity offers true team development with sandboxes.  Sandboxes
offer every team member a safe, personalized place to work.  Changes to project
files are automatically communicated to leverage team development.
.np
MKS Source Integrity is designed to make your entire development team more
productive.  You can use our state of the art GUI, or you can access MKS Source
Integrity from the command line.  We even have built in integration into the
WATCOM C/C++ IDE to make MKS Source Integrity the ultimate in ease of use.
.np
Additional features of MKS Source Integrity include:  visual differencing and
visual merging, event triggers, built in reporting facilities, both binary and
text files support, an advanced promotion
model, and more.
.*

.*

.*

.section STL <Toolkit> (&cat)
.*
.np
.illust begin
ObjectSpace, Inc.
14881 Quorum Drive
Suite 400
Dallas, TX  75240

Tel:  (214) 934-2496
FAX:  (214) 663-9100
.illust end
.*
.np
.*
.ix 'STL <Toolkit> (&cat)'

.ix 'ObjectSpace, Inc.'

.ix '&cat'
.*
.illust begin
Systems<ToolKit> is a cross-platform, ANSI-compliant C++ library that includes
a comprehensive implementation of the Standard Template Library (STL), the
ANSI/ISO string, time, date, time zone, portable error handling, threads,
synchronization, binary streaming, sockets and other
system programming classes.

The Systems<ToolKit> binary streaming system allows you to stream your own
objects, STL containers, and other vendor's objects into a file or across a
network.  Unlike other vendor's, the streaming system allows you to add
lightweight persistence to your classes without modifying their
inheritance structure.
 ------------------------------------------------------------------------------
----------------------------------
STL<ToolKit>

STL<ToolKit> is a cross-platform, ANSI-compliant C++ library that includes a
comprehensive implementation of the Standard Template Library (STL), the
ANSI/ISO string, 64-bit time and date, time zone, threads and synchronization.
.illust end
.*

.*

.*

.section Systems Toolkit (&cat)
.*
.np
.illust begin
ObjectSpace, Inc.
14881 Quorum Drive
Suite 400
Dallas, TX  75240

Tel:  (214) 934-2496
FAX:  (214) 663-9100
.illust end
.*
.np
.*
.ix 'Systems Toolkit (&cat)'

.ix 'ObjectSpace, Inc.'

.ix '&cat'
.*
Systems<ToolKit> is a cross-platform, ANSI-compliant C++ library that includes
a comprehensive implementation of the Standard Template Library (STL), the
ANSI/ISO string, time, date, time zone, portable error handling, threads,
synchronization, binary streaming, sockets and other
system programming classes.

The Systems<ToolKit> binary streaming system allows you to stream your own
objects, STL containers, and other vendor's objects into a file or across a
network.  Unlike other vendor's, the streaming system allows you to add
lightweight persistence to your classes without modifying their
inheritance structure.
 ------------------------------------------------------------------------------
----------------------------------
STL<ToolKit>

STL<ToolKit> is a cross-platform, ANSI-compliant C++ library that includes a
comprehensive implementation of the Standard Template Library (STL), the
ANSI/ISO string, 64-bit time and date, time zone, threads and synchronization.
.*

.*

.*

.section GraphiC/(DOS)(WIN)(NT)(286)(OS2) (&cat)
.*
.np
.illust begin
Scientific Endeavors Corp.
508 N. Kentucky Street
Kingston, TN  37753


Sales:  (800) 998-1571
Tel:  (423) 376-4146
FAX:  (423) 376-1571
.illust end
.*
.np
.*
.ix 'GraphiC/(DOS)(WIN)(NT)(286)(OS2) (&cat)'

.ix 'Scientific Endeavors Corp.'

.ix '&cat'
.*
GraphiC is a library of over 240 'C' routines for producing all sorts of
technical plots. With GraphiC it is easy to include publication quality
graphics as part of your application. Most popular printers and file formats
are supported.
.np
Supported plot types include 3-D and contour plots with various shading
options, linear, log-log and semi-log, polar, and more. With the GraphiC
routines you can also invent new plot types to display your data with maximum
impact.
.np
The GraphiC interface has been designed so that platform migration is a snap.
Macros are provided to accomodate differances between DOS and GUI interfaces so
that it is possible to create a Windows or OS/2 application without makeing any
platform specific API calls. For example, a program written for GraphiC for DOS
will work perfectly with GraphiC/OS2 by simply
compiling it for OS/2 and linking with the GraphiC/OS2 library.
.np
GraphiC comes as source code so that complete customization is possible. Make
files are provided to help with the creation and maintainance of the library.
The installation program will compile the library for you if you choose.
.np
GraphiC can be used with PostScript fonts with the PostScript add on
graphiC/PST. GraphiC/PST creates vectors from the PostScript metrics so that
all of the font plotting features of GraphiC can be utilized with the
PostScript fonts installed on your system.
.np
CraphiC uses a high resolution internal grid so that the maximnm resolution of
the output device can be utilizied.
.*
.figure *depth='2.75' *scale= *file='sciend'
.*

.*

.section CodeBase (&cat)
.*
.np
.illust begin
Sequiter Software, Inc.
Suite 209, 9644 - 54 Avenue
Edmonton, Alberta, Canada T6E 5V1


Tel:  (403) 437-2410
FAX:  (403) 436-2999
.illust end
.*
.np
.*
.ix 'CodeBase (&cat)'

.ix 'Sequiter Software, Inc.'

.ix '&cat'
.*
CodeBase 5.1 is a multi-user Xbase compatible C/C++ library for database
management.  With CodeBase, your applications can use any of the five most
popular indexing formats as well as their associated memo files:  FoxPro 2.0
(.CDX, .IDX), dBASE IV (.MDX), dBASE  III
PLUS (.NDX), and Clipper (.NTX).  CodeBase 5.1 also provides record and file
locking that is compatible with the multi-user versions of dBASE IV, FoxPro 2
and Clipper.  Easy to use,... Named like familiar dBase commands, CodeBase 5.1
functions reduce your learning curve by
allowing  you to use your xBase expertise right away.  CodeBase 5.1
applications automatically utilize our new Bit Optimized Query Technology to
return query results on a 500,000 record data file in just one second!
CodeReporter 2.0 and special CodeBase 5.1 reporting functions make designing
and generating reports from your C/C++ applications simple.  CodeBase 5.1,
combined with CodeControls 2.0 our Data Aware custom controls, turn your
favorite compiler into a
visual development environment.  The Standard version of CodeBase 5.1 supports
most compilers under DOS, OS/2 and Windows, and Windows NT.  Upgrade to the
special Multi-Platform version of CodeBase 5.1 to port your application to
UNIX, SUN, AIX and The Macintosh.  (CodeBase 5.1 includes: complete library
Source Code,  CodeReporter 2.0,
CodeControls 2.0 and Royalty Free distribution of your application.)
.*

.*

.*

.section WNDX (&cat)
.*
.np
.illust begin
WNDX Corporation
Suite #418, 1167 Kensington Crescent NW
Calgary, Alberta, Canada T2N 1X7


Tel:  (403) 283-5590
FAX:  (403) 283-6250
.illust end
.*
.np
.*
.ix 'WNDX (&cat)'

.ix 'WNDX Corporation'

.ix '&cat'
.*
The WNDX Portable GUI Software Development kit includes programmer's libraries
(The WNDX Portable GUI Libraries) and an interactive, visual GUI resource
builder (WNDX OPUS) for developing high-performance human-computer interfaces
that are 100% source-code portable between: Windows 3.1, Windows 95, Windows
NT, Macintosh, OS/2, OSF/Motif and MS-DOS (graphics-mode).
.np
The WNDX Portable GUI API supports over 1000 GUI functions including GUI
objects and attributes such as windows, dialogs, menus, text, lists, tables,
graphs and custom controls.  Applications written for the WNDX API are often
smaller, faster and easier to develop and maintain than applications built with
native GUI SDKs. AND they are 100% portable.
.np
When you write your graphical user interface (GUI) source code ONCE in WNDX it
will transport seamlessly (in as long as it takes to recompile and relink) to
any of the other popular GUI platforms.  Source code you develop to the WNDX
API will recompile across any of all supported platforms with WNDX handling the
differences in the native environments.
.np
With WNDX, you have full access to the underlying API. Many of our customers
extend their Microsoft Windows applications by mixing WNDX and Windows calls
and resources.  The WNDX code is portable.
.np
WNDX uses a 'superset' approach to portability, whereas other companies use
either a subset approach (lowest common denominator of services) which reduces
your options, or a totally simulated approach that is slower and more error
prone. Our 'superset' approach gives you the whole spectrum of over 1000
function calls and attributes, supported on all platforms.
.*
.figure *depth='2.75' *scale= *file='screen00'
.*

.*

.section Zinc Application Framework (&cat)
.*
.np
.illust begin
Zinc Software Inc.
405 South 100 East  2nd Floor
Pleasant Grove, Utah  84062


Sales:  (800) 638-8665
Tel:  (801) 785-8900
FAX:  (801) 785-8996
.illust end
.*
.np
.*
.ix 'Zinc Application Framework (&cat)'

.ix 'Zinc Software Inc.'

.ix '&cat'
.*
Zinc Application Framework 4.1 is an object-oriented, cross-platform,
internationalized, class library and visual development tool.  Zinc supports
Symantec C++ 7.0 for DOS (both Text Mode and Graphics Mode), Microsoft Windows,
Win32 and Apple Macintosh (required Symantec C++
7.0 for Macintosh).  Zinc 4.0 also supports Windows NT, IBM OS/2, OSF/Motif,
Curses, NEXTSTEP and DESQview/X.  All platforms are supported with one set of
source code.
.np
Zinc 4.1 offers a comprehensive feature set including the following objects:
drag and drop, geometry management, scrolling windows, event mapping, palette
mapping, table, printer, notebook, status bar, tool bar, formatted string,
date, time, number (with currency), bitmap buttons, lists, combo box and many
more.
.np
Zinc Designer is the only visual development tool that creates and stores
platform-independent, user-interface objects.  Developers can interactively
drag and drop interface objects to develop application screens on any platform
that Zinc supports.  Twenty two full featured object editors give direct access
to all library-level features for each object.  Zinc Designer also features an
image editor for bitmaps and icons, a message editor and a defaults editor for
Help and System
information.  Zinc POST (Persistent Object Storage Technology) provides robust
platform-independent resources.  These binary files can be moved transparently
across platforms and are easily internationalized.
.np
Zinc 4.1 supports 13 languages and 19 country locales.  Developers can use a
single set of source code to support single-byte (ISO) languages such as
English, French and German as well as double-byte (Unicode) languages such as
Japanese, Korean and Chinese.
.np
The product includes the library, Zinc Designer and full source code.
.*
.figure *depth='2.75' *scale= *file='zinc'
.*

.*
:set symbol="cat" value="Other Libraries & Utilities"

.chap Other Libraries & Utilities
.*
.np
The following section contains listings for other libraries and utilities
supporting Watcom C or C++.

.*

.section PC-Install (&cat)
.*
.np
.illust begin
Abraxas Software, Inc.
5530 SW Kelly Avenue
Portland, Oregon  97201


Sales:  (800) 347-5214
Tel:  (503) 244-5253
FAX:  (503) 244-8375
.illust end
.*
.np
.*
.ix 'PC-Install (&cat)'

.ix 'Abraxas Software, Inc.'

.ix '&cat'
.*
PC-Install is an easy-to-use, professional installation program intended for
anyone who distributes applications or data files - a perfect fit for Watcom
C++ developers.  It provides all of the installation features that you will
ever need yet requires less than 30 minutes to create a completely personalized
installation.  You can designate your own colors for your installation screens,
add personalized titles, display your company logo, and include your own pre-
and post-installation messages. What the end-user sees is your installation
program with titles, messages, and instructions specific to your application.
.np
All necessary installation functions are easily accessible with PC-Install.  It
can check for a particular CPU or display adapter, verify sufficient free disk
space, and even start your program when the installation is complete.  During
installation, PC-Install creates the primary installation directory and any
other required directories, and then copies files to the appropriate locations.
Of course, PC-Install can update AUTOEXEC and CONFIG files.  It even modifies
INI files and creates Windows groups and icons.
.np
For software upgrades, you can specify whether PC-Install overwrites already
existing files, have PC-Install ask for overwrite permission, or prevent
overwriting completely.  And you can even allow the user to select groups of
files for installation (e.g., allow the user to select only program files or
only data files for installation).
.np
PC-Install includes PC-Shrink=81, a program that compresses files fo=r
unlimited, royalty-free distribution with PC-Install.  Files can be compressed
one at a time or in groups, and large compressed files can be split across
multiple diskettes when necessary.
.*
.figure *depth='2.75' *scale= *file='2020'
.*

.*

.section APMoney++ (&cat)
.*
.np
.illust begin
Advanced Computing Labs
P.O. Box 1547
West Chester, Ohio  45071


Sales:  (800) 430-5227
Tel:  (513) 779-2716
FAX:  (513) 779-4010
.illust end
.*
.np
.*
.ix 'APMoney++ (&cat)'

.ix 'Advanced Computing Labs'

.ix '&cat'
.*
Computations involving amounts of money require absolute precision: APMoney++
provides the highest precision integer arithmetic, period.
.np
APMoney++ is a C++ library that implements computer arithmetic of unprecedented
precision, surpassing the competition to set a new standard in high precision
financial arithmetic. While
other vendors toy with 14, 18, or even 28 digits of precision,  APMoney++
raises the bar by implementing 'arbitrary precision' arithmetic. That means you
can represent numbers that require
thousands of digits, hundreds of thousands of digits, even millions of digits.
.np
.illust begin
APMoney DebtAmount('1524367650086546546567657657567067');
\\\\ in pennies
APMoney Interest( DebtAmount * 0.185 );
.illust end
.np
In fact, our algorithms are so powerful, that it is unlikely that any computer
on earth will have sufficient memory to represent a number of the highest
precision attainable with APMoney++.
.np
To avoid loss of precision, early computers relied on BCD (Binary Coded
Decimal) representations of large numbers to do integer and fixed point
arithmetic.  Early microprocessors, for example the
6502, used packed BCD as a native data type to make floating point calculations
possible.  With the advent of floating point coprocessors BCD was no longer
needed, and modern microprocessors do all their integer arithmetic in binary.
Today representing numbers using BCD is wasteful of computer memory, and
implementing arithmetic operations is inefficient, wasting precious CPU time.
.np
Using algorithms based on higher radix number representations, APMoney++
implements integer arithmetic that far surpasses the BCD scheme in terms of
computer efficiency and representational capacity. APMoney++ represents numbers
in base 2^16, where each digit can take on one of 65536 values and is
represented as a 2 byte word or integer. Using a BCD
representation, the same two bytes can be used to store at most 10000 digits.
In terms of representational capacity alone then, APMoney++ realizes a six-fold
increase in efficiency!
.np
To order call: 1-800-430-LABS, FAX 1-513-779-2716
.*
.figure *depth='2.75' *scale= *file='apmoney'
.*

.*

.section Neural L++ (&cat)
.*
.np
.illust begin
Advanced Computing Labs
P.O. Box 1547
West Chester, Ohio  45071


Sales:  (800) 430-5227
Tel:  (513) 779-2716
FAX:  (513) 779-4010
.illust end
.*
.np
.*
.ix 'Neural L++ (&cat)'

.ix 'Advanced Computing Labs'

.ix '&cat'
.*
The Neural++ library features a fully object oriented design, utilizing
features like class inheritance, virtual functions, and object persistence. The
object granularity extends to the
level of layers, collections of fully interconnected neurons. Weight (or
connection) matrices are implemented as objects of class DMatrix, a full-
featured general purpose matrix class (Math++).
.np
Neural++ was developed using Math++, a general purpose C++ mathematics library
from Advanced Computing Labs. The Neural++ package includes the Math++ library.
.np
Imagine having the full functionality of a mathematics library at your
disposal, ready to be applied to your data, to sets of neurons, to weight
matrices, to experimental neural networks, to anything you can imagine, to
anything you dare imagine...
.np
Imagine the power of an object oriented mathematical development library
designed with the needs of your neural network in mind! Or, stop imagining and
get your hands on Neural++ today!
.np
.illust begin
For example, this is the code needed to create and train a 2 layer BP
(backpropagation) neural network:

BP bpnet( 5, 10, 1 );
    /* BP object: 5 input nodes, 10 hidden, 1 output neuron */
NNData Data;
    /* uninitialized Data object
*/
Data.useDataFile('parity.dat');
    /* initial with raw data from file parity.dat                         */
double error;
while ((error = bpnet.train( &Data, bp_epoch)) > 0.05)
  cout << 'Error ' << error << endl;
.illust end
.np
Math++ library functions can be used to great advantage. For example, to
compute the variance of all data samples corresponding to input node 1,
Neural++ and Math++ functions can be combined:   double variance =
(Data.getData( 1 )).variance(); What could possibly be easier than that!
.np
Neural++ includes Neural++ Tools, a collection of prompt-driven command line
utilities that provide easy access to complex neural objects. Neural++ comes
with close to 600 pages of text
including numerous examples, hints, and complete class by class reference
sections. Neural++ Tools features step-by-step tutorials, walking you through
the tasks of setting up a neural network
project, pre-processing training and validation data, and training a neural
network.
.np
Neural++ object library available for DOS and NT based compilers. Neural++
source code sold separately, requires non-disclosure. Math++ object library
included, source sold separately. No royalties.
.np

To order call: 1-800-430-LABS, FAX 1-513-779-2716
.*
.figure *depth='2.75' *scale= *file='neural'
.*

.*

.section HASP -- The Professional Software Protection Solution (&cat)
.*
.np
.illust begin
Aladdin Software Security Inc.
The Empire State Building
350 Fifth Ave., Suite 6614
New York, NY  10118

Tel:  (972) 3-5375795
FAX:  (972) 3-5375796
.illust end
.*
.np
.*
.ix 'HASP -- The Professional Software Protection Solution (&cat)'

.ix 'Aladdin Software Security Inc.'

.ix '&cat'
.*
Unauthorized use of software costs software developers over $15 billion each
year.
.np
Aladdin Knowledge Systems is a world leading developer of software security
systems. Aladdin's HASP product line is an advanced software protection system
that enables software developers to increase their revenues by protecting their
software from unauthorized use and distribution.
.np
Since 1984, over one million HASP hardware keys have enabled more than 8,000
software developers in over 60 countries to protect their software. Our clients
include industry leaders such as CA, IBM, Lotus, Quark, Toshiba, Samsung and
AT&T. In fact, reviews in the international computer press consistently rate
HASP as the best protection solution available.
.np
Based on advanced ASIC technology and sophisticated anti-debugging and
protection algorithms, HASP is regarded as the most secure software protection
system available. Multiple protection features further enhance security.
.np
State-of-the-art technology makes HASP the most secure, reliable, and cost-
effective protection system on the market. With unsurpassed ease-of-use, HASP
offers the developer rapid implementation, using high-level programming
procedures. And, full transparency and
compatibility guarantee end-user satisfaction.
.np
HASP is available in memory, non-memory, time-based, and network versions, with
cross-platform support for different operating environments and hardware
platforms, and hundreds of supported
compilers and languages. Utilities and software upgrades are provided free of
change.
.np
The HASP product line offers the widest range of PC-based protection solutions
available, with support for Watcom C/C++ compilers under DOS, Windows 3.x,
Windows NT, Windows95, Win32s, OS/2, Japanese NEC and Fujitsu, and LANs. HASP
also offers Macintosh, Power Mac, Amiga, and Open Systems solutions.
.np
For more information, visit Aladdin's World Wide Web Home Page -
http://www.hasp.com/.
.*

.*

.*

.section MemoHASP (&cat)
.*
.np
.illust begin
Aladdin Software Security Inc.
The Empire State Building
350 Fifth Ave., Suite 6614
New York, NY  10118

Tel:  (972) 3-5375795
FAX:  (972) 3-5375796
.illust end
.*
.np
.*
.ix 'MemoHASP (&cat)'

.ix 'Aladdin Software Security Inc.'

.ix '&cat'
.*
Unauthorized use of software costs software developers over $15 billion each
year.
.np
MemoHASP is an advanced software protection key that enables software
developers to increase their revenues by protecting their software from
unauthorized use and distribution.
.np
With up to 496 bytes of internal read/write memory, MemoHASP gives the
developer virtually unlimited flexibility.
.np
.illust begin
MemoHASP lets you:

Control access to different software modules.
Rent or lease software.
Distribute demo versions that can be activated only a limited number of times.
Implement correct version control of your software.
Save passwords and other sensitive data.
Assign a unique code to each of your clients.
And more.
.illust end
.np
The HASP Remote Update System enables remote updating (via phone, fax, e-mail
or modem) of MemoHASP's memory to allow additional users to access the
application, and open new software modules.
.np
Based on advanced ASIC technology and sophisticated anti-debugging and
protection algorithms, MemoHASP is regarded as the most secure software
protection system available. Multiple protection features further enhance
security.
.np
State-of-the-art technology makes MemoHASP the most secure, reliable, and cost-
effective protection system on the market. With unsurpassed ease-of-use,
MemoHASP offers the developer rapid implementation, using high-level
programming procedures. And, full
transparency and compatibility guarantee end-user satisfaction.
.np
MemoHASP offers support for Watcom C/C++ compilers under DOS, Windows 3.x,
Windows NT, Windows95, Win32s, OS/2, Japanese NEC and Fujitsu, and LANs.
Utilities and software upgrades are provided free of change.
.np
HASP-3 is a low-cost/high-security non-memory version of MemoHASP, and
MemoHASP36 is a version for Japanese NEC and Fujitsu PCs.
.np
For more information, visit Aladdin's World Wide Web Home Page -
http://www.hasp.com/.
.*

.*

.*

.section NetHASP (&cat)
.*
.np
.illust begin
Aladdin Software Security Inc.
The Empire State Building
350 Fifth Ave., Suite 6614
New York, NY  10118

Tel:  (972) 3-5375795
FAX:  (972) 3-5375796
.illust end
.*
.np
.*
.ix 'NetHASP (&cat)'

.ix 'Aladdin Software Security Inc.'

.ix '&cat'
.*
Unauthorized use of software costs software developers over $15 billion each
year.
.np
NetHASP is an advanced software protection key for LAN and WAN network
environments that enables software developers to increase their revenues by
protecting their software from unauthorized use and distribution.
.np
A single NetHASP protection key, connected to any of the computers in the
network, provides flexible 3-way software protection: protect your software
against illegal use, limit the number of users who can access the application
concurrently, and control access for up to 112 different applications or
modules! The HASP Remote Update System enables remote updating (via phone, fax,
e-mail or modem) of NetHASP's memory to allow additional workstations to access
the
protected software, enable additional runtimes, and more.
.np
Based on advanced ASIC technology, and sophisticated anti-debugging and
protection algorithms, NetHASP is regarded as the most secure software
protection system available. Multiple protection features further enhance
security.
.np
State-of-the-art technology makes NetHASP the most secure, reliable, and cost-
effective protection system on the market. With unsurpassed ease-of-use,
NetHASP offers the developer rapid implementation, using high-level programming
procedures. And, full transparency and
compatibility guarantee end-user satisfaction.
.np
NetHASP offers support for IPX, NetBIOS, and TCP/IP LANs and WANs, with
solutions for Watcom C/C++ compilers under DOS, Windows 3.x, Windows NT,
Windows95, OS/2, Japanese NEC and Fujitsu. Utilities and software upgrades are
provided free of change.
.np
NetHASP36 is a version for Japanese NEC PCs.
.np
For more information, visit Aladdin's World Wide Web Home Page -
http://www.hasp.com/.
.*

.*

.*

.section TimeHASP (&cat)
.*
.np
.illust begin
Aladdin Software Security Inc.
The Empire State Building
350 Fifth Ave., Suite 6614
New York, NY  10118

Tel:  (972) 3-5375795
FAX:  (972) 3-5375796
.illust end
.*
.np
.*
.ix 'TimeHASP (&cat)'

.ix 'Aladdin Software Security Inc.'

.ix '&cat'
.*
Unauthorized use of software costs software developers over $15 billion each
year.
.np
TimeHASP is an advanced software protection key with an internal real-time
clock that enables software developers to increase their revenues by protecting
their software from unauthorized use and distribution.
.np
With an internal clock and up to 496 bytes of internal read/write memory,
TimeHASP lets you rent or lease software, and charge clients periodically for
software use and maintenance. The HASP Remote Update System enables remote
updating (via phone, fax, e-mail or modem) of TimeHASP's memory to renew an
expired demo or lease period.
.np
Based on advanced ASIC technology and sophisticated anti-debugging and
protection algorithms, TimeHASP is regarded as the most secure software
protection system available. Multiple protection features further enhance
security.
.np
State-of-the-art technology makes TimeHASP the most secure, reliable, and cost-
effective protection system on the market. With unsurpassed ease-of-use,
TimeHASP offers the developer rapid implementation, using high-level
programming procedures. And, full transparency and compatibility guarantee end-
user satisfaction.
.np
TimeHASP offers support for Watcom C/C++ compilers under DOS, Windows 3.x,
Windows NT, Windows95, OS/2, Japanese NEC and Fujitsu, and LANs. Utilities and
software upgrades are provided free of change.
.np
For more information, visit Aladdin's World Wide Web Home Page -
http://www.hasp.com/.
.*

.*

.*

.section Gpf 2.1 Professional Developers Kit (&cat)
.*
.np
.illust begin
Apical Software Inc.
40 Falls Road
P.O. Box 432
Moodus, Conneticut 06469

Sales:  (800) 831-0017
Tel:  (860) 873-3300
FAX:  (860) 873-3302
.illust end
.*
.np
.*
.ix 'Gpf 2.1 Professional Developers Kit (&cat)'

.ix 'Apical Software Inc.'

.ix '&cat'
.*
Gpf is a Visual application development environment that takes
full advantage of OS/2 2.x to create native Client/Server or
Stand-alone applications for OS/2 PM  or DOS/Windows.  As a 3GL
(C or C++ and optionally PL1) source code generator Gpf offers
all the advantages of hand coding native GUI applications,
combined with the ease of a What You See Is What You Get visual
programming environment.  With Gpf, the designer simply paints
the GUI screens as they ought to appear and Gpf takes care of
the rest.  All interface management and event handling logic is
generated automatically.  Navigation code, custom logic and
context sensitive help are created and linked to objects as they
are designed.  Since these are properly inserted by Gpf, code
integrity during regeneration is assured.

Adding GpfTools provides Reusable objects, Design Browsing, and
Automatic Documentation to create the complete Pro Developers
Toolkit.

Graphical browsing of the design includes a pop up true view of
any window, and automatic documentation. Information may be
output in text or INF (PM viewable) format  In addition,
GpfTools offers a powerful merge facility allowing the developer
to combine designs or  to drag selected objects from the
currently open view and drop them into an accumulate/paste
window.  Copy objects at any level including entire windows,
notebook pages, design objects (presentation objects, user
function objects, user control objects, bitmap/icon/pointer
objects, etc.), even sets of windows with all the associated
objects.
.*

.*

.*

.section LANSA (&cat)
.*
.np
.illust begin
Aspect Computing
187 Albert Street
Waterloo, ON  N2L 3T4


Tel:  (519) 886-1688
FAX:  (519) 886-7407
.illust end
.*
.np
.*
.ix 'LANSA (&cat)'

.ix 'Aspect Computing'

.ix '&cat'
.*
LANSA is an integrated family of highly productive software design, development
and maintenance products for both host and client/server applications. LANSA's
structured high level language greatly improves productivity and facilitates
the production of platform independent
client/server solutions. With LANSA, commercial grade software can be developed
quickly with a minimum skill set.  It can also be maintained simply and safely.
.illust begin
Features
*      Active Repository
*      Referential Integrity
*      Validations - declarative and programmable
*      Extended DB2/400 Event Triggers
*      PC DB Event Triggers
*      Security - field and file
*      Multilingual, DBCS and RLTB support
*      Structured high level language (RDML)
*      Full RDML prompting syntax experts
*      Programmable RDML templates
*      Action diagram editor
*      Free form editor
*      Object Oriented modelling and prototyping
*      Automatic screen/window generation
*      Screen/Window painter
*      Report painter
*      Compile
*      Online RDML debugging
*      Stand-alone PC development
*      LAN team development
*      Test across multiple platforms
.illust end
.illust begin
Source Code Independence
*      Operating System
*      Database
*      User Interface
*      Communications protocols
*      Distributed Function Partitioning
*      Distributed Data Partitioning
*      Independent of client/server model
.illust end
.illust begin
PC Application Integration
*      Copy and paste clipboard
*      DB to ASCII file import/export
.illust end
.illust begin
Client/Server Models
*      AS/400 standalone
*      Distributed logic
*      Mobile PC standalone
*      Distributed data
*      Remote data
.illust end
.illust begin
Development Platform
*      OS/400
*      OS/2
*      Windows 95
*      Windows NT
.illust end
.illust begin
Execution Environments - Server
*      OS/400 DDS, DB2/400, RPG
*      OS/2 PM, DB2/2, C
*      AIX Motif, DB2/6000, C
*      Windows NT, SQL Server, C
.illust end
.illust begin
Execution Environments - Client
*      Windows 3.1, ODBC, C
*      OS/2 PM, DB2/2, C
*      Windows NT, SQL Server, C
.illust end
.illust begin
Communication Protocols
*      APPC, TCP/IP
*      SNA Server
.illust end
.illust begin
Note: Server combinations may also be used in 3 tier Server / Agent / Client
topology.
.illust end
.*

.*

.*

.section Crusher! Data Compression Toolkit (&cat)
.*
.np
.illust begin
DC Micro Development
P.O. Box 54588
Lexington, KY
40555

Sales:  1-800-775-1073
Tel:  (606) 268-1559
FAX:  (606) 266-0726
.illust end
.*
.np
.*
.ix 'Crusher! Data Compression Toolkit (&cat)'

.ix 'DC Micro Development'

.ix '&cat'
.*
Crusher is a high-performance, portable data compression library for DOS,
Windows, OS/2, Unix, and Macintosh developers. The comprehensive API of 45+
functions, identical for all platforms, provides buffer compression, file
compression, archiving, subdirectory support, wildcards, disk spanning,
encryption, self-extracting EXE's and more. Compresses data to 20-50% of
original size or less. As little as 15K overhead. Implement full archiving in
just four function calls. Crusher archives are portable across all supported
platforms, including DOS, Windows (16-bit and 32-bit), Macintosh, OS/2, Unix,
HP-9000, RS/6000, AS/400 and other O/S's. Special support for embedded
systems.
.np
Includes FULL SOURCE CODE as well as numerous sample applications including
ARQ, convenient command-line utility for managing Crusher archives, and SETUP,
a
Windows installation/setup program. Supports all C/C++ memory models and
Visual Basic. Windows version includes VBX custom control and full on-line
documentation. Limited 30-day warranty. A free demo is available for
downloading from our bbs.
.np
.illust begin
Retail Pricing
Platform        w/o source code w/source code
DOS             $199                    $249
Win16           $239                    $299
Win32           n/a                     $299
Macintosh       n/a                     $299
OS/2            n/a                     $349
Unix            n/a                     $349
.illust end
.*

.*

.*

.section Hardlock (&cat)
.*
.np
.illust begin
Glenco Engineering
270 Lexington Drive
Buffalo Grove, IL  60089


Tel:  (708) 808-0300
FAX:  (708) 808-0313
.illust end
.*
.np
.*
.ix 'Hardlock (&cat)'

.ix 'Glenco Engineering'

.ix '&cat'
.*
Hardlock Copy Protection Systems
Glenco Engineering, Inc.
.np
Hardlock represents the state of the art in copy protection. The Hardlock
device is the smallest, yet most compatible on the market today. It attaches to
a PC's printer port, but is transparent to the end-user and all printing
functions. Its impenetrable security comes from a variable response algorithm
within an Application Specific Integrated Circuit (ASIC). Hardlock is
compatible with DOS, Windows, OS/2, Unix and Xenix. Hardlock with Memory adds
128 bytes of EEPROM read-write memory for developer customization of software
packages, or management of multiple products or modules.
.np
For applications that require a protection unit internal to the PC, Hardlock on
a Board is functionally identical to Hardlock with Memory, and features our
unique 'Flippy Board' design. One side of the board is suitable for PC XT/AT 8
bit slots, while the other is micro channel (MCA) compatible for certain PS/2s.
.*
.figure *depth='2.75' *scale= *file='glenco'
.*

.*

.section Greenleaf ArchiveLib (&cat)
.*
.np
.illust begin
Greenleaf Software, Inc.
16479 Dallas Parkway, Suite 570
Dallas, Texas 75248


Sales:  (800) 523-9830
Tel:  (214) 248-2561
FAX:  (214) 248-7830
.illust end
.*
.np
.*
.ix 'Greenleaf ArchiveLib (&cat)'

.ix 'Greenleaf Software, Inc.'

.ix '&cat'
.*
Greenleaf ArchiveLib provides the developer with a set of classes and functions
to compress and store ASCII and binary data into an archive for storage, as
well as to retrieve and expand the stored data from the archive.  Data is
compressed and expanded using a proprietary algorithm.  Uncompressed data can
be situated in a file or a memory buffer.  ArchiveLib has been designed to be
flexible for handling any type of data that developers require.  The series of
classes and functions in ArchiveLib is geared to the C++ or C programmer, but
maintains language independence.  It contains a variety of functions to add,
replace, delete, update and retrieve objects of compressed data within the
archive.  ArchiveLib is available as a DLL for access by Windows 3.1 and
Windows NT developers.  Includes complete, fully commented, ANSI C compliant
source code and is royalty free.  Supports most popular C/C++ compilers.
.*
.figure *depth='2.75' *scale= *file='green1'
.*

.*

.section Greenleaf Database Library (&cat)
.*
.np
.illust begin
Greenleaf Software, Inc.
16479 Dallas Parkway, Suite 570
Dallas, Texas 75248


Sales:  (800) 523-9830
Tel:  (214) 248-2561
FAX:  (214) 248-7830
.illust end
.*
.np
.*
.ix 'Greenleaf Database Library (&cat)'

.ix 'Greenleaf Software, Inc.'

.ix '&cat'
.*
This library has over 240 functions to create or provide fast access to xBASE
files such as dBASE III & IV, Clipper, FoxPro, FoxBASE+, Alpha IV, and
compatible database products.  Library features include:  standalone, multi-
user and network access, automatic record and file locking, built-in disk
caching, index expression evaluation, and searches using full or partial keys.
Routines are supplied to access the following file types: fixed length records
(DBF), variable length memo records (DBT and FBT), and indices (CDX, IDX, MDX,
NDX and NTX).  Now includes high level functions which allow you greater
flexibility; i.e., when you open a database file, it also opens index and memo
files.  New version also includes a C++ layer, relational capabilities, a
Windows Help file, and new Windows demos.  Includes complete, fully commented,
ANSI C compliant source code and Microsoft Windows 3.1 and NT DLL's.
.*
.figure *depth='2.75' *scale= *file='green4'
.*

.*

.section Greenleaf PowerComm (&cat)
.*
.np
.illust begin
Greenleaf Software, Inc.
16479 Dallas Parkway, Suite 570
Dallas, Texas 75248


Sales:  (800) 523-9830
Tel:  (214) 248-2561
FAX:  (214) 248-7830
.illust end
.*
.np
.*
.ix 'Greenleaf PowerComm (&cat)'

.ix 'Greenleaf Software, Inc.'

.ix '&cat'
.*
PowerComm Toolkit for Windows is a native Windows 3.1 implementation of
Greenleaf CommLib 5.1.  PowerComm consists of a DLL and a virtual device driver
(VxD).  The DLL contains most of the high level code of CommLib including file
transfer, I/O, status, modem controls and other communications functions.  The
VxD contains the low-level Interrupt Service Routines and other time sensitive
code.  PowerComm implements CommLib's PortOpenGreenleaf(), the most powerful
driver in CommLib, within  Windows.  You can initialize any number of ports
using one or more types of non-intelligent multiport boards in the same PC.
Another unique feature of PowerComm is that it does not 'step on' the Windows
COMM.DRV communications driver.  Requires CommLib 5.1 or 5.2.
.*
.figure *depth='2.75' *scale= *file='green5'
.*

.*

.section Hamilton C shell (&cat)
.*
.np
.illust begin
Hamilton Laboratories
21 Shadow Oak Drive
Sudbury, MA
01776-3165

Tel:  (508) 440-8307
FAX:  (508) 440-8308
.illust end
.*
.np
.*
.ix 'Hamilton C shell (&cat)'

.ix 'Hamilton Laboratories'

.ix '&cat'
.*

.*

.*

.*

.section CX Family of Precision Frame Grabbers (&cat)
.*
.np
.illust begin
ImageNation Corporation
P.O. Box 276
Beaverton, OR  97075-0276


Tel:  (503) 641-7408
FAX:  (503) 643-2458
.illust end
.*
.np
.*
.ix 'CX Family of Precision Frame Grabbers (&cat)'

.ix 'ImageNation Corporation'

.ix '&cat'
.*
ImageNation, Inc. produces a family of video frame grabber boards.  The family
supports a number of bus architectures including the ISA bus, STD bus, and
PC104 embedded systems
form factor.   These precision image capture boards are used in a wide variety
of  scientific,
medical, factory automation and machine vision applications.
.np
Software shipped with the product includes both high level application level
software and low level support software.  The Watcom 32 bit library for the
DOS/4GW Extender acts as a low level driver for these boards.  It implements
over 120 functions including frame grabbing, low level board control, and image
processing functions.
.*

.*

.*

.section Object/Designer (&cat)
.*
.np
.illust begin
ImageSoft, Inc.
2 Haven Avenue
Port Washington, NY  11050


Tel:  (516) 767-2233
FAX:  (718) 767-4307
.illust end
.*
.np
.*
.ix 'Object/Designer (&cat)'

.ix 'ImageSoft, Inc.'

.ix '&cat'
.*

.*

.*

.*

.section MTOS-UX/386/486 (&cat)
.*
.np
.illust begin
Industrial Programming Inc.
100 Jericho Quadrangle
Suite 215
Jericho, NY  11753

Tel:  (516) 938-6600
FAX:  (516) 938-6609
.illust end
.*
.np
.*
.ix 'MTOS-UX/386/486 (&cat)'

.ix 'Industrial Programming Inc.'

.ix '&cat'
.*
MTOS-UX/386/486 is a real-time multi-tasking executive for the 386, 486 and
Pentium.  It is a member of the MTOS-UX family of real-time operating systems,
available for a PC and for stand-alone platforms.   All versions of MTOS-UX
have the same programmer interface.  Application software, when written in C,
is portable from platform to platform.
.np
MTOS-UX is specifically designed for high speed, compactness, portability and
generality.  It is widely used in communications, process control, medical
instrumentation, factory automation and a variety of other embedded systems.
All objects in this fully dynamic system may be created and deleted.
Scheduling is based on priority, with round-robin for tasks of equal priority.
MTOS-UX features include an extensive set of coordination and synchronization
facilities, such as message exchanges, event flags, memory pools, deferred
coordination, semaphores, signals, and controlled
shared variables.
.np
Additional available features include: (1) a DOS-compatible file system, (2)
MTOS-UX windowing system, (3) an interface to US Software UseNet(tm) and
Epilogue(tm) communication software, and (4) an interface to the metaWINDOW(tm)
graphics system, plus a full set of drivers for the screen/keyboard, diskette,
hard disk,line printer, serial I/O, RAMdisk, etc.
.np
When debugging with MTOS-UX, a third party debugger can be used, as well as the
MTOS-UX dynamic debugger, which includes a basic debugger and status reporter.
This debugger/status reporter is included with every MTOS-UX development kit to
facilitate development and testing of application code.
.*

.*

.*

.section DemoSHIELD (&cat)
.*
.np
.illust begin
InstallSHIELD Corp.
1100 Woodfield Rd.  Suite 108
Schaumburg, IL  60173


Sales:  (800) 374-4353
Tel:  (708) 240-9111
FAX:  (708) 240-9120
.illust end
.*
.np
.*
.ix 'DemoSHIELD (&cat)'

.ix 'InstallSHIELD Corp.'

.ix '&cat'
.*
DemoShield4 for Windows 3.1 and DemoShield4 for Windows 95 and Windows NT

DemoSHIELD demos and tutorials show off your application with interactive, high
impact demos, cue cards, help systems and tutorials for any Windows
application.  DemoSHIELD is the only demo toolkit that can actually control an
application live.  Of course you can also simulate your application with .AVI
files and screen captures created from your favorite capture utility.
.np
DemoSHIELD features: live application control recorder and player, Visual
design environment to layout, build and test your demo, high performance image
compression, smart VCR and menu navigational controls, complete control over
each object and event, integrated Setup
Wizard and uninstaller, royalty free distribution.
.np
.illust begin
Media type: 3.5
Released: 8/95
Cost: $495
.illust end
.*
.figure *depth='2.75' *scale= *file='dsscreen'
.*

.*

.section InstallSHIELD3 for Windows (&cat)
.*
.np
.illust begin
InstallSHIELD Corp.
1100 Woodfield Rd.  Suite 108
Schaumburg, IL  60173


Sales:  (800) 374-4353
Tel:  (708) 240-9111
FAX:  (708) 240-9120
.illust end
.*
.np
.*
.ix 'InstallSHIELD3 for Windows (&cat)'

.ix 'InstallSHIELD Corp.'

.ix '&cat'
.*
InstallShield3 for Windows 3.1 and Windows for Workgroups

Microsoft chose to work exclusively with Stirling to design InstallShield3.
InstallShield3 is the worldwide standard for installing 16-bit applications.
InstallShield3 features: new user interface, automatic billboard capability,
automatic 3D look, integrated uninstall features, the Visual Debugger, over 30
new built in dialog boxes, Online Reference, over 30 new functions to
automate most common tasks, script language enhancements, completely new
documentation and technical support, new, ready-to-use templates.
.np
.illust begin
Media type: 3.5
Released: 7/95
Cost: $595
.illust end
.*
.figure *depth='2.75' *scale= *file='iswin'
.*

.*

.section InstallShield3 for Windows 95 & Windows NT (&cat)
.*
.np
.illust begin
InstallSHIELD Corp.
1100 Woodfield Rd.  Suite 108
Schaumburg, IL  60173


Sales:  (800) 374-4353
Tel:  (708) 240-9111
FAX:  (708) 240-9120
.illust end
.*
.np
.*
.ix 'InstallShield3 for Windows 95 & Windows NT (&cat)'

.ix 'InstallSHIELD Corp.'

.ix '&cat'
.*
InstallShield3 for Windows 95 and Windows NT (Intel)

InstallShield3 for Windows 95 and Windows NT 3.5 (Intel) now shipping!
Microsoft chose to work exclusively with Stirling to design InstallShield3.
InstallShield3 for Windows 95 and NT features long name file support, automatic
creation of folders and icons, a built in UnInstallShield that integrates with
the Windows 95 Add/Remove Program Control Panel Applet and complete support for
the new Windows 95 Registry.
.np
InstallShield3 features: new user interface, automatic billboard capability,
automatic 3D look, integrated uninstall features, the Visual Debugger, over 30
new built in dialog boxes, Online Reference, over 30 new functions to automate
most common tasks, script language
enhancements, completely new documentation and technical support, new, ready-to-
use templates.
.np
.illust begin
Media type: 3.5
Released: 7/95
Cost: $595
.illust end
.*

.*

.*

.section MethodMaker (&cat)
.*
.np
.illust begin
Mark V Systems Ltd.
16400 Ventura Blvd., Suite 303
Encino, CA 91436


Sales:  (800) 995-7671
Tel:  (818) 995-7671
FAX:  (818) 995-4267
.illust end
.*
.np
.*
.ix 'MethodMaker (&cat)'

.ix 'Mark V Systems Ltd.'

.ix '&cat'
.*
MethodMaker (R) by Mark V Systems:  MethodMaker is an exciting  new extension
to the ObjectMaker family which allows rapid development of new method
notations.  MethodMaker also allows the user to modify and extend existing
ObjectMaker and ProcessMaker method support to meet project and organization
requirements. The user can easily build or modify the
tool support for a method by editing a diagram set. The new, or further
prototyped method is self
documented by the defining diagram set, and can be regenerated at any time to
take advantage of new ObjectMaker features and capabilities.  MethodMaker, with
simple diagrams and fill in forms allows you to specify and modify the tool
support for menus, notations, syntax checking, semantics specification and
repository capture of semantics and other information and relationships.  All
ObjectMaker CASE  Tool functionality is inherited.
.np
Contact MethodMaker marketing at 818 995 7671, fax 818 995 4267 or
methodmaker@markv.com.
.*

.*

.*

.section Object Maker (&cat)
.*
.np
.illust begin
Mark V Systems Ltd.
16400 Ventura Blvd., Suite 303
Encino, CA 91436


Sales:  (800) 995-7671
Tel:  (818) 995-7671
FAX:  (818) 995-4267
.illust end
.*
.np
.*
.ix 'Object Maker (&cat)'

.ix 'Mark V Systems Ltd.'

.ix '&cat'
.*
ObjectMaker by Mark V Systems:  With the ObjectMaker CASE Tool you can model
your application requirements and design in one or more of the most popular
notations.  ObjectMaker supports more than 30 of the most popular analysis and
design notations for software engineering and allows you to mix and match
notations to build a single model of your software application.  You can choose
the notations and the depth of detail your application requires.  ObjectMaker
also offers support for detailed design, code generation and document
generation for construction, delivery and maintenance phases.  Reverse
Engineering tools offer you the opportunity to re-engineer applications, reuse
legacy code and incorporate commercially available components into your model
for design, construction and maintenance.
.np
Contact ObjectMaker marketing at 818 995 7671, fax 818 995 4267, or
objectmaker@markv.com.
.*

.*

.*

.section ObjectMaker TDK (&cat)
.*
.np
.illust begin
Mark V Systems Ltd.
16400 Ventura Blvd., Suite 303
Encino, CA 91436


Sales:  (800) 995-7671
Tel:  (818) 995-7671
FAX:  (818) 995-4267
.illust end
.*
.np
.*
.ix 'ObjectMaker TDK (&cat)'

.ix 'Mark V Systems Ltd.'

.ix '&cat'
.*
ObjectMaker TDK by Mark V Systems: The ObjectMaker Tool Development Kit (TDK)
offers developers, integrators, OEMs, consultants, and methodologists the
opportunity to customize methods, notations, syntax rules, syntax checking,
semantic specification and repository capture of all semantics, and other
information and relationships important to your process and problem space.  The
TDK provides direct access to the rules (predicate logic) that create, control,
and pre- and post-condition all tool behavior, and manage all repository
navigation and iteration.  The TDK offers you the possibility of growing your
tool and method support as your organization and process grows and matures.
This is more than just being able to use the next method that
comes along, more than mixing and matching notations to create the multiple
views necessary for today's problems.  It means you can add to the notation you
select, add to the semantics, add to the checking,  add to the code generation,
and more as you gain experience and understand that what you need is beyond
what the published methods offer.  Published methods,
especially the object oriented methods, are good starting points.  Your process
will mature past the published methods. You will need to recognize and capture
the information and relationships important for your problem space.  The
ObjectMaker TDK provides tailorable support which enables you to develop and
extend your own methods.  The TDK gives you the opportunity to use and reuse
your repository contents, your application models, your component libraries by
giving you the facilities for data and control integration with other life
cycle tools.
.np
Contact ObjectMaker marketing at 818 995 7671, fax 818 995 4267, or
objectmaker@markv.com.
.*

.*

.*

.section ProcessMaker (&cat)
.*
.np
.illust begin
Mark V Systems Ltd.
16400 Ventura Blvd., Suite 303
Encino, CA 91436


Sales:  (800) 995-7671
Tel:  (818) 995-7671
FAX:  (818) 995-4267
.illust end
.*
.np
.*
.ix 'ProcessMaker (&cat)'

.ix 'Mark V Systems Ltd.'

.ix '&cat'
.*
ProcessMaker (R) by Mark V Systems:  ProcessMaker is a specialized modeling
tool which is coupled to an underlying semantics repository and code/text
generator.  ProcessMaker supports many popular process diagram notations and
provides the user the capability to easily develop a graphic representation of
a process. Users needing to capture process models, work flow models or
enterprise models for process improvement, analysis, measurement, reuse, re-
engineering or enactment have the choice of using multiple notations to create
the views necessary for
these tasks. ProcessMaker will generate output to a variety of process
enactment products.  Additional process modeling notations, and other
techniques can be added to ProcessMaker using MethodMaker and ObjectMaker TDK
tools described above.  More than 15 notations are supported at this time
including the popular IDEF/IDEF1x, ProNet, Process Decision Program
Charts, Process Breakdown Structure Charts, YPL and Petri Nets.
.np
Contact ProcessMaker marketing at 818 995 7671, fax 818 995 4267 or
processmaker@markv.com.
.*

.*

.*

.section FontBUILDER (&cat)
.*
.np
.illust begin
Metagraphics Software Corporation
200 Clock Tower Place, Suite 201E

Carmel, CA  93922

Sales:  (800) 332-1550
Tel:  (408) 622-8950
FAX:  (408) 622-8955
.illust end
.*
.np
.*
.ix 'FontBUILDER (&cat)'

.ix 'Metagraphics Software Corporation'

.ix '&cat'
.*
Metagraphics FontBUILDER works with scaleable outline fonts to create high-
quality MetaWINDOW bitmap fonts at any size or resolution you specify.
FontBUILDER includes over 20 outline typefaces in four font families (Times,
Helvetica, Courier and Script), plus can import both
PostScript and TrueType fonts for conversion to bitmap fonts for use with
MetaWINDOW graphic toolkits.  Style facings include normal, bold, italic, thin,
condensed, wide, expanded, hollow - and
combinations thereof.  Virtually no limitiation on font point sizes.  Virtually
unlimited font rasterization resolutions.
.np
FontBUILDER works with MetaWINDOW for DOS, -286 or -386 protected mode.  All
fonts provided may be distributed Royalty Free.  Full 30-day product guarantee.
.*
.figure *depth='2.75' *scale= *file='metapowr'
.*

.*

.section FontWINDOW (&cat)
.*
.np
.illust begin
Metagraphics Software Corporation
200 Clock Tower Place, Suite 201E

Carmel, CA  93922

Sales:  (800) 332-1550
Tel:  (408) 622-8950
FAX:  (408) 622-8955
.illust end
.*
.np
.*
.ix 'FontWINDOW (&cat)'

.ix 'Metagraphics Software Corporation'

.ix '&cat'
.*
Metagraphics FontWINDOW provides an extended set of bitmap fonts, font tools
and font documentation for use with Metagraphics MetaWINDOW. Over 200
additional English and international font styles are provided.  The graphical
bitmap font editor allows you to create
custom fonts or foreign language character sets; merge characters from
different fonts to create a new font; create icons and animation fonts; or
create new bold-faced, italicized or rotated font sets.
.np
FontWINDOW works with MetaWINDOW-DOS, -286 or -386.  All fonts provided are
Royalty Free.  Full 30-day product guarantee.
.np
For additional information:
.np
CompuServe:        GO METAGR, LIB 12, download FWDEMO.ZIP
.br
Internet ftp:      ftp.metagraphics.com, download FWDEMO.ZIP
.br
Metagraphics BBS:  408-622-8945, download DEMO\\FWDEMO.ZIP
.*
.figure *depth='2.75' *scale= *file='metapowr'
.*

.*

.section KEY-LOK (&cat)
.*
.np
.illust begin
Microcomputer Applications, Inc.
3167 East Otero Circle
Littleton, Colorado 80122


Tel:  (303) 770-1917
FAX:  (303) 770-1863
.illust end
.*
.np
.*
.ix 'KEY-LOK (&cat)'

.ix 'Microcomputer Applications, Inc.'

.ix '&cat'
.*
Microcomputer Applications, Inc. has been successfully preventing software
piracy since 1982.  As the oldest supplier of PC based security products, we
have developed products that combine maximum security with maximum reliability.
Our parallel port KEY-LOK device comes with a lifetime warranty against
failure, as further evidence of its durability.  High level program
protection requires a combination of both hardware and software.  The software
portion of the system is designed to prevent pirates from using debugging
utilities to take apart and thus bypass the hardware communication algorithms.
.np
The hardware portion of the system is designed to prevent reverse engineering.
Our security system uses 'active' algorithms so that someone cannot capture a
communication sequence and play it back as a means of bypassing security.  This
device comes with 120 bytes of EEPROM memory to support multi-product/feature
protection.  Optional real-time-clock and KEYTAG for secure memory alteration
are available.
.np
We have been supporting Watcom compilers for several years now.  We support all
of the various options of DOS extenders, and can easily support new ones on the
market within a few days of customer request.  We can also provide a Novell NLM
so that a single device can be used to support multiple nodes on a network.
The NT version of our security system can also be used for multi-session and/or
multi-node control.  We also support OS/2, in addition
to standard DOS and Windows applications.  Our complementary serial port COMPU-
LOCK product can be used to protect software operating on any platform under
any operating system.
.*

.*

.*

.section KEY-LOK Security System (&cat)
.*
.np
.illust begin
Microcomputer Applications, Inc.
3167 East Otero Circle
Littleton, Colorado 80122


Tel:  (303) 770-1917
FAX:  (303) 770-1863
.illust end
.*
.np
.*
.ix 'KEY-LOK Security System (&cat)'

.ix 'Microcomputer Applications, Inc.'

.ix '&cat'
.*
Prevent software piracy using our state-of-the-art parallel port hardware
device combined with powerful security software. Active algorithm (different
each time used). Each device is customer unique and individually serialized.
Use parallel port to directly program 120 bytes of read/write memory. Optional
KEYTAG for very secure KEY-LOCK memory modification in the field. Optional Real-
Time-Clock  to support product leasing. Serial port devices are also available.
.*

.*

.*

.section MKS Source Integrity (&cat)
.*
.np
.illust begin
Mortice Kern Systems, Inc.
185 Columbia Street West
Waterloo, Ontario, Canada  N2L 5Z5


Sales:  (800) 265-2797
Tel:  (519) 884-2251
FAX:  (519) 884-8861
.illust end
.*
.np
.*
.ix 'MKS Source Integrity (&cat)'

.ix 'Mortice Kern Systems, Inc.'

.ix '&cat'
.*
MKS Source Integrity is a complete, project oriented version control and build
system.  With MKS Source Integrity, you can:
.np
.illust begin
     - Track which files are included in each project so important files are
never lost or left behind.

     - Know the current version of each file that is associated with the
project.

     - See at a glance which files are currently locked for editing and who has
locked them.

     - Track dependencies between files and import these dependencies into your
make file.

     - Take snapshots of your project and recreate these snapshots at any point
in the future.
.illust end
.np
MKS Source Integrity offers true team development with sandboxes.  Sandboxes
offer every team member a safe, personalized place to work.  Changes to project
files are automatically communicated to leverage team development.
.np
MKS Source Integrity is designed to make your entire development team more
productive.  You can use our state of the art GUI, or you can access MKS Source
Integrity from the command line.  We even have built in integration into the
WATCOM C/C++ IDE to make MKS Source Integrity the ultimate in ease of use.
.np
Additional features of MKS Source Integrity include:  visual differencing and
visual merging, event triggers, built in reporting facilities, both binary and
text files support, an advanced promotion
model, and more.
.*

.*

.*

.section Movil CPF (&cat)
.*
.np
.illust begin
Movil
2000 California Street
Mountain View, CA 94040


Tel:  (408) 773-0984
FAX:  (408) 773-9059
.illust end
.*
.np
.*
.ix 'Movil CPF (&cat)'

.ix 'Movil'

.ix '&cat'
.*
Especially efficient for large C/C++/FORTRAN projects.  Now you can speed up
the
compilation  drastically without modifying your source code.  No more 5 hour
compiles.  CPF intercepts calls  to compiler made from your make files and
distributes compilation over several LAN nodes  and/or CPUs on multiple-
processor systems.
.np
Your compilation must run under Windows95 and  Windows/NT 3.5x; cross-compilers
are supported.  Currently works with Microsoft Visual C++  2.x and  4.0 and
Watcom 10.5 desktops.
Command-line C/C++ compilers from Microsoft,  Borland and Watcom are supported
also.  Completely user-configurable.
.np
CPF consists of CPF Server running on local computer and several CPF NetServers
running on  remote machines.  When make utility or batch file is executed on
the local computer, CPF
intercepts command lines and submits them to remote CPF NetServers or executes
them locally  depending on the available resources.  Each of the remote
machines running CPF NetServer uses  its own copy of the compiler.  In order to
decide whether a particular command line could be sent  for execution to remote
machine or has to be executed locally CPF parses the command line and  compares
it with the configuration information.  For example, a compiler command
line could be  executed remotely but LINK command has to be executed on the
local computer.
To increase performance CPF can cache precompiled header files and intermediate
files on remote  nodes.  Each of the remote machines can process multiple
commands simultaniously and
the local  computer can invoke multiple instances of a compiler at the same
time.  This allows for the optimal use of computers with multiple CPUs running
under SMP Windows/NT.
.np
(*1)CPF Monitor utility allows user to monitor execution of jobs by CPF.
Because CPF parses command lines according to configuration information, only
changes to  CPF configuration
are required to accomodate a new compiler release or even a completely new
compiler (*2).
.np
(*1) Not all compilers support multiple simultaneous compiles on the same
computer.
.np
(*2) However, we do not guarantee that any new compiler could be accomodated
just through  configuration changes.
.*

.*

.*

.section Application/Integrator Workbench (&cat)
.*
.np
.illust begin
Netwise, Inc.
2477 55th St.  Suite 101
Boulder, CO  80301


Sales:  800-733-7722
Tel:  (303) 442-8280
FAX:  (303) 442-3798
.illust end
.*
.np
.*
.ix 'Application/Integrator Workbench (&cat)'

.ix 'Netwise, Inc.'

.ix '&cat'
.*
Application/Integrator Workbench is a Windows-based client/server middleware
development tool.  It allows developers to quickly and easily design and
generate the distributed function communications code necessary for desktop and
midrange processes to interoperate
with mainframe application transactions.  The Workbench is a component of
TransAccess Application/Integrator.
.np
The Workbench uses Windows GUI technology to define interfaces for client and
server application code and then generates all the code necessary to interface
with the client and server processes.  Less coding and more functionality make
the Workbench the best
distributed function middleware tool.  Most other distributed function
middleware development tools require programmers to learn new application
programming interfaces (APIs) and write/imbed code.
.np
Using the Workbench, developers can do rapid prototyping to fine-tune
distributed function designs and rapidly build enterprise client/server
applications.  Since all communications design and code generation is completed
from within the Workbench, future communications enhancements are accomplished
using the Workbench rather than having to locate and alter API verbs and
parameters imbedded in application code.
.*

.*

.*

.section Select OMT Professional (&cat)
.*
.np
.illust begin
Select Software Tools Ltd.
Suite #84 Brookhollow Office Park
1526 Brookhollow Drive
Santa Ana, California  92705

Tel:  (714) 957-6633
FAX:  (714) 957-6219
.illust end
.*
.np
.*
.ix 'Select OMT Professional (&cat)'

.ix 'Select Software Tools Ltd.'

.ix '&cat'
.*

.*

.*

.*

.section ImageNation (&cat)
.*
.np
.illust begin
Spicer Corporation
221 McIntyre Drive
Kitchener, Ontario
N2R 1G1

Tel:  (519) 748-2462
FAX:  (519) 748-9457
.illust end
.*
.np
.*
.ix 'ImageNation (&cat)'

.ix 'Spicer Corporation'

.ix '&cat'
.*
.illust begin
As a high-performance software which assists with the presentation and
orchestration of electronic information, Imagenation provides imaging solutions
to a wide variety of office and engineering applications.  Imagenation
incorporates scan, view, annotate, markup, edit, plot hotspot and text search
capabilities for Windows, Macintosh and UNIX.

The feature-rich software supports industry-standard file formats for CAD,
raster, vector and text including bi-level, grayscale and 24-bit color.
Imagenation also facilitates software-only image manipulation at speeds
comparable to expensive hardware-assisted products while minimizing RAM
requirements and imposing practically no limitations on the image-size used.

Managing overlays, multi-page documents, mixed page formats and sizes within a
document, Imagenation can combine images in many ways to create sophisticated
and useful documents.  As well, the software provides a customizable and
intuitive user interface.  By adhering to industry standards, Imagenations
user interface complies with the look and feel of the platform.

Database independent, Imagenations comprehensive API commands (Motif Messages,
Apple Events, DDE, DLL function calls, OLE 2 and ODMA) allow seamless
integration into document management and workflow systems.  This enables
Imagenation to be used in solutions such as PDM, EDMS or custom applications
using tools such as Visual Basic, Powerbuilder and Visual C++.

Imagenation is used in imaging solutions such as engineering revision control,
facsimile processing, drawing distribution, CD-ROM document navigation, plant
maintenance and legal document imaging.  The software is available in several
languages.

Offering a complete set of viewing capabilities and options, exceptional load
and display times, and unmatched redline, markup and edit tools, Imagenation is
the preferred choice of experts.
.illust end
.*

.*

.*

.section Graph Layout Toolkit (&cat)
.*
.np
.illust begin
Tom Sawyer Software
1828 Fourth Street
Berkeley, CA  94710


Sales:  800-929-TOMS
Tel:  (510) 848-0853
FAX:  (510) 848-0854
.illust end
.*
.np
.*
.ix 'Graph Layout Toolkit (&cat)'

.ix 'Tom Sawyer Software'

.ix '&cat'
.*
.illust begin
Tom Sawyer's Graph Layout Toolkit is a family of portable libraries that
deliver an immediate face-lift to graphics applications with their
sophisticated layout algorithms. The Graph Layout Toolkit libraries' logical
representation of objects and connections allow end users to more easily see
underlying relationships within complicated data. The libraries also work in
real time, rarely requiring more than a few seconds to produce quality output
even for large graphs with several hundred nodes.

Four extensible C++ class libraries that include ANSI C APIs make up the Graph
Layout Toolkit family: the Circular, Hierarchical, Orthogonal*, and Symmetric
Layout Libraries. All libraries share a common foundation.

* Orthogonal layout will be generally available with release 2.2 of the Graph
Layout Toolkit in the first quarter of 1996, but can be made available in pre-
release form for select customers.

The Hierarchical library is ideal for the layout of directed graphs.  For
example, it is excellent for drawing complicated function call graphs and for
layout of nested outline PERT charts used in project management applications.

The Circular library is ideal for layout of complicated ring and star
topologies. For example, it may be used to layout complicated IP networks where
devices on the same Class A, Class B or Class C network
or devices on the same subnet are placed around the same circle. It is also
excellent at relating geographic site based information within the framework of
a logical layout product. It functions by partitioning
nodes into logical groups based on a number of flexible node grouping models.
Each group of nodes is placed on radiating circles based on the interconnection
of these groups.

The Symmetric library exposes the natural symmetry inherent in many graph
structures. For instance, this library is superb at rendering arbitrary
enterprise-wide computer networks or mesh networks.

Navigation Features
-------------------------
Graphs help you to manage information, but one graph is often not sufficient.
We provide easy to use, yet powerful tools to help you to manage information
that often spans many graphs.

The Graph Layout Toolkit helps you write powerful graph editing applications
with intelligent window management. Set up hypertext like associations from
nodes and edges in a graph to other graphs whether they are displayed in the
same window or different windows.

Supported Environments
-------------------------
The Graph Layout Toolkit libraries operate with most major operating systems,
compilers and GUI Toolkits. Support is also provided for the ANSI C compiler
designed to work with these C++ compilers listed below.

Sun SPARCstation:
    SunOS 4.1.x: Sun C++, GNU C++, MetaWare C++ and CenterLine C++
    Solaris 2.x: Sun C++, GNU C++, MetaWare C++ and CenterLine C++
HP 9000: HP C++, GNU C++
SGI Iris: SGI C++
IBM RS/6000: IBM C++
NeXT: NeXT C++
DEC OSF/1: DEC C++

Tom Sawyer Software is one of seven software companies nationwide to win the
U.S. Department of Commerce, National Institute of Standards and Technology's
Advanced Technology Program (ATP) award grant (95-09) for Component Based
Software Technology Development in 1995.
.illust end
.*

.*

.*

.section USFiles (&cat)
.*
.np
.illust begin
United States Software Corporation
14215 N.W. Science Park Drive
Portland, Oregon  97229


Sales:  (800) 356-7097
Tel:  (503) 641-8446
FAX:  (503) 644-2413
.illust end
.*
.np
.*
.ix 'USFiles (&cat)'

.ix 'United States Software Corporation'

.ix '&cat'
.*
USFiles is a DOS compatible file system for embedded use.  It is supplied in
source code form, and is used to provide DOS compatible file access, in
embedded environments where DOS is not
present.  USFiles can be used with the MultiTask! RTOS, some other RTOS, or
none at all.  Any type of floppy, hard, or ram drive is easily supported by
providing the sector read and sector
write functions necessary to access that device.  The user interface is through
the standard ANSI C stream I/O functions: fopen, fread, fprintf, etc.  No
royalties are charged.
.*

.*

.*

.section USNET (&cat)
.*
.np
.illust begin
United States Software Corporation
14215 N.W. Science Park Drive
Portland, Oregon  97229


Sales:  (800) 356-7097
Tel:  (503) 641-8446
FAX:  (503) 644-2413
.illust end
.*
.np
.*
.ix 'USNET (&cat)'

.ix 'United States Software Corporation'

.ix '&cat'
.*
USNET is a TCP/IP protocol stack designed specifically for embedded use.  It is
compact (about 24K), and fast.  It is compatible with most popular RTOSes
(including MultiTask!).
USNET provides client/server support for FTP, TFTP, TELNET and BOOTP.  Two
API's are supported, either the BSD socket interface, or a dynamic protocol
interface.  USNET supports the following standard Internet suite of protocols,
all of which are compliant with current RFC's:  TCP, UDP, IP, ICMP, ARP, RARP.
Drivers are provided for many popular ethernet interfaces and serial
interfaces.  Full source code is provided, and no royalties are charged.
.*

.*

.*
:set symbol="cat" value="Printer Libraries & Utilities"

.chap Printer Libraries & Utilities
.*
.np
The following section contains listings for printer libraries and utilities
supporting Watcom C or C++.

.*

.section BD/CX (&cat)
.*
.np
.illust begin
Autumn Hill Software
1145 Ithaca Drive
Boulder, Colorado 80303


Tel:  (303) 494-8865
FAX:  (303) 494-7802
.illust end
.*
.np
.*
.ix 'BD/CX (&cat)'

.ix 'Autumn Hill Software'

.ix '&cat'
.*
BD/CX is the third generation of Autumn Hill's printer toolkits.  BD/CX
provides printer interface tools and an optional presentation graphics library
for professional developers who want to focus on their application and yet
assure their users of high-quality output.  The BD/CX Printer Interface Toolkit
kernel is all you need to support basic graphics screen printing with access to
the basic text-handling features of a printer.  Adding BD/CX Presentation
Graphics and font components results in a device-independent presentation-
quality graphics environment that c an drive any printer at maximum resolution.
BD/CX supports DOS, Extended DOS, OS/w 2.x and Warp, MS-Windows 3.x, MS-Windows
95, and Windows NT along with all major compilers on these  platforms.
.*

.*

.*

.section Ingraf (&cat)
.*
.np
.illust begin
Sutrasoft
10506 Permian Drive
Sugar Land, Texas  77478


Tel:  (713) 491-2088
FAX:  (713) 240-6883
.illust end
.*
.np
.*
.ix 'Ingraf (&cat)'

.ix 'Sutrasoft'

.ix '&cat'
.*
INGRAF contains routines that you can use to create high quality graphics
with your IBM (or compatible) personal computer and any of numerous output
devices. INGRAF is available for C, FORTRAN-77, BASIC, and PASCAL, with most
routines being written in the applicable language.

In addition to general drawing routines such as line, arc, circle, grid, etc.,
that you can use to create log (semi-log and log-log), and polar plots,
INGRAF includes routines for creating bar, pie, scatter, polar and
smith charts , as well as the HIGH-LOW-CLOSE plots.

Some of the features of INGRAF are:

     Draw and scale X and Y axes independently of one another, with
     arbitrary placement.

     Control the placement and direction of text labels, (also the size
     of the text on some devices).

     Determine the size and spacing of tick marks and their placement in
     relation to the axes.

     Choose from several symbols to mark points.

     Select from various line styles and grid styles, depending on your
     choice of graphics device.

     Turn line clipping on or off.

     Generate hatching patterns with six hatch styles.


INGRAF contains over 150 user callable routines. The 350+ page user manual
includes over 50 sample programs and graphs. The same samples also are
included on diskette. INGRAF comes with complete source code and ready
to use libraries. There are NO ROYALTIES or RUN-TIME FEES.
.*

.*

.*

.section Wingraf for Windows (&cat)
.*
.np
.illust begin
Sutrasoft
10506 Permian Drive
Sugar Land, Texas  77478


Tel:  (713) 491-2088
FAX:  (713) 240-6883
.illust end
.*
.np
.*
.ix 'Wingraf for Windows (&cat)'

.ix 'Sutrasoft'

.ix '&cat'
.*
WINGRAF contains routines that you can use to create high quality graphics
with your IBM (or compatible) personal computer and any of numerous output
devices. WINGRAF is available for C, FORTRAN-77, BASIC, and PASCAL, with most
routines being written in the applicable language.

In addition to general drawing routines such as line, arc, circle, grid, etc.,
that you can use to create log (semi-log and log-log), and polar plots,
WINGRAF includes routines for creating bar, pie, scatter, polar and
smith charts , as well as the HIGH-LOW-CLOSE plots.

Some of the features of WINGRAF are:

     Draw and scale X and Y axes independently of one another, with
     arbitrary placement.

     Control the placement and direction of text labels, (also the size
     of the text on some devices).

     Determine the size and spacing of tick marks and their placement in
     relation to the axes.

     Choose from several symbols to mark points.

     Select from various line styles and grid styles, depending on your
     choice of graphics device.

     Turn line clipping on or off.

     Generate hatching patterns with six hatch styles.


WINGRAF contains over 140 API routines. The 350+ page user manual
includes over 50 sample programs and graphs. The same samples also are
included on diskette. WINGRAF comes with complete source code and ready
to use DLL and libraries. There are NO ROYALTIES or RUN-TIME FEES.
.*

.*

.*

.section SCRIPT (&cat)
.*
.np
.illust begin
The Symmetry Group
PO Box 26195
Columbus, OH  43226


Sales:  (800) 346-3938
Tel:  (614) 431-2667
FAX:  (614) 431-5734
.illust end
.*
.np
.*
.ix 'SCRIPT (&cat)'

.ix 'The Symmetry Group'

.ix '&cat'
.*
SCRIPT is a complete text formatting system for DOS that developers can
incorporate into their application.  SCRIPT uses (and requires) SLATE or SLATE
with Graphics to provide the printer interface.
.np
SCRIPT comes with a standard set of Formatting Commands and Macros. In
addition, new commands and macros can be defined to work with data from the
application.
.np
When SCRIPT is incorporated into an application program, it can accept commands
and data from text and format files to build a formatted document.  These files
can be provided with the application and modified by the end user to add logos,
alter the order and presentation of data, add lines and shading to create
forms, add barcodes, etc.
.np
SCRIPT can be extended to define macros that access internal application data.
New commands can be added to call functions in the application to access new
data or perform other operations.
.np
There are no royalties, no matter how many copies of your program you ship or
how many programs you use it in. A maintenance program is available to keep the
software current.
.*

.*

.*

.section SLATE (&cat)
.*
.np
.illust begin
The Symmetry Group
PO Box 26195
Columbus, OH  43226


Sales:  (800) 346-3938
Tel:  (614) 431-2667
FAX:  (614) 431-5734
.illust end
.*
.np
.*
.ix 'SLATE (&cat)'

.ix 'The Symmetry Group'

.ix '&cat'
.*
The Slate Universal Printer Driver is an interface library providing all the
printing functions you need for the most complex DOS printing application.  It
supports the entire spectrum of printers from early dot matrix and daisy wheel
printers to the modern laser, PostScript, and color printers.
.np
The system is designed to help you get more out of your current software.
Whether you deal with complex printing programs or just need your printed
output to look more professional, SLATE is the
system you need.
.np
SLATE comes with configuration and testing tools which allow the end user to
select their printer from a database of nearly 1000 printers and to specify how
their system is connected.  The testing
tools are used to ensure correct configuration by printing a series of function
tests on the printer.
.np
SLATE is a library that permanently links to your application program.  The
specifications and capabilities of individual printers are stored in a Printer
Database.  The 170 text printing functions
simplify and speed up software development while making the application code
independent of the printer.
.np
SLATE with Graphics includes all of the text features of SLATE and adds more
than 60 image printing functions to print screens, logos, signatures, barcodes
and more.
.np
There are no royalties, no matter how many copies of your program you ship or
how many programs you use it in.  A maintenance program is available to keep
the software and Printer
Database current.
.*
.figure *depth='2.75' *scale= *file='symmetry'
.*

.*
:set symbol="cat" value="Real-Time Operating Systems"

.chap Real-Time Operating Systems
.*
.np
The following section contains listings for real-time operating systems with
support for Watcom C or C++.
.*

.section Nucleus RTX and Nucleus PLUS (&cat)
.*
.np
.illust begin
Accelerated Technology Inc.
4266 Cottage Hill Road  Suite #5
Mobile, Alabama  36609


Sales:  (800) 468-6853
Tel:  (205) 661-5770
FAX:  (205) 661-5788
.illust end
.*
.np
.*
.ix 'Nucleus RTX and Nucleus PLUS (&cat)'

.ix 'Accelerated Technology Inc.'

.ix '&cat'
.*
Accelerated Technology, Inc. provides developers with two real-time, multi-
tasking kernels, Nucleus RTX and Nucleus PLUS.  Both products offer a complete
set of multi-tasking facilities, including task communication, task
synchronization, memory management and debug support.  Nucleus PLUS provides
several new facilities, including dynamic configuration, pipes, signals and
application timers.  Accelerated Technology also provides local and fully RFC
compliant TCP/IP support and MS-DOS embedded file support with Nucleus NET,
Nucleus TCP/IP and Nucleus FILE, respectively.  Nucleus products are reasonably
priced and are offered without any run-time royalties.  Six months of free
technical support and source code are provided.
.*

.*

.*

.section RTXC (&cat)
.*
.np
.illust begin
Embedded System Products
10450 Stancliff, Suite 110
Houston, TX 77099-4383


Sales:  (800) 525-4302
Tel:  713-561-9990
FAX:  713-561-9980
.illust end
.*
.np
.*
.ix 'RTXC (&cat)'

.ix 'Embedded System Products'

.ix '&cat'
.*
RTXC - is a flexible, field-proven multitasking real-time kernel for use in a
wide varitey of applications. RTXC manages tasks and time, synchronizes with
events, and permits transferal of data between tasks.  RTXC supports
preemptive, round robin and time-slices task scheduling.
RTXC is ROMable, supplied with source code free of any runtime royalties.  RTXC
can provide support to DOS functions.
.np
RTXC is specifically configured to support Watcom and is integrated with the
Concurrent Sciences and Paradigm debuggers.  Softaid's emulator is kernel aware
with RTXC.
.np
RTXCio - is a device independent input/output subsystem that permits
application tasks to make direct request to any supported device.  Multiple
task may access the same device and a single task may access multiple devices.
RTXCio also supports both synchronous and asynchrous
input/output operations.
.np
DOS File Mangement, Graphics and Networking support are available. RTXC - is a
flexible, field-proven multitasking real-time kernel for use in a wide varitey
of applications. RTXC manages tasks and time, synchronizes with events, and
permits transferal of data between tasks.  RTXC supports preemptive, round
robin and time-slices task scheduling.  RTXC is ROMable, supplied with source
code free of any runtime royalties.  RTXC can provide support to DOS functions.
.np
RTXC is specifically configured to support Watcom and is integrated with the
Concurrent Sciences and Paradigm debuggers.  Softaid's emulator is kernel aware
with RTXC.
.np
RTXCio - is a device independent input/output subsystem that permits
application tasks to make direct request to any supported device.  Multiple
task may access the same device and a single task may access multiple devices.
RTXCio also supports both synchronous and asynchrous
input/output operations.
.np
DOS File Mangement, Graphics and Networking support are available.
.*

.*

.*

.section MTOS-UX/386/486 (&cat)
.*
.np
.illust begin
Industrial Programming Inc.
100 Jericho Quadrangle
Suite 215
Jericho, NY  11753

Tel:  (516) 938-6600
FAX:  (516) 938-6609
.illust end
.*
.np
.*
.ix 'MTOS-UX/386/486 (&cat)'

.ix 'Industrial Programming Inc.'

.ix '&cat'
.*
MTOS-UX/386/486 is a real-time multi-tasking executive for the 386, 486 and
Pentium.  It is a member of the MTOS-UX family of real-time operating systems,
available for a PC and for stand-alone platforms.   All versions of MTOS-UX
have the same programmer interface.  Application software, when written in C,
is portable from platform to platform.
.np
MTOS-UX is specifically designed for high speed, compactness, portability and
generality.  It is widely used in communications, process control, medical
instrumentation, factory automation and a variety of other embedded systems.
All objects in this fully dynamic system may be created and deleted.
Scheduling is based on priority, with round-robin for tasks of equal priority.
MTOS-UX features include an extensive set of coordination and synchronization
facilities, such as message exchanges, event flags, memory pools, deferred
coordination, semaphores, signals, and controlled
shared variables.
.np
Additional available features include: (1) a DOS-compatible file system, (2)
MTOS-UX windowing system, (3) an interface to US Software UseNet(tm) and
Epilogue(tm) communication software, and (4) an interface to the metaWINDOW(tm)
graphics system, plus a full set of drivers for the screen/keyboard, diskette,
hard disk,line printer, serial I/O, RAMdisk, etc.
.np
When debugging with MTOS-UX, a third party debugger can be used, as well as the
MTOS-UX dynamic debugger, which includes a basic debugger and status reporter.
This debugger/status reporter is included with every MTOS-UX development kit to
facilitate development and testing of application code.
.*

.*

.*

.section AMX 386 Real-Time Multitasking Kernel (&cat)
.*
.np
.illust begin
KADAK Products Ltd.
206-1847 West Broadway Ave.,
Vancouver, B.C.
CANADA
V6J 1Y5
Tel:  (604) 734-2796
FAX:  (604) 734-8114
.illust end
.*
.np
.*
.ix 'AMX 386 Real-Time Multitasking Kernel (&cat)'

.ix 'KADAK Products Ltd.'

.ix '&cat'
.*
.illust begin
*For protected mode 386 and 486 microprocessors
*Full-featured, compact ROMable kernel with fast interrupt response
*Preemptive, priority based task scheduler with optional time slicing
*Mailbox, semaphore, resource, event, list, buffer and memory managers
*Configuration Builder utility eases system construction
*InSight(tm) Debug Tool is available to view system internals and gather task
execution information
*PC device support and DOS compatible file I/O
*Comprehensive, crystal clear documentation
*No royalties to pay
*Source code included
*KADAK and AMX have developed an enviable track record for reliability and
support
.illust end
.np
AMX* 386 is a real-time operating system for protected mode 80386
microprocessors.  The AMX family of kernels, first released in 1980, is used by
more than 1,000 developers worldwide.
.np
.illust begin
AMX features include:
*Nested interrupts with priority ordering
*Preemptive, priority based task scheduler
*Timing support for delays, timeouts, periodic events
*Time slicing option with adjustable slices
*Message passing with configurable message length
*Dynamic task creation and dynamic task priorities
.illust end
.np
.illust begin
Managers are provided for:
*Semaphore signalling and resource allocation
*Event synchronization
*Mailboxes and message exchanges
*Fast, fixed size memory buffer allocation
*Dynamic memory allocation similar to malloc()
*Linked lists and circular lists
.illust end
.np
.illust begin
PC support provides:
*PC device access
*DOS function call and file I/O
.illust end
.np
.illust begin
Development Support:
*Configuration Builder utility
*AMX is available for a wide range of target processors
*Comprehensive, simple-to-follow documentation including sample programs
.illust end
.np
.illust begin
Product Support:
*Prompt and courteous technical support by telephone or fax
*Reference Manual highlights the answers to the more common technical support
questions
*AMX source code included to ease updates
*Software updates included for one year
*AMX reliability field-proven since 1980
.illust end
.np
.illust begin
KADAK Non-Exclusive Dealers

AUSTRALIA
Baltec Systems Pty. Ltd., Alistair Henderson
26 Mayneview Street, Milton, Queensland 4064
Phone: (61)7 369-5900
Fax: (61)7 369-5257

FRANCE
OMNITEL, Jacques Ledu
31, rue Jean Rostand, Orsay Cedex 91893
Phone: (33)1 698 55044
Fax: (33)1 698 55426

GERMANY
Creative Daten GmbH, Dieter Daubenspeck
Roesslweg 9, Graefelfing/Munchen D-82166
Phone: (49)89 898 1640
Fax: (49) 89 89816414

SWEDEN
Q-Instrument Scandinavia AB, Per-Arne Andersson
Pyramidvagen 6, Box 5544, Huddinge S-14105
Phone: (46)8 740 4580
Fax: (46)8 740 0860

UNITED KINGDOM
Great Western Instruments Ltd., John Legg
Redwood House, Bristol Road, Keynsham, Bristol, BS18 2BB
Phone: (44)117 9860400
Fax: (44)117 9860401
.illust end
.*

.*

.*

.section AMX 86 Real-Time Multitasking Kernel (&cat)
.*
.np
.illust begin
KADAK Products Ltd.
206-1847 West Broadway Ave.,
Vancouver, B.C.
CANADA
V6J 1Y5
Tel:  (604) 734-2796
FAX:  (604) 734-8114
.illust end
.*
.np
.*
.ix 'AMX 86 Real-Time Multitasking Kernel (&cat)'

.ix 'KADAK Products Ltd.'

.ix '&cat'
.*
.illust begin
*For real mode 80x86/88 microprocessors
*Full-featured, compact ROMable kernel with fast interrupt response
*Preemptive, priority based task scheduler with optional time slicing
*Mailbox, semaphore, resource, event, list, buffer and memory managers
*Configuration builder utility eases system construction
*InSight* Debug Tool is available to view system internals and gather task
execution information
*PC device support and DOS compatible file I/O
*Comprehensive, crystal clear documentation
*No royalties to pay
*Source code included
*KADAK and AMX have developed an enviable track record for reliability and
support
.illust end
.np
.illust begin
AMX* 86 is a real-time operating system for real mode 80x86/88 microprocessors.
The AMX family of kernels, first
released in 1980, is used by more than 1,000 developers worldwide.
.illust end
.np
.illust begin
AMX features include:
*Nested interrupts with priority ordering
*Preemptive, priority based task scheduler
*Timing support for delays, timeouts, periodic events
*Time slicing option with adjustable slices
*Message passing with configurable message length
*Dynamic task creation and dynamic task priorities
.illust end
.np
.illust begin
Managers are provided for:
*Semaphore signalling and resource allocation
*Event synchronization
*Mailboxes and message exchanges
*Fast, fixed size memory buffer allocation
*Dynamic memory allocation similar to malloc()
*Linked lists and circular lists
.illust end
.np
.illust begin
PC support provides:
*PC device access
*DOS function call and file I/O support
*DOS command processor access
.illust end
.np
.illust begin
Development Support
*Configuration Builder utility
*AMX is available for a wide range of target processors
*Comprehensive, simple-to-follow documentation including sample programs
.illust end
.np
.illust begin
Product Support
*Prompt and courteous technical support by telephone or fax
*Reference Manual highlights the answers to the more common technical support
questions
*AMX source code included to ease updates
*Software updates included for one year
*AMX reliability field-proven since 1980
.illust end
.np
.illust begin
KADAK Non-Exclusive Dealers

AUSTRALIA
Baltec Systems Pty. Ltd., Alistair Henderson
26 Mayneview Street, Milton, Queensland 4064
Phone: (61)7 369-5900
Fax: (61)7 369-5257

FRANCE
OMNITEL, Jacques Ledu
31, rue Jean Rostand, Orsay Cedex 91893
Phone: (33)1 698 55044
Fax: (33)1 698 55426

GERMANY
Creative Daten GmbH, Dieter Daubenspeck
Roesslweg 9, Graefelfing/Munchen D-82166
Phone: (49)89 898 1640
Fax: (49) 89 89816414

SWEDEN
Q-Instrument Scandinavia AB, Per-Arne Andersson
Pyramidvagen 6, Box 5544, Huddinge S-14105
Phone: (46)8 740 4580
Fax: (46)8 740 0860

UNITED KINGDOM
Great Western Instruments Ltd., John Legg
Redwood House, Bristol Road, Keynsham, Bristol, BS18 2BB
Phone: (44)117 9860400
Fax: (44)117 9860401
.illust end
.*

.*

.*

.section smx (&cat)
.*
.np
.illust begin
Micro Digital, Inc.
12842 Valley View Street
Garden Grove, CA 92649


Sales:  (800) 366-2491
Tel:  (714) 373-6862
FAX:  (714) 891-2363
.illust end
.*
.np
.*
.ix 'smx (&cat)'

.ix 'Micro Digital, Inc.'

.ix '&cat'
.*
smx is a real-time multitasking kernel for use in embedded systems.  It is
specifically designed for demanding real-time applications.  It offers a full
suite of kernel services, yet emphasizes simplicity and ease of use.  smx
focuses on the 80x86 processor family and has many features to facilitate 80x86
development.  These increase speed and efficiency of memory usage.
.np
smx also offers full support for the most popular C/C++ compilers and
assemblers, and it is one of only a few kernels to provide a C++ library.   smx
is ROMable for standalone environments.  It
also runs equally well with DOS, and it provides PC support.
.np
smx has been in use for 6 years and has been used in hundreds of applications.
During this time, it has undergone numerous bug fixes and has steadily evolved
into a better and better kernel.
Today, smx is reliable, robust, and highly capable.  It is ready for demanding,
trouble-free use.
.np
smx also features extensive error checking.  Over 70 error types are monitored,
logged, and displayed by the error manager.  This valuable diagnostic tool has
been highly praised by many smx users.
.np
smx is delivered in pre-compiled library form with source-code startup
platforms.  smx source code is available separately.
.*

.*

.*

.section smxDLM (&cat)
.*
.np
.illust begin
Micro Digital, Inc.
12842 Valley View Street
Garden Grove, CA 92649


Sales:  (800) 366-2491
Tel:  (714) 373-6862
FAX:  (714) 891-2363
.illust end
.*
.np
.*
.ix 'smxDLM (&cat)'

.ix 'Micro Digital, Inc.'

.ix '&cat'
.*
smxDLM permits independent executable modules (dynamic load modules) to be
loaded and executed as tasks under smx.  Dynamic load modules may be in .exe,
com, or custom formats.  They may be loaded from disk or via data link.  Any
number may run simultaneously, and each may spawn additional tasks.
.np
To run with smxDLM, an application is divided into a resident section and one
or more transient sections.  The resident section includes the standard smx
functions, the DLM loader, and resident application code.  It might be an .exe
file which is loaded via DOS, or it might be permanently in ROM.  The transient
sections are independent 'Dynamic Load Modules'.  These are loaded by the DLM
loader into RAM or flash ROM.
.np
Prior to loading, each DLM is linked with the DLM version of the smx library
(and any other libraries it requires).  The smx DLM library has a pseudo call
of the same name as each smx call.  A pseudo call loads its call i.d. into the
AX register, then executes a software interrupt. (The interrupt level is user
selectable.)
.np
In the resident section, the smx command interpreter, XCOM, interprets the call
i.d., adjusts the stack, and invokes the specified smx call.  The smx call
returns directly to the DLM caller upon completion.  This much of the operation
is transparent to the application code - - it need not know which smx library
(standard or DLM) it has been linked to.
.np
.*

.*

.*

.section smxProbe (&cat)
.*
.np
.illust begin
Micro Digital, Inc.
12842 Valley View Street
Garden Grove, CA 92649


Sales:  (800) 366-2491
Tel:  (714) 373-6862
FAX:  (714) 891-2363
.illust end
.*
.np
.*
.ix 'smxProbe (&cat)'

.ix 'Micro Digital, Inc.'

.ix '&cat'
.*
smxProbe is a task-level debugger for high-level debugging of systems based
upon smx.  Unlike code debuggers which allow stepping through or breaking upon
instructions and looking at
variables,  smxProbe allows triggering or breaking upon task operations and
looking at control blocks, queues, and trace buffers.  Besides being an
invaluable debugging tool, smxProbe
will show the user the high-level workings of his code and will strengthen his
understanding of multitasking.
.np
We purposely kept smxProbe simple.  Its functionality is limited to only the
most useful debugging commands. This way, the user is freed from having to
learn yet another complicated development
tool!
.np
The primary features of smxProbe are as follows:  smxProbe maintains three
trace buffers:  error buffer, task trace buffer, and smx call trace buffer.
These are allocated from the far heap.  Each may be up to 64K bytes in size.
Trace buffers can be viewed with the showb() command.  In addition, smxProbe
permits examining smx control blocks and queues.  All information is
presented symbolically and is nicely formatted.  smxProbe allows setting
triggerpoints and breakpoints.  It also permits freezing tasks below a
specified level.  In addition to the smxProbe
commands, all smx calls (e.g. start(atask)) may be executed from the smxProbe
command line.  All functions can be performed while the application is running
or stopped.
.np
smxProbe operates standalone or with a code debugger.  It also can be operated
locally or remotely via a serial link.
.*

.*

.*

.section TNT DOS Extender SDK (&cat)
.*
.np
.illust begin
Phar Lap Software
60 Aberdeen Avenue
Cambridge, MA  02138


Tel:  (617) 661-1510
FAX:  (617) 876-2972
.illust end
.*
.np
.*
.ix 'TNT DOS Extender SDK (&cat)'

.ix 'Phar Lap Software'

.ix '&cat'
.*
TNT DOS-Extender SDK Version 8.0
.np
.illust begin
 Write 32-Bit Protected Mode Realtime Programs for MS DOS
 Write Multi Megabyte MS DOS Embedded Applications with 32-Bit Addressing
 Trap Real Mode Interrupts and Pass to Application in Protected Mode
 DosStyle or NtStyle
.illust end
.np
.illust begin
Under NtStyle:
 216 Win32 APIs Supported
 DLLs, Threads, Multitasking, Priority SchedulingAll Four NT Classes
 Semaphores, Mutex, Events
 Adjustable Time SlicesAs Short as 1 Millisecond
 Interrupt Drivers for Printing and Mouse Control
 Disk and Keyboard Drivers Allow Other Threads to Execute During Idle or
Waiting times
 Multiple Extended-DOS Programs Share a Single Copy of the DOS-Extender
.illust end
.np
.illust begin
Under DosStyle:
 Dynamic Link Libraries
 INT 21h Interface
 Uses Less Memory
.illust end
.np
The TNT DOS-Extender SDK is a 32-bit development tool that enables programmers
to build multi-megabyte embedded and realtime applications that take advantage
of powerful Windows NT features. These features include DLLs, threads, priority
scheduling, and multitasking, under MS DOS. The TNT DOS Extender product
includes the WinPipe VXD which enables developers to write a Windows GUI front
end for their 32-bit DOS applications. The TNT DOS-Extender software runs on
any DOS-based 80386 or higher PC and supports a wide range of 32-bit tools.
including C and C++ compilers from Microsoft, Borland, MetaWare, Symantec, and
Watcom. In addition to the TNT DOS-Extender software, the SDK includes a 32-bit
version of the Microsoft CodeView debugger and Phar Laps SRCBug debugger,
386|ASM macro assembler, and 386|LIB librarian.
.*
.figure *depth='2.75' *scale= *file='dos_ext'
.*

.*

.section TNT Embedded ToolSuite SDK (&cat)
.*
.np
.illust begin
Phar Lap Software
60 Aberdeen Avenue
Cambridge, MA  02138


Tel:  (617) 661-1510
FAX:  (617) 876-2972
.illust end
.*
.np
.*
.ix 'TNT Embedded ToolSuite SDK (&cat)'

.ix 'Phar Lap Software'

.ix '&cat'
.*
TNT Embedded ToolSuite version 8.0
.np
The TNT Embedded ToolSuite version 8.0 software set from Phar Lap Software,
Inc. is a suite of development tools delivering a total solution for 32-bit
embedded realtime systems development.
.np
.illust begin
The suite consists of:
 TNT Embedded Realtime Kernel Threads, Priority scheduling, Semaphores, Events,
Pipes, and more
 Visual System Builder
 LinkLoc 32-bit linker/locator
 CVEMB and TDEMB shells for embedded debugging
 Full support for C/C++ run-time libraries
 MS DOS compatible file system
 Floating point emulation library
.illust end
.np
The TNT Embedded ToolSuite system allows a developer to use familiar compilers,
debuggers, and other tools to create a 386/486/Pentium processor based embedded
realtime system. Compilers supported are the C/C++ compilers from Microsoft,
Borland, Watcom, and MetaWare.
The TNT Embedded Kernel is sold with an unlimited run-time licence for use on a
single embedded product.
.np
Requirements for a ROMed embedded kernel are 14K ROM and 13K RAM and a serial
or parallel port. Embedded programs can be loaded from either diskettes or hard
disks. Single board computers such as PC/104 computers make ideal targets.
.np
Minimum host requirements are a MS DOS or Windows compatible system with 4M
memory, C/C++ compiler, and a serial or parallel line for debugging the target.
.*
.figure *depth='2.75' *scale= *file='ets_draw'
.*

.*

.section SuperTask (&cat)
.*
.np
.illust begin
United States Software Corporation
14215 N.W. Science Park Drive
Portland, Oregon  97229


Sales:  (800) 356-7097
Tel:  (503) 641-8446
FAX:  (503) 644-2413
.illust end
.*
.np
.*
.ix 'SuperTask (&cat)'

.ix 'United States Software Corporation'

.ix '&cat'
.*
SuperTask! 386PM is a suite of development tools and a Real Time Multitasking
OS for use in embedded projects.
.np
The suite includes:
ViewTask! which is a design tool that runs under DOS to specify the project at
the task level, produce skeleton source, and perform a simulation which will
tell you the viability of the
design on the hardware specified, using your task specifications.
.np
ProtoTask! is a debugging versions of the RTOS which allows you to run your
multitasking code in real-mode under DOS.  This allows preliminary testing of
your application in this environment thus saving time downloading to the target
system.
.np
MultiTask! is the 32-bit protected mode RTOS which you include in your
application.  Full source code is provided, and no royalties are charged.
MultiTask! and your application are compiled and linked in 32-bit flat model,
and can then be placed in ROM on the target (386 or higher) processor board.
.np
Applications can also be built to run under DOS with a DOS-extender.
.*

.*

.*
:set symbol="cat" value="Scientific Libraries"

.chap Scientific Libraries
.*
.np
The following section contains listings for scientific libraries supporting
Watcom C or C++.
.*

.section SciMath C/C++ (&cat)
.*
.np
.illust begin
Advanced Scientific Applications
215 E. Orangethorpe Ave. Suite 333
Fullerton, CA 92632


Tel:  (714) 680-6600
FAX:  (714) 680-4241
.illust end
.*
.np
.*
.ix 'SciMath C/C++ (&cat)'

.ix 'Advanced Scientific Applications'

.ix '&cat'
.*
SciMath   C/C++

Advanced Scientific Math Library.  Now SciMath Version 7.00 provides a complete
C/C++ scientific numerical math library on a royalty free basis.   SciMath.lib
provides hundreds of advanced mathematical functions in the areas of:
Optimization   Interpolation    Approximation    Complex FFTAEs   Complex
Bessel  Functions       Integration Differentiation   Roots   Statistics
Differential Equations Linear/Nonlinear Systems Eigensystems Transforms
Special Functions    Matrix/Vector Operations  Random Numbers Sparse Systems
and many more. Just link SciMath.lib to your application and start using
hundreds of advanced mathematical functions.

Available  for most 16 and 32 bit compilers and platforms including  Borland
C/C++, Watcom C/C++, Microsoft  C/C++, Intel  Codebuilder,  Zortech  C++,  and
more.  Operating Systems:  DOS  16/32  (Extended and real  mode),  Windows
16/32/NT/95,  OS/2,  UNIX...etc.    Original  list  price starting at: $600.00.
.*

.*

.*

.section TG-CAD 2D (&cat)
.*
.np
.illust begin
Disk Software Inc.
109 S. Murphy Road
Plano, Texas  75094


Sales:  (800) 635-7760
Tel:  (214) 423-7288
FAX:  (214) 423-7288
.illust end
.*
.np
.*
.ix 'TG-CAD 2D (&cat)'

.ix 'Disk Software Inc.'

.ix '&cat'
.*
This is a collection of over 400 2D device independent geometric routines.  The
library includes routines that create parametric lines, compute tangents and
normals, generate arcs, ellipses, circles, and 2D curves such as NURBS, Bezier,
B-Spline, Catmull-Rom, quadratic, and conics.  You can create a NURB curve that
interpolates through the control points.  You can compute a circle or arc that
is tangent to two or three circles, lines, and points.  This library contains a
rich assortment of intersection routines that compute the intersections of
lines, arcs, circles, curves and combinations thereof.  You can compute a
piecewise Bezier curve that will pass through a set of digitized points (great
for reproducing text and symbols).  You can determine the intersections,
unions, differences, of convex and concave polygons.  You can compute the
distance between points, lines, arcs and combinations thereof.  This product
gives you the ability to determine if points are outside, inside, or on the
edge of a polygon.  Also, there are 2D composite transformations such as scale,
rotate, shear, translate, reflect, and their respective inverse.  Included with
the library are routines that compute the surface area of 2D geometric shapes.
A wide range of vector computations are included.  You can decompose a concave
polygon into a series of convex polygons.  You can compute the offset of a
polyline made up of line segments and arcs.  A complete entity library is
included that gives you the ability to maintain data that describes a geometric
entity.  This information includes athe geometric data that describes the
entity plus color, line style, entity coordinate system, layer, and more.  Two
dimensional entities include Point, Line, Polyline, Text, Fill, Dimension,
Circle, Arc, Shape, Insert, Viewport, and more.  Manual & example programs
included.  Source Code Available, 30 day limited guarantee.
.*

.*

.*

.section TG-CAD 3D (&cat)
.*
.np
.illust begin
Disk Software Inc.
109 S. Murphy Road
Plano, Texas  75094


Sales:  (800) 635-7760
Tel:  (214) 423-7288
FAX:  (214) 423-7288
.illust end
.*
.np
.*
.ix 'TG-CAD 3D (&cat)'

.ix 'Disk Software Inc.'

.ix '&cat'
.*
This is a collection of over 400 3D geometric routines.  The library includes a
wide range of routines that generate B-Spline, Catmull-Rom, Bezier, quadratic
and NURBS surfaces and curves.  The library makes it easy to compute normals
and tangents to curves and surfaces.  You can perform 3D polygon planar
clipping and view clipping.  View clipping allows you to clip a scene to a
specific view volume.  You can create wire frames of solids such as spheres,
paraboloids, hyperboloids, ellipsoids, regular polyhedrons, cones, cylinders,
pyramids, prisms and more.  You can create complete or partial surfaces of
revolution.  You can extrude solids based on a 2D shape.  There are hidden line
routines that can create scenes with all hidden lines removed.  You can specify
the color of the objects in the hidden transformations such as rotation, scale,
translate mirror and perspective and their respective inverses.  You can
compute the intersection of lines, planes, and curves.  You can create
perspective views of 3D objects or scenes.  Manual & example programs included.
Source code available.  30 day limited guarantee.
.*

.*

.*

.section TG-CAD Professional (&cat)
.*
.np
.illust begin
Disk Software Inc.
109 S. Murphy Road
Plano, Texas  75094


Sales:  (800) 635-7760
Tel:  (214) 423-7288
FAX:  (214) 423-7288
.illust end
.*
.np
.*
.ix 'TG-CAD Professional (&cat)'

.ix 'Disk Software Inc.'

.ix '&cat'
.*
A Complete CAD/CAM/CAE Graphics Developers Kit.  The professional version is a
combination of TG-CAD 2D v5.0, TG-CAD 3D v5.0, TG-CAD DXF Translator v2.0 and
TG-CAD Draw v2.0.
.*

.*

.*

.section TG-DXF Translator (&cat)
.*
.np
.illust begin
Disk Software Inc.
109 S. Murphy Road
Plano, Texas  75094


Sales:  (800) 635-7760
Tel:  (214) 423-7288
FAX:  (214) 423-7288
.illust end
.*
.np
.*
.ix 'TG-DXF Translator (&cat)'

.ix 'Disk Software Inc.'

.ix '&cat'
.*
A complete DXF Library for Windows and DOS.  This library gives you the ability
to read and write AutoCAD DXF files through release 12.  You can read AutoCAD
symbol/font files.  You read and write all DXF data structures.  Once you read
them into our data structures, you can use the DXF entities with the geometric
routines in TG-CAD 2D and 3D.  You can draw DXF files using TG-CAD Draw.  You
can read a single layer or all of the layers in a DXF file.  You can explode
AutoCAD DXF block entities into a series of entities.  Included with the
library is a program that will read a DXF file, expolode the blocks and write a
new file with the exploded blocks.  Manual & example programs included.  Source
code available.  30 day limited guarantee.
.*

.*

.*

.section CSL - Scientific Programming Library (&cat)
.*
.np
.illust begin
Eigenware Technologies
1959 White Feather Lane
Nokomis, Florida  34275


Tel:  (813) 488-0118
FAX:  (813) 488-0118
.illust end
.*
.np
.*
.ix 'CSL - Scientific Programming Library (&cat)'

.ix 'Eigenware Technologies'

.ix '&cat'
.*
CSL is a collection of Eigenware's most frequently requested numerical
solutions, covering a wide range of problems, including linear algebra,
eigensystems, matrix computations, time series, smoothing and filtering,
statistics, regression, linear and integer programming, nonlinear systems,
optimization, differential equations, curve fitting, graphics, test functions
and much, much more.
.np
CSL is mature and reliable, derived from credible algorithms, and maintained
over a large user base. Used by industry, universities, consultants, financial,
government, and research institutions.  When your program calls on CSL, it is
calling on proven reliability, demonstrated by
extensive use in a variety of applications around the world. Over 800
exhaustively tested and proven functions give you greater accuracy,
reliability, and efficiency.  CSL example programs are supplied on computer
readable media.  Application notes illustrate the utility of CSL. Distributed
as source code with Makefiles for the WATCOM compiler.
.*

.*

.*

.section ACSL Model (&cat)
.*
.np
.illust begin
MGA Software
200 Baker Avenue
Concord, MA  01742


Tel:  (508) 369-5115
FAX:  (508) 369-0013
.illust end
.*
.np
.*
.ix 'ACSL Model (&cat)'

.ix 'MGA Software'

.ix '&cat'
.*
ACSL Model  is a complete environment for simulation, modelling, and analyzing
systems described by time-dependent, nonlinear differential equations or
transfer functions.  ACSL Model has powerful instructions,  including a
complete compliment of simulation operators and commands tailored for
continuous simulation and linear analysis.  Included with ACSL Model is the
Graphic Modeller, which is a graphic user interface, block-diagram front end.
.np
The ACSL (Advanced Continuous Simulation Language) consists of two sections:
the model definition and the run time commands.  The model definition involves
establishing mathematical specifications with ACSL statements for the
continuous simulation system being modeled.  The model is then analyzed by
instructions interpreted during the run time command section.  Once a model is
defined, it can be kept on file and analyzed over and over again by the run
time commands since all variables in the model definition can be displayed,
plotted, or printed and any constant or variable changed before a simulation
run.
.np
The Graphic Modeller enables the user to visually create, execute, and analyze
simulation models.  The Graphic Modeller major features include the following:
full compliment of primitives for ACSL instructions, functions, and macros:
user defined blocks: modern drawing package: multiple-view, multiple-editor
environment; and hierarchical modelling, both top down and bottom up.  The
Graphic Modeller helps the user to create a model that is visually meaningful
and easy to understand.
.*

.*

.*

.section ACSLrt Realtime (&cat)
.*
.np
.illust begin
MGA Software
200 Baker Avenue
Concord, MA  01742


Tel:  (508) 369-5115
FAX:  (508) 369-0013
.illust end
.*
.np
.*
.ix 'ACSLrt Realtime (&cat)'

.ix 'MGA Software'

.ix '&cat'
.*
ACSLrt is ACSL ( Advanced Continuous Simulation Language) with real time
extensions.  ACSLrt is for real time simulation.  The primary characteristics
of realtime operation are synchronizing model execution with a realtime clock
and communicating simulation data between the computer and the real world
through a realtime I/O board.  ACSLrt is synchronized with a computers real
time clock.  Realtime simulations require precise synchronization between the
model  and the external hardware and Input/Output boards for communication
between the computer and the external hardware.  For the PC computer platform,
ACSLrt includes ACSL with Graphic Modeller for Windows with real time
extensions, Keithley analog and digital Input/Output board, and Watcom FORTRAN
77/32 10.5 compiler.  Major features of ACSLrt are the following: powerful
simulation engine; speed; portability across multiple computer hardware
platforms, including DOS, Windows, and UNIX systems; and an advanced GUI
interface.
.*

.*

.*

.section Ingraf (&cat)
.*
.np
.illust begin
Sutrasoft
10506 Permian Drive
Sugar Land, Texas  77478


Tel:  (713) 491-2088
FAX:  (713) 240-6883
.illust end
.*
.np
.*
.ix 'Ingraf (&cat)'

.ix 'Sutrasoft'

.ix '&cat'
.*
INGRAF contains routines that you can use to create high quality graphics
with your IBM (or compatible) personal computer and any of numerous output
devices. INGRAF is available for C, FORTRAN-77, BASIC, and PASCAL, with most
routines being written in the applicable language.

In addition to general drawing routines such as line, arc, circle, grid, etc.,
that you can use to create log (semi-log and log-log), and polar plots,
INGRAF includes routines for creating bar, pie, scatter, polar and
smith charts , as well as the HIGH-LOW-CLOSE plots.

Some of the features of INGRAF are:

     Draw and scale X and Y axes independently of one another, with
     arbitrary placement.

     Control the placement and direction of text labels, (also the size
     of the text on some devices).

     Determine the size and spacing of tick marks and their placement in
     relation to the axes.

     Choose from several symbols to mark points.

     Select from various line styles and grid styles, depending on your
     choice of graphics device.

     Turn line clipping on or off.

     Generate hatching patterns with six hatch styles.


INGRAF contains over 150 user callable routines. The 350+ page user manual
includes over 50 sample programs and graphs. The same samples also are
included on diskette. INGRAF comes with complete source code and ready
to use libraries. There are NO ROYALTIES or RUN-TIME FEES.
.*

.*

.*

.section Wingraf for Windows (&cat)
.*
.np
.illust begin
Sutrasoft
10506 Permian Drive
Sugar Land, Texas  77478


Tel:  (713) 491-2088
FAX:  (713) 240-6883
.illust end
.*
.np
.*
.ix 'Wingraf for Windows (&cat)'

.ix 'Sutrasoft'

.ix '&cat'
.*
WINGRAF contains routines that you can use to create high quality graphics
with your IBM (or compatible) personal computer and any of numerous output
devices. WINGRAF is available for C, FORTRAN-77, BASIC, and PASCAL, with most
routines being written in the applicable language.

In addition to general drawing routines such as line, arc, circle, grid, etc.,
that you can use to create log (semi-log and log-log), and polar plots,
WINGRAF includes routines for creating bar, pie, scatter, polar and
smith charts , as well as the HIGH-LOW-CLOSE plots.

Some of the features of WINGRAF are:

     Draw and scale X and Y axes independently of one another, with
     arbitrary placement.

     Control the placement and direction of text labels, (also the size
     of the text on some devices).

     Determine the size and spacing of tick marks and their placement in
     relation to the axes.

     Choose from several symbols to mark points.

     Select from various line styles and grid styles, depending on your
     choice of graphics device.

     Turn line clipping on or off.

     Generate hatching patterns with six hatch styles.


WINGRAF contains over 140 API routines. The 350+ page user manual
includes over 50 sample programs and graphs. The same samples also are
included on diskette. WINGRAF comes with complete source code and ready
to use DLL and libraries. There are NO ROYALTIES or RUN-TIME FEES.
.*

.*

.*
:set symbol="cat" value="Screen Managers"

.chap Screen Managers
.*
.np
The following section contains listings for screen manager products supporting
Watcom C or C++.
.*

.section Dynace Windows Development System (&cat)
.*
.np
.illust begin
Algorithms Corporation
3020 Liberty Hills Drive
Franklin, TN  37064


Tel:  (615) 791-1636
FAX:  (615) 791-7736
.illust end
.*
.np
.*
.ix 'Dynace Windows Development System (&cat)'

.ix 'Algorithms Corporation'

.ix '&cat'
.*
Dynace Windows Development System (WDS)
-------------------------------------------------------------------------
The Dynace Windows Development System (WDS) is a Dynace class library which
enables a C programmer with no knowledge of C++, Dynace, the Windows API or
message-driven architecture to write real Windows applications with an absolute
minimum learning curve and number of lines of code.  In fact, it is possible to
become familiar enough with windows, menus, dialogs and controls using WDS to
write a Windows application after just one day!  A 'Hello World' program takes
only four lines of code!
.*
.figure *depth='2.75' *scale= *file='algologo'
.*

.*

.section Menuet/C (&cat)
.*
.np
.illust begin
Autumn Hill Software
1145 Ithaca Drive
Boulder, Colorado 80303


Tel:  (303) 494-8865
FAX:  (303) 494-7802
.illust end
.*
.np
.*
.ix 'Menuet/C (&cat)'

.ix 'Autumn Hill Software'

.ix '&cat'
.*
Despite the growing importance of the C++ language and graphical operating
systems such as OS/2 and Windows, C is still the most widely used language on
the desktop.  If you are developing applications for DOS using C then you
should know about our Menuet/C GUI toolkit.  Virtually all improtant C
development environments for DOS are supported as well as 16-bit and 32-bit
protected mode environments.  There is EMS memory and virtual memory using
disk.  And, Menuet/C provides the IDT screen designer and icon and font
editors, along with lots of font and icon files.
.np
There's also over 1,000 pages of printed documentation and 35 fully functioning
sample programs.
.*

.*

.*

.section Vitamin C Plus - DOS (&cat)
.*
.np
.illust begin
Creative Programming Consultants
P.O. Box 112097
Carrollton, TX  75011-2097


Sales:  (800) 726-6447
Tel:  (214) 245-9139
FAX:  (214) 245-9717
.illust end
.*
.np
.*
.ix 'Vitamin C Plus - DOS (&cat)'

.ix 'Creative Programming Consultants'

.ix '&cat'
.*
Vitamin C 4.0 makes it easy to include a state-of-the-art user interface in all
your C/C++ programs.  Its rich library of C functions lets you create windows
up to 32k each, with or without a title, border, cursor, shadow, or scroll
bars.  Then write to any window any time--even if it is invisible or obscured.
.np
Creating forms and dialogs is easy with Vitamin C data entry objects like push
buttons, radio buttons, check boxes, list boxes, scroll bars, text editors, and
entry fields.  And each is bursting with options that let you shape its look-
and-feel.  Plus, Vitamin C is easily customized--even without modifying the
library source.  Filter functions let you intercept operations before they
happen so you control the results.
.np
Vitamin C's full featured horizontal and vertical menus help you tie your
system together.  And its context sensitive help system provides object
specific pop-up help messages.  Even the keyboard is fully configurable, and
truly integrated mouse support is automatic when
Vitamin C detects a mouse.
.np
The bottom line?  With power to slash development time and flexibility to meet
your changing needs, Vitamin C 4.0 is the user interface solution you've been
looking for!
.*
.figure *depth='2.75' *scale= *file='imagea'
.*

.*

.section MEWEL (&cat)
.*
.np
.illust begin
MAGMA Software Systems
15 Bodwell Terrace
Millburn, New Jersey 07041


Tel:  (201) 912-0192
FAX:  (201) 912-0103
.illust end
.*
.np
.*
.ix 'MEWEL (&cat)'

.ix 'MAGMA Software Systems'

.ix '&cat'
.*
MEWEL 4.1 is a cross-platform user interface tookit which gives your
application complete portability between Microsoft Windows, DOS text, DOS
graphics, OS/2 text, UNIX text, and OSF Motif. Since MEWEL's API is compatible
with the standard Microsoft Windows API, you can easily port programs between
Windows and any of the environments which MEWEL supports,
even if you already have existing Windows programs.
.np
Programmers can develop new stand-alone applications using MEWEL, or can port
their existing Windows applications to any of the platforms which MEWEL
supports. MEWEL supports Windows 3.x features such as Control windows (listbox,
combo, radio, checkbox, pushbutton, scrollbars, single & multi-line edit,
static) Multiple Document Interface (MDI) Dialog Boxes Overlapping Windows with
moving and resizing Multi-level Menus Mouse Windows BMP files (blitting,
stretching, compressing) PCX files Icons (character and graphical) Multiple
proportional fonts MEWEL supports the Watcom 10.5 32-bit compiler, and the DOS
4G/W and Pharlap TNT DOS extenders. The DOS Graphics version supports the
MetaWindows 386 and Watcom graphics libraries.
.*
.figure *depth='2.75' *scale= *file='wmewlgui'
.*

.*

.section C/Windows Toolchest (&cat)
.*
.np
.illust begin
Mix Software, Inc.
1132 Commerce Drive
Richardson, Texas  75081


Sales:  (800) 333-0330
Tel:  (214) 783-6001
FAX:  (214) 783-1404
.illust end
.*
.np
.*
.ix 'C/Windows Toolchest (&cat)'

.ix 'Mix Software, Inc.'

.ix '&cat'
.*
The C/Windows Toolchest provides an easy way to add a sophisticated user
interface with full mouse support to DOS and DOS extender applications.
Two simple function calls are all it takes to create movable, resizable
windows, complete with scroll bars and other standard controls; including
minimize, maximize, restore and menu buttons.  A wide variety of other
controls are also available; including push buttons, radio buttons and
check boxes.  Of course there is extensive support for both horizontal
and vertical menus, with or without scroll bars.  For collecting user
input, a comprehensive set of functions are available to manipulate data
entry fields.
.*
.figure *depth='2.75' *scale= *file='cwindow'
.*

.*

.section Zinc Application Framework (&cat)
.*
.np
.illust begin
Zinc Software Inc.
405 South 100 East  2nd Floor
Pleasant Grove, Utah  84062


Sales:  (800) 638-8665
Tel:  (801) 785-8900
FAX:  (801) 785-8996
.illust end
.*
.np
.*
.ix 'Zinc Application Framework (&cat)'

.ix 'Zinc Software Inc.'

.ix '&cat'
.*
Zinc Application Framework 4.1 is an object-oriented, cross-platform,
internationalized, class library and visual development tool.  Zinc supports
Symantec C++ 7.0 for DOS (both Text Mode and Graphics Mode), Microsoft Windows,
Win32 and Apple Macintosh (required Symantec C++
7.0 for Macintosh).  Zinc 4.0 also supports Windows NT, IBM OS/2, OSF/Motif,
Curses, NEXTSTEP and DESQview/X.  All platforms are supported with one set of
source code.
.np
Zinc 4.1 offers a comprehensive feature set including the following objects:
drag and drop, geometry management, scrolling windows, event mapping, palette
mapping, table, printer, notebook, status bar, tool bar, formatted string,
date, time, number (with currency), bitmap buttons, lists, combo box and many
more.
.np
Zinc Designer is the only visual development tool that creates and stores
platform-independent, user-interface objects.  Developers can interactively
drag and drop interface objects to develop application screens on any platform
that Zinc supports.  Twenty two full featured object editors give direct access
to all library-level features for each object.  Zinc Designer also features an
image editor for bitmaps and icons, a message editor and a defaults editor for
Help and System
information.  Zinc POST (Persistent Object Storage Technology) provides robust
platform-independent resources.  These binary files can be moved transparently
across platforms and are easily internationalized.
.np
Zinc 4.1 supports 13 languages and 19 country locales.  Developers can use a
single set of source code to support single-byte (ISO) languages such as
English, French and German as well as double-byte (Unicode) languages such as
Japanese, Korean and Chinese.
.np
The product includes the library, Zinc Designer and full source code.
.*
.figure *depth='2.75' *scale= *file='zinc'
.*

.*
:set symbol="cat" value="Software Security"

.chap Software Security
.*
.np
The following section contains listings for software security packages
supporting Watcom C or C++.

.*

.section HASP -- The Professional Software Protection Solution (&cat)
.*
.np
.illust begin
Aladdin Software Security Inc.
The Empire State Building
350 Fifth Ave., Suite 6614
New York, NY  10118

Tel:  (972) 3-5375795
FAX:  (972) 3-5375796
.illust end
.*
.np
.*
.ix 'HASP -- The Professional Software Protection Solution (&cat)'

.ix 'Aladdin Software Security Inc.'

.ix '&cat'
.*
Unauthorized use of software costs software developers over $15 billion each
year.
.np
Aladdin Knowledge Systems is a world leading developer of software security
systems. Aladdin's HASP product line is an advanced software protection system
that enables software developers to increase their revenues by protecting their
software from unauthorized use and distribution.
.np
Since 1984, over one million HASP hardware keys have enabled more than 8,000
software developers in over 60 countries to protect their software. Our clients
include industry leaders such as CA, IBM, Lotus, Quark, Toshiba, Samsung and
AT&T. In fact, reviews in the international computer press consistently rate
HASP as the best protection solution available.
.np
Based on advanced ASIC technology and sophisticated anti-debugging and
protection algorithms, HASP is regarded as the most secure software protection
system available. Multiple protection features further enhance security.
.np
State-of-the-art technology makes HASP the most secure, reliable, and cost-
effective protection system on the market. With unsurpassed ease-of-use, HASP
offers the developer rapid implementation, using high-level programming
procedures. And, full transparency and
compatibility guarantee end-user satisfaction.
.np
HASP is available in memory, non-memory, time-based, and network versions, with
cross-platform support for different operating environments and hardware
platforms, and hundreds of supported
compilers and languages. Utilities and software upgrades are provided free of
change.
.np
The HASP product line offers the widest range of PC-based protection solutions
available, with support for Watcom C/C++ compilers under DOS, Windows 3.x,
Windows NT, Windows95, Win32s, OS/2, Japanese NEC and Fujitsu, and LANs. HASP
also offers Macintosh, Power Mac, Amiga, and Open Systems solutions.
.np
For more information, visit Aladdin's World Wide Web Home Page -
http://www.hasp.com/.
.*

.*

.*

.section KEY-LOK (&cat)
.*
.np
.illust begin
Microcomputer Applications, Inc.
3167 East Otero Circle
Littleton, Colorado 80122


Tel:  (303) 770-1917
FAX:  (303) 770-1863
.illust end
.*
.np
.*
.ix 'KEY-LOK (&cat)'

.ix 'Microcomputer Applications, Inc.'

.ix '&cat'
.*
Microcomputer Applications, Inc. has been successfully preventing software
piracy since 1982.  As the oldest supplier of PC based security products, we
have developed products that combine maximum security with maximum reliability.
Our parallel port KEY-LOK device comes with a lifetime warranty against
failure, as further evidence of its durability.  High level program
protection requires a combination of both hardware and software.  The software
portion of the system is designed to prevent pirates from using debugging
utilities to take apart and thus bypass the hardware communication algorithms.
.np
The hardware portion of the system is designed to prevent reverse engineering.
Our security system uses 'active' algorithms so that someone cannot capture a
communication sequence and play it back as a means of bypassing security.  This
device comes with 120 bytes of EEPROM memory to support multi-product/feature
protection.  Optional real-time-clock and KEYTAG for secure memory alteration
are available.
.np
We have been supporting Watcom compilers for several years now.  We support all
of the various options of DOS extenders, and can easily support new ones on the
market within a few days of customer request.  We can also provide a Novell NLM
so that a single device can be used to support multiple nodes on a network.
The NT version of our security system can also be used for multi-session and/or
multi-node control.  We also support OS/2, in addition
to standard DOS and Windows applications.  Our complementary serial port COMPU-
LOCK product can be used to protect software operating on any platform under
any operating system.
.*

.*

.*

.section KEY-LOK Security System (&cat)
.*
.np
.illust begin
Microcomputer Applications, Inc.
3167 East Otero Circle
Littleton, Colorado 80122


Tel:  (303) 770-1917
FAX:  (303) 770-1863
.illust end
.*
.np
.*
.ix 'KEY-LOK Security System (&cat)'

.ix 'Microcomputer Applications, Inc.'

.ix '&cat'
.*
Prevent software piracy using our state-of-the-art parallel port hardware
device combined with powerful security software. Active algorithm (different
each time used). Each device is customer unique and individually serialized.
Use parallel port to directly program 120 bytes of read/write memory. Optional
KEYTAG for very secure KEY-LOCK memory modification in the field. Optional Real-
Time-Clock  to support product leasing. Serial port devices are also available.
.*

.*

.*
:set symbol="cat" value="Sound Library"

.chap Sound Library
.*
.np
The following section contains listings for sound libraries
supporting Watcom C or C++.

.*

.section CodeCheck (&cat)
.*
.np
.illust begin
Abraxas Software, Inc.
5530 SW Kelly Avenue
Portland, Oregon  97201


Sales:  (800) 347-5214
Tel:  (503) 244-5253
FAX:  (503) 244-8375
.illust end
.*
.np
.*
.ix 'CodeCheck (&cat)'

.ix 'Abraxas Software, Inc.'

.ix '&cat'
.*
CodeCheck 5.0 is a programmable tool for managing all C and C++ source code on
a file or project basis.  CodeCheck is input compatible with all variants of
K&R, ANSI C and C++.  CodeCheck is designed to solve all of your Portability,
Maintainability, Complexity, Reusability, Quality Assurance, Style Analysis,
Library/Class Management, Code Review, Software Metric, Standards Adherence,
and Corporate Compliance Problems.
.illust begin
*  Compliance- CODECHECK allows your corporate coding and project specification
standards to be completely automated for compliance validation
*  Complexity-Measures program size(Halstead) and program complexity(McCabe).
*  Portability-CODECHECK identifies code that will not port between DOS, OS/S,
Unix, VMS, and the Macintosh, and check for compatibility with ANSI, POSIX, and
other standards.
.illust end
.illust begin
Prices are: DOS,MAC $495.00
*    OS/2,NT $995.00
*    UNIX,   $1995.00
.illust end
.illust begin
ABRAXAS SOFTWARE, INC  5530 SW KELLY, PORTLAND OREGON 97201
TEL (503) 244-5253  FAX (503) 244-8375 E-mail: abraxas @ ortel.org
.illust end
.*

.*

.*

.section PCYACC (&cat)
.*
.np
.illust begin
Abraxas Software, Inc.
5530 SW Kelly Avenue
Portland, Oregon  97201


Sales:  (800) 347-5214
Tel:  (503) 244-5253
FAX:  (503) 244-8375
.illust end
.*
.np
.*
.ix 'PCYACC (&cat)'

.ix 'Abraxas Software, Inc.'

.ix '&cat'
.*
PCYACC 5.0 is a complete language development environment that generates ANSI C
& C++ source code from input Language Description Grammars for building
Assemblers, Compilers, Interpreters, Browsers, Page Description Languages,
Language Translators, Syntax Directed Editors, Language Validators, Natural
Language Processors, Expert System Shells, and Query Languages.
.illust begin
*  New! Generates C & YACC classes for Windows 3.0 and OS/2 2.0 Presentation
Manager
*  New! Build Professional systems with full ERROR HANDLING, RECOVERY &
REPORTING.
*  Lexical analyzer generator ABRAXAS PCLEX is included.
.illust end
.illust begin
Prices are: DOS,MAC  $495.00
*    OS/2, NT $995.00
*    UNIX     $1995.99
.illust end
.np
ABRAXAS SOFTWARE, INC. 5530 SW KELLY, PORTLAND OREGON 97201
TEL (503) 244-5253  FAX (503) 244-8375 E-mail: abraxas @ ortel.org
.*

.*

.*

.section Object Master for Windows (&cat)
.*
.np
.illust begin
ACI US, Inc.
20883 Stevens Creek Blvd.
Cupertino, CA  95014


Tel:  (408) 252-4444
FAX:  (408) 252-4829
.illust end
.*
.np
.*
.ix 'Object Master for Windows (&cat)'

.ix 'ACI US, Inc.'

.ix '&cat'
.*
Object Master for Windows, winner of InfoWorld's 1994 Landmark Technology
Award, speeds the development of C/C++ programming with innovative tools for
writing, editing and navigating through code.   Object Master parses code,
checks syntax in real-time, and maintains a dynamic data dictionary of project
components. Includes class-tree windows for graphically viewing code and
Smalltalk-like browser windows for quick navigation.
.np
.illust begin
Smart Source Code Editor
Unlike most text or source code editors, Object Master understands code and
takes advantage of the language structure. And it's dynamic. Syntax is checked
when code is added or saved and any changes are automatically updated
throughout the project.  You can immediately see the effects of changes made to
code without having to recompile.
.illust end
.illust begin
Industrial-Strength Browser
Most browsers only let you view individual files. With Object Master, you can
have multiple browser windows open simultaneously, enabling you to work with
several modules or sections of code.  Object Master also provides a high level
of project abstraction, allowing you to visualize the relationship between
various parts of a project.
.illust end
.illust begin
Powerful Navigation
With one mouse click, you can move from a function call directly to its
definition. Object Master's data dictionary instantly locates code and its
components and saves you from searching through the entire project for code.
.illust end
.illust begin
And Much More
'If you ever wished to be able to do something quickly and easily when writing
code, it's probably a feature in Object Master.'  InfoWorld, October 24, 1994.
.illust end
.*

.*

.*

.section FOR_C (&cat)
.*
.np
.illust begin
Cobalt Blue, Inc.
555 Sun Valley Drive
Roswell, GA  30076


Tel:  (770) 518-1116
FAX:  (770) 640-1182
.illust end
.*
.np
.*
.ix 'FOR_C (&cat)'

.ix 'Cobalt Blue, Inc.'

.ix '&cat'
.*
Converts FORTRAN-77 to ANSI C, delivering very readable, maintainable code!  It
supports
many VAX, PRIME and IBM-VS extensions for cost-effective porting of FORTRAN to
other
environments.  FOR_C offers basic static analysis and error checking,
delivering compiler-like
performance even when a FORTRAN compiler is not yet available on your target
platform, e.g.
when using an accelerator board.  The package also includes a C-like
preprocessor for easy
code customization, automatic prototyping, special de-include capabilities and
many formatting
options.  Also compatible with FOR_STRUCT, Cobalt Blue's FORTRAN restructuring
tool.
.*

.*

.*

.section C-Vision for C/C++ (&cat)
.*
.np
.illust begin
Gimpel Software
3207 Hogarth Lane
Collegeville, Pennsylvania 19426


Tel:  (610) 584-4261
FAX:  (610) 584-4266
.illust end
.*
.np
.*
.ix 'C-Vision for C/C++ (&cat)'

.ix 'Gimpel Software'

.ix '&cat'
.*
Do you know where all your C/C++ variables and functions are?  Do you know what
they're doing?
.np
C-Vision is a set of documentation tools to help you analyze, understand and
maintain
C/C++ programs. It includes four main components:
.illust begin
a cross-referencer, a function call diagrammer, an intelligent source code
lister, and a reformatter.
.illust end
.np
C-Vision supports a mixed suite of C and C++ modules. It supports K&R and ANSI
C and ANSI/ISO C++ and runs on OS/2 and MS-DOS (includes 386 DOS-extended
executables).
.np
The cross-referencer provides highly detailed symbol descriptions including
symbol usage (assigned, declared, address used) and type information.  Cross-
reference information can be
dumped to disk as ASCII files and manipulated directly.
.np
The tree diagrammer is customizable to show different views of your code (to
flow downwards or upwards) and trees can be pruned in many different ways.
.np
In addition to trees of function calls, C-Vision can produce trees of classes
and show the relationships between them. Tree information can be dumped to disk
as ASCII files and manipulated directly.
.np
The lister will print outlined listings of your code. Comments and keywords can
be printed in a user-defined font, such as italics, bold, underline, etc.
.np
The reformatter supports independent control of curly-braces, labels,
preprocessor statements, case/default statements and more and also includes a
comment reformatter.  Operator spacing can be adjusted through the use of a
user-modifiable configuration file.
.*

.*

.*

.section PC-lint for C/C++ (&cat)
.*
.np
.illust begin
Gimpel Software
3207 Hogarth Lane
Collegeville, Pennsylvania 19426


Tel:  (610) 584-4261
FAX:  (610) 584-4266
.illust end
.*
.np
.*
.ix 'PC-lint for C/C++ (&cat)'

.ix 'Gimpel Software'

.ix '&cat'
.*
PC-lint for C/C++ is a source code checker that supports a mixed suite of C and
C++ modules.
It will find bugs, glitches and inconsistencies that a compiler working on one
module at a time will miss.
.np
Are your inherited destructors virtual?  Are your constructor new's matched by
your destructor delete's?  Are names inadvertently hiding other names?  Are C++
modules consistent with C
modules?
.np
PC-lint for C/C++ will find these problems, as well as, missing or redundant
access specifiers, out-of-order constructor initializers, creation of
temporaries, undefined and unreferenced class members, and more.
.np
Full C++ Support:  PC-lint for C/C++ is based on the ARM and is tracking the
latest ANSI/ISO draft including exceptions and templates.
.np
PC-lint for C/C++ also includes our traditional C checking, such as,
inconsistent declarations, argument/parameter mismatches, uninitialized
variables, unaccessed variables, variables assigned but not used, suspicious
macros, indentation irregularities, loss of precision, unusual Booleans,
signed/unsigned mismatches, suspicious expressions, unused macros, printf-scanf
irregularities and more.
.np
PC-lint provides for strong type checking based on typedef and it will flag
variables not initialized based on the flow of control.
.np

It provides a plethora of options for message suppression, message format,
compiler dependencies, etc.  All messages can be individually suppressed or
enabled, both locally and globally. Runs on MS-DOS, Windows NT and OS/2.  The
DOS executable uses a built-in 386 DOS extender to enable it to handle very
large applications.
.*

.*

.*
:set symbol="cat" value="Source Analysis"

.chap Source Analysis
.*
.np
The following section contains listings for source analysis tools with support
for Watcom C or C++.
.*

.section WinScope (&cat)
.*
.np
.illust begin
The Periscope Company, Inc.
1475 Peachtree Street NE
Suite 100
Atlanta, GA  30309

Sales:  800-722-7006
Tel:  (404) 888-5335
FAX:  (404) 888-5520
.illust end
.*
.np
.*
.ix 'WinScope (&cat)'

.ix 'The Periscope Company, Inc.'

.ix '&cat'
.*

.*

.*


